********************************************************************************
*                                                                              *
*                                  2DHF                                        *
*                                                                              *
*                                                                              *
*         2-Dimensional Finite Difference Hartree-Fock program                 *
*                         for diatomic molecules                               *
*                                                                              *
*                            (version 1-2003)                                  *
*                                                                              *
*                                                                              *
*  Copyright (C) 1996 Jacek Kobus, Jacek.Kobus@phys.uni.torun.pl               *
*  Instytut Fizyki, Uniwersytet Mikolaja Kopernika                             *
*  Grudziadzka 5/7, PL-87-100 Torun, Poland                                    *
*                                                                              *
*  Copyright (C) 1996 Leif Laaksonen, Leif.Laaksonen@csc.fi                    *
*  Centre for Scientific Computing                                             *
*  Tietotie 6, P.O.Box 405, FIN-02101 Espoo, Finland                           *
*                                                                              *
*  Copyright (C) 1996 Dage Sundholm, sundholm@chem.helsinki.fi                 *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program (see COPYING).                                      *
*                                                                              *
********************************************************************************


The program finds virtually exact solutions of the Hartree-Fock and
Hartree-Fock-Slater equations for diatomic molecules. The lowest
energy eigenstates of a given irreducible representation and spin can
be obtained.

Single particle two-dimensional numerical functions (orbitals) are
used to construct an antisymmetric many-electron wave function of the
restricted open-shell Hartree-Fock model. The orbitals are obtained by
solving the Hartree-Fock equations which are coupled two-dimensional
second-order (elliptic) partial differential equations (PDE).  The
Coulomb and exchange potentials are obtained as solutions of the
corresponding Poisson equations. The PDEs are disretized by the
8th-order central difference stencil on a two-dimensional grid (or
subgrids) and the resulting large and sparse system of linear
equations is solved by the (multicolour) successive overrelaxation
method ((MC)SOR). The self-consistent-field iterations are interwoven
with the (MC)SOR ones and orbital energies and normalization factors
are used to monitor the convergence. The accuracy of solutions depends
mainly on the grid and the system under consideration.

See the following articles for the detailed description of the
program:

  L.Laaksonen, P.Pyykko, and D. Sundholm, Comp. Phys. Reports 4 (1986) 219.
  L.Laaksonen, D.Sundholm, and P.Pyykk\"o, in "Scientific Computing in
    Finland,", Eds. K. Kankaala and R. Nieminen, Research Report R1/89,
    Centre for Scientific Computing, (1989) p. 183.
  P.Pyykk\"o, in Numerical Determination of the Electronic Structure
    of Atoms, Diatomic and Polyatomic Molecules (NATO ASI Series C271) 
    Eds. M.Defranceschi and J Delhalle, p.161
  J.Kobus, Chem. Phys. Lett. 202 (1993) 7
  J.Kobus, Comput. Phys. Commun. 78 (1994) 247
  J.Kobus, L.Laaksonen, D.Sundholm, Comp. Phys.Commun. 98 (1996) 346-358 
  J.Kobus, Numerical Hartree-Fock methods for diatomic molecules,
    Handbook of Molecular Physics and Quantum Chemistry (Chichester),
    ed. S.~Wilson (Wiley, 2002)

The programming language used is Fortran 77. However, two routines
written in C are used for recording the date and time of the run and
the CPU usage. Several BLAS (Basic Linear Algebra System) routines are
emulated by the program. When possible they should be replaced by
their library equivalents (see Makefile).

Typical running times are very case dependent - from hundreds seconds
on an ordinary workstation up to several hours/days on a supercomputer.

The current version of the program can be downloaded from
http://laaksonen.csc.fi/num2d.html. Its original version (from 1996)
can be obtained from CPC Program Library, Queen's University of
Belfast, N. Ireland.

See INSTALLATION to configure, compile and run the program.

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prtmat ###
c
c     Prints an array into a file.
c
      subroutine prtmat (m,n,a,ioutmat)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension a(m,n)

      do im=1,m
         write(ioutmat,1000) (a(im,in),in=1,n)
      enddo
c     when preparing data for matlab use Ew.d or Fw.d format 
01000 format(500E16.8)
c     01000 format(5F15.6)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### hypgf ###		  	    
c
      function hypgf(np,lp,x)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)		

      hypgf=1.d0
      if (-np.eq.0) return
      t=dble(np)*x/dble(lp)
      hypgf=hypgf+t
      if (-np.eq.1) return
      do i=2,-np
         t=t*x*dble(np+i-1)/dble(lp+i-1)/dble(i)
         hypgf=hypgf+t
      enddo
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### norm94 ###
c
      subroutine norm94 (iorb,psi,f4,wgt2,wk0,xnorm)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      real*8 f4
      include 'commons8.inc'
      dimension psi(*),f4(*),wgt2(*),wk0(*)

      ibeg = i1b (iorb)
      ngrid= i1si(iorb)
      do i=1,ngrid
         wk0(i)=psi(ibeg-1+i)*psi(ibeg-1+i)
      enddo

      call prod  (ngrid,f4,wk0)

      xnorm=ddot (ngrid,wgt2,1,wk0,1)
      area(iorb)=xnorm

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### tfpot ###  
c
c     
      subroutine tfpot (psi,pot,excp,f2,f4,wk0)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),f2(*),f4(*),wk0(*)

      if (imethod.eq.2.or.ini.eq.4) return
      
      if (ini.ne.6) then
         
c        Initialization of Coulomb potentials
         
         print *,'... initializing Coulomb potentials ...'
         
c        loop over orbitals
         
         slim=1.0d0
         zc1= 2.0d0
         zc2= 2.0d0
         do iorb=1,norb
            ngrid=i1si(iorb)	 	 
            ishift=i1b(iorb)-1	
            ez1=eza1(iorb)
            ez2=eza2(iorb)	  	
            
            ch1=-1.0d0
            ch2=-1.0d0
            if (ez1.lt.precis) ch1=-2.0d0
            if (ez2.lt.precis) ch2=-2.0d0
            
            crt1=abs(co1(iorb))
            crt2=abs(co2(iorb))
            
c           loop over grid points

            do imu=1,mxnmu
               inioff=(imu-1)*nni
               vxit=vxi(imu)
               do in=1,nni
                  igp=ishift+inioff+in
                  vetat=veta(in)
                  if (imu.eq.1.and.in.eq.1) then
                     pot(igp)=0.d0
                  else
                     pot(igp)=thofe(r,vetat,vxit,zc1,ch1,slim)*crt1
     &                    +thofe(r,(-vetat),vxit,zc2,ch2,slim)*crt2
                  endif
               enddo
            enddo
            call prod(ngrid,f4,pot(i1b(iorb)))               
         enddo
      endif

c     Initialization of exchange potentials
      
      do i=1,length3
         excp(i)=0.d0
      enddo

      if (imethod.eq.3) then
         call slaterp(psi,pot,excp,f2,f4,wk0)
         print *,'... initializing Slater exchange potential ...'
         return
      elseif (iform.eq.1.or.iform.eq.3) then
         
         print *,'... initializing exchange potentials ...'

c        Initialization of exchange potentials that are all kept in memory
         
c        loop over orbitals
         
         do iorb1=1,norb
            do iorb2=iorb1,norb
               k=iorb1+iorb2*(iorb2-1)/2
               if (iorb1.eq.iorb2.and.ll(iorb2).eq.0) goto 50
               ngrid=i3si(k)
               ishift=i3b(k)-1
               
c              loop over grid points
           
               do imu=1,mxnmu
                  if (imu.eq.1) goto 40
                  inioff=(imu-1)*nni
                  vxit=vxi(imu)
                  do in=1,nni
                     if (in.eq.1.or.in.eq.nni) goto 30
                     igp=ishift+inioff+in
                     vetat=veta(in)
                     ra1=(r/2.d0)*(vxit+vetat)
                     ra2=(r/2.d0)*(vxit-vetat)

                     if (ra1.gt.1.d-8) then
                        excp(igp)=co1(iorb1)/ra1
                     else
                        excp(igp)=0.d0
                     endif
                     if (ra2.gt.1.d-8) then
                        excp(igp)=excp(igp)+co2(iorb1)/ra2
                     endif
 30                  continue
                  enddo
 40               continue	
               enddo
               call prod(ngrid,f4,excp(i3b(k)))               
               if (iorb1.eq.iorb2) goto 50
               if (ll(iorb1).eq.0.or.ll(iorb2).eq.0) goto 50
               ishift=ishift+ngrid
               call dcopy(ngrid,excp(i3b(k)),1,excp(i3b(k)+ngrid),1)
 50            continue
            enddo
         enddo

      elseif (iform.eq.0.or.iform.eq.2) then

         print *,'... initializing exchange potentials ...'

         call prepwexch
         do iorb1=1,norb
            do iorb2=1,i3nexcp(iorb1)
               k=i3breck(iorb1,iorb2)
               i3beg=i3brec(iorb1,iorb2)
               iorb2t=i3orb2(k)
               i3b(k)=i3beg        
               ngrid=i3si(k)
               if (ilc(k).eq.1) then
                  irec=i3xpair(iorb1,iorb2)
                  ishift=i3b(k)-1
                  
c                 loop over grid points
                  
                  if (iwexch(k).ne.0) then
                     do imu=1,mxnmu
                        if (imu.eq.1) goto 41
                        inioff=(imu-1)*nni
                        vxit=vxi(imu)
                        do in=1,nni
                           if (in.eq.1.or.in.eq.nni) goto 31
                           igp=ishift+inioff+in
                           vetat=veta(in)
                           ra1=(r/2.d0)*(vxit+vetat)
                           ra2=(r/2.d0)*(vxit-vetat)
                          
                           if (ra1.gt.1.d-8) then
                              excp(igp)=co1(iorb1)/ra1
                           else
                              excp(igp)=0.d0
                           endif
                           if (ra2.gt.1.d-8) then
                              excp(igp)=excp(igp)+co2(iorb1)/ra2
                           endif
 31                        continue
                        enddo
 41                     continue	
                     enddo
                  endif
                  call prod(ngrid,f4,excp(i3b(k)))               
               elseif (ilc(k).eq.2) then
                  irec=i3xpair(iorb1,iorb2)
                  call dcopy(ngrid,excp(i3beg-ngrid),1,
     &                 excp(i3beg),1)
               endif
            enddo
            
c           save exchange potential involving iorb1 on disk 
            call wtdexch(iorb1,excp)
         enddo
      endif
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### ortho ###
c
c     This is a orthogonalisation routine. 
c
      subroutine ortho (iorb1,psi,f4,wgt2,wk0,iprt)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),f4(*),wgt2(*),wk0(*)
      dimension ovla(60),istp(60)

      jor=0
      ibeg1 = i1b (iorb1)
c ! orbitals are stored in reverse order
      do iorb2=1,norb
         iorb3=norb-iorb2+1
         if (iorb3.le.iorb1) go to 101
         
         ngrid= min (i1si(iorb1),i1si(iorb3))	  	    
         if (mgx(6,iorb3).ne.mgx(6,iorb1)) go to 101
         if (ige(iorb3).ne.ige(iorb1)) go to 101
         
         jor=jor+1
         ibeg3= i1b (iorb3 )
         istp(jor)=ibeg3
         
         call prod2 (ngrid,psi(ibeg1),psi(ibeg3),wk0)
         call prod  (ngrid,f4,wk0)
         
         ovla(jor)=ddot (ngrid,wgt2,1,wk0,1)

c        write final overlap
         
         if (iprt.ne.0) then
c           write(*,60) iorn(iorb1),bond(iorb1),gut(iorb1),
c           &                   iorn(iorb3),bond(iorb3),gut(iorb3),ovla(jor)
c           
            write(*,60) iorn(iorb1),bond(iorb1),gut(iorb1),
     &           iorn(iorb3),bond(iorb3),gut(iorb3),ovla(jor)
 60         format(4x,' <',i2,1x,a5,1x,a1,1x,'|',
     &           1x,i2,1x,a5,1x,a1,1x,'> = ',d10.2)     
         endif
 101     continue
      enddo

      if (iprt.eq.2) return

c     start orthogonalisation

      if (jor.eq.0) return

      ano=0.d0
      do ira=1,jor
         ngrid= min (i1si(iorb1),i1si(ira))	  	    	
         ano=ano+ovla(ira)*ovla(ira)
         call daxpy (ngrid,-ovla(ira),psi(istp(ira)),1,psi(ibeg1),1)
      enddo

c     normalize the orthogonalized orbital isa  but be sure the
c     unorthogonalized isa was normalized otherwise use <isa/isa>
c     instead of 1. in ano

      ano=sqrt(1.d0+ano)/(1.d0-ano*ano)
      ngrid = i1si(iorb1)
      call dscal (ngrid,ano,psi(ibeg1),1)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inpi ###
c
c    This routine reads an integer from the array IA,
c    starting at IA(istrt(jrec)) and continuing for inumb(jrec))
c    elements. Plus signs are ignored, the answer is accumulated
c    in JBUF.
c
      subroutine inpi(jbuf)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 ia,ichar(14),itemp
      common/iochan/ iinp5,iinp11,iinp12,iinp13,iinp14,
     &               iout6,iout21,iout22,iout23,iout24
      common/work/jrec,jump,istrt(40),inumb(40),ia(80)
      data ichar/'0','1','2','3','4','5','6','7','8','9',
     &           '+','&','^','-'/,inpiexit/-99999/

      jbuf = inpiexit
      jrec = jrec + 1
      if(jrec.gt.jump)goto 430
      jbuf=0
      n = inumb(jrec)
      ifact = 1
      ist=istrt(jrec)
      nstrt = ist + n - 1
      do i = 1,n
         itemp = ia(nstrt)
         do j=1,14
            if(ichar(j).eq.itemp) goto 45
         enddo
 44      write(iout6,*) 'Error detected in inpi'
         stop 'inpi'

 45      if(j.lt.11)goto 47
         if(nstrt.ne.ist)goto 44
         if(j.ge.14)jbuf=-jbuf
         goto 430
 47      jbuf=jbuf+(j-1)*ifact
         ifact = ifact * 10
         nstrt=nstrt-1
      enddo

430   return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### asympti ###
c
      subroutine asympti (pot,excp)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*),excp(*)

c     determine values of Coulomb potential in the asymptotic region
c     from the multipole expansion
c
      do iorb=1,norb
         if (itouch(iorb).eq.1) then	
	    ibeg=i2b(iorb)
            if (idbg(301).eq.0) then
               call zmulti(iorb,pot(ibeg))
            else
               call zmultii(iorb,pot(ibeg))
            endif
         endif	    
      enddo 	

c     determine values of exchange potentials in the asymptotic region 
c     from multipole expansion

      do iorb1=1,norb
         do iorb2=iorb1,norb

            if (itouch(iorb1).eq.0.and.itouch(iorb2).eq.0) goto 10
            if (iorb1.eq.iorb2.and.mgx(6,iorb1).eq.0 ) goto 10
            if ((iorb1.eq.iorb2).and.(ilc(iorb1*(iorb1+1)/2).lt.1)) 
     &           goto 10

c           orbitals in increasing order

            ipc=iorb1+iorb2*(iorb2-1)/2
            iax=i3b(ipc)

            idel=abs(mgx(6,iorb1)-mgx(6,iorb2))
            if (iorb1.eq.iorb2) idel=2*mgx(6,iorb1)

            ido=0
 1234       ido=ido+1
            if (ido.eq.2) then
               idel=mgx(6,iorb2)+mgx(6,iorb1)
               ipc=ipc+norb*(norb+1)/2
               iax=iax+i3si(ipc)
            endif

            if (idbg(301).eq.0) then
               call zasyx1  (idel,ipc,excp(iax))
            else
               call zasyxi  (idel,ipc,excp(iax))
            endif

            if (ilc(ipc).eq.2.and.ido.eq.1) go to 1234
 10         continue
         enddo
      enddo
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inifun ###
c
c     Initializes orbitals and potentials.
c
      subroutine inifun (cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),
     & 		cw_suppl(*),cw_sctch(*)

c     zeroizing arrays explicitly

      do i=1,length1
         cw_orb(i)=0.d0
      end do

      do i=1,length2
         cw_coul(i)=0.d0
      end do

      do i=1,length3
         cw_exch(i)=0.d0
      end do

      if (ini.eq.1) then

c        to initialize properly functions and orbital energies in the case of
c        the HFS calculations islat (which is nonzero) parameter has to be kept 
c        zero before the program reaches the scf routine.

         if (islat.ne.0) islat=0
         call inihyd (cw_orb,cw_coul,cw_exch,
     &        cw_suppl(i4b(7)),cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &        cw_sctch(i5b(1)))
         idump=1
      elseif (ini.eq.2) then

c  initial values of orbitals are provided by the GAUSSIAN92 program

         write(*,*) 'Initializing orbitals using GAUSSIAN94 output'
         call prepg94
         call inigauss(cw_orb,cw_coul,cw_exch,
     &        cw_suppl(i4b(7)),cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &        cw_sctch(i5b(1)))
         idump=1
      elseif (ini.eq.3) then

         write(*,*) 'Initializing orbitals using GAUSSIAN94 long output'
         call prepg94l
         call inigauss(cw_orb,cw_coul,cw_exch,
     &        cw_suppl(i4b(7)),cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &        cw_sctch(i5b(1)))
         idump=1
         
      elseif (ini.eq.4) then
         idump=0
         call rfdisk (cw_orb,cw_coul,cw_exch,cw_sctch(i5b(1)))

c        To generate a higher lying one-electron diatomic state all the lower
c        ones have to be retrieved from disk file and kept for the sake of 
c        the orthogonalization.
c        The current highest orbital is being initialized as a linear combination 
c        of hyfrogenic atomic orbitals.
c        When the incomplete orbital disk file is encountered the values of ini 
c        is changed from 5 to 4.
         
         call inihyd (cw_orb,cw_coul,cw_exch,
     &        cw_suppl(i4b(7)),cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &        cw_sctch(i5b(1)))
         idump=1

      elseif (ini.eq.5) then
c        see ini=4
         idump=0
         call rfdisk (cw_orb,cw_coul,cw_exch,cw_sctch(i5b(1)))

         if (ini.eq.4) then
            call inihyd (cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b(7)),cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b(1)))
            idump=1
         endif
      elseif (ini.eq.6) then
         idump=0
         call rfdisk (cw_orb,cw_coul,cw_exch,cw_sctch(i5b(1)))
         print *,'... initializing exchange potentials ...'
	 call tfpot(cw_orb,cw_coul,cw_exch,
     &        cw_suppl(i4b(7)),cw_suppl(i4b(9)),
     &        cw_sctch(i5b(1)))
      endif
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### slaterp ###
c
c     Calculates the exchange potentials as the local Slater approximation
c
      subroutine slaterp(psi,pot,excp,f2,f4,wk0)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'	

      dimension psi(*),pot(*),excp(*),f2(*),f4(*),wk0(*)

c     sl1=3/pi   sl2=1./3.
c     sl1=3/(8pi)   sl2=1./3.
      if (nel.eq.1) return

      do i=1,mxsize
         wk0(i)=0.d0
      enddo	

c     contributions from the local slater exchange

      do iorb1=1,norb
         iborb1=i1b(iorb1)	   	 
         ngorb1=i1si(iorb1)	 	 
         coo=occ(iorb1)
         do i=1,ngorb1
            wk0(i)=wk0(i)+coo*psi(iborb1+i-1)*psi(iborb1+i-1)
         enddo
      enddo


c     multiply the exch. pot. by f4 to make it commensurate with
c     the coulomb pot.

      third=1.d0/3.d0
      xa=-3.d0/2.d0*alphaf*(3.d0/pii/(2.d0*pii))**third
      do i=1,mxsize
         wk0(i)=xa*(wk0(i))**third*f4(i)
      enddo		

c     store the local exchange pot. in excp array

      call dcopy (mxsize,wk0,1,excp(1),1)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### homo_det ###
c
c     Determines Ci symmetry of a given orbital and uses it to replace
c     the values in the [pi/2,pi] region by these from the [0,pi/2] one. 
c
      subroutine homo_det (n2,nmut,psii,ihsym)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psii(nni,nmut)

      if (idbg(99).ne.0) then
c        check symmetry and impose the symmetry
         if (psii(2,10)*psii(nni-1,10).gt.0.d0) then
            do ni=1,n2-1
               do mi=1,nmut
                  psii(nni+1-ni,mi)= psii(ni,mi)
               enddo
            enddo
            ihsym= 1
         else
            do ni=1,n2-1
               do mi=1,nmut
                  psii(nni+1-ni,mi)=-psii(ni,mi)
               enddo
            enddo
c           
            do mi=1,nmut
               psii(n2,mi)=0.d0
            enddo
            ihsym=-1
         endif
      else
c        set symmetry according to input data
         if (ihsym.eq.1) then
            do ni=1,n2-1
               do mi=1,nmut
                  psii(nni+1-ni,mi)= psii(ni,mi)
               enddo
            enddo
         else
            do ni=1,n2-1
               do mi=1,nmut
                  psii(nni+1-ni,mi)=-psii(ni,mi)
               enddo
            enddo
            do mi=1,nmut
               psii(n2,mi)=0.d0
            enddo   
         endif
      endif
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### focksl ###
c
c     Calculates the exchange potentials as the local Slater approximation.
c
      subroutine focksl(iorb,psi,pot,excp,e,f0,f1,f2,f4,wk0,wk1,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'	
      dimension psi(*),pot(*),excp(*),e(*),f0(*),f1(*),f2(*),f4(*),
     &	    wk0(*),wk1(*),wk2(*)	

      iborb=i1b(iorb)
      ngorb=i1si(iorb)
      ibpot=i2b(iorb)
      ngpot=i2si(iorb)	
      norb2=norb*norb			

      if (idbg(97).ne.0) then
         write(*,*) 'iorb,iborb,ngorb,ibpot,ngpot'
         write(*,*)  iorb,iborb,ngorb,ibpot,ngpot
      endif

      ipe=mgx(6,iorb)
      ipex=ipe-2*(ipe/2)
      
      if (ipe.eq.0) then
	 call dcopy (mxsize,f0,1,wk0,1)
	 call daxpy (mxsize,eng(iorb),f1,1,wk0,1)
      else

c        e enter the expression with minus sign which is already
c        incorporated in e

         w=dble(ipe*ipe)
         call dcopy (mxsize,f0,1,wk0,1)
         call daxpy (mxsize,eng(iorb),f1,1,wk0,1)
         call daxpy (mxsize,w,e,1,wk0,1)
      endif

      if(idbg(97).ne.0) then
         write(*,*) 'eng(iorb)',eng(iorb)
         write(*,*) 'focksl: f0'
         call pmtx (nni,nmu(1),f0,1,1,incrni,incrmu)
         write(*,*) 'focksl: f1'
         call pmtx (nni,nmu(1),f1,1,1,incrni,incrmu)
         write(*,*) 'focksl: f2'
         call pmtx (nni,nmu(1),f2,1,1,incrni,incrmu)
         write(*,*) 'focksl: f4'
         call pmtx (nni,nmu(1),f4,1,1,incrni,incrmu)
         write(*,*) 'fock: wk0'
         call pmtx (nni,nmu(1),wk0,1,1,incrni,incrmu)
      endif

      do i=1,mxsize
         wk1 (i)=0.d0
         wk2 (i)=0.d0
         foc2(i)=0.d0
         excp(i)=0.d0
      enddo	

      if (nel.gt.1) then
         if (norb.eq.1) then

c     contribution from coulomb potential of one sigma orbital

c     24/04/01  
c     Valentin Karasiev spotted and fixed an error in handling 
c     two-electron cases (for a single orbital systems)
c           call dcopy (ngpot,pot(ibpot),1,wk1,1)
c     12/12/02 jkob added
c           call prod (mxsize,f2,wk1)
c     in order to treat systems like LiH+2 properly
      
            oc=occ(iorb)
            call daxpy (ngpot,oc,pot(ibpot),1,wk1,1)
            call prod (mxsize,f2,wk1)
         else
            
c           add contributions from coulomb and off-diagonal lagrange mult.

            do iorb1=1,norb
               iborb1=i1b(iorb1)	   	 
               ngorb1=i1si(iorb1)	 
               ibpot1=i2b(iorb1)
               ngpot1=i2si(iorb1)

               ideng=iorb1+norb*(iorb-1)
               coo=occ(iorb1)
               
c              in the local exchange approx. the coulomb potential includes
c              also the contribution from the orbital

               if (idbg(95).ne.0) then
                  write(*,*) 'focksl: iorb1,ibpot1,coo',iorb1,ibpot1,coo
               endif
               call daxpy (ngpot1,coo,pot(ibpot1),1,wk1,1)

               if (iorb.ne.iorb1.and.engo(ideng).ne.0.d0) then
                  do i=1,ngorb1
                     foc2(i)=foc2(i)+engo(ideng)*f4(i)*psi(iborb1+i-1)
                  enddo		
               endif
            enddo

c        contributions from the local slater exchange

            do iorb1=1,norb
               iborb1=i1b(iorb1)	   	 
               ngorb1=i1si(iorb1)	 	 
               coo=occ(iorb1)
               do i=1,ngorb1
                  wk2(i)=wk2(i)+coo*psi(iborb1+i-1)*psi(iborb1+i-1)
               enddo
            enddo

c           multiply the exchange potentia by f4 to make it commensurate 
c           with the coulomb potntial

            do i=1,mxsize
               wk2(i)=-3.d0/2.d0*alphaf
     &                *(3.d0/pii*wk2(i))**(1.d0/3.d0)*f4(i)
            enddo		
            
            if(idbg(97).ne.0) then
               write(*,*) 'vfock: alphaf,sl1,sl2 ',alphaf,sl1,sl2
               write(*,*) 'nni,nmu,incrni,incrmu',
     &              nni,nmu(1),incrni,incrmu
               write(*,*) 'vfock: slater potential'
               call pmtx (nni,nmu(1),wk2,1,1,incrni,incrmu)
               
               write(*,*) 'focksl: coulomb potential'
               call pmtx (nni,nmu(1),wk1,1,1,incrni,incrmu)
               
               write(*,*) 'focksl: one-electron contr.'
               call pmtx (nni,nmu(1),wk0,1,1,incrni,incrmu)
            endif
            
c           store the local exchange pot. in excp array
            
            call dcopy (ngorb1,wk2,1,excp(1),1)
            
c           add the local exchange to the coulomb potential
            
            call add (mxsize,wk2,wk1)
            
c           multiply coulomb/exchange potentials and off-diagonal Lagrange
c           multipliers by f2
         
            call prod (mxsize,f2,wk1)
            call prod (mxsize,f2,foc2)
         endif
c        nel.gt.1 
      endif

c     add one electron and coulomb pot. contributions

      call add (mxsize,wk0,wk1)
      call dcopy (mxsize,wk1,1,foc1,1)

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### reada ###	
c
c     Reads the matrix A from a disk file in an unformatted form
c
      subroutine reada (iunit,ndim,a,ierr)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)	
      dimension a(ndim)

      read (iunit,err=1000) a
      ierr=0
      return
      
 1000 ierr=1
      return
      end      

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### factor2 ###
c
c     Calculates n!!
c
      function factor2(n)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)		

      factor2=1.d0
      do i=1,n,2
         factor2=dble(i)*factor2
      enddo	

      return
      end

********************************************************************************
*                                                                              *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rayl ###  
c
c     Solves the eigenvalue to the schroedinger equation as e = <w(i)/h/w(j)>

      subroutine rayl(iorb,psi,pot,excp,e,f0,wgt1,wgt2,
     &			wk0,wk1,wk2,wk3)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),e(*),f0(*),wgt1(*),wgt2(*),
     &     wk0(*),wk1(*),wk2(*),wk3(*)

c  Slater exchange approximation is used	

      if (islat.ne.0) then
         call raylsl (iorb,psi,pot,excp,e,f0,wgt1,wgt2,wk0,wk1,wk2,wk3)
         return
      endif

      wtwoel=0.d0
      
      i1beg=i1b(iorb)
      i2beg=i2b(iorb)	
      nmut=i1mu(iorb)
      ngorb=i1si(iorb)
      ngpot=i2si(iorb)	

      if (ngorb.ne.ngpot) then
         write(*,*) 'Orbitals and corresponding Coulomb potentials ',
     &        'have to be defined on the same number of grid points'
         stop 'raylsl'
      endif

      isd=iorb+(iorb-1)*norb
      engo(isd)=0.0d0
      ipe=mgx(6,iorb)
      ipex=ipe-2*(ipe/2)

c     calculate derivatives over mu and ni 

      if (ipex.eq.0) then
         isym= 1
      else
         isym=-1
      endif

      call fill (nni,nmut,isym,psi(i1beg),wk3)
      call difni (nmut,wk3,wk0,wk1,wk2)
      call refill(nni,nmut,wk1,wk0)

      call difmu (nmut,wk3,wk2)
      call refill(nni,nmut,wk0,wk2)

c     add contribution from derivatives over mu and ni

      call add (ngorb,wk0,wk1)

      if (idbg(70).ne.0) then
         call dcopy (ngorb,wk1,1,wk2,1)
         call prod  (ngorb,psi(i1beg),wk2)
         w=ddot(ngorb,wgt1,1,wk2,1)
c         write(*,'(i6,2d22.14)') ngorb,wk1(ngorb),wgt1(ngorb)
         write(*,'(" rayl: kinetic energy ",d22.14)') w
      endif
      
      if (ipe.eq.0) then
         call dcopy (ngorb,f0,1,wk0,1)
      else
         
c        e enters the expression with minus sign which is already 
c        incorporated in e

         w=dble(ipe*ipe)
         call dcopy (ngorb,f0,1,wk0,1)
         call daxpy (ngorb,w,e,1,wk0,1)
      endif

      if (idbg(70).ne.0) then
         call prod2 (ngorb,psi(i1beg),wk0,wk2)
         call prod  (ngorb,psi(i1beg),wk2)
         w=ddot(ngorb,wgt1,1,wk2,1)
c        nuclear energy for non-sigma orbitals contains contribution from e term
c        (in toten this term is correctly added to the kinetic energy contribution)
         write(*,*) ' rayl: nuclear energy ',w
      endif

      call proda (ngorb,psi(i1beg),wk0,wk1)
      call prod (ngorb,psi(i1beg),wk1)
      
      woneel=ddot(ngorb,wgt1,1,wk1,1)
      
      if(idbg(96).ne.0) then
         write(*,*) 'woneel', woneel
         write(*,*) 'rayl: wk0'
         call pmtx (nni,nmu(1),wk0,1,1,incrni,incrmu)
         write(*,*) 'rayl: wk1'
         call pmtx (nni,nmu(1),wk1,1,1,incrni,incrmu)
      endif

      if (nel.gt.1) then
         do i=1,mxsize
            wk2(i)=0.d0
         enddo
         
         if (norb.eq.1) then
            
c           contribution from coulomb potential of one sigma orbital
 
c           14/12/02
c	    call dcopy (ngpot,pot(i2beg),1,wk2,1)
            oc=occ(norb)
            call daxpy (ngpot,oc,pot(i2beg),1,wk2,1)
	    call prod  (ngorb,psi(i1beg),wk2)
         else

c           add contributions from coulomb and exchange potentials

	    do iorb1=1,norb

c              it is asumed that exchange potentials involving iorb1 
c              has already been retrieved from disk

               i1beg1=i1b(iorb1)
               i2beg1=i2b(iorb1)
               ngorb1=i1si(iorb1)		
               ngpot1=i2si(iorb1)
               oc=occ(iorb1)				
               kex=iorb+norb*(iorb1-1)
               
               if (iorb.le.iorb1) then
		  ihc=iorb+iorb1*(iorb1-1)/2
               else
		  ihc=iorb1+iorb*(iorb-1)/2
               endif
               
               i3beg=i3b(ihc)
               ngex =i3si(ihc)
               ngrid=min(ngorb,ngpot1)		
               do i=1,mxsize
	          wk0(i)=0.d0
               enddo	    

               call dcopy (ngpot1,pot(i2beg1),1,wk0,1)
               call prod  (ngrid,psi(i1beg),wk0)
               
               if (iorb.eq.iorb1) oc=oc-1.d0
               if (oc.ne.1.d0) then
		  call dscal (ngrid,oc,wk0,1)
               endif
               
               if (iorb1.ne.iorb)  then
                  ngrid2=min(ngorb1,ngex,ngorb)		
		  oc=gec(kex)
		  call prodas (ngrid2,-oc,psi(i1beg1),excp(i3beg),wk0)
		  if (ilc(ihc).gt.1) then
                     oc=gec(kex+norb*norb)
                     call prodas (ngrid2,-oc,psi(i1beg1),
     &                    excp(i3beg+ngex),wk0)
		  endif
               else
		  if ((ipe.gt.0).and.(ilc(ihc).gt.0)) then
                     ngrid2=min(ngorb1,ngex,ngorb)		
                     oc=gec(kex)
                     call prodas(ngrid2,-oc,psi(i1beg1),excp(i3beg),wk0)
		  endif
               endif

               if (iorb1.eq.1) then
		  call dcopy (ngrid,wk0,1,wk2,1)
               else
		  call add   (ngrid,wk0,wk2)
               endif
	    enddo
         endif

c        to complete the integrand wk2 has to be multiplied by psi(i1beg)

         call prod (ngorb,psi(i1beg),wk2)
         wtwoel=ddot(ngorb,wgt2,1,wk2,1)
      endif	  	  

      engo(isd) = woneel+wtwoel
      eng(iorb) = engo(isd)

      if(idbg(95).ne.0) then
         write(*,'(i6,3d22.14)') 'iorb,woneel,wtwoel', iorb,woneel,wtwoel
      endif

      if(idbg(96).ne.0) then
         write(*,*) 'wtwoel', wtwoel
         write(*,*) 'rayl: wk0'
         call pmtx (nni,nmu(1),wk0,1,1,incrni,incrmu)
         write(*,*) 'rayl: wk2'
         call pmtx (nni,nmu(1),wk2,1,1,incrni,incrmu)
      endif
      
      if (idbg(70).ne.0) then
         write(*,'("rayl: woneel, wtwoel, eng ",3d22.14)') 
     &        woneel,wtwoel,eng(iorb)
      endif
      
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zz1g ###
c 
c     Evaluate the nuclear potential for Gaussian models.  
c                                                                
      function zz1g(i,j)
      implicit integer*4 (i-n)
      implicit real*8 (A-H, O-Z)
      include 'commons8.inc'
c     ainfcm: bohr radius in cm
      data ainfcm/0.529 177 249  d-08/

      fmtoau=1.0d-13/ainfcm

      if (z1.eq.0.d0) then
         zz1g=0.d0
         eta1=1d35
         return
      endif
      
c     set atomic weight 
      
      atw=z1atmass
      at3=atw**(one/three)
      rrmsfm = 0.836d 00*at3+0.570d 00
      
c     change units from fm into bohr
      
      rrms = rrmsfm*fmtoau
c
c     exponent of the Gaussian distribution $\rho_0 exp(-\eta r^2)$
c     rrms=(3/(2\eta)^{1/2)
      
      eta1=3d0/(2d0*rrms*rrms)

      ri = r*(vxi(i)+veta(j))/2.d0

c     set the normalization constant $Z=rho_0 (pi/eta)^{3/2}$

c     rho0=z1/(pii/eta1)**1.5d0  
c     x=eta1*ri*ri
c     dg15= dgamit(1.5d0,x)*x**1.5d0*dgamma(1.5d0)
c     zz1g = 2.0d0*pii*rho0*(dg15/eta1**1.5d0+ri*exp(-x)/eta1)
c
c     making use of F77 intrinsic function 
c     erf(x)=2/(Pi)^(1/2)*int_)^x exp(-t^2)dt
c     if available
c
      zz1g=z1*erf(sqrt(eta1)*ri)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inaorb ###
c
c     Initializes array aorb which is used by asyorb to calculate
c     boundary values of a given orbital at the practical infinity.
c
      subroutine inaorb (nmi,aorb,aorb1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension aorb(nni,4),aorb1(*)

      jj=0
      do j=nmi-3,nmi
         jj=jj+1
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
c           see mulex	    
            raiq1=sqrt(vxisq(j-1)+vetasq(i)-1.d0)
            raiq =sqrt(vxisq(j)+vetasq(i)-1.d0)

            if (idbg(101).ne.0) then 
               raiq1=sqrt(vxi1(j-1)*vxi1(j-1)-veta1(i)*veta1(i)+1.d0)
               raiq =sqrt(vxi1(j)*vxi1(j)-veta1(i)*veta1(i)+1.d0)
            endif
	    aorb(i,jj)=(abs(aorb1(kk-nni)/aorb1(kk)))**0.25d0
     &           *exp(sqrt(abs(aorb1(kk-nni)))*(raiq1-raiq))
         enddo
      enddo
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### wtdexch ###
c
c     Writes exchange potentials involving orbital iorb as separate files 
c
      subroutine wtdexch (iorb1,excp)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension excp(*)

      do iorb2=1,i3nexcp(iorb1)
         k=i3breck(iorb1,iorb2)
         itemp=iwexch(k)
         if (iwexch(k).ne.0) then
            if (iwexch(k).eq.-1) iwexch(k)= 0
            if (iwexch(k).eq.-2) iwexch(k)=-1
            i3beg=i3brec(iorb1,iorb2)
            irec=i3xpair(iorb1,iorb2)
            ngrid=i3si(k) 
            call wrec(irec,ngrid,excp(i3beg))
         endif
      enddo

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### sor ###
c
c     Performs one iteration of the sor process applied to
c     the equation (diagonal part of the differentiation operator, i.e.
c     the coefficient multiplying fun(ni,mi) is included in lhs array)
c
c    { d2(mi) + b(mi)*d1(mi) + d2(ni) + d(ni)*d1(ni)
c		      + lhs(ni,mi) } fun(ni,mi) = rhs(ni,mi)
c
c     warning! this routine uses mesh defined by mesh
c
      subroutine sor (fun,lhs,rhs,b,d,
     &     indx1,indx2,indx6a,indx6b,indx7)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      real*8	lhs
      include 'commons8.inc'
      
      dimension fun(*),lhs(*),rhs(*),b(*),d(*),
     &     indx1(*),indx2(*),indx6a(*),indx6b(*),indx7(*)	

c     indx1 (indx2) array elements point to the particular (consequtive)
c     element of fun (lhs, rhs, b and d) to be relaxed

c     first relax the inner points- region i (formula a1)
      
c     ipoiss=1 - approximately 20 mflops (Cray XMP)

      do i=1,ngrd1
         ij=indx1(i)
         ik=indx2(i)

         ddmi2=dmu2t(1) * ( fun(ij-nni4) + fun(ij+nni4) )+
     &        dmu2t(2) * ( fun(ij-nni3) + fun(ij+nni3) )+
     &        dmu2t(3) * ( fun(ij-nni2) + fun(ij+nni2) )+
     &        dmu2t(4) * ( fun(ij-nni1) + fun(ij+nni1) )
        
         ddmi1=dmu1t(1) * ( fun(ij-nni4) - fun(ij+nni4) )+
     &        dmu1t(2) * ( fun(ij-nni3) - fun(ij+nni3) )+
     &        dmu1t(3) * ( fun(ij-nni2) - fun(ij+nni2) )+
     &        dmu1t(4) * ( fun(ij-nni1) - fun(ij+nni1) )

         ddni2=dni2(1) * ( fun(ij-   4) + fun(ij+   4) )+
     &        dni2(2) * ( fun(ij-   3) + fun(ij+   3) )+
     &        dni2(3) * ( fun(ij-   2) + fun(ij+   2) )+
     &        dni2(4) * ( fun(ij-   1) + fun(ij+   1) )

         ddni1=dni1(1) * ( fun(ij-   4) - fun(ij+   4) )+
     &        dni1(2) * ( fun(ij-   3) - fun(ij+   3) )+
     &        dni1(3) * ( fun(ij-   2) - fun(ij+   2) )+
     &        dni1(4) * ( fun(ij-   1) - fun(ij+   1) )

         cc=ddmi2 + b(ik)*ddmi1 + ddni2 + d(ik)*ddni1
         fun(ij) = omega * (rhs(ik)-cc)/lhs(ik)+ omega1 * fun(ij)
      enddo

c     determine values at the bondary points from extrapolation
      
      if (isym.eq.1) then
         if (ifill.eq.1.or.ifill.eq.2) then
            do i=1,ngrd7
               ij=indx7(i)
               fun(ij)=exeven(1)*fun(ij+nni1)+exeven(2)*fun(ij+nni2)+
     &              exeven(3)*fun(ij+nni3)+exeven(4)*fun(ij+nni4)+
     &              exeven(5)*fun(ij+nni5)
            enddo
         endif     

         do i=1,ngrd6a
            ij=indx6a(i)
            fun(ij)=exeven(1)*fun(ij+1)+exeven(2)*fun(ij+2)+
     &           exeven(3)*fun(ij+3)+exeven(4)*fun(ij+4)+
     &           exeven(5)*fun(ij+5)
         enddo

         do i=1,ngrd6b
            ij=indx6b(i)
            fun(ij)=exeven(1)*fun(ij-1)+exeven(2)*fun(ij-2)+
     &           exeven(3)*fun(ij-3)+exeven(4)*fun(ij-4)+
     &           exeven(5)*fun(ij-5)
         enddo
      else
         if (ifill.eq.1.or.ifill.eq.2) then
            do i=1,ngrd7
               ij=indx7(i)
               fun(ij)=0.d0
            enddo
         endif
        
         do i=1,ngrd6a
            ij=indx6a(i)
            fun(ij)=0.d0
         enddo

         do i=1,ngrd6b
            ij=indx6b(i)
            fun(ij)=0.d0
         enddo
      endif

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### dointerp ###	
c
c	Performs interpolations of orbitals and potentials between grids. 
c       Orbitals and potentials are treated separately.
c
c work array is not needed any more

      subroutine dointerp (ic,nmuall_p,nmuall,fbefore,fafter) 
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)	
      real*8 vmuq
      include 'commons8.inc'
      include 'commons16.inc'
      dimension fbefore(nni_p,*),fafter(nni,*)

c  The previous grid containes nni_p point in \nu (\eta) direction and
c  nmuall_pt point in \mu (\xi) direction

      if ((nmuall.ne.nmuall_p.or.
     &     ngrids.ne.ngrids_p.or.
     &     rinf.ne.rinf_p).and.nni.eq.nni_p) then

c  prepare data for routines evaluating coefficients of the Lagrange
c  polynomial

         if (ic.eq.1) then

c  Interpolate in mu variable      

c  Interpolation of orbitals is done separately in two regions in mu 
c  variable. The inner region extends from mu=1 to the last maximum
c  and the outer (tail) region extends from that maximum to the practical 
c  infinity. The values in the latter are logarithmed before 
c  the interpolation is carried out.

c  Find the tail region: the maximum is sought along the line which is 
c  almost perpendicular to the intermolecular axis (to avoid picking up
c  zeros for ungerade orbitals)

c  The above scheme turned out to be unnecessary

            iord=iord_mu_orb
            kbeg=1
            kend=iord
            iord2=iord/2
            do imu=1,nmuall_p
               vmuq(imu)=vmu_p(imu)
            enddo
            
            nall_p=nmuall_p
            nall  =nmuall
            nstart_p  =1
            nstart    =1
            call dointerp_mu (nni_p,nstart_p,nall_p,nstart,nall,
     &           fbefore,fafter) 

         elseif (ic.eq.2) then
            iord=iord_mu_coul
            kbeg=1
            kend=iord
            iord2=iord/2
            do imu=1,nmuall_p
               vmuq(imu)=vmu_p(imu)
            enddo
            
            ninner_p=1
            ninner  =1
            nall_p=nmuall_p
            nall  =nmuall
            call dointerp_mu (nni_p,ninner_p,nall_p,ninner,nall,
     &           fbefore,fafter) 

         elseif (ic.eq.3) then
            iord=iord_mu_exch
            kbeg=1
            kend=iord
            iord2=iord/2
            do imu=1,nmuall_p
               vmuq(imu)=vmu_p(imu)
            enddo

            ninner_p=1
            ninner  =1
            nall_p=nmuall_p
            nall  =nmuall
            call dointerp_mu (nni_p,ninner_p,nall_p,ninner,nall,
     &           fbefore,fafter) 
         endif

c        Extrapolation (needed when R_infy is being increased seems to 
c        cause degradation of accuracy. That is why these values are 
c        taken equal (for each nu) to those corresponding to nmuall_p, 
c        i.e tp the values of the last column of fbefore

         imu_bext=nmuall
         do imu=1,nmuall
            if (vmu(imu).ge.vmu_p(nmuall_p)) then
               imu_bext=imu
               goto 1234
            endif
         enddo
01234    continue
         do in=1,nni_p
            do im=imu_bext,nmuall
               fafter(in,im)=fbefore(in,nmuall_p)
            enddo
         enddo
         
      elseif (nni.ne.nni_p.and.
     &        (nmuall.eq.nmuall_p.and.
     &	           ngrids.eq.ngrids_p.and.rinf.eq.rinf_p)) then

c        interpolate in nu variable      

         if (nni_p.gt.mxnmu) then
            print *,"dointerp: error! array vmuq is too short"
            stop
         endif

         do i=1,nni_p
            vmuq(i)=vni_p(i)
         enddo

         if (ic.eq.1) then
            iord=iord_nu_orb
            kbeg=1
            kend=iord
            iord2=iord/2
c            stop "dointerp: error check array dimension"
            call dointerp_nu (nmuall_p,fbefore,fafter) 
         elseif (ic.eq.2) then
            iord=iord_nu_coul
            kbeg=1
            kend=iord
            iord2=iord/2
            call dointerp_nu (nmuall_p,fbefore,fafter) 
         elseif (ic.eq.3) then
            iord=iord_nu_exch
            kbeg=1
            kend=iord
            iord2=iord/2
            call dointerp_nu (nmuall_p,fbefore,fafter) 
         endif
      else
         write(*,'(/,1x,"dointerp: error! cannot perform interpolation")')
	 stop "dointerp"   
      endif
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rayln ###
c 
c     Evaluates the off-diagonal Lagrange multiplier e(iorb2,iorb1)
c
      subroutine rayln(iorb1,iorb2,psi,pot,excp,wgt2,wk0,wk1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),wgt2(*),wk0(*),wk1(*)

c     the Slater exchange approximation is used

      if (islat.ne.0) then
         call raynsl(iorb1,iorb2,psi,pot,excp,wgt2,wk0,wk1)
         return
      endif

      if (mgx(6,iorb1).ne.mgx(6,iorb2)) return
      if (ige(iorb1).ne.ige(iorb2)) return

      isd=iorb1+(iorb2-1)*norb
      ipe=mgx(6,iorb2)
      engo(isd)=0.d0
      i1beg1=i1b(iorb1)
      i1beg2=i1b(iorb2)
      ngorb1=i1si(iorb1)
      ngpot1=i2si(iorb1)	

      ngorb2=i1si(iorb2)     
      ngpot2=i2si(iorb2)	

      norb2=norb*norb

c     add contributions from coulomb and exchange potentials

      do iorb=1,norb
         i1beg=i1b(iorb)
         ngorb=i1si(iorb)		
         ngpot=i2si(iorb)
         
         kex=iorb2+norb*(iorb-1)
         hh2=1.d0

         if (iorb2.le.iorb) then
            ihc=iorb2+iorb*(iorb-1)/2
         else
            ihc=iorb+iorb2*(iorb2-1)/2
         endif

         i2beg=i2b(iorb)
         i3beg=i3b(ihc)
         ngex =i3si(ihc)
         
         ngrid=min(ngorb2,ngpot)		
         do i=1,mxsize
            wk0(i)=0.d0
         enddo	    

         coo=occ(iorb)
         if (iorb2.eq.iorb) coo=coo-1.d0
         
         call dcopy (ngrid,pot(i2beg),1,wk0,1)
         call prod  (ngrid,psi(i1beg2),wk0)

         if (coo.ne.1.d0) then
            call dscal (ngrid,coo,wk0,1)
         endif

         ngrid2=min(ngorb2,ngex,ngorb)		
         if (iorb.ne.iorb2)  then
            coo=hh2*gec(kex)
            call prodas (ngrid2,-coo,psi(i1beg),excp(i3beg),wk0)
            if (ilc(ihc).gt.1) then
               coo=hh2*gec(kex+norb*norb)
               call prodas (ngrid2,-coo,psi(i1beg),
     &              excp(i3beg+i3si(ihc)),wk0)
            endif
         else
            if ((ipe.gt.0).and.(ilc(ihc).gt.0)) then
               coo=hh2*gec(kex)
               call prodas (ngrid2,-coo,psi(i1beg),excp(i3beg),wk0)
            endif
         endif
       
         if (iorb.eq.1) then
            call dcopy (ngrid,wk0,1,wk1,1)
         else
            call add   (ngrid,wk0,wk1)
         endif
      enddo
      
c     to complete the integrand wk1 has to be multiplied by psi(i1beg1)

      call prod (ngrid,psi(i1beg1),wk1)
      wtwoel=ddot(ngrid,wgt2,1,wk1,1)
      
      engo(isd)= wtwoel
      
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### factor ###
c
c     Calculates the factorial of n.
c
      function factor(n)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)		

      factor=1.d0
      if (n.eq.0) return
      do i=1,n
         factor=dble(i)*factor
      enddo	
     
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### mesh ###
c
c     Initializes index arrays determining the ordering of mesh points 
c     during sor process
c    
c     type of ordering (itype==iorder):
c     itype=1 -- natural column-wise 
c     itype=2 -- middle
c     itype=3 -- natural row-wise 
c     itype=4 -- reverse row-wise

      subroutine mesh(imcase,ig,indx1,indx2,indx6a,indx6b,indx7)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension indx1(*),indx2(*),indx6a(*),indx6b(*),indx7(*)

c   initialize variables needed in sor and mcsor

      nni1=nni+8
      nni2=nni1+nni1
      nni3=nni2+nni1
      nni4=nni3+nni1
      nni5=nni4+nni1

      nni8=nni+8
      nmut=nmu(ig)
      nmu8=nmut+8

      if (imcase.eq.1) then
         iend1=nmut
         iend2=nmut-4	  
      elseif (imcase.eq.2) then
         iend1=nmut+4
         iend2=nmut	  
      endif

      itype=iorder(ig)
      goto (100,200,300,400,500,600,700,800),itype

00100 continue

c     natural column-wise ordering. bondary points are excluded
c     the upper limit of mu variable is nmu.

c     ?  values for points (j,nmu+1), (j,nmu+2) and (j,nmu+3) are calculated
c     ?  from the asymptotic exspansion (the indexes refer to the larger
c     ?  grid, see routine fill and refill).
c
c     region i
c
c     in the case of more than one grids the upper limit in not nmut-4
c     but nmut

      ngrd1=0
      do i=6,iend1
         ii=(i-1)*nni8
         do j=6,nni+3
            ngrd1=ngrd1+1
c           ires2(j,i)=ngrd1
            indx1(ngrd1)=ii+j
         enddo
      enddo

      ngrd2=0
      do i=2,iend2
         ii=(i-1)*nni
         do j=2,nni-1
            ngrd2=ngrd2+1
c      ires1(j,i)=ngrd2
c      iresni(ngrd2)=j
c      iresmu(ngrd2)=i
            indx2(ngrd2)=ii+j
         enddo
      enddo

01000 continue

c     region vi
c     bondary values from extrapolation
c     values for points (j,nmut-3),...,(j,nmut) are calculated from
c     asymptotic expansion (orbitals) or multipole expansion (potentials)

      i0=0
      do i=5,iend1
         i0=i0+1
         indx6a(i0)=(i-1)*nni8+5
      enddo
      ngrd6a=i0

      i0=0
      do i=5,iend1
         i0=i0+1
         indx6b(i0)=(i-1)*nni8+nni+4
      enddo
      ngrd6b=i0

      i0=0
      do j=6,nni+3
         i0=i0+1
         indx7(i0)=4*nni8+j
      enddo
      ngrd7=i0

      if (imcase.eq.1) then
         ingr1(1,ig)=ngrd1
         ingr1(2,ig)=ngrd6a
         ingr1(3,ig)=ngrd6b
         ingr1(4,ig)=ngrd7	  	  	  
      elseif (imcase.eq.2) then	  
         ingr2(1,ig)=ngrd1
         ingr2(2,ig)=ngrd6a
         ingr2(3,ig)=ngrd6b
         ingr2(4,ig)=ngrd7	  	  	  
      endif	  	

      if (idbg(41).ne.0) then
         write(*,*) 'indx1 ',(indx1 (i),i=1,ngrd1)
         write(*,*) 'indx2 ',(indx2 (i),i=1,ngrd2)
         write(*,*) 'indx6a',(indx6a(i),i=1,ngrd6a)
         write(*,*) 'indx6b',(indx6b(i),i=1,ngrd6b)
         write(*,*) 'indx7 ',(indx7 (i),i=1,ngrd7 )
      endif

      if (idbg(42).ne.0) then
         write(*,*) 'ngrd1,ngrd2,ngrd6a,ngrd6b,ngrd7  ',
     &        ngrd1,ngrd2,ngrd6a,ngrd6b,ngrd7
      endif
      return

00200 continue

c     the following sequence of mesh points is a modification of
c     Laaksonen's "middle" type of sweeps

      i0=0
      nmux=(nmu8-1)/2
      nnix=(nni8-1)/2

      do i=6,iend1
         if (i.le.nmux) then
            ii=nmux-i+6
         else
            ii=i
         endif
         i2=ii-4

         do j=6,nni+3
            if(j.le.nnix) then
               jj=nnix-j+6
            else
               jj=j
            endif
            j2=jj-4

            i0=i0+1
            indx2(i0)=(i2-1)*nni  +j2
            indx1(i0)=(ii-1)*nni8 +jj
         enddo
      enddo

      ngrd1=i0
      ngrd2=i0

c     bondary points like in the itype=1 case

      goto 1000

00300 continue

c     natural row-wise ordering
      
c     region i

      ngrd1=0
      do j=6,nni+3
         do i=6,iend1
            ii=(i-1)*nni8
            ngrd1=ngrd1+1
            indx1(ngrd1)=ii+j
         enddo
      enddo

      ngrd2=0
      do j=2,nni-1
         do i=2,iend1-4
            ii=(i-1)*nni
            ngrd2=ngrd2+1
            indx2(ngrd2)=ii+j
         enddo
      enddo

c     bondary points like in the itype=1 case

      goto 1000

00400 continue

c     reverse  ordering: mi=nmut-4 sweep in ni variable, mi=nmut-5 followed
c     by another sweep in ni etc.. it should allow the bondary conditions
c     to propagate quicker into the solution.

c     region i

      ngrd1=0
      do j=nni+3,6,-1
         do i=iend1,6,-1
            ii=(i-1)*nni8
            ngrd1=ngrd1+1
            indx1(ngrd1)=ii+j
         enddo
      enddo

      ngrd2=0
      do j=nni-1,2,-1
         do i=iend1-4,2,-1
            ii=(i-1)*nni
            ngrd2=ngrd2+1
            indx2(ngrd2)=ii+j
         enddo
      enddo

c   bondary points like in the itype=1 case

      goto 1000

00500 continue
00600 continue
00700 continue
00800 continue
      write(*,*) 'undefined type of ordering'
      stop 'mesh'

      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prod2 ###
c
c     a vector times a vector: dr(i)=dx(i)*dy(i), i=1..n
c
      subroutine   prod2(n,dx,dy,dr)
      real*8	 dx(*),dy(*),dr(*)
      integer*4 i,n

      do i = 1,n
        dr(i) = dx(i) * dy(i)
      enddo

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zmultii ###	
c
      subroutine zmultii(ixa,pot)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*),dome(10)

c      do j=nmulast+1,mxnmu
      do j=mxnmu-3,mxnmu
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            rr=sqrt(vxisq(j)+vetasq(i)-1.d0)
            cost=veta(i)*vxi(j)/rr
            rr1=1.d0/(rr*r2)

            dome(1)=cost
            dome(2)=(3.d0*cost*cost-1.d0)*5.d-01
            do n=2,(impole-1)
               dome(n+1)=(dble(2*n+1)*cost*dome(n)-dble(n)*
     &              dome(n-1))/dble(n+1)
            enddo

            pe=0.d0
            do m=1,impole
               kxk=ixa+(m-1)*norb
               pe=pe+cmulti(kxk)*dome(m)*(rr1**dble(m+1))
            enddo 
            pot(kk)=r2*vxi(j)*(pe+rr1)	  
         enddo
      enddo
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prepwexch ###
c
c   Writes to disk exchange potentials involving orbital iorb.
c
      subroutine prepwexch
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

      do iorb1=1,norb
         do iorb2=iorb1,norb
            k=i3xk(iorb2,iorb1)
            if (k.ne.0) iwexch(k)=k
         enddo
      enddo

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### oshell ###
c
c     Calculates the weights of the two-electron contributions to the total 
c     energy expression for an open shell scf case.
c
      subroutine oshell
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*8 alpha,beta
      include 'commons8.inc'
      data alpha/'+'/, beta/'-'/

c !!! isum=norb

      do i=1,2*maxorb*maxorb
         gec(i)=0.d0
      enddo

      do i=1,4*norb
         spn(i)=spin(i)
      enddo

      do i=1,isum
         isumi=4*(i-1)
*        gec(i)=occ(i)-1.0
         iloop(i)=2
         iqm(1+isumi)=1
         iqm(2+isumi)=1
         if (mgx(3,i).gt.0) then
            iloop(i)=4
            iqm(3+isumi)=-1
            iqm(4+isumi)=-1
         endif
      enddo
      
c     initialize spn and spin arrays
c     throw out the electrons + = alpha and - = beta
c     the orbital is locked = 1 (open shell case)
c                           = 0 (close shell case) 
      
      do i=1,isum
         if (lock(i).eq.0) then
            jj=4*(i-1)
            spn(jj+1)=alpha
            spn(jj+2)=beta
            if (mgx(3,i).gt.0) then
               spn(jj+3)=alpha
               spn(jj+4)=beta
            endif
         endif
      enddo
      
      do i=1,4*isum
         spin(i)=spn(i)
      enddo
      
c     loop now through all electrons
      
      isu2=isum*isum
      do i=1,isum
         ixx=4*(i-1)
         div(i)=0.d0
         do ii=1,iloop(i)
            ix=ii+ixx
            if ((spn(ix).ne.alpha).and.(spn(ix).ne.beta)) goto 12
            div(i)=div(i)+1.d0
            
            do j=1,isum
               jxx=4*(j-1)
               kk=i+isum*(j-1)

               mpl=abs(mgx(3,i)-mgx(3,j))
               mmi=abs(mgx(3,i)+mgx(3,j))

               do jj=1,iloop(j)
                  jx=jxx+jj
                  if ((spn(jx).ne.alpha).and.(spn(jx).ne.beta)) goto 15
c                 div(i)=div(i)+1.0d0
                  
                  if ((mpl.eq.mmi).and.(spn(ix).eq.spn(jx)).
     &                 and.(i.ne.j)) then
                     gec(kk)=gec(kk)+1.d0
                  endif
                  
                  if ((mpl.ne.mmi).and.(spn(ix).eq.spn(jx))) then
                     if ((i.eq.j).and.(iqm(ix).ne.iqm(jx))) then
                        gec(kk)=gec(kk)+1.d0
                     endif

                     if ((i.ne.j).and.(iqm(ix).eq.iqm(jx))) then
                        gec(kk)=gec(kk)+1.d0
                     endif
                     
                     if ((i.ne.j).and.(iqm(ix).ne.iqm(jx))) then
                        gec(kk+isu2)=gec(kk+isu2)+1.d0
                     endif
                  endif
 15               continue
               enddo
            enddo
 12         continue
         enddo
         
         if (abs(div(i)).lt.1.d-06) goto 1000
         
         if (idbg(150).ne.0) then
            write(6,1101)
01101       format(2x,' i,idiv,gec(kk),gec(kk+isu2),div(i)')
         endif
         do idiv=1,isum
            kk=i+isum*(idiv-1)
            gec(kk)=gec(kk)/div(i)
            gec(kk+isu2)=gec(kk+isu2)/div(i)
            if (idbg(151).ne.0) then
               write(6,1102)  iorn(i),bond(i),gut(i),
     &              iorn(idiv),bond(idiv),gut(idiv),
     &              gec(kk),gec(kk+isu2),div(i)
01102          format(i4,1x,a8,a1,i4,1x,a8,a1,3f5.1)
            endif
         enddo
 10      continue
      enddo
            
      ial=0
      ibe=0
      imag=0
      do i=1,isum
         isumi=4*(i-1)
         if (lock(i).eq.0) goto 100

         do ii=1,iloop(i)
            imu=ii+isumi
            if (spn(imu).eq.alpha) ial=ial+1
            if (spn(imu).eq.beta) ibe=ibe+1
            if (spn(imu).eq.alpha.or.spn(imu).eq.beta) then
               imag=imag+iqm(imu)
            endif
 110        continue
         enddo
 100     continue
      enddo

c     loop over occupied shells
      
c     no distinction is made between close and open shell cases
c     as far as storage reservation is concerned.
c     count has been modified to cover the both cases.

      do j=1,(isum-1)
         do i=(j+1),isum
            icou(j,i)=0
            icou(i,j)=0

            if (mgx(6,j).ne.mgx(6,i)) goto 300
            if (gut(j).ne.gut(i)) goto 300
            
            if ((lock(j).gt.0).or.(lock(i).gt.0)) then
               icou(j,i)=1
               icou(i,j)=1
            endif
 300        continue
         enddo
      enddo

      return
 1000 continue
      write(iout6,1001)
 1001 format(/1x,'... error in spin orbitals ...'//)
      stop 'oshell'
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### locenergy ###
c  
c     Calculates the locale energy for a given orbital.
c
      subroutine locenergy (iorb,psi,pot,excp,e,f0,f4,wgt1,wgt2,
     &			wk0,wk1,wk2,wk3)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*13 fn
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),e(*),f0(*),wgt1(*),wgt2(*),
     &          wk0(*),wk1(*),wk2(*),wk3(*),f4(*)

      ioutmat=30

      open(ioutmat,file='vni',status='unknown',form='formatted')
      write(ioutmat,*) nni
      write(ioutmat,1000) (vni(in),in=1,nni)
      close(ioutmat)

      open(ioutmat,file='vmu',status='unknown',form='formatted')
      write(ioutmat,*) i1mu(1)
      write(ioutmat,1000) (vmu(im),im=1,i1mu(1))
      close(ioutmat)
01000 format(F25.15)

      wtwoel=0.d0

      i1beg=i1b(iorb)
      i2beg=i2b(iorb)	
      nmut=i1mu(iorb)
      ngorb=i1si(iorb)
      ngpot=i2si(iorb)	

      isd=iorb+(iorb-1)*norb
      engo(isd)=0.0d0
      ipe=mgx(6,iorb)
      ipex=ipe-2*(ipe/2)

c     calculate derivatives over mu and ni 

      if (ipex.eq.0) then
         isym= 1
      else
         isym=-1
      endif
      
      call fill (nni,nmut,isym,psi(i1beg),wk3)
      call difni (nmut,wk3,wk0,wk1,wk2)
      call refill(nni,nmut,wk1,wk0)
      
      call difmu (nmut,wk3,wk2)
      call refill(nni,nmut,wk0,wk2)

c     add contribution from derivatives over mu and ni
      
      call add (ngorb,wk0,wk1)
      
      if (ipe.eq.0) then
         call dcopy (ngorb,f0,1,wk0,1)
      else
         
c        e enter the expression with minus sign which is already 
c        incorporated in e
         
         w=dble(ipe*ipe)
         call dcopy (ngorb,f0,1,wk0,1)
         call daxpy (ngorb,w,e,1,wk0,1)
      endif
      
      call proda (ngorb,psi(i1beg),wk0,wk1)
      call prod (ngorb,wgt1,wk1)

c  now wk1 contains (T+V)|psi>

c	  call prod  (ngorb,psi(i1beg),wk1)
c	  w=ddot(ngorb,wgt1,1,wk1,1)
c	  write(*,*) '<T+V> ',w
c          stop

      do i=1,ngorb
         wk2(i)=0.d0
      enddo

      if (nel.gt.1) then
         if (norb.eq.1) then

c           contribution from coulomb potential of one sigma orbital

	    call dcopy (ngpot,pot(i2beg),1,wk2,1)
	    call prod  (ngorb,psi(i1beg),wk2)
         else
	    do i=1,mxsize
               wk2(i)=0.d0
	    enddo

c    add contributions from coulomb and exchange potentials

	    do iorb1=1,norb
               i1beg1=i1b(iorb1)
               i2beg1=i2b(iorb1)
               ngorb1=i1si(iorb1)		
               ngpot1=i2si(iorb1)
               oc=occ(iorb1)				
               kex=iorb+norb*(iorb1-1)

               if (iorb.le.iorb1) then
		  ihc=iorb+iorb1*(iorb1-1)/2
               else
		  ihc=iorb1+iorb*(iorb-1)/2
               endif

               i3beg=i3b(ihc)
               ngex =i3si(ihc)

               ngrid=min(ngorb,ngpot1)		
               do i=1,mxsize
	          wk0(i)=0.d0
               enddo	    

               call dcopy (ngpot1,pot(i2beg1),1,wk0,1)
               call prod  (ngrid,psi(i1beg),wk0)

               if (iorb.eq.iorb1) oc=oc-1.d0
               if (oc.ne.1.d0) then
		  call dscal (ngrid,oc,wk0,1)
               endif

               if (iorb1.ne.iorb)  then
                  ngrid2=min(ngorb1,ngex,ngorb)		
		  oc=gec(kex)
		  call prodas (ngrid2,-oc,psi(i1beg1),excp(i3beg),wk0)
		  if (ilc(ihc).gt.1) then
                     oc=gec(kex+norb*norb)
                     call prodas (ngrid2,-oc,psi(i1beg1),
     &                    excp(i3beg+ngex),wk0)
		  endif
		else
                   if ((ipe.gt.0).and.(ilc(ihc).gt.0)) then
                      ngrid2=min(ngorb1,ngex,ngorb)		
                      oc=gec(kex)
                      call prodas (ngrid2,-oc,psi(i1beg1),
     &                     excp(i3beg),wk0)
                   endif
		endif

		if (iorb1.eq.1) then
                   call dcopy (ngrid,wk0,1,wk2,1)
		else
                   call add   (ngrid,wk0,wk2)
		endif
             enddo
	  endif

c         to complete the integrand wk2 has to be multiplied by psi(i1beg)

  	  call prod (ngorb,wgt2,wk2)
       endif	  	  

c      wk2 contains V(fock)|psi>
       
       i1beg=i1b(iorb)
       ngorb=i1si(iorb)

       call add   (ngorb,wk1,wk2)
       
       call dcopy (ngorb,wk2,1,wk3,1)

c      call prod  (ngorb,psi(i1beg),wk2)
c      w=ddot(ngorb,wgt1,1,wk2,1)
c      write(*,*) '<T+V> ',w

       w=-eng(iorb)

       call dcopy(ngorb,f4,1,wk1,1)
       call prod(ngorb,psi(i1beg),wk1)
       call prod(ngorb,wgt2,wk1)
       call dcopy (ngorb,wk1,1,wk0,1)
       call daxpy(ngorb,w,wk1,1,wk2,1)

       w=0.d0
       w1=0.d0
       w2=0.d0
       wk2max=0.d0
       do i=1,ngorb

c         exclude grid points where nuclei are located

          if (abs(wk2(i)).gt.wk2max) then
             wk2max=abs(wk2(i))
             imax=i
          endif
          if (.not.(i.eq.1.or.i.eq.(ngrid-mxnmu))) then 
             w=w+wk2(i)*wk2(i)
             w1=w1+wk2(i)*wk2(i)*f4(i)*wgt2(i)
c            w2=w2+wk2(i)*wk2(i)*f4(i)
          endif
       enddo

       write(*,*) 'imax, wk2max',imax,wk2max
       
       if (idbg(496).ne.0) then
          go to ( 11, 12, 13, 14, 15, 16), iorb
00011     fn='bf-1p.lenergy'
          goto 100
00012     fn='bf-5s.lenergy'
          goto 100
00013     fn='bf-4s.lenergy'
          goto 100
00014     fn='bf-3s.lenergy'
          goto 100
00015     fn='bf-2s.lenergy'
	  goto 100
00016     fn='bf-1s.lenergy'
00100     continue
          open(ioutmat,file=fn,status='unknown',form='formatted')
  	  ibeg=i1b(iorb)
          call prtmat (nni,i1mu(1),wk2,ioutmat)
          close(ioutmat)
        endif

c       write(*,1010) iorn(iorb),bond(iorb),w,sqrt(w),w1,w2,sqrt(w2)
c       write(*,1010) iorn(iorb),bond(iorb),w,sqrt(w),w1,sqrt(w1)
        write(*,1010) iorn(iorb),bond(iorb),w1,sqrt(w1),
     &       sqrt(w1)/(-eng(iorb))
c01010   format(10x,i2,1x,a5,'  ',2d15.5/16x,d15.5/16x,2d15.5)
01010   format(10x,i2,1x,a5,'  ',4d15.5)

c        call enrradius(wk2)

        if (idbg(497).ne.0) then
           call leexact1(wk3,wk0)
c          call divide(wk0,psi(i1beg))
        else
c          call leexact(wk1,wk2)
        endif

	return
	end

c Several auxiliary routines follow.

c ### prtmatle ###
c
      subroutine prtmatle (m,n,a,ioutmat)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension a(m,n)

c  loop over grid points

      if (n.gt.500) then
         print *,'prtmatle: nonadequate format'
         stop
      endif

      do im=1,m
         write(ioutmat,1000) (a(im,in),in=1,n)
      enddo
01000 format(500F25.15)

      return
      end


c ### enrradius ###
c
      subroutine enrradius (vt)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension vt(nni,mxnmu)
      include 'commons8.inc'

      dev1=0.d0
      dev2=0.d0
      idev2=0
      r1max=0.2d0
      ipoints=0
      izero=0

      do ini=1,nni
         do imu=1,mxnmu
            r1=(r/2.d0)*(vxi(imu)+veta(ini))            
            t=vt(ini,imu)**2
            dev1=dev1+t
            if (abs(r1).gt.r1max) then
               dev2=dev2+t
               idev2=idev2+1
            endif
         enddo
      enddo
      write(*,*) 'Eucleadian norm ',sqrt(dev1),-0.5d0-eng(1)
      write(*,*) 'Eucleadian norm for r>rmax ',idev2,r1max,sqrt(dev2)

      return
      end

c ### leexact ###
c
      subroutine leexact (a,b)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension a(nni,mxnmu),b(nni,mxnmu)
      include 'commons8.inc'
      iorb=1
      dev1=0.d0
      dev2=0.d0
      dev3=0.d0
      ipoints=0
      izero=0
      do ini=1,nni
         do imu=1,mxnmu

            r1=(r/2.d0)*(vxi(imu)+veta(ini))            

            dnum=0.d0
            ddnom=0.d0
            a(ini,imu)=0.d0
            s1=0.d0
            s2=0.d0
            s3=0.d0

            if (abs(r1).gt.precis) then
               do ipb=npbasis,1,-1
                  d1=primexp(ipb)
                  c1=primcoef(iorb,ipb)
                  e=(2.d0*d1/pii)**(3.d0/4.d0)*exp(-d1*r1*r1)
                  s1=s1+c1*(-2.d0*d1*d1*r1*r1)*e
                  s2=s2+c1*(3.d0*d1)*e
                  if (abs(r1).gt.precis) s3=s3+c1*(-z1/r1)*e
                  ddnom=ddnom+c1*e
               enddo
               dnum=s1+s2+s3
               if (idbg(497).ne.0) then
                  a(ini,imu)=dnum
               else
                  a(ini,imu)=dnum+0.5d0*ddnom
               endif
               ipoints=ipoints+1
               dev1=dev1+(a(ini,imu))**2
            else
               izero=izero+1
            endif
         enddo
      enddo
      write(*,*) 'deviation of gaussian approximation from -Z**2/2'
      write(*,*)  ipoints,sqrt(dev1),sqrt(dev1/dble(ipoints))

      dev2=0.d0
      dev3=0.d0
      do inii=1,nni
         do imu=1,mxnmu
c            dev2=dev2+(a(ini,imu)+z1*z1/2.d0-b(ini,imu))**2
            dev2=dev2+(a(ini,imu)-b(ini,imu))**2
         enddo
      enddo

      write(*,*) 'deviation of gaussian approximation from exact one'
      write(*,*) sqrt(dev2)
      write(*,'(2d20.6,2i10)') sqrt(dev1), sqrt(dev2), ipoints, izero

      stop

      dev1=0.d0
      dev2=0.d0
      dev3=0.d0
      ipoints=0
      do ini=1,nni
         do imu=1,mxnmu
            r1=(r/2.d0)*(vxi(imu)+veta(ini))            
            dnum=0.d0
            ddnom=0.d0
            a(ini,imu)=0.d0
            do ipb=1,npbasis
               ic1 =icgau(ipb)
               d1  =primexp(ipb)
               c1 =primcoef(iorb,ipb)
               if (abs(r1).gt.precis.and.(d1*r1*r1).lt.200.0d0) then
                  dnum=dnum+c1*(-2.d0*d1*d1*r1*r1+3.d0*d1-z1/r1)*
     &                 (2.d0*d1/pii)**(3.d0/4.d0)*exp(-d1*r1*r1)
                  ddnom=ddnom+c1*(2.d0*d1/pii)**(3.d0/4.d0)*
     &                 exp(-d1*r1*r1)
               endif
            enddo
            if (abs(ddnom).gt.precis) then
               a(ini,imu)=dnum+0.5d0*ddnom
            else
               a(ini,imu)=0.d0
            endif
            ipoints=ipoints+1
            dev1=dev1+(a(ini,imu))**2
         enddo
      enddo
      write(*,*) 'deviation of gaussian approximation from -Z**2/2'
      write(*,*)  ipoints,sqrt(dev1),sqrt(dev1/dble(ipoints))

      dev2=0.d0
      dev3=0.d0
      do ini=1,nni
         do imu=1,mxnmu
            dev2=dev2+(a(ini,imu)-b(ini,imu))**2
         enddo
      enddo

      write(*,*) 'deviation of gaussian approximation from exact one'
      write(*,*) sqrt(dev2)
      write(*,'(3d20.6,i10)') sqrt(dev1), sqrt(dev2), sqrt(dev3),ipoints

      return
      end

c ### leexact1 ###
c
      subroutine leexact1 (vt,orb)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension vt(nni,mxnmu),orb(nni,mxnmu)
      include 'commons8.inc'
      iorb=1
      w=eng(iorb)

      dev1=0.d0
      dev2=0.d0
      idev2=0
      r1max=0.2d0
      ipoints=0
      izero=0

      do ini=1,nni
         do imu=1,mxnmu
            r1=(r/2.d0)*(vxi(imu)+veta(ini))            
            dnum=0.d0
            ddnom=0.d0
            s1=0.d0
            s2=0.d0
            s3=0.d0
            if (abs(r1).gt.precis) then
               do ipb=npbasis,1,-1
                  d1=primexp(ipb)
                  c1=primcoef(iorb,ipb)
                  e=(2.d0*d1/pii)**(3.d0/4.d0)*exp(-d1*r1*r1)
                  s1=s1+c1*(-2.d0*d1*d1*r1*r1)*e
                  s2=s2+c1*(3.d0*d1)*e
                  if (abs(r1).gt.precis) s3=s3+c1*(-z1/r1)*e
                  ddnom=ddnom+c1*e
               enddo
               dnum=s1+s2+s3
               if (idbg(497).ne.0.and.abs(ddnom).gt.precis) then
                  t=(vt(ini,imu)-dnum/ddnom*orb(ini,imu))**2
                  dev1=dev1+(vt(ini,imu)-dnum/ddnom*orb(ini,imu))**2
               endif
               if (abs(r1).gt.r1max) then
                  dev2=dev2+t
                  idev2=idev2+1
               endif
            endif
         enddo
      enddo
      write(*,*) 'deviation from exact local energy',sqrt(dev1)
      write(*,*) 'deviation from exact local energy outside radius'
      write(*,*) idev2,r1max,sqrt(dev2)

      return
      end

c ### divide ###
c
      subroutine divide (a,b)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension a(nni,mxnmu),b(nni,mxnmu)
      include 'commons8.inc'
      iorb=1

      dev1=0.d0
      dev2=0.d0
      dev3=0.d0
      ipoints=0
      izero=0
      do ini=1,nni
         do imu=1,mxnmu
            if (abs(b(ini,imu)).gt.precis) then
               a(ini,imu)=a(ini,imu)/b(ini,imu)
            else
               a(ini,imu)=0.d0
               izero=izero+1
            endif
         enddo
      enddo
      write(*,*) 'deviation of gaussian approximation from -Z**2/2'
      write(*,*)  sqrt(dev1),izero

      return
      end

c ### exorbitals ###
c     
C     This subroutine prints out orbitals
c
      subroutine exorbitals (ioutmat,psi)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*13 fn
      include 'commons8.inc'

      dimension psi(*)

      open(ioutmat,file='vni',status='unknown',form='formatted')
      write(ioutmat,*) nni
      write(ioutmat,1000) (vni(in),in=1,nni)
      close(ioutmat)

      open(ioutmat,file='vmu',status='unknown',form='formatted')
      write(ioutmat,*) i1mu(1)
      write(ioutmat,1000) (vmu(im),im=1,i1mu(1))
      close(ioutmat)
01000 format(F25.15)

      do iorb=1,norb
         iout=ioutmat+norb-iorb+1
         open(iout,status='unknown',form='formatted')
         ibeg=i1b(iorb)
         call prtmat (nni,i1mu(1),psi(ibeg),iout)
         close(iout)
         write(*,*) 'exorbitals: ',iout
      enddo
01010 format(10x,i2,1x,a5,'  ',4d15.5)
        
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### coulmom ###
c
c     Calculates multipole moments up to order k_max=7.
c
      subroutine coulmom (psi,f4,wgt2,dd0,dd1,dd2,dd3,dd4,
     &                              dd5,dd6,dd7,wk1,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),f4(*),wgt2(*),wk1(*),wk2(*),
     &	dd0(nni,mxnmu),dd1(nni,mxnmu),dd2(nni,mxnmu),
     &	dd3(nni,mxnmu),dd4(nni,mxnmu),
     &  dd5(nni,mxnmu),dd6(nni,mxnmu),dd7(nni,mxnmu)
      data imulmx/8/       

      if (impole.gt.imulmx) then
         write(*,*) 'order of multipole expansion cannot exceed',
     &        imulmx
         stop 'coulmom'
      endif

c     loop over orbitals
c     rr=r  xr2=R/2  costh == xi*eta/rr

      xr2=r/2.d0	
      do iorb=1,norb
         if (itouch(iorb).eq.0) goto 500	    	
         ibeg = i1b (iorb)
         ngrid= i1si(iorb)	  
         
         do mu=1,mxnmu
            do ni=1,nni
               rr=sqrt(vxisq(mu)+vetasq(ni)-1.d0)
c              r==xrr=(R/2)rr see eq.13 (CPC 98 (1996) 346)
               xrr=xr2*rr
               if (abs(rr).lt.precis) then
	          costh=0.d0
               else
	          costh=vxi(mu)*veta(ni)/rr
               endif
c              domei=P_k (Legendre polynomial of order k)
               dome1 = costh
               dome2 =( 3.d0*costh*dome1 - 1.d0      )/ 2.d0
               dome3 =( 5.d0*costh*dome2 - 2.d0*dome1)/ 3.d0
               dome4 =( 7.d0*costh*dome3 - 3.d0*dome2)/ 4.d0
               dome5 =( 9.d0*costh*dome4 - 4.d0*dome3)/ 5.d0
               dome6 =(11.d0*costh*dome5 - 5.d0*dome4)/ 6.d0
               dome7 =(13.d0*costh*dome6 - 6.d0*dome5)/ 7.d0
               dome8 =(15.d0*costh*dome7 - 7.d0*dome6)/ 8.d0
c              dome9 =(17.d0*costh*dome8 - 8.d0*dome7)/ 9.d0
c              dome10=(19.d0*costh*dome9 - 9.d0*dome8)/10.d0

               xw=xrr
               dd0(ni,mu)=dome1*xw
               xw=xw*xrr
               dd1(ni,mu)=dome2*xw
               xw=xw*xrr
               dd2(ni,mu)=dome3*xw
               xw=xw*xrr
               dd3(ni,mu)=dome4*xw
               xw=xw*xrr
               dd4(ni,mu)=dome5*xw
               xw=xw*xrr
               dd5(ni,mu)=dome6*xw
               xw=xw*xrr
               dd6(ni,mu)=dome7*xw
               xw=xw*xrr
               dd7(ni,mu)=dome8*xw
            enddo
         enddo

         if (idbg(100).ne.0) then
            write(*,*) 'momen0: dd0 '
            call pmtx(nni,mxnmu,dd0,1,1,incrni,incrmu)
            write(*,*) 'momen0: dd2 '
            call pmtx(nni,mxnmu,dd2,1,1,incrni,incrmu)
            write(*,*) 'momen0: dd4 '
            call pmtx(nni,mxnmu,dd4,1,1,incrni,incrmu)
         endif

c        Now d0, d1, d2 and d3 is equal to P0, P1*r, P2*r**2 and P3*r**2,
c        respectively. P0, P1,..  are Legendre polynomials of a specified
c        order.

c        Prepare integrands and calculate moments. Multiplication by f4 is 
c        necessary because of the factor 2/(r*cosh(mu)) incorporated in wgt2.

         call prod2 (ngrid,psi(ibeg),psi(ibeg),wk1)
         call prod  (ngrid,f4,wk1)

         if (ihomon.ne.0) then	
            cmulti (iorb	  ) = 0.d0
         else
            call prod2 (ngrid,dd0,wk1,wk2)
            cmulti (iorb	  ) = ddot (ngrid,wgt2,1,wk2,1)
         endif
         
         call prod2 (ngrid,dd1,wk1,wk2)
         cmulti (iorb+norb) = ddot (ngrid,wgt2,1,wk2,1)

         if (ihomon.ne.0) then	
            cmulti (iorb+2*norb) = 0.d0
         else
            call prod2 (ngrid,dd2,wk1,wk2)
            cmulti (iorb+2*norb) = ddot (ngrid,wgt2,1,wk2,1)
         endif

         call prod2 (ngrid,dd3,wk1,wk2)
         cmulti (iorb+3*norb) = ddot (ngrid,wgt2,1,wk2,1)
         
         if (ihomon.ne.0) then	
            cmulti (iorb+4*norb) = 0.d0
         else
            call prod2 (ngrid,dd4,wk1,wk2)
            cmulti (iorb+4*norb) = ddot (ngrid,wgt2,1,wk2,1)
         endif

         call prod2 (ngrid,dd5,wk1,wk2)
         cmulti (iorb+5*norb) = ddot (ngrid,wgt2,1,wk2,1)

         if (ihomon.ne.0) then	
            cmulti (iorb+6*norb) = 0.d0
         else
            call prod2 (ngrid,dd6,wk1,wk2)
            cmulti (iorb+6*norb) = ddot (ngrid,wgt2,1,wk2,1)
         endif

         call prod2 (ngrid,dd7,wk1,wk2)
         cmulti (iorb+7*norb) = ddot (ngrid,wgt2,1,wk2,1)

         if (idbg(101).ne.0) then
            write(*,*)
            write(*,*) 'momen0 - multipole moments for orbital ',iorb
            write(*,1111) cmulti (iorb       ),cmulti (iorb+	norb),
     &           cmulti (iorb+2*norb),cmulti (iorb+3*norb),
     &           cmulti (iorb+4*norb),cmulti (iorb+5*norb),
     &           cmulti (iorb+6*norb),cmulti (iorb+7*norb)

 1111       format(5d13.5)
         endif
 500     continue
      enddo
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### ttime ###
c
c     Returns cpu time in seconds
c
      subroutine ttime(t)
      real*8 t      
      real*4 et,etime, time(2)
c      real*4 a,b
c     real*4 second
c
c     usage: 
c     etime - Convex, Sun, Intel (Linux) 
c     second - Cray 
c     mclock - RS6000 (current process time in 1/100 sec.)
c     getusedcpu - machine independent

      et=etime(time)
      t=dble(time(1))

c     t=dble(second())
c     t=dble(mclock())/100.d0
c     
c     generic (hopefully)
c      call getusedcpu(a , b)
c      t=dble(a)
      return
      end

********************************************************************************
*                                                                              *  
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### raylloc ###
c
c     Solves the eigenvalue to the schroedinger equation as e = <w(i)/h/w(j)>
c
      subroutine raylloc(iorb,psi,pot,excp,e,f0,f4,wgt1,wgt2,
     &			wk0,wk1,wk2,wk3)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*13 fn
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),e(*),f0(*),wgt1(*),wgt2(*),
     &          wk0(*),wk1(*),wk2(*),wk3(*),f4(*)

      ioutmat=30

      open(ioutmat,file='vni',status='unknown',form='formatted')
      write(ioutmat,1000) (vni(in),in=1,nni)
      close(ioutmat)

      open(ioutmat,file='vmu',status='unknown',form='formatted')
      write(ioutmat,1000) (vmu(im),im=1,i1mu(1))
      close(ioutmat)
01000 format(5F15.6)

      wtwoel=0.d0

      i1beg=i1b(iorb)
      i2beg=i2b(iorb)	
      nmut=i1mu(iorb)
      ngorb=i1si(iorb)
      ngpot=i2si(iorb)	

      isd=iorb+(iorb-1)*norb
      engo(isd)=0.0d0
      ipe=mgx(6,iorb)
      ipex=ipe-2*(ipe/2)

c     calculate derivatives over mu and ni 

      if (ipex.eq.0) then
         isym= 1
      else
         isym=-1
      endif

      call fill (nni,nmut,isym,psi(i1beg),wk3)
      call difni (nmut,wk3,wk0,wk1,wk2)
      call refill(nni,nmut,wk1,wk0)

      call difmu (nmut,wk3,wk2)
      call refill(nni,nmut,wk0,wk2)

c     add contribution from derivatives over mu and ni

      call add (ngorb,wk0,wk1)

      if (ipe.eq.0) then
         call dcopy (ngorb,f0,1,wk0,1)
      else

c        e enter the expression with minus sign which is already incorporated in e

         w=dble(ipe*ipe)
         call dcopy (ngorb,f0,1,wk0,1)
         call daxpy (ngorb,w,e,1,wk0,1)
      endif

      call proda (ngorb,psi(i1beg),wk0,wk1)
      call prod (ngorb,wgt1,wk1)

c     now wk1 contains (T+V)|psi>

c     call prod  (ngorb,psi(i1beg),wk1)
c     w=ddot(ngorb,wgt1,1,wk1,1)
c     write(*,*) '<T+V> ',w

      do i=1,ngorb
         wk2(i)=0.d0
      enddo

      if (nel.gt.1) then
         if (norb.eq.1) then

c           contribution from coulomb potential of one sigma orbital

	    call dcopy (ngpot,pot(i2beg),1,wk2,1)
	    call prod  (ngorb,psi(i1beg),wk2)
         else
	    do i=1,mxsize
               wk2(i)=0.d0
	    enddo
            
c           add contributions from coulomb and exchange potentials
            
	    do iorb1=1,norb
               i1beg1=i1b(iorb1)
               i2beg1=i2b(iorb1)
               ngorb1=i1si(iorb1)		
               ngpot1=i2si(iorb1)
               oc=occ(iorb1)				
               kex=iorb+norb*(iorb1-1)
               if (iorb.le.iorb1) then
		  ihc=iorb+iorb1*(iorb1-1)/2
               else
		  ihc=iorb1+iorb*(iorb-1)/2
               endif
               i3beg=i3b(ihc)
               ngex =i3si(ihc)

               ngrid=min(ngorb,ngpot1)		
               do i=1,mxsize
	          wk0(i)=0.d0
               enddo	    
               
               call dcopy (ngpot1,pot(i2beg1),1,wk0,1)
               call prod  (ngrid,psi(i1beg),wk0)
               
               if (iorb.eq.iorb1) oc=oc-1.d0
               if (oc.ne.1.d0) then
                  call dscal (ngrid,oc,wk0,1)
               endif

               if (iorb1.ne.iorb)  then
                  ngrid2=min(ngorb1,ngex,ngorb)		
		  oc=gec(kex)
		  call prodas (ngrid2,-oc,psi(i1beg1),excp(i3beg),wk0)
		  if (ilc(ihc).gt.1) then
                     oc=gec(kex+norb*norb)
                     call prodas (ngrid2,-oc,psi(i1beg1),
     &					excp(i3beg+ngex),wk0)
		  endif
               else
		  if ((ipe.gt.0).and.(ilc(ihc).gt.0)) then
                     ngrid2=min(ngorb1,ngex,ngorb)		
                     oc=gec(kex)
                     call prodas (ngrid2,-oc,psi(i1beg1),excp(i3beg),wk0)
		  endif
               endif

               if (iorb1.eq.1) then
		  call dcopy (ngrid,wk0,1,wk2,1)
               else
		  call add   (ngrid,wk0,wk2)
               endif
	    enddo
         endif

c        to complete the integrand wk2 has to be multiplied by psi(i1beg)
         
         call prod (ngorb,wgt2,wk2)
      endif	  	  

c     wk2 contains V(fock)|psi>

      i1beg=i1b(iorb)
      ngorb=i1si(iorb)

      call add   (ngorb,wk1,wk2)     
      
c     call prod  (ngorb,psi(i1beg),wk2)
c     w=ddot(ngorb,wgt1,1,wk2,1)
c     write(*,*) '<T+V> ',w

      w=-eng(iorb)

      call dcopy(ngorb,f4,1,wk1,1)
      call prod(ngorb,psi(i1beg),wk1)
      call prod(ngorb,wgt2,wk1)
      call daxpy(ngorb,w,wk1,1,wk2,1)

      w=0.d0
      do i=1,ngorb
         w=w+wk2(i)*wk2(i)
      enddo

      if (idbg(496).ne.0) then
         go to ( 11, 12, 13, 14, 15, 16), iorb
00011    fn='bf-1p.lenergy'
         goto 100
00012    fn='bf-5s.lenergy'
         goto 100
00013    fn='bf-4s.lenergy'
         goto 100
00014    fn='bf-3s.lenergy'
         goto 100
00015    fn='bf-2s.lenergy'
         goto 100
00016    fn='bf-1s.lenergy'
00100    continue
         open(ioutmat,file=fn,status='unknown',form='formatted')
         ibeg=i1b(iorb)
         call prtmat (nni,i1mu(1),wk2,ioutmat)
         close(ioutmat)
      endif
      write(*,1010) iorn(iorb),bond(iorb),sqrt(w)
01010 format(18x,i2,1x,a5,'  ',d10.2)

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zmulti ###	
c
      subroutine zmulti(ixa,pot)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*),dome(10)

      do j=mxnmu-3,mxnmu
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            rr=sqrt(vxisq(j)+vetasq(i)-1.d0)
            cost=veta(i)*vxi(j)/rr
            rr1=1.d0/(rr*r2)

            dome(1)=cost
            dome(2)=(3.d0*cost*cost-1.d0)*5.d-01
            do n=2,(impole-1)
               dome(n+1)=(dble(2*n+1)*cost*dome(n)-dble(n)*
     &              dome(n-1))/dble(n+1)
            enddo
            
            pe=0.d0
            do m=1,impole
               kxk=ixa+(m-1)*norb
               pe=pe+cmulti(kxk)*dome(m)*(rr1**dble(m+1))
            enddo 
            pot(kk)=r2*vxi(j)*(pe+rr1)	  
         enddo
      enddo
      return
      end

c ### zmultitail ###
c
      subroutine zmultitail(iorb,pot)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*),dome(10),pottmp(10)

c     potentials are calculated for ni=Pi/2

      j=mxnmu
      itt=(j-1)*nni
      i=(nni-1)/2
      kk=i+itt
      rr=sqrt(vxisq(j)+vetasq(i)-1.d0)
      costh=veta(i)*vxi(j)/rr
      xr=1.d0/(rr*r2)
      
      dome(1)=costh
      dome(2)=(3.d0*costh*costh-1.d0)*0.5d0
      do n=2,(impole-1)
         dome(n+1)=(dble(2*n+1)*costh*dome(n)
     &        -dble(n)*dome(n-1))/dble(n+1)
      enddo
      
      pe=0.d0
      xrr=xr
      do m=1,impole
         xrr=xrr*xr
         kxk=iorb+(m-1)*norb
         pe=pe+cmulti(kxk)*dome(m)*xrr
         pottmp(m)=r2*vxi(j)*(pe+xr)	  
      enddo
      
      write(*,1000) iorn(iorb),bond(iorb),gut(iorb),pottmp(1),
     &     (pottmp(m)-pottmp(m-1),m=2,impole),pottmp(impole)
 1000 format(i4,1x,a8,a1,3x,/4d13.5/5d13.5)
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### homo ###
c
c     Determines Ci symmetry of a given orbital (or set of orbitals) and uses 
c     it to replace the values in the [pi/2,pi] region by these from the
c     [0,pi/2] one. 

      subroutine homo (iorb,psi)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*)

c     ihsym = 1 - symmetry g
c     ihsym =-1 - symmetry u

      if (iorb.eq.0) then
         iorb1=1
         iorb2=norb
      else
         iorb1=iorb
         iorb2=iorb
      endif

      n2=nni/2+1
      
      do i=iorb1,iorb2
         ibeg = i1b(i)
         nmut = i1mu(i)	  
         ihsym=ihomo(i)
         call homo_det (n2,nmut,psi(ibeg),ihsym)
         if (idbg(99).ne.0) then
            write(*,*) 'homo: ihomo(iorb),ihsym',
     &           iorn(i),bond(i),gut(i),ihomo(i),ihsym
         endif
      enddo
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### asymorb ###
c
c     Calculates asymptotic values of a given orbital at the practical infinity.
c
      subroutine asymorb (nmi,psi,aorb)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),aorb(nni,4)

      jj=0
      do j=nmi-3,nmi
         itt=(j-1)*nni
         jj=jj+1
         do i=1,nni
	    kk=i+itt
	    ps1=psi(kk)
	    psi(kk)=psi(kk-nni)*aorb(i,jj)
	    psi(kk)=ps1+omega*(psi(kk)-ps1)
         enddo
      enddo
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### relexch1 ###
c
      subroutine relexch1 (iorb,cw_sor,psi,pot,excp,bpot,d,e,f3,g,
     &			 lhs,rhs,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      real*8 lhs
      integer*4 cw_sor

      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),cw_sor(*),
     &     rhs(*),bpot(*),d(*),e(*),f3(*),
     &     g(*),lhs(*),wk2(*)	

      if (nel.lt.2 ) return
      
      if     (exlexp.eq.0) then
	  ifirst=1
      elseif (exlexp.eq.2) then
c        recalculate only those exchange potentials which depend on orbitals 
c        modified	so far (note the reverse order of relaxation in scf)
         ifirst=iorb
      endif
      
      ngorb=i1si(iorb)	  
      do iorb1=ifirst,norb
         iswtch=0

         if (iorb.eq.iorb1.and.mgx(6,iorb).eq.0 ) goto 10
         if ((iorb.eq.iorb1).and.(ilc(iorb*(iorb+1)/2).lt.1)) goto 10

c        orbitals in increasing order

         if (iorb.lt.iorb1) then
	    in1=iorb
	    in2=iorb1	  
         else	    
	    in1=iorb1
	    in2=iorb
         endif	    
         ib1=i1b(in1)
         ng1=i1si(in1)
         ib2=i1b(in2)
         ng2=i1si(in2)	  

         ipc=in1+in2*(in2-1)/2
         iwexch(ipc)=-1

         ibexp=i3b(ipc)
         ngexp=i3si(ipc)

         idel=abs(mgx(6,in1)-mgx(6,in2))
         if (in1.eq.in2) idel=2*mgx(6,in1)
         idel1=mgx(6,in1)+mgx(6,in2)
         
c        prepare right-hand side of the poisson equation
         
         do i=1,ngorb
            wk2(i)=0.d0
         enddo	
         
         ngrid=min(ng1,ng2)
         call prod2 (ngrid,psi(ib1),psi(ib2),wk2)
         call prod2 (ngorb,wk2,g,rhs)
         
         ipex=idel-2*(idel/2)
c        if (mod(idel,2).eq.0) then
         if (ipex.eq.0) then	  
            isym= 1
         else
            isym=-1
         endif
 1000    continue

c         write(*,'("relexch1: iorb,iorb1,ipc,ibexp",4i8)') 
c     &        iorb,iorb1,ipc,ibexp

         do itr1=1,maxsor1	  	
            do ig=1,i1ng(iorb)
               do i=1,i1si(iorb)
                  wk2(i)=0.d0
               enddo	
               
               omega=ovfexch(ig)
               omega1=1.d0-omega
               ioffst=ioffs(ig)	    
               ioffs1=ioffst+1
               ibexp1=ibexp+ioffst	  	  
               
               do i=1,4
                  dmu2t(i)=dmu2(i,ig)
                  dmu1t(i)=dmu1(i,ig)
               enddo
               
c              prepare left-hand side of the poisson equation
c              include the diagonal part of the differentiation 
c              operator in lhs
               
               if (idel.eq.0) then
                  do i=1,ngsize(ig)
                     lhs(ioffst+i)=f3(ioffst+i)+diag(ig)
                  enddo		
               else
                  xdel=dble(idel*idel)
                  do i=1,ngsize(ig)
                     lhs(ioffst+i)=f3(ioffst+i)+
     &                    xdel*e(ioffst+i)+diag(ig)
                  enddo				
               endif
               
               if (i1ng(iorb).eq.1) then 
c                 icase=1
                  ifill=1
                  ngrd1 =ingr1(1,ig)
                  ngrd6a=ingr1(2,ig)
                  ngrd6b=ingr1(3,ig)
                  ngrd7 =ingr1(4,ig)	  	  
                  call fill (nni,nmu(ig),isym,excp(ibexp),wk2)
                  do itr2=1,maxsor2/lsor	  		
                     call sor
     &                    (wk2,lhs(ioffs1),rhs(ioffs1),
     &                    bpot(ioffs1),d(ioffs1),
     &                    cw_sor(iadext(ig)),cw_sor(iadnor(ig)),
     &                    cw_sor(iadex1(ig)),cw_sor(iadex2(ig)),
     &                    cw_sor(iadex3(ig)))
                  enddo     
                  call refill (nni,nmu(ig),excp(ibexp),wk2)     
               else
                  if (ig.eq.1) then 
c                    icase=2
                     ifill=2
                     ngrd1 =ingr2(1,ig)
                     ngrd6a=ingr2(2,ig)
                     ngrd6b=ingr2(3,ig)
                     ngrd7 =ingr2(4,ig)	  	  	    
                  elseif (ig.ne.1.and.ig.ne.i1ng(iorb)) then 
c                    icase=2
                     ifill=3
                     ngrd1 =ingr2(1,ig)
                     ngrd6a=ingr2(2,ig)
                     ngrd6b=ingr2(3,ig)
                     ngrd7 =ingr2(4,ig)	  	  	    
                  elseif (ig.eq.i1ng(iorb)) then 
                     ifill=4
                     ngrd1 =ingr1(1,ig)
                     ngrd6a=ingr1(2,ig)
                     ngrd6b=ingr1(3,ig)
                     ngrd7 =ingr1(4,ig)	  	  	    
                     muoffs=iemu(ig-1)-1
                  endif
               endif
            enddo
         enddo
         if (iswtch.eq.1) goto 10
         if (ilc(ipc).lt.2) goto 10
         iwexch(ipc)=-2
         idel=idel1
         ibexp=ibexp+ngexp
         ipc=ipc+norb*(norb+1)/2
         iswtch=1
         goto 1000
 10      continue
      enddo
c      write(*,'(2d25.14)'),excp(122),excp(10465-1)
c      write(*,'(2d25.14)'),excp(ibexp),excp(ibexp+ngexp-1)
 1021 format(/,i5,10d12.3,/(5x,10d12.3))
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### difmu ###
c
c    This routine calculates 
c
c     (\frac{\partial^2}{\partial\mu^2} + 
c           b(\ni,\mu) \frac{\partial}{\partial \mu}) f(\ni,\mu)
c
c    Function f has been imersed in the array f(nni+8,nmu+8) in order
c    to calculated derivatives in all the grid points.
c    Originally the routine was used for a single grid of constatnt step
c    size hmu. Accordingly dmu array contained the first- and second-order
c    derivative coefficients (taken from the 8th-order Sterling
c    interpolation formula) multiplied by the b array. 
c
c    To make the routine work in the multigrid case (ngrids.ne.1) 
c    the values of dmu(k,imu) for 
c
c        imu=iemu(1)-3 ... iemu(1)+3
c        imu=iemu(2)-3 ... iemu(2)+3
c        .
c        imu=iemu(ngrids-1)-3 ... iemu(ngrids-1)+3
c
c    must be prepared with derivative coefficients which are based on
c    other interpolation formulae taking into account different grid
c    density to the left and right of the grid boundaries. See prepfix
c    for detailes.
c
c
c    This routine calculates 
c
c     {\partial^2 / \partial\mu^2 + 
c           b(\ni,\mu) \partial / \partial \mu} f(\ni,\mu)
c
c    Function f has been imersed in the array f(nni+8,nmu+8) in order
c    to calculated derivatives in all the grid points.
c    Originally the routine was used for a single grid of constatnt step
c    size hmu. Accordingly dmu array contained the first- and second-order
c    derivative coefficients (taken from the 8th-order Sterling
c    interpolation formula) multiplied by the B array. 
c
c    To make the routine work in the multigrid case (ngrids.ne.1!) 
c    the values of dmu(k,imu) for 
c
c        imu=iemu(1)-3 ... iemu(1)+3
c        imu=iemu(2)-3 ... iemu(2)+3
c        .
c        imu=iemu(ngrids-1)-3 ... iemu(ngrids-1)+3
c
c    must be prepared with derivative coefficients which are based on
c    other interpolation formula taking into account different grid
c    density to the left and right of the grid boundaries. See prepfix
c    for detailes.
c
      subroutine difmu (n,f,fd)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension f(nni+8,*),fd(nni+8,*)	

c     The following loop runs now till j=mxnmu so that the derivatives are
c     also defined in the tail region, i.e. for (i,mxnmu-3),...,(i,mxnmu)
c     To this end the fill routine provides extra values for
c     (i,mxnmu+1),...,(i,mxnmu+4) points.

      do j=1,n
         call mxv(f(1,j),nni+8,dmu(1,j),9,fd(1,j+4))
      enddo
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rfdexch ###
c
c     Reads from a disk file exchange potentials involving orbital iorb
c
      subroutine rfdexch (iorb1,excp)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension excp(*)

      idble=0
      do iorb2=1,i3nexcp(iorb1)
         k=i3breck(iorb1,iorb2)
         i3beg=i3brec(iorb1,iorb2)
         if (ilc(k).eq.1) then
            i3b(k)=i3beg        
         elseif (ilc(k).eq.2) then
            if (idble.eq.0) then
               i3b(k)=i3beg        
               idble=1
            else
               idble=0
            endif
         endif
        
         irec=i3xpair(iorb1,iorb2)
         ngrid=i3si(k)

         call rrec(irec,ngrid,excp(i3beg))
      enddo
      return

 900  write(iout6,*) 'error detected when reading exchange',  
     &     ' potential',iorb1,iorb2,k,irec
      stop 'rfdexch'
 1050 format(/1x,'... writing functions to disk ...'//)
 1070 format(//1x,'error! can not write data to disk'//)     
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inihyd ###  
c
c     This routine initializes molecular orbitals as linear
c     combinations of hydrogenic functions on centres A and B.
c     In the case of HF or HFS calculations Coulomb (exchange) potentials are 
c     approximated as a linear combination of Thomas-Fermi (1/r) potentials 
c     of the two centres; if method OED is chosen the potential functions are 
c     set to zero.
c
      subroutine inihyd (psi,pot,excp,f2,f4,wgt2,wk0)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),f2(*),f4(*),wgt2(*),wk0(*)

c     Initialization of molecular orbitals 

        print *,'... initializing molecular orbitals from hydrogenic',
     &          ' functions ...'

c       loop over orbitals

        if (ini.eq.4.) then
           norbt=1
        else
           norbt=norb
        endif

	do iorb=1,norbt
           
           ishift=i1b(iorb)-1
           n1=mgx(1,iorb)
           l1=mgx(2,iorb)
           m1=mgx(3,iorb)
           ez1=eza1(iorb)

c          normalization factor for Laguere polynomials

           fn1=(2.d0*ez1/dble(n1))**(3.d0/2.d0+dble(l1))
     &          *sqrt(factor(n1+l1)/(2.d0*dble(n1)*factor(n1-l1-1)))
     &          /factor(2*l1+1)

c          normalization factor for spherical harmonics

           shn1=(-1.d0)**m1/sqrt(4.d0*pii)*
     &		sqrt((2*l1+1)*factor(l1-m1)/factor(l1+m1))
           if (m1.eq.0) shn1=1.d0/sqrt(4.d0*pii)*
     &		sqrt((2*l1+1)*factor(l1-m1)/factor(l1+m1))

c          multiplication factor fot the associate Legendre polynomials
c          alp1=(-1.d0/2.d0)**m1*factor(l1+m1)/factor(l1-m1)/factor(m1)

           n2=mgx(4,iorb)
           l2=mgx(5,iorb)
           m2=mgx(6,iorb)
           ez2=eza2(iorb)	  	
           fn2=(2.d0*ez2/dble(n2))**(3.d0/2.d0+dble(l2))
     &          *sqrt(factor(n2+l2)/(2.d0*dble(n2)*factor(n2-l2-1)))
     &          /factor(2*l1+1)

           shn2=(-1.d0)**m2/sqrt(4.d0*pii)*
     &		sqrt((2*l2+1)*factor(l2-m2)/factor(l2+m2))

c	  alp2=(-1.d0/2.d0)**m2*factor(l2+m2)/factor(l2-m2)/factor(m2)     
           
c          loop over grid points

           do imu=1,mxnmu
              inioff=(imu-1)*nni
              do in=1,nni
                 igp=ishift+inioff+in

c                for each grid point, e.i. for (vmu(imu),vni(ini)) 
c                determine its distance |_r1| and |_r2| from the nuclei A 
c                and B and cosine of the polar angles costh1 and costh2 
c                between z axis and the vectors _r1 and _r2
c
c                rr=dsqrt(xi(j,6)-eta(i,3)+1.d0)
c                rr=dsqrt(vxi12(j)-veta12(i)+1.d0)	
c                rr=dsqrt(vxisq(j)+vetasq(i)-1.d0)	
c                costh=eta(i,1)*xi(j,4)/rr

                 psi1=0.d0
                 psi2=0.d0

                 rr=(r/2.d0)*sqrt(vxisq(imu)+vetasq(in)-1.d0)		
                 z=(r/2.d0)*vxi(imu)*veta(in)
                 r1t=(r/2.d0)*(vxi(imu)+veta(in))
                 r2t=(r/2.d0)*(vxi(imu)-veta(in))

                 if (r1t.lt.precis) then
                    costh1=0.d0
c                    r1t=1.0d-10
c                    psi1=0.d0
c                    psi2=0.d0
c                    goto 99
                 else   
                    costh1=(z+r/2.d0)/r1t
                 endif
c
                 if (r2t.lt.precis) then
                    costh2=0.d0
c                    r2t=1.0d-10
c                    psi1=0.d0
c                    psi2=0.d0
c                    goto 99
                 else   
                    costh2=-(z-r/2.d0)/r2t	
                 endif
c                
c                calculate radial part of the hydrogenic orbital centered 
c                on both the nuclei
                 
                 if     (co1(iorb).ne.0.d0) then
                    psi1=fn1*plaguer(n1,l1,ez1,r1t)
     &                   *shn1*plegendg(l1,m1,costh1)
                 endif

                 if (co2(iorb).ne.0.d0) then	    
                    psi2=fn2*plaguer(n2,l2,ez2,r2t)
     &                   *shn2*plegendg(l2,m2,costh2)	  
                 endif
00099            continue
                 psi(igp)=co1(iorb)*psi1+co2(iorb)*psi2
                 if(m1.eq.1) psi(igp)=-psi(igp)
              enddo
           enddo

c          call norm94 (iorb,psi,f4,wgt2,wk0,xnorm)
c          write (*,1115) iorn(iorb),bond(iorb),xnorm,ipnzero

01114   format(/1x,'  orbital        norm       (# primitive bf)')
01115   format(1x,i2,1x,a5,d20.12,' (',i4,')')
        enddo

c  initialize Coulomb and exchange potentials

        call tfpot(psi,pot,excp,f2,f4,wk0)	

        return
	end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### exocc ###
c
c     Calculates the number of alpha and beta electrons for a given orbital.
c
      subroutine exocc (iorb,ocup,ocdown)

      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*8 alpha,beta
      include 'commons8.inc'
      data alpha,beta /'+','-'/

      ocup  =0.d0
      ocdown=0.d0

      ipe =mgx(6,iorb)
      ip=4*(iorb-1)

      if(ipe.eq.0) then
         iend=2
      else
         iend=4
      endif

      do i=1,iend
         if(spin(ip+i).ne.alpha.and.spin(ip+i).ne.beta) goto 10
         if(spin(ip+i).eq.alpha) ocup  =ocup+1.d0
         if(spin(ip+i).eq.beta ) ocdown=ocdown+1.d0
00010    continue
      enddo

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### refill ###
c  
c     Reverses the action of fill and fill[2-4]
c
      subroutine refill (nni,nmi,fun,work)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension fun(nni,*),work(nni+8,nmi+8)

c     refill the interior of work array

      do i=1,nmi
         do j=1,nni
            fun(j,i)=work(j+4,i+4)
         enddo
      enddo

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### es ###
c
c     This routine has been taken from GRASP2 package (ver. 1.00, 17 jan 1992, 
c     Copyright (C) 1992 by F.A. Parpia, I.P. Grant, and C.F. Fischer)
c
************************************************************************
*                                                                      *
      SUBROUTINE ES (F,S2F,S3F)
*                                                                      *
*   ----------------   SECTION 01   SUBPROGRAM 14   ----------------   *
*   EVALUATE THE SUM OF THE SERIES                                     *
*                                                                      *
*                       INFINITY      N              K                 *
*              S  (F) =   SUM     (-1)  EXP (N*F) / N                  *
*               K        N = 0                                         *
*                                                                      *
*   FOR K = 2, 3 TO MACHINE PRECISION. THIS IS A UTILITY SUBROUTINE,   *
*   CALLED BY SUBROUTINES NUCPOT AND NCHARG.                           *
*                                                                      *
*   NO SUBROUTINES CALLED                                              *
*                                                                      *
*   WRITTEN BY FARID A PARPIA, AT OXFORD  LAST REVISION: 25 JAN 1988   *
*                                                                      *
************************************************************************
*
      implicit real*8 (a-h, o-z)
*   
      common/cons/zero,half,tenth,one,two,three,ten
*   
      n = 0
      s2f = zero
      s3f = zero
      fase = one
    1 n = n+1
         en = dble (n)
         obn = one/en
         fase = -fase
         enf = exp (en*f)
         term2 = fase*enf*obn*obn 
         term3 = term2*obn                                              
         s2last = s2f
         s2f = s2f+term2
         s3f = s3f+term3  
         if (abs (s2f) .ne. abs (s2last)) goto 1                        
*
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### homo_check ###
c
c     Determines Ci symmetry of a given orbital and uses it to replace
c     the values in the [pi/2,pi] region by these from the [0,pi/2] one.
c
      subroutine homo_check(psi) 
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*8 sigma,pi,delta,phi
      include 'commons8.inc'
      dimension psi(*)
      data sigma/'sigma'/,pi/'pi'/,delta/'delta'/,phi/'phi'/ 

      write(*,1000)
      do iorb=1,norb
         ibeg = i1b(iorb)
         nmut = i1mu(iorb)	  
         call homo_check1(nmut,psi(ibeg),ihsym)
         if (ihsym.eq.1) then
            if (bond(iorb).eq.sigma.or.bond(iorb).eq.delta) then 
               write(*,1005) iorn(iorb),bond(iorb),gut(iorb)
            else  
               write(*,1010) iorn(iorb),bond(iorb),gut(iorb)
            endif
         endif
         if (ihsym.eq.-1) then
            if(bond(iorb).eq.sigma.or.bond(iorb).eq.delta) then 
               write(*,1010) iorn(iorb),bond(iorb),gut(iorb)
            else
               write(*,1005) iorn(iorb),bond(iorb),gut(iorb)
            endif
         endif
      enddo
01000 format(/,' checking symmetry of orbitals:'/,
     &     '          required    actual ')
01005 format(1x,i3,1x,a8,1x,a1,10x,'g')
01010 format(1x,i3,1x,a8,1x,a1,10x,'u')
      return
      end

c ### homo_check1 ###
c
      subroutine homo_check1 (nmut,psii,ihsym)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psii(nni,nmut)

      n2=(nni-1)/2+1
      if (psii(2,10)*psii(nni-1,10).gt.0.d0) then
         ihsym= 1
      else
         ihsym=-1
      endif
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### fill4 ###
c
c     Immerses FUN array into WORK and adds boundary values: 
c     the last subgrid
c
      subroutine fill4 (nni,nmi,fun,work)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      common/interp/ cint2(9,4),cint3l(9,4),cint3r(9,4),cint4(9,4),
     &		   iadint2(4),iadint3l(4),iadint3r(4),iadint4(4)
      common/sorwk/ omega,omega1,dmu2t(4),dmu1t(4),icase,ifill,
     &              isym,muoffs

      dimension fun(nni,*),work(nni+8,nmi+8),fint(450,4)	

c     muoffs=iemu(ig-1)-1
c     fill the interior of work array

      do i=1,nmi
         do j=1,nni
            work(j+4,i+4)=fun(j,muoffs+i)
         enddo
      enddo

c     values over i=1 bondary are determined from the interpolation formula
c     mu=2,...,4 from interpolation (coefficients from cint4)

      do i=2,4
         call mxv(fun(1,iadint4(i)),nni,cint4(1,i),9,fint(1,i))
      enddo

      do i=2,4
         do j=1,nni
	    work(j+4,i)= fint(j,i)
         enddo
      enddo

c     the following code is necessary since the derivatives must be calculated
c     up to i=nmi
      do i=1,4
         do j=1,nni
	    work(j+4,nmi+4+i)= fun(j,muoffs+nmi)
         enddo
      enddo

c     isym = 1 - even symmetry, isym =-1 - odd symmetry

      if (isym.eq.1) then

c ni=1...4
         do i=1,nmi
            do j=2,5
               work(6-j,i+4)= fun(j,muoffs+i)
            enddo
         enddo

c ni=ni+4...ni+8
         do i=1,nmi
            jj=0
            do j=nni-4,nni-1
               jj=jj+1
               work(nni+9-jj,i+4)= fun(j,muoffs+i)
            enddo
         enddo
      else
         do i=1,nmi
            do j=2,5
               work(6-j,i+4)=-fun(j,muoffs+i)
            enddo
         enddo

         do i=1,nmi
	    jj=0
            do j=nni-4,nni-1
               jj=jj+1
               work(nni+9-jj,i+4)=-fun(j,muoffs+i)
            enddo
         enddo
      endif

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### nmucalc ###
c
c     Calculates nmu for given nni and practical infinity values 
c     (a single grid case is assumed) 
c
      function nmucalc()
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*8 sigma,pi,delta,phi
      character*8 spac,ger,uger
      include 'commons8.inc'

c     mxnmu --  maximum no. of grid points in mu variable
c               mxmnu should be of the form 6N+1
c     hni - step in ni variable
c     hmu - step in mu variable
      
c     determine step size in nmu variable so as hmu is approximately
c     equal to hni

c     adjust, if necessary, the number of grid points in nu variable
      k1=5
      k2=6
 12   nord=(nni-1)/k2
      if (k2*nord.ne.nni-1) then
         nni=nni-1
         goto 12
      endif

c     estimate nmu assuming that hmu=hni

      hni=pii/dble(nni-1)

      xmi0=2.d0*rgrid(1)/r
      xmi0=log(xmi0+sqrt(xmi0*xmi0-1.d0))
c      hmu(1)=xmi0/dble(mxnmu-1)
      mxnmu=xmi0/hni+1
      nmu(1)=mxnmu

c     adjust, if necessary, the number of grid points in mu variable
      ig=1
 20   continue
      ichk1=0
      ichk2=0
 11   nord=(nmu(ig)-1)/k2
      if (k2*nord.ne.nmu(ig)-1) then
         nmu(ig)=nmu(ig)-1
         ichk2=ichk2+1
         goto 11
      endif
      if (ichk1.ne.0.or.ichk2.ne.0) goto 20

      mxnmu=nmu(1)

c     calculate hmu(1) for the adjusted value of mxnmu
      xmi0=2.d0*rgrid(1)/r
      xmi0=log(xmi0+sqrt(xmi0*xmi0-1.d0))
      hmu(1)=xmi0/dble(mxnmu-1)

      nmucalc=mxnmu
      
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zz1 ###
c
c     Part of this routine has been taken from GRASP2 package (ver. 1.00,  
c     Copyright (C) 1992 by F.A. Parpia, I.P. Grant, and C.F. Fischer)
c
c     Evaluate the nuclear potential for Fermi models.  
c                                                                      
      function zz1(i,j)
      implicit integer*4 (i-n)
      implicit real*8 (A-H, O-Z)
      include 'commons8.inc'

c     ainfcm: bohr radius in cm
      data ainfcm/0.529 177 249  d-08/

      if (z1.eq.0.d0) then
         zz1=0.d0
         return
      endif

      fmtoau=1.0d-13/ainfcm

c     potential energy is V(i,j)=-zz1(i,j)/r1 -z2/r2
c     set atomic weight 

      atw=z1atmass
      at3=atw**(one/three)
      rrmsfm = 0.836d 00*at3+0.570d 00
      tfm = 2.30d 00

c     change units from fm into bohr
      rrms = rrmsfm*fmtoau
      t = tfm*fmtoau  
      a = t/(4.0d 00*log (3.0d 00))         
      facto1 = rrms**2-(7.0d 00/5.0d 00)*(pii**2)*(a**2)
      c = sqrt (5.0d 00/3.0d 00) * sqrt (facto1) 

      abc = a/c
      tabc = two*abc
      abc2 = abc*abc
      thabc2 = three*abc2
      abc3 = abc2*abc
      cba = c/a
      pi2 = pii*pii
      hpiac2 = half*pi2*abc2
      six = two*three
      h3 = half*three
      h3php = h3+hpiac2                                              
      call es (-cba,s2mcba,s3mcba)
      sabc3 = six*abc3
      dmsas = -sabc3*s3mcba
      en = one + abc2*pi2 + dmsas
      zbn = z1/en

      ri = r*(vxi(i)+veta(j))/2.d0
      rmc = ri-c
      rmcba = rmc/a
      rbc = ri/c
      if (rbc .le. one) then
         call es (rmcba,s2rcba,s3rcba)
         zz1 = zbn*( dmsas + sabc3*s3rcba
     &        +rbc*( h3php-thabc2*s2rcba
     &        -half*rbc*rbc) )
      else
         call es (-rmcba,s2rcba,s3rcba)
         zz1 = z1 * ( one
     &        +thabc2 * ( rbc *s2rcba
     &        +tabc*s3rcba ) / en )
      endif
      
      if (idbg(451).ne.0) then
         if (abs(zz1-z1).gt.1.d-8) then
            write(*,*) i,j,ri,zz1
         endif
      endif
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### chasympot ###
c
c     Checking contributions of multipole moments to Coulomb and exchange 
c     potentials at the practical infinity.
c
c     Determine asymptotic (boundary) values of Coulomb and exchange
c     potentials from the multipole expansion of a given order.
c
      subroutine chasympot (pot,excp)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*),excp(*)

c     write(*,*) 'asympt: for two different nonsigma orbitals',
c     & 	  'the case (+-) is now also included'

      write(*,*) 'Checking multipole expansion for Coulomb potentials'
      do iorb=norb,1,-1
         call zmultitail(iorb,pot(ibeg))
      enddo 	

      if (iform.eq.0.or.iform.eq.2) return
      if (islat.eq.1) return

      write(*,*)
      write(*,*) 'Checking multipole expansion for exchange potentials'
      do iorb1=1,norb
         do iorb2=iorb1,norb
            if (iorb1.eq.iorb2.and.mgx(6,iorb1).eq.0 ) goto 10
            if ((iorb1.eq.iorb2).and.
     &           (ilc(iorb1*(iorb1+1)/2).lt.1)) goto 10

c           orbitals in increasing order

            ipc=iorb1+iorb2*(iorb2-1)/2
            iax=i3b(ipc)

            idel=abs(mgx(6,iorb1)-mgx(6,iorb2))
            if (iorb1.eq.iorb2) idel=2*mgx(6,iorb1)

            ido=0
 1234       ido=ido+1
            if (ido.eq.2) then
               idel=mgx(6,iorb2)+mgx(6,iorb1)
               ipc=ipc+norb*(norb+1)/2
               iax=iax+i3si(ipc)
            endif
            
            write(*,1000) iorn(iorb1),bond(iorb1),gut(iorb1),
     &           iorn(iorb2),bond(iorb2),gut(iorb2)
            write(*,*) '------ ilc(ipc) ',iorb1,iorb2,'...',idel,
     &           '...',ipc,ilc(ipc)
 1000       format(i4,1x,a8,a1,3x,i4,1x,a8,a1,3x)
            
            if (idbg(300).eq.0) then
               call zasyxtail1   (idel,ipc,excp(iax))
            else
               call zasyxtail  (idel,ipc,excp(iax))
            endif
            
            if (ilc(ipc).eq.2.and.ido.eq.1) go to 1234
 10         continue
         enddo
      enddo
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### clrstring ###
c
c     Removes unprintable signs from an array.
c
      subroutine clrstring (imax,str)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 str(80),digits(10)
      data digits/'0','1','2','3','4','5','6','7','8','9'/
      
      do i=80,1,-1
         imax=i
         do j=1,10
            if (str(i).ne.digits(j)) then 
               str(i)=' '
            else 
               goto 111
            endif
         enddo
      enddo
 111  continue
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### blas_ymp ###
c
c     Interface to Cray BLAS routines: scopy, saxpy, sscal, sdot
c
      subroutine  dcopy(n,dx,ix,dy,iy)
      real*8  dx(*),dy(*)
      integer*4 ix,iy,n

      call scopy(n,dx,ix,dy,iy)
      return
      end

      subroutine  daxpy(n,da,dx,ix,dy,iy)
      real*8 da,dx(*),dy(*)
      integer*4 ix,iy,n

      call saxpy(n,da,dx,ix,dy,iy)
      return
      end

      subroutine  dscal(n,da,dx,ix)
      real*8 da,dx(*)
      integer*4 ix,n

      call sscal(n,da,dx,ix)
      return
      end

      function  ddot(n,dx,ix,dy,iy)
      real*8  dx(*),dy(*),ddot
      integer*4  ix,iy,n

      ddot=sdot(n,dx,ix,dy,iy)
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rfdisk ### 
c
c     Controls retrieving orbitals and potentials from a disk file
c
      subroutine rfdisk (cw_orb,cw_coul,cw_exch,cw_sctch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),cw_sctch(*)

      call rheader(norb_p)
      if (iinterp.eq.0) then	
         call rfun (norb_p,cw_orb,cw_coul,cw_exch)	
      else
	 call grid_old
	 call rfun_int (norb_p,cw_orb,cw_coul,cw_exch,cw_sctch)	
      endif
      
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### mulex ###
      subroutine mulex(i,j,mt,dome)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension dome(10)

      rr=sqrt(vxisq(j)+vetasq(i)-1.d0)		
      costh=0.d0
      if (abs(rr).gt.precis) then
         costh=veta(i)*vxi(j)/rr	 
      endif

      costh2=costh*costh
      costh3=costh2*costh
      costh4=costh2*costh2

      if (mt.eq.0) then
c        m=0
         dome( 1)=costh
         dome( 2)=( 3.d0*costh*dome(1) - 1.d0)	  / 2.d0
         dome( 3)=( 5.d0*costh*dome(2) - 2.d0*dome(1))/ 3.d0
         dome( 4)=( 7.d0*costh*dome(3) - 3.d0*dome(2))/ 4.d0
         dome( 5)=( 9.d0*costh*dome(4) - 4.d0*dome(3))/ 5.d0
         dome( 6)=(11.d0*costh*dome(5) - 5.d0*dome(4))/ 6.d0
         dome( 7)=(13.d0*costh*dome(6) - 6.d0*dome(5))/ 7.d0
         dome( 8)=(15.d0*costh*dome(7) - 7.d0*dome(6))/ 8.d0
         return
      elseif (mt.eq.1) then
c        m=1
         sini2=abs(1.d0-costh2)
         sini =sqrt(sini2)
         dome(1)=sini*calp(12)
         dome(2)=costh*sini*calp(5)	  
         dome(3)=sini*(5.d0*costh2-1.d0)*calp(4)
         dome(4)=sini*(7.d0*costh3-3.d0*costh)*calp(3)
         return
      elseif (mt.eq.2) then
c        m=2
         sini2=abs(1.d0-costh2)
         sini =sqrt(sini2)
         dome(2)=sini2*calp(8)	  
         dome(3)=sini2*costh*calp(7)
         dome(4)=sini2*(7.d0*costh2-1.d0)*calp(6)
         return
      elseif (mt.eq.3) then 
c        m=3
         sini2=abs(1.d0-costh2)
         sini =sqrt(sini2)
         sini3=sini2*sini
         dome(3)=sini3*calp(10)
         dome(4)=sini3*costh*calp(9)
         return
      elseif (mt.eq.4) then
c        m=4
         sini2=abs(1.d0-costh2)
         sini =sqrt(sini2)
         sini3=sini2*sini
         sini4=sini2*sini2
         dome(4)=sini4*calp(11)
      endif
      return	
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### toten ### 
c
c     Calculates total energy 
c
      subroutine toten (psi,pot,excp,e,f0,wgt1,wgt2,wk0,wk1,wk2,wk3)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),e(*),f0(*),wgt1(*),wgt2(*),
     &     wk0(*),wk1(*),wk2(*),wk3(*)
      data eps /1.d-7/

      if (islat.ne.0) then
c        the Slater exchange approximation is used
	 call totensl (psi,pot,excp,e,f0,wgt1,wgt2,wk0,wk1,wk2,wk3)
	 return
      endif

      engt(1)=eng(1)

      call prepwexch

      engt(1)=0.d0
      
c     calculate first contributions from one particle operators and
c     coulomb potential contributions within the same shell

      if (idbg(70).ne.0) then
	 write(*,*) 'orb        t        v(n)      t+v(n)     ',
     &        ' v(c-within shell)'
      endif
      
      norb2=norb*norb
      woneel=0.d0
      wdcoul=0.d0

      vkt=0.d0
      vnt=0.d0
      
      do iorb=1,norb
         iborb=i1b(iorb)
         isiorb=i1si(iorb)
         nmut=i1mu(iorb)
         ibpot=i2b(iorb)	  
         isipot=i2si(iorb)
         if (idbg(70).ne.0) write(*,*) 'iorb,occ(iorb)',iorb,occ(iorb)
         oc=occ(iorb)

         ipe=mgx(6,iorb)
         ipex=ipe-2*(ipe/2)

c        calculate derivatives over mu and ni variables by means of matrix
c        multiplication

         if (ipex.eq.0) then
	    isym= 1
         else
	    isym=-1
         endif
     
         call fill (nni,nmut,isym,psi(iborb),wk3)
         call difni (nmut,wk3,wk0,wk1,wk2)
         call refill(nni,nmut,wk1,wk0)
         call difmu (nmut,wk3,wk2)
         call refill(nni,nmut,wk0,wk2)

c        add derivatives over mu and ni

         call add (isiorb,wk0,wk1)

c        add contribution from phi part of laplasian
c        e enters the expression with minus sign which is already
c        incorporated in e
         
         if (ipe.ne.0) then
	    w=dble(ipe*ipe)
	    call dcopy (isiorb,e,1,wk0,1)
	    if (ipe.ne.1) then
               call dscal (isiorb,w,wk0,1)
	    endif
	    call prod  (isiorb,psi(iborb),wk0)
	    call add   (isiorb,wk0,wk1)
         endif
    
         call dcopy (isiorb,wk1,1,wk2,1)
         call prod  (isiorb,psi(iborb),wk2)
         w=ddot(isiorb,wgt1,1,wk2,1)
c         write(*,'(3d22.14)') w,wk1(isiorb/2),wk2(isiorb/2)
c         write(*,'(3d22.14)') psi(iborb),psi(iborb+3*isiorb/4)
c         write(*,*) isiorb,iborb
         vk(iorb)=w
         
         call dcopy (isiorb,f0,1,wk0,1)
         call prod  (isiorb,psi(iborb),wk0)
         
         call prod2 (isiorb,psi(iborb),wk0,wk2)
         w=ddot(isiorb,wgt1,1,wk2,1)
         vn(iorb)=w

         call add (isiorb,wk0,wk1)
         call prod (isiorb,psi(iborb),wk1)

         w = ddot(isiorb,wgt1,1,wk1,1)
         woneel=woneel+oc*w

         if (nel.lt.2) then
            vkt=vkt+oc*vk(iorb)
            vnt=vnt+oc*vn(iorb)
            evt=woneel
            epott=vnt
            virrat=(epott+z1*z2/r)/vkt
            etot=evt+z1*z2/r
            return
         endif

c        contribution from coulomb interaction within the same shell
         
         if (oc.gt.1.d0) then
	    if (isipot.ne.isiorb) then
               write(iout6,*) 'coulomb potentials and orbitals',
     &              ' have to defined on the same number of subgrids'
               stop 'toten'
            endif				
            call dcopy (isipot,pot(ibpot),1,wk2,1)
            call prod  (isiorb,psi(iborb),wk2)
            call prod  (isiorb,psi(iborb),wk2)
            
            w=ddot(isiorb,wgt2,1,wk2,1)
            wdcoul=wdcoul+oc*(oc-1.d0)/2.d0*w
         endif	    
         
         vkt=vkt+oc*vk(iorb)
         vnt=vnt+oc*vn(iorb)
         
         if (idbg(70).ne.0) then
            write(*,6000) iorb, vk(iorb),vn(iorb),
     &           vk(iorb)+vn(iorb),w
         endif
 10      continue
      enddo
      
 6000 format(' ',i4,2x,4d22.14)
 6010 format(' ',i4,2x,4d22.14)
 6012 format(' ',2i4,2x,4d22.14)

c     contribution from coulomb and exchange interaction between shells
      
      wndc =0.d0
      wex1 =0.d0
      wex2 =0.d0

      do iorb1=1,norb
         
c        retrieve from a disk file exchange potentials involving iorb1

         if (iform.eq.0.or.iform.eq.2) then
            call  rfdexch(iorb1,excp)
         endif
         
         iborb1=i1b(iorb1)
         isiorb1=i1si(iorb1)
         nmut1=i1mu(iorb1)
         ibpot1=i2b(iorb1)
         isipot1=i2si(iorb1)	  	  
         oc1=occ(iorb1)	
         
         ipe1=mgx(6,iorb1)
         iex1 =iorb1+iorb1*(iorb1-1)/2

         call dcopy (isiorb1,psi(iborb1),1,wk0,1)
         call prod  (isiorb1,psi(iborb1),wk0)

c        calculate exchange interaction within pi, delta, etc. open shell
         
         if (ipe1.gt.0.and.abs(oc1-1.d0).gt.eps) then
            call exint (iorb1,ocx1)
            ibex=i3b(iex1)
            isiex1=i3si(iex1)
            
            ngrid=min(isiorb1,isiex1)
            call prod2  (ngrid,wk0,excp(ibex),wk1)
            w=ddot (ngrid,wgt2,1,wk1,1)
            wex1=wex1+ocx1*w
            
            if (idbg(70).ne.0) then
               write(*,6020) iorb1,w
 6020          format(' ','orb v(x-within shell) ',i4,2x,4d15.5)
            endif
            
            if (idbg(71).ne.0) then
               write(*,7020) iorn(iorb1),bond(iorb1),gut(iorb1),
     &              ipe1,ocx1
 7020          format(' ','v(x-within shell)  ',
     &              i4,1x,a8,a1,i4,f6.2)
            endif
         endif
         
         do iorb2=iorb1+1,norb
            iborb2=i1b(iorb2)
            isiorb2=i1si(iorb2)
            nmut2=i1mu(iorb2)
            ibpot2=i2b(iorb2)
            isipot2=i2si(iorb2)	  
            oc2=occ(iorb2)	

c           coulomb interaction between shells

            ngrid=min(isipot2,isiorb1)
            call prod2 (ngrid,pot(ibpot2),wk0,wk1)

            w=ddot(ngrid,wgt2,1,wk1,1)
            wndc=wndc+oc1*oc2*w

            if (idbg(70).ne.0) then
               write(*,6022) iorb1,iorb2,w
 6022          format(' ','orb1 orb2 v(c-inter shell) ',2i4,2x,4d15.5)
               write(*,*) 'wndc ',iorb1,wndc
            endif

            if (idbg(71).ne.0) then
               write(*,7022) iorn(iorb1),bond(iorb1),gut(iorb1),
     &              iorn(iorb2),bond(iorb2),gut(iorb2),oc1*oc2
 7022          format(' ','v(c-inter shell)  ',i4,1x,a8,a1,
     &              i4,1x,a8,a1,f6.2)
            endif
            
            ipe2=mgx(6,iorb2)
            iex=iorb1+iorb2*(iorb2-1)/2
            ibex=i3b(iex)	  
            isiex=i3si(iex)

c           exchange interaction between shells (same lambda)	  

            call excont (iorb1,iorb2,ocx1,ocx2)	  
            
            ngrid=min(isiorb1,isiorb2,isiex)
            call prod2 (ngrid,excp(ibex),psi(iborb1),wk1)
            call prod  (ngrid,psi(iborb2),wk1)
            
            w=ddot(ngrid,wgt2,1,wk1,1)
            wex1=wex1+ocx1*w
            
            if (idbg(70).ne.0) then
               write(*,6024) iorb1,iorb2,w
 6024          format(' ','orb1 orb2 v(x-inter shell)a',2i4,2x,4d15.5)
               write(*,*) 'wex1 ',iorb1,iorb2,w,wex1
            endif
            
            if (idbg(71).ne.0) then
               write(*,7024) iorn(iorb1),bond(iorb1),gut(iorb1),
     &              iorn(iorb2),bond(iorb2),gut(iorb2),ocx1
07024          format(' ','v(x-inter shell)a ',i4,1x,a8,a1,
     &              i4,1x,a8,a1,f6.2)
            endif
            
c           exchange interaction between shells (different lambda)
            
            if (ilc(iex).gt.1) then
               call prod2 (ngrid,excp(ibex+ngrid),psi(iborb1),wk1)
               call prod  (ngrid,psi(iborb2),wk1)
               w=ddot (ngrid,wgt2,1,wk1,1)
               wex2=wex2+ocx2*w

               if (idbg(70).ne.0) then
                  write(*,6026) iorb1,iorb2,w
 6026             format(' ','v(x-inter shell)b ',2i4,2x,4d15.5)
                  write(*,*) 'wex2 ',iorb1,iorb2,w,wex2
               endif

               if (idbg(71).ne.0) then
                  write(*,7026) iorn(iorb1),bond(iorb1),gut(iorb1),
     &                 iorn(iorb2),bond(iorb2),gut(iorb2),ocx2
 7026             format(' ','v(x-inter shell)b ',i4,1x,a8,a1,
     &                 i4,1x,a8,a1,f6.2)
               endif
               
            endif
 20         continue
         enddo
      enddo
      
      evt=woneel+wdcoul+wndc-wex1-wex2
      epott=vnt+wdcoul+wndc-wex1-wex2
      virrat=(epott+z1*z2/r)/vkt
      etot=evt+z1*z2/r
      
      engt(1)=evt
      
      if (idbg(70).ne.0) then
         write(*,*) 'total energy: ', evt
         write(*,*) 'contributions: one-electron     coulomb',
     &        '     exchange  '
         write(*,'(3d22.14)')  woneel,wdcoul+wndc,wex1+wex2
      endif
      
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### wtdexch1 ###
c
c     Writes exchange potentials as separate files
c
      subroutine wtdexch1 (excp)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension excp(*)

      do iorb1=1,norb
         do iorb2=iorb1,norb
            k=i3xk(iorb1,iorb2)
            if (ilc(k).ne.0) then
               i3beg=i3b(k)
               irec=i3xrec1(k)
               ngrid=i3si(k) 

               call wrec(irec,ngrid,excp(i3beg))

               if (ilc(k).eq.2) then
                  i3beg=i3b(k)+ngrid
                  irec=i3xrec2(k)
                  call wrec(irec,ngrid,excp(i3beg))
               endif
            endif
         enddo
      enddo
      return
 900  continue
      write(iout6,*) 'error detected when writing exchange',  
     &     ' potential',iorb1,iorb2,k,irec
      stop 'wtdexch1'
 1050 format(/1x,'... writing functions to disk ...'//)
 1070 format(//1x,'error! can not write data to disk'//)     
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### difni ###
c
c    This routine calculates 
c
c     (\frac{\partial^2}{\partial\ni^2} + 
c           d(\ni,\mu) \frac{\partial}{\partial \ni}) f(\ni,\mu)
c
c     The function is imersed in the array f(nni+8,nmut+8)
c     To allow for the differentiation over ni variable in the form
c     of matrix times vector the array f has to be transposed first.
c     Results of differentiation are stored directly column-wise in 
c     another matrix which means doing back tranposition before 
c     returning to a calling routine.
c
c     This routine differentiates a function over ni variable.
c     the function is imersed in the array f(nni+6,nmut+6)
c
      subroutine difni (n,f,fd,wtran1,wtran2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension f(nni+8,n+8),fd(nni+8,n+8),
     &          wtran1(n+8,nni+8),wtran2(n+8,nni+8)

c     To allow for the differentiation over ni variable in the form
c     of matrix times vector the array f has to be transposed first.
c     Results of differentiation will be stored directly
c     column-wise in another matrix which means doing back tranposition
c     before returning to calling routine.  

      call gmtran (f,wtran1,nni+8,n+8)

      do j=1,nni
         call mxv (wtran1(1,j),n+8,dni(1,j),9,wtran2(1,j+4))
      enddo

      call gmtran(wtran2,fd,n+8,nni+8)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### fock ###
c
c     Calculates the Fock potential for a given orbital.
c
      subroutine fock (iorb,psi,pot,excp,e,f0,f1,f2,f4,wk0,wk1,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),e(*),f0(*),f1(*),f2(*),f4(*),
     &	    wk0(*),wk1(*),wk2(*)	

      iborb=i1b(iorb)
      ngorb=i1si(iorb)
      ibpot=i2b(iorb)
      ngpot=i2si(iorb)	
      norb2=norb*norb		
      ipe=mgx(6,iorb)
      ipex=ipe-2*(ipe/2)
      
      if (ipe.eq.0) then
         call dcopy (mxsize,f0,1,wk0,1)
         call daxpy (mxsize,eng(iorb),f1,1,wk0,1)
      else

c        e enter the expression with minus sign which is already
c        incorporated in e

         w=dble(ipe*ipe)
         call dcopy (mxsize,f0,1,wk0,1)
         call daxpy (mxsize,eng(iorb),f1,1,wk0,1)
         call daxpy (mxsize,w,e,1,wk0,1)
      endif

      if(idbg(97).ne.0) then
         write(*,*) 'eng(iorb)',eng(iorb)
         write(*,*) 'fock: f0'
         call pmtx (nni,nmu(1),f0,1,1,incrni,incrmu)
         write(*,*) 'fock: f1'
         call pmtx (nni,nmu(1),f1,1,1,incrni,incrmu)
         write(*,*) 'fock: f2'
         call pmtx (nni,nmu(1),f2,1,1,incrni,incrmu)
         write(*,*) 'fock: f4'
         call pmtx (nni,nmu(1),f4,1,1,incrni,incrmu)
         write(*,*) 'fock: wk0'
         call pmtx (nni,nmu(1),wk0,1,1,incrni,incrmu)
      endif

      do i=1,mxsize
         wk1 (i)=0.d0
         wk2 (i)=0.d0	  
         foc2(i)=0.d0
      enddo	

      if (nel.gt.1) then
         if (norb.eq.1) then
            
c           contribution from coulomb potential of one sigma orbital

            call dcopy (ngpot,pot(ibpot),1,wk1,1)
         else

c           add contributions from coulomb and exchange potentials

            do iorb1=1,norb
               iborb1=i1b(iorb1)
               ngorb1=i1si(iorb1)
               kex=iorb+norb*(iorb1-1)
               ideng=iorb1+norb*(iorb-1)
               
               if (iorb.le.iorb1) then
                  idexp=iorb+iorb1*(iorb1-1)/2
               else
                  idexp=iorb1+iorb*(iorb-1)/2
               endif
               
               ibpot1=i2b(iorb1)
               ngpot1=i2si(iorb1)
               ibexp=i3b(idexp)
               ngexp=i3si(idexp)
               
               if (idbg(95).ne.0) then
                  write(*,*) 'focksl: iorb1,ibpot1,coo',iorb1,ibpot1,coo
               endif
               
               coo=occ(iorb1)
               if (iorb.eq.iorb1) coo=coo-1.d0
               
               call daxpy (ngpot1,coo,pot(ibpot1),1,wk1,1)
               
               if (iorb1.ne.iorb)  then
                  coo=gec(kex)
                  call dcopy (ngexp,excp(ibexp),1,wk2,1)
                  call dscal (ngexp,coo,wk2,1)
                  
                  if (ilc(idexp).gt.1) then
                     coo=gec(kex+norb2)
                     call daxpy (ngexp,coo,excp(ibexp+ngexp),1,wk2,1)
                  endif
                  
                  if (engo(ideng).ne.0.d0) then
                     call daxpy (ngexp,engo(ideng),f4,1,wk2,1)
                  endif
                  
                  call prod (ngorb1,psi(ibpot1),wk2)
                  call add  (ngorb1,wk2,foc2)
               else
                  if ((ipe.gt.0).and.(ilc(idexp).gt.0)) then
                     coo=gec(kex)
                     call dcopy (ngexp,excp(ibexp),1,wk2,1)
                     ngrid=max(ngexp,ngorb1)
                     call prod  (ngorb1,psi(iborb1),wk2)
                     call dscal (ngrid,coo,wk2,1)
                     call add (ngrid,wk2,foc2)
                  endif
               endif
            enddo
         endif
         
         if (idbg(97).ne.0) then
            write(*,*) 'fock: coulomb potential'
            call pmtx (nni,nmu(1),wk1,1,1,incrni,incrmu)
            write(*,*) 'fock: one-electron contr.'
            call pmtx (nni,nmu(1),wk0,1,1,incrni,incrmu)
c           write(*,*) ' fock0 - f4   '
c           call pmtx (nni,nmi,f4   ,incrni,incrmi)
         endif
         
c        multiply coulomb and exchange pot. by f2
         
         call prod (mxsize,f2,wk1)
         call prod (mxsize,f2,foc2)
      endif

c  add one electron and coulomb pot. contributions
c  are coulomb and exchange pot zero at infinity?

      call add (mxsize,wk0,wk1)
      call dcopy (mxsize,wk1,1,foc1,1)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### hypgf3 ###		  	    
c
	function hypgf3(na,nb,nc,x)
      implicit integer*4 (i-n)
        implicit real*8 (a-h,o-z)		

	hypgf3=1.d0
	if (na.eq.0) return
	a=dble(na)
	b=dble(nb)
	c=dble(nc)
	t=a*b*x/c
	hypgf3=hypgf3+t
	if (-na.eq.1) return
	do i=2,-na
	   t=t*x*(a+dble(i-1))*(b+dble(i-1))/(c+dble(i-1))/dble(i)
	   hypgf3=hypgf3+t
	enddo
	return
	end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### grid_old ###
c
c     Initializes grid info to enable interpolation.
c
      subroutine grid_old
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

      ibmu_p(1)=1
      iemu_p(1)=nmu_p(1)
      mxnmu_p=nmu_p(1)
      ioffs_p(1)=0
      do ig=2,ngrids_p
         mxnmu_p=mxnmu_p+nmu_p(ig)-1
         ibmu_p(ig)=iemu_p(ig-1)	 	 
         iemu_p(ig)=mxnmu_p
         ioffs_p(ig)=nni_p*(iemu_p(ig-1)-1)
      enddo

c     determine the size of each grid
      
      do ig=1,ngrids_p
         ngsize_p(ig)=nni_p*nmu_p(ig)
      enddo

c     total no of grid points 

      mxsize_p=nni_p*mxnmu_p

c     hni - step in ni variable
c     hmu - step in mu variable

c     determine step size in ni variable 

      hni_p=pii/dble(nni_p-1)

c     determine step size in mu variable for each grid

      if (ngrids_p.eq.1.and.rgrid_p(1).ge.0.5d0) then
         xmi0=2.d0*rgrid_p(1)/r_p
         xmi0=log(xmi0+sqrt(xmi0*xmi0-1.d0))
         hmu_p(1)=xmi0/dble(mxnmu_p-1)
      else
         do ig=1,ngrids_p
            if(ig.eq.1) then 
               hmu_p(ig)=rgrid_p(ig)
            else
               hmu_p(ig)=hmu_p(1)*rgrid_p(ig)
            endif
         enddo
      endif

c     initialize mu and xi arryas

      vmu_p(1) =0.d0
      vxi_p(1) =cosh(vmu_p(1))
      vxisq_p(1)=vxi_p(1)*vxi_p(1)	    	    
      vxi1_p(1)=sqrt(vxi_p(1)*vxi_p(1)-1.d0)
      vxi2_p(1)=0.0d0

      ib=2
      
      do ig=1,ngrids_p
         ie=iemu_p(ig)
         do i=ib,ie
            vmu_p(i)=vmu_p(i-1)+hmu_p(ig)
            vxi_p(i)=cosh(vmu_p(i))
            vxisq_p(i)=vxi_p(i)*vxi_p(i)	    	    

c           sqrt(vxi*vxi-1)  and  ssf*vxi/sqrt(vxi*vxi-1)
            
            vxi1_p(i)=sqrt(vxi_p(i)*vxi_p(i)-1.d0)
            vxi2_p(i)=vxi_p(i)/vxi1_p(i)
c           enddo over i
         enddo 
         ib=ie+1
c        enddo over ig
      enddo

c     determine rinf
      
      write(iout6,*) 
      write(iout6,*) 'about to interpolate: previous grid info:'
      write(iout6,*) 'subgrid  nni    nmu   hni  hmu      rb '
      rinf_p=r_p*vxi_p(iemu_p(ngrids_p))/2.d0
      do ig=1,ngrids_p
         rinfig_p=r_p*vxi_p(iemu_p(ig))/2.d0
         write(iout6,1000) ig,nni_p,nmu_p(ig),hni_p,hmu_p(ig),rinfig_p
      enddo
01000 format(4x,i2,3x,i4,2x,i4,2f8.5,f8.3)

c    initialize ni and eta arrays

      do i=1,nni_p
         vni_p(i)=dble((i-1))*hni_p
         veta_p(i)=cos(vni_p(i))
         vetasq_p(i)=veta_p(i)*veta_p(i)		

c        sqrt(1-veta*veta) and  veta/sqrt(1-veta*veta)
c        
         veta1_P(i)=sqrt(1.d0-veta_p(i)*veta_p(i))
         if (veta1_p(i).lt.precis) then
            veta2_p(i)=0.0
         else
            veta2_p(i)=veta_p(i)/veta1_p(i)
         endif
      enddo

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rrec ###
c
        subroutine rrec(irec,ngrid,axyz)
      implicit integer*4 (i-n)
        implicit real*8 (a-h,o-z)
        include 'commons8.inc'        
        dimension axyz(ngrid)
        iunit=irec+30
        if (iunit.gt.maxunit) then
           write(*,910)
           stop "rrec"
 910       format('rrec: maximum unit number exceeded ',
     &        '(see User''s Guide)')
        endif
        open(iunit,status='unknown',form='unformatted')
        rewind(iunit)
        read  (iunit) axyz
        close(iunit)
        return
        end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### printall ###
c
c     This routine can be used to check if input data have been
c     correctly transformed into values of numerous variable used by the
c     program.
c
      subroutine printall
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      character*1 str(80)
      equivalence(datetime,str(1))

      call banner

      call  getdatetime(datetime)
      imax=0
      call  clrstring(imax,str)
      write(*,'(1x,80a1)') (str(i),i=1,imax)

c     calculate the total length of working arrays (in bytes)

c     system under consideration

      izz1=nint(z1)
      izz2=nint(z2)
      write(iout6,*) 
      write(iout6,*) '  molecular system: '
      write(iout6,*) 
      write(iout6,1000) element(izz1), z1, element(izz2), z2 ,
     &                  r,r*0.529177249d0

      if     (ifermi.eq.1) then 
         write(iout6,1401) z1atmass,element(izz1),
     &        z2atmass,element(izz2)

      elseif (ifermi.eq.2) then
         write(iout6,1402) z1atmass,element(izz1),
     &        z2atmass,element(izz2)
      endif
         
      write(iout6,*) 
      if (imethod.eq.1) write(iout6,*) '  method: HF'
      if (imethod.eq.2) write(iout6,*) '  method: OED'
      if (imethod.eq.3) write(iout6,1002) alphaf

      if (ifefield.eq.1) write(iout6,1300) ffield

c     its electronic configuration

      write(iout6,*) 
      write(iout6,*) '  electronic configuration:'
      write(iout6,*) 

      nsigma=0
      nsigmag=0
      nsigmau=0
      npi   =0
      ndelta=0
      nphi  =0
      do iorb=1,norb
         if (orbsym(iorb).eq.'sigma') nsigma=nsigma+1
c        if (orbsym(iorb).eq.'sigma g') nsigmag=nsigmag+1
c        if (orbsym(iorb).eq.'sigma u') nsigmau=nsigmau+1
         if (orbsym(iorb).eq.'pi'   ) npi   =npi   +1
         if (orbsym(iorb).eq.'delta') ndelta=ndelta+1
         if (orbsym(iorb).eq.'phi'  ) nphi  =nphi  +1
      enddo

      iorbr=0
      do iorb=1,norb
         if (iorbr.eq.0.and.orbsym(iorb).eq.'sigma') iorbr=nsigma
c        if (iorbr.eq.0.and.orbsym(iorb).eq.'sigma g') iorbr=nsigmag
c        if (iorbr.eq.0.and.orbsym(iorb).eq.'sigma u') iorbr=nsigmau
         if (iorbr.eq.0.and.orbsym(iorb).eq.'pi') iorbr=npi
         if (iorbr.eq.0.and.orbsym(iorb).eq.'delta') iorbr=ndelta
         if (iorbr.eq.0.and.orbsym(iorb).eq.'phi') iorbr=nphi
         nspins=4
         if (orbsym(iorb).eq.'sigma') nspins=2
         iput=4*(iorb-1)
         write(iout6,1020) iorbr, orbsym(iorb),gut(iorb),
     &        (spin(i+iput),i=1,nspins)  
         iorbr=iorbr-1
      enddo

c     number of electrons and total charge

      write(iout6,*) 
      write(iout6,1010) nel, izz1+izz2-nel

      if (ini.eq.1.or.ini.eq.4) then
         write(iout6,*) 
         write(iout6,*) '  LCAO via hydrogenic functions:'
         write(iout6,*) 
         write(iout6,1030)
         
         iorbr=0
         do iorb=1,norb
            if (iorbr.eq.0.and.orbsym(iorb).eq.'sigma') iorbr=nsigma
            if (iorbr.eq.0.and.orbsym(iorb).eq.'pi') iorbr=npi
            if (iorbr.eq.0.and.orbsym(iorb).eq.'delta') iorbr=ndelta
            if (iorbr.eq.0.and.orbsym(iorb).eq.'phi') iorbr=nphi
            
            iput=4*(iorb-1)
            write(iout6,1032) iorbr, orbsym(iorb),gut(iorb),
     &           mgx(1,iorb),mgx(2,iorb),
     &           eza1(iorb),co1(iorb),
     &           mgx(4,iorb),mgx(5,iorb),
     &           eza2(iorb),co2(iorb)
            iorbr=iorbr-1
         enddo
      endif

      write(iout6,*) 
      write(iout6,*) '  grid:'
      if (ngrids.eq.1) then
         write(iout6,1040) nni,hni,nmu(ngrids),hmu(ngrids),
     &        rinf 
      else
         write(iout6,1042) nni,hni,mxnmu,rinf 
         write(iout6,*)
         write(iout6,*) '     subgrid   nni   nmu    hni      hmu',
     &        '      rb     heta     hxib     hxie'
         rinf=r*vxi(iemu(ngrids))/2.d0
         heta=abs(veta(nni)-veta(nni-1))
         ib=1
         do ig=1,ngrids
            rinfig=r*vxi(iemu(ig))/2.d0
            ie=iemu(ig)
            hxibeg=vxi(ib+1)-vxi(ib)
            hxiend=vxi(ie)-vxi(ie-1)
            write(iout6,1045) ig,nni,nmu(ig),hni,hmu(ig),rinfig,
     &           heta,hxibeg,hxiend
            ib=ie
         enddo
      endif

      write(iout6,*) 
      write(iout6,*) '  scf:'
      if (abs(facmul).lt.100.d0) then
         write(iout6,1049) maxscf,nobckup,ienterm,inoterm,facmul
      else
         write(iout6,1050) maxscf,nobckup,ienterm,inoterm,facmul
      endif

      write(iout6,*) 
      if       (exlorb.eq.0.d0) then
         write (iout6,1051) 
      else
         write (iout6,1052) 
      endif
      if       (exlcoul.eq.0.d0) then
         write (iout6,1053)
      else
         write (iout6,1054)
      endif
      if (imethod.eq.1) then
         if     (exlexp.eq.0.d0) then
            write (iout6,1055) 
         elseif (exlexp.eq.2.d0) then
            write (iout6,1056)
         else
            write (iout6,1057) 
         endif
      endif

      write(iout6,*) 
      write(iout6,*) '  (mc)sor:'

      if     (ipoiss.eq.1) then
         write(iout6,*) '         SOR method used for relaxing ',
     &        'orbitals and potentials'  
      elseif (ipoiss.eq.2) then
         write(iout6,*) '         MCSOR method used for relaxing ',
     &        'orbitals and potentials'  
      elseif (ipoiss.eq.3) then
         write(iout6,*) '         SOR method used for relaxing ',
     &        'orbitals and MCSOR for potentials'     
      endif


      write(iout6,*) 
c      write(iout6,1060) maxsor2, maxsor1
      write(iout6,1060) maxsor2, maxsor2/lsor
      
      write(iout6,*) 
      if (ngrids.eq.1) then
         ior=iorder(ngrids)
         if (ior.eq.1) write(iout6,1071)
         if (ior.eq.2) write(iout6,1072)
         if (ior.eq.3) write(iout6,1073)
         if (ior.eq.4) write(iout6,1074)
      else
         do ig=1,ngrids
            ior=iorder(ig)
            if (ior.eq.1) write(iout6,1081) ig
            if (ior.eq.2) write(iout6,1082) ig
            if (ior.eq.3) write(iout6,1083) ig
            if (ior.eq.4) write(iout6,1084) ig
         enddo
      endif

      write(iout6,*) 
      write(iout6,1090)
      do ig=1,ngrids
         write(iout6,1092) ig,ovforb(ig),ovfcoul(ig),ovfexch(ig)
      enddo
      
      if (alphaf.ne.0.d0) then
         write(iout6,*) 
         write(iout6,1100) alphaf, sltthr
      endif

      if (iplot.eq.1) then
         write(iout6,*) 
         write(iout6,1105)
      elseif (iplot.eq.2) then
         write(iout6,*) 
         write(iout6,1106)
      endif

      if (ifermi.eq.1) call fermi(1)

      write(iout6,*) 
      write(iout6,1110)

c     Text segment of the program has about 3.2MB.
      
c     The amount of 'statically' allocated memeory (i.e. for a given choice
c     of $MAXMU and $MAXNI values) is primarily due to common block FOCKPOT 
c     and several other arrays depending on the current value of $MAXMU and 
c     $MAXNI. 

      length0=8*(2*maxfock+26*maxmu+32*maxni+1800*maxorb+
     &     66*maxnpbasis+100000)
      lengtht=8*(length1+length2+length3+length4+length5)+
     &          4*(length6)

      if (imethod.eq.2.or.imethod.eq.3) then
         nexch=1 
      endif

      write(*,1200) length0/1048576.0,lengtht/1048576.0

c     write(*,1202) 2*maxfock*8/1.0e6 
      
      mm3=2*norb*mxsize+nexch*mxsize
      if (idbg(550).ne.0) mm3=3*mxsize
      write(*,1210) norb,norb,nexch,i1e(norb),i1e(norb)*8/1.e6,
     &     i2e(norb),i2e(norb)*8/1.e6,
     &     nexch*mxsize,nexch*mxsize*8/1.e6,mm3,mm3*8/1.e6
      write(*,'("//////////////////////////////////////////////",
     &     "//////////////////////////////////")')

 1000 format(10x,a2,'(',f5.2,')',3x,a2,' (',f5.2,')',
     &     3x,'R =',f9.5,' bohr =',f8.5,' angstroms')
 1401 format(/3x,'finite nuclei (Fermi nuclear charge distribution):',
     &     /10x,'atomic masses:', f7.1,
     &     ' ( ',a2,')',f7.1,' ( ',a2,')')
 1402 format(/3x,'finite nuclei (Gauss nuclear charge distribution):',
     &     /10x,'atomic masses:', f7.1,
     &     ' ( ',a2,')',f7.1,' ( ',a2,')')
 1002 format(10x,'method: HFS (alpha = ',f4.2,')')
 1010 format(10x,'number of electrons =',i5/
     &     10x,'total charge        =',i5 )
 1020 format(10x,i2,2x,a8,a1,2x,4a2)
 1030 format(10x,' orbital           n1 l1   Z1    c1',
     &     '       n2 l2   Z2    c2 '/)
 1032 format(10x,i2,2x,a8,a1,5x,2i3,2f6.2,5x,2i3,2f6.2)
 1040 format(10x,'nu (h_nu) ',i6,'    (',f7.5,')'/
     &     10x,'mu (h_mu) ',i6,'    (',f7.5,')'/,
     &     10x,'R_infinity   ',f6.2)
 1042 format(10x,'nu (h_nu) ',i6,'    (',f7.5,')'/
     &     10x,'mu (h_mu) ',i6,'              '/,
     &     10x,'R_infinity   ',f6.2)
 1045 format(10x,i2,3x,i4,2x,i4,2f9.5,f8.3,3f9.5)
 1049 format(10x,'maxscf  =',i5/
     &     10x,'nobckup =',i5/
     &     10x,'ienterm =',i5/
     &     10x,'inoterm =',i5/
     &     10x,'facmul  =',f8.2)
 1050 format(10x,'maxscf  =',i5/
     &     10x,'nobckup =',i5/
     &     10x,'ienterm =',i5/
     &     10x,'inoterm =',i5/
     &     10x,'facmul  =',d8.1)
 1051 format(10x,'orbitals are relaxed')
 1052 format(10x,'orbitals are kept frozen')
 1053 format(/10x,'Coulomb potentials are relaxed')
 1054 format(/10x,'Coulomb potentials are kept frozen')
 1055 format(/10x,'the exchange potential for each pair ',
     &     'of orbitals is relaxed',/10x,'each time any ',
     &     'of the oritals is updated')
 1056 format(/10x,'exchange potential for each pair of orbitals is',
     &     ' relaxed only'/10x,'once per single scf ',
     &     'iteration (default)')
 1057 format(/10x,'exchange potentials are kept frozen')
c 1060 format(10x,i2,' (mc)sor iterations on a (sub)grid without',
c     &     ' boundary values',/,10x,'being updated (default 10)',
c     &     //10x,i2,' iteration(s) of the group of (mc)sor iterations',
c     &     ' (as defined above);'/10x,'between these iterations boundary ',
c     &     'values are recalculated')

 1060 format(10x,i2,' (mc)sor iterations for orbitals (default 10)',
     &      /10x,i2,' (mc)sor iterations for potentials (default 10)')

 1071 format(10x, 'grid points ordering: natural column-wise')
 1072 format(10x, 'grid points ordering: middle (default)')
 1073 format(10x, 'grid points ordering: natural row-wise')
 1074 format(10x, 'grid points ordering: reversed natural row-wise')
 1081 format(10x, 'ordering of points on subgrid',i3,': ',
     &     ' natural column-wise')
 1082 format(10x,'ordering of points on subgrid',i3,': ',
     &     'middle (default)')
 1083 format(10x, 'ordering of points on subgrid',i3,': ',
     &     ' natural row-wise')
 1084 format(10x, 'ordering of points on subgrid',i3,': ',
     &     ' reverse natural row-wise')
 1090 format(10x, 'overrelaxation parameters:'/13x,
     &     'subgrid      orbitals       potentials ')
 1092 format(13x,2x,i2,10x,f5.3,6x,f5.3,6x,f5.3)
 1100 format(3x,'Xalpha approximation:'/10x,'alpha = ',f4.2,5x/,10x,
     &     'if maximum orbital energy error drops below ',
     &     e7.2,' the full exchange'/10x,'is turned on ',
     &     'and until then exchange potential is not relaxed')
 1105 format(3x,'Plot:'/,10x,'orbital values exported in (x,z) ',
     &     'cartesian coordinates')
 1106 format(3x,'Plot:'/,10x,'orbital values exported in (ni,mu) ',
     &     'prolate spheroidal coordinates')
 1110 format(3x,'memory usage:')
 1200 format(10x,'text                                ',14x,' 0.3 MB '/,
     &     10x,'data                                ',12x,f6.1,' MB'/,
     &     10x,'dynamical allocation                ',12x,f6.1,' MB ')
 1210 format(
     &     /10x,'number of orbitals                    ',i10,
     &     /10x,'number of Coulomb potentials          ',i10,
     &     /10x,'number of exchange potentials         ',i10,
     &     /10x,'orbital array length                  ',i10,'',f6.1,' MB',
     &     /10x,'Coulomb potential array length        ',i10,'',f6.1,' MB',
     &     /10x,'exchange potential array length       ',i10,'',f6.1,' MB',
     &     /10x,'total                                 ',i10,'',f6.1,' MB'//)
 1300 format(11x,'finite electric field: ',f8.5,' au')
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rfun ###	
c
c     Reads functions from a disk file in an unformatted form
c
      subroutine rfun (norbt,cw_orb,cw_coul,cw_exch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)	
      character*15 csub
      character*75 cmess
      include 'commons8.inc'

      dimension cw_orb(*),cw_coul(*),cw_exch(*)
      dimension i1bt(60),i2bt(60),i3bt(1830),
     &     i1et(60),i2et(60),i3et(1830),
     &     i1sit(60),i2sit(60),i3sit(1830),
     &     i1ngt(60),i2ngt(60),i3ngt(1830),
     &     i1mut(60),i2mut(60),i3mut(1830)	
      
      read (iinp11,err=1000) i1bt,i2bt,i3bt,i1et,i2et,i3et,
     &     i1sit,i2sit,i3sit,i1ngt,i2ngt,i3ngt,
     &     i1mut,i2mut,i3mut	

c     retrieve orbitals 
     
      ioffset=norb-norbt
      do i=1,norbt
         call reada(iinp11,i1si(i+ioffset),cw_orb(i1b(i+ioffset)),ierr)
         if (ierr.ne.0) then
            write(iout6,*) 'error detected when reading orbital',i
            stop 'rfun'
         endif				   	
      enddo	   

c     retrieve the extra data from the orbital input file

      read(iinp11,end=1010,err=1010) area
      read(iinp11,end=1010,err=1010) eng
      read(iinp11,end=1010,err=1010) engo
      read(iinp11,end=1010,err=1010) cmulti
      read(iinp11,end=1010,err=1010) excdi
      read(iinp11,end=1010,err=1010) excqu
      read(iinp11,end=1010,err=1010) excoc
      read(iinp11,end=1010,err=1010) exche
      read(iinp11,end=1010,err=1010) exc5
      read(iinp11,end=1010,err=1010) exc6
      read(iinp11,end=1010,err=1010) exc7
      read(iinp11,end=1010,err=1010) exc8

      rewind iinp11	
     
c     read in Coulomb potentials 
      
      do i=1,norbt
         call reada(iinp12,i2si(i+ioffset),cw_coul(i2b(i+ioffset)),
     &        ierr)
         if (ierr.ne.0) then
            write(iout6,*) 'error detected when reading coulomb',
     &           ' potential',i
            stop 'rfun'
         endif				   	
      enddo	   
      rewind iinp12	
     
c     read in exchange potentials from the exhange potential input file
c     (only for HF calculations)

      if (imethod.eq.1) then
         if (iform.eq.1.or.iform.eq.3.and.ini.ne.6) then
            do iorb1=1,norbt
               do iorb2=iorb1,norbt
                  k=iorb1+iorb2*(iorb2-1)/2
                  if (iorb1.eq.iorb2.and.ll(iorb1).eq.0) goto 50
                  call reada(iinp13,i3si(k),cw_exch(i3b(k)),ierr)
                  if (ierr.ne.0) then
                     write(iout6,*) 'error detected when reading ',
     &                    'exchange potential',iorb1,iorb2,k
c                    stop 'rfun'
                  endif				   	
                  if (iorb1.eq.iorb2) goto 50
                  if (ll(iorb1).eq.0.or.ll(iorb2).eq.0) goto 50
                  call reada(iinp13,i3si(k),cw_exch(i3b(k)+i3si(k)),
     &                 ierr)
                  if (ierr.ne.0) then
                     write(iout6,*) 'error detected when reading ',
     &                    'exchange potential',iorb1,iorb2,k
c                    stop 'rfun'
                  endif				   	
 50               continue
               enddo
            enddo
            rewind iinp13
         endif
         write(*,*) '... orbitals and potentials have been ',
     &              'retrieved ... '
      endif
      return
 1000 continue
      write(*,*) '... error detected when retrieving the disk', 
     &           ' file ... '
      stop 'rfun'
      
 1010 write(*,*) '... error has been detected when retrieving ',
     &     'extension of the orbital input file ...'
      write(*,*) '... disk file without extension retrieved ... '
      idump=1
 1100 continue

      csub='rfun'
      if(idbg(59).ne.0) then
         write(*,*) 'rfdisk |||||||||||||||'

c        print orbitals and coulomb potentials

	 do i=1,norb
            cmess='orbital '      	 
            write(*,*) 'rfdisk: ',iorn(i),' ',bond(i)
            call pmtx(nni,i1mu(i),cw_orb(i1b(i)),1,1,incrni,incrmu)
	 enddo	   
         stop
         
	 do i=1,norb
            cmess='Coulomb potential '      	 
	    call dbgp (59,csub,cmess,cw_coul(i2b(i)),nni,i2mu(i))
	 enddo	   

c        print exchange potentials

         cmess='exchange potential '      	 
	 do i=1,nexch
            call dbgp (59,csub,cmess,cw_exch(i3b(i)),nni,i3mu(i))
	 enddo	   
      endif
      
      return
      end
	

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### updaddr ###
c
c     Updates addresses of exchange potentials to make
c     them correspond to newly read in functions
c
      subroutine updaddr(iorb1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

c     copy i3btv into i3b

      do  iorb2=1,norb
         k=i3xk(iorb1,iorb2)
         i3b(k)=i3btv(iorb1,iorb2)
         print *,'iaddr: ',iorb1,iorb2,k,i3b(k)
      enddo

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inpa ###
c
c    This routine examines the contents of IA and extracts a
c    character string of 8 chars. This string is stored in IBUF.
c    The remaining non-blank characters (if any) are ignored.

      subroutine inpa(guf)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 ia,iblnk,iall,ibuf
      character*8 ibufr,guf

      common/iochan/ iinp5,iinp11,iinp12,iinp13,iinp14,
     &               iout6,iout21,iout22,iout23,iout24
      common/work/jrec,jump,istrt(40),inumb(40),ia(80)
      dimension ibuf(8),iall(60)
      equivalence (ibuf(1),ibufr)

      data iblnk/' '/
      data iall/'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
     &          'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
     &          'u', 'v', 'w', 'x', 'y', 'z', '-', '-', '-', ' ',
     &          'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
     &          'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
     &          'U', 'V', 'W', 'X', 'Y', 'Z', '-', '-', '-', ' '/

      do i=1,8
         ibuf(i)=iblnk
      enddo
      jrec = jrec + 1
      if(jrec .gt. jump) goto 11
      n = inumb(jrec)
      nstrt = istrt(jrec)
      if (n.gt.8) n=8
      do i = 1,n
         ibuf(i) = ia(nstrt)
         nstrt = nstrt + 1
      enddo

11    guf=ibufr

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rheader ###
c
      subroutine rheader(norb_p)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*80 datetime_p
      character*1 dtarr1(80),dtarr2(80)
      equivalence(header_p,dtarr1(1))
      equivalence(datetime_p,dtarr2(1))

      include 'commons8.inc'

      mismatch=0
      idump=0

      read(iinp11,err=1000) header_p
      read(iinp11,err=1000) datetime_p

      imax1=0
      imax2=0
      call clrstring (imax1,dtarr1)
      call clrstring (imax2,dtarr2)

      write(iout6,1050)
c     write(iout6,1060) header_p,datetime_p 
      write(iout6,1060) (dtarr1(i),i=1,imax1)
      write(iout6,1061) (dtarr2(i),i=1,imax2)

      read(iinp11,err=1000) ngrids_p,nni_p,nmu_p

      if (iinterp.eq.0) then
         if (ngrids.ne.ngrids_p ) then
            write (iout6,*) 'mismatch in ngrids: '
            write (iout6,*) 'input=',ngrids,' file=',ngrids_p
            stop 'rheader'
         endif

         if (nni.ne.nni_p) then
            write (iout6,*) 'mismatch in nni: '
            write (iout6,*) 'input=',nni,' file=',nni_p
            stop 'rheader'
         endif	   

         do ig=1,ngrids   
            if (nmu(ig).ne.nmu_p(ig)) then
               write (iout6,*) 'mismatch in nmu for grid ',ig,':'
               write (iout6,*) 'input=',nmu(ig),' file=',nmu_p(ig)
               stop 'rheader'
            endif
         enddo	
      endif

      read(iinp11,err=1000) r_p,rgrid_p
      read(iinp11,err=1000) z1_p,z2_p	
      
      rd =abs(r_p-r)
      z1d=abs(z1_p-z1)
      z2d=abs(z2_p-z2)

c     test for various parameters
      
      if (rd.gt.1.d-06) then
         write(iout6,*) 'mismatch in bond length:'
         write(iout6,*) 'input=',r, 'disk=',r_p

      elseif (z1d.gt.1.d-06) then
         write(iout6,*) 'Warning! mismatch in Z1:'
         write(iout6,*) 'input=',z1, 'disk=',z1_p

      elseif (z2d.gt.1.d-06) then
         write(iout6,*) 'Warning! mismatch in Z2:'
         write(iout6,*) 'input=',z2, 'disk=',z2_p
      endif	   

      if (iinterp.eq.0) then
         do ig=1,ngrids   
            if (abs(rgrid(ig)-rgrid_p(ig)).gt.1.d-6 ) then
               write (iout6,*) 'mismatch in a subgrid ',ig,':'
               write (iout6,*) 'input=',rgrid(ig),' file=',rgrid_p(ig)
               stop 'rheader'
            endif
         enddo	
      endif

      read(iinp11,err=1000) norb_p,nel_p,nexch_p
      nexch=nexch_p
     
      if (nel.ne.nel_p) then
         write (iout6,*) '    Warning: mismatch in number of ',
     &        'electrons: input=',nel,' file=',nel_p
      endif

      if (norb.ne.norb_p ) then
         write (iout6,*) '    Warning: mismatch in number of ',
     &        'orbitals:  input=',norb,' file=',norb_p
         if (norb.gt.norb_p.and.imethod.eq.2) then 
c           write (iout6,*) '... continuing with crossed fingers ...',
c           &			     '; ini=4
            write (iout6,*) '... assuming a virtual orbital is ',
     &           'being generated ...'
         else
            stop 'rheader'
         endif
      endif

      return
      
 1000 continue
      write(iout6,1070)
      stop	
c
 1050 format(/1x,'... retrieving data from disk ...')	
 1060 format( 1x,'    file with heading: ',80a1)
 1061 format( 1x,'    created on: ',80a1)
 1070 format(//1x,'rheader: cannot read data from disk'//)     
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### plaguer ###		  	    
c
c
      function plaguer(n,l,cz,cr)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)		

      np=n-l-1
      lp=2*l+2
      x=cz*cr/dble(n)
      plaguer=cr**dble(l)*exp(-x)*hypgf(-np,lp,x+x)		    

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### mxv ###
c
c     Multiplies the matrix DX(nr,nc) times the vector DV(nc) and stores 
c     the result in the vector DY(nr) by means of calling DGEMV 
c
      subroutine  mxv (dx,nr,dv,nc,dvr)
      integer*4  nr,nc,incr
      real*8  alpha,beta,dx(nr,nc),dv(nc),dvr(nr)
      character*1 trans
      data trans/'n'/,incr/1/,alpha/1.d0/,beta/0.d0/

      call dgemv (trans,nr,nc,alpha,dx,nr,dv,incr,beta,dvr,incr)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### fermi ###
c     
c     Analyzes Fermi charge distribution.
c
      subroutine fermi(iprint)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

      if (iprint.ne.0) then
         write(*,*) ' '
         write(*,*) '  finite nuclei with the Fermi charge',
     &        ' distribution'
      endif

c     calcualte parameters of the finite nucleus charge distribution
c     (Fremi distribution)

c     ainfcm: bohr radius in cm

      ainfcm=0.529 177 249  d-08
      fmtoau=1.0d-13/ainfcm

      if (z1.ne.0.d0) then

c        set atomic weight for centre A

         atw=z1atmass
         at3=atw**(1.d0/3.d0)
         rrmsfm = 0.836d 00*at3+0.570d 00
         tfm = 2.30d 00

c        change units from fm into bohr

         rrms = rrmsfm*fmtoau
         t = tfm*fmtoau  
         a = t/(4.0d 00*log (3.0d 00))         
         facto1 = rrms**2-(7.0d 00/5.0d 00)*(pii**2)*(a**2)
         c = sqrt (5.0d 00/3.0d 00) * sqrt (facto1) 

         ni=nni
         nc1=0
         xr2=r/2.0
         do mu=1,mxnmu
	    rr=sqrt(vxisq(mu)+vetasq(ni)-1.d0)
            xrr=xr2*rr
            if (abs(xrr-xr2).lt.c) then 
               nc1=nc1+1
               if (idbg(450).ne.0) write(*,*) 'mu,xrr',mu,xrr
            endif
         enddo

         mu=1
         nc2=0
         do ni=nni,nni/2,-1
	    rr=sqrt(vxisq(mu)+vetasq(ni)-1.d0)
            xrr=xr2*rr
            if (abs(xrr-xr2).lt.c) then
               nc2=nc2+1
               if (idbg(450).ne.0) write(*,*) 'ni,xrr',ni,xrr
            endif
         enddo

         if (iprint.ne.0) then
            write(*,*) '    center A: '
            write(*,*) '    c = ',c,' bohr', '  a = ',a,' bohr' 
            write(*,*) '    nu=-1:',nc1, ' points inside radius c'
            write(*,*) '    mu= 1:',nc2, ' points inside radius c'
            write(*,*) ' '
         endif
         elseif (z2.ne.0.d0) then

c           set atomic weight for centre B

         atw=z2atmass
         at3=atw**(1.d0/3.d0)
         rrmsfm = 0.836d 00*at3+0.570d 00
         tfm = 2.30d 00

c        change units from fm into bohr

         rrms = rrmsfm*fmtoau
         t = tfm*fmtoau  
         a = t/(4.0d 00*log (3.0d 00))         
         facto1 = rrms**2-(7.0d 00/5.0d 00)*(pii**2)*(a**2)
         c = sqrt (5.0d 00/3.0d 00) * sqrt (facto1) 

         ni=1
         nc1=0
         xr2=r/2.0
         do mu=1,mxnmu
	    rr=sqrt(vxisq(mu)+vetasq(ni)-1.d0)
            xrr=xr2*rr
            if (abs(xrr-xr2).lt.c) then 
               nc1=nc1+1
               if (idbg(450).ne.0) write(*,*) 'mu,xrr',mu,xrr
            endif
         enddo

         mu=1
         nc2=0
         do ni=nni,nni/2,-1
	    rr=sqrt(vxisq(mu)+vetasq(ni)-1.d0)
            xrr=xr2*rr
            if (abs(xrr-xr2).lt.c) then
               nc2=nc2+1
               if (idbg(450).ne.0) write(*,*) 'ni,xrr',ni,xrr
            endif
         enddo

         if (iprint.ne.0) then
            write(*,*) '     Center B: '
            write(*,*) '     c = ',c,' bohr', '  a = ',a,' bohr' 
            write(*,*) '     nu=1:',nc1, ' points inside radius c'
            write(*,*) '     mu= 1:',nc2, ' points inside radius c'
         endif
      endif

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### fill ###
c
c     Immerses FUN array into WORK and adds boundary values.
      subroutine fill (nni,nmi,isym,fun,work)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension fun(nni,nmi),work(nni+8,nmi+8)

c     fill the interior of work array

      do i=1,nmi
         do j=1,nni
            work(j+4,i+4)=fun(j,i)
         enddo
      enddo

c     isym = 1 - even symmetry, isym =-1 - odd symmetry
c     values over i=nmi bondary are determined from the asymptotic expansion

      if (isym.eq.1.d0) then

c  mu=1...4	
         do i=2,5
            do j=1,nni
               work(j+4,6-i)= fun(j,i)
            enddo
         enddo

c        mu=nmu+5....nmu+8
c        the following code is necessary since the derivatives must be 
c        calculated up to i=nmi

         do i=1,4
            do j=1,nni
               work(j+4,nmi+4+i)= fun(j,nmi)
            enddo
         enddo

c        ni=1...4
         do i=1,nmi
            do j=2,5
               work(6-j,i+4)= fun(j,i)
            enddo
         enddo

c        ni=ni+4...ni+8
	  do i=1,nmi
             jj=0
             do j=nni-4,nni-1
                jj=jj+1
                work(nni+9-jj,i+4)= fun(j,i)
             enddo
          enddo
      else
         do i=2,5
            do j=1,nni
               work(j+4,6-i)=-fun(j,i)
            enddo
         enddo

         do i=1,4
            do j=1,nni
               work(j+4,nmi+4+i)= fun(j,nmi)
            enddo
         enddo

         do i=1,nmi
            do j=2,5
               work(6-j,i+4)=-fun(j,i)
            enddo
         enddo

         do i=1,nmi
	    jj=0
            do j=nni-4,nni-1
               jj=jj+1
               work(nni+9-jj,i+4)=-fun(j,i)
            enddo
         enddo
      endif

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### totensl ###
c
c     Calculates total energy for the local exchange approximation
c
      subroutine totensl (psi,pot,excp,e,f0,wgt1,wgt2,wk0,wk1,wk2,wk3)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'	
      dimension psi(*),pot(*),excp(*),e(*),f0(*),wgt1(*),wgt2(*),
     &     wk0(*),wk1(*),wk2(*),wk3(*)  

      data eps /1.d-7/

      engt(1)=eng(1)

      if (nel.lt.2) return

      engt(1)=0.d0
      
c     calculate first contributions from one particle operators and
c     Coulomb potential contributions within the same shell

      if (idbg(70).ne.0) then
	 write(*,*) 'orb        t        v(n)      t+v(n)     ',
     &        ' v(c-within shell)'
      endif

      norb2=norb*norb
      woneel=0.d0
      wdcoul=0.d0

      do iorb=1,norb
         iborb=i1b(iorb)
         isiorb=i1si(iorb)
         nmut=i1mu(iorb)
         ibpot=i2b(iorb)	  
         isipot=i2si(iorb)
         oc=occ(iorb)
         
         ipe=mgx(6,iorb)
         ipex=ipe-2*(ipe/2)

c        calculate derivatives over mu and ni variables by means of matrix
c        multiplication

         if (ipex.eq.0) then
	    isym= 1
         else
	    isym=-1
         endif
         
         call fill (nni,nmut,isym,psi(iborb),wk3)
         call difni (nmut,wk3,wk0,wk1,wk2)
         call refill(nni,nmut,wk1,wk0)
         call difmu (nmut,wk3,wk2)
         call refill(nni,nmut,wk0,wk2)

c        add derivatives over mu and ni

         call add (isiorb,wk0,wk1)

c        add contribution from phi part of laplasian
c        e enters the expression with minus sign which is already
c        incorporated in e

         if (ipe.ne.0) then
	    w=dble(ipe*ipe)
	    call dcopy (isiorb,e,1,wk0,1)
	    if (ipe.ne.1) then
               call dscal (isiorb,w,wk0,1)
	    endif
	    call prod  (isiorb,psi(iborb),wk0)
	    call add   (isiorb,wk0,wk1)
         endif
         
         call dcopy (isiorb,wk1,1,wk2,1)
         call prod  (isiorb,psi(iborb),wk2)
         w=ddot(isiorb,wgt1,1,wk2,1)
         vk(iorb)=w
         
         call dcopy (isiorb,f0,1,wk0,1)
         call prod  (isiorb,psi(iborb),wk0)
         
         call prod2 (isiorb,psi(iborb),wk0,wk2)
         w=ddot(isiorb,wgt1,1,wk2,1)
         vn(iorb)=w

         call add	 (isiorb,wk0,wk1)
         call prod (isiorb,psi(iborb),wk1)
         
         w = ddot(isiorb,wgt1,1,wk1,1)
         woneel=woneel+oc*w
      enddo

c     contribution from coulomb interaction within the same shell

      if (isipot.ne.isiorb) then
         write(iout6,*) 'coulomb potentials and orbitals have to ',
     &        'defined on the same number of subgrids'
         stop 'toten'
      endif				

c     calculate the coulomb potential contribution from all the orbitals
c     (include 1/2 factor )

      do i=1,mxsize
         wk2(i)=0.d0
      enddo
      
      do iorb=1,norb
         ibpot=i2b(iorb)
         isipot=i2si(iorb)	
         oc=occ(iorb)/2.d0
         call daxpy (isipot,oc,pot(ibpot),1,wk2,1)
      enddo

c     contribution from coulomb interaction

      wndc =0.d0
      do iorb=1,norb
         iborb=i1b(iorb)
         isiorb=i1si(iorb)	  
         call prod2 (isiorb,psi(iborb),psi(iborb),wk0)
         call prod (isiorb,wk2,wk0)
         call dscal (isiorb,occ(iorb),wk0,1)
         w=ddot(isiorb,wgt2,1,wk0,1)
         wndc=wndc+w
      enddo
      
c     contribution from local exchange interaction

      do i=1,mxsize
         wk1(i)=0.d0
         wk2(i)=0.d0
      enddo	  
      
      do iorb=1,norb
         iborb=i1b(iorb)
         isiorb=i1si(iorb)	  
         call exocc (iorb,ocup,ocdown)
         call prodas (isiorb,ocup ,psi(iborb),psi(iborb),wk1)
         call prodas (isiorb,ocdown,psi(iborb),psi(iborb),wk2)
      enddo
      
      do i=1,mxsize
         wk1(i)=wk1(i)**(4.d0/3.d0)
         wk2(i)=wk2(i)**(4.d0/3.d0)
      enddo	  

      call add (mxsize,wk1,wk2)
      
c     since the local exchange potentai is formed from the orbitals directly
c     multiply it by f4 to get rid of 2/(r*cosh(xi)) already present in
c     wgt2

      xrr=r/2.d0
      do i=1,mxnmu
         ii=(i-1)*nni
         do j=1,nni
	    wk0(ii+j)=xrr*vxi(i)
         enddo
      enddo

      call prod (mxsize,wk0,wk2)

      w=ddot(mxsize,wgt2,1,wk2,1)
      wex=-9.d0/4.d0*alphaf*(3/(4.d0*pii))**(1.d0/3.d0) * w
      
      evt=woneel+wndc+wex
      engt(1)=evt
      etot=evt+z1*z2/r

 6100 format(1x,'total electronic energy: ',d25.13)
 6110 format(1x,'total            energy: ',d25.13)

      if (idbg(70).ne.0) then
         write(*,*)'totesl - woneel,wndc,wex,etotal ',
     &        woneel,wndc,wex,evt
      endif

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### relcoul2 ###
c
      subroutine relcoul2 (iorb,cw_sor,psi,pot,excp,bpot,d,f3,g,
     &     lhs,rhs,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      integer*4 cw_sor
      real*8 lhs
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),cw_sor(*),
     &     rhs(*),bpot(*),d(*),f3(*),
     &     g(*),lhs(*),wk2(*)

c     dimension of wk2 array need be only (nni+8)*(nmi+4) but
c     (nni+8)*(nmi+8) array is reserved
      
      if (nel.eq.1) return
     
c     prepare right-hand side of the poisson equation
      
      iborb=i1b(iorb)
      ngrid=i1si(iorb)	
      call prod2 (ngrid,psi(iborb),psi(iborb),wk2)
      call prod2 (ngrid,wk2	,g	,rhs)

c     even symmetry for coulomb potential
      isym=1
      ibpot=i2b(iorb)
c     
      do itr1=1,maxsor1	  	
         do ig=1,i1ng(iorb)
            omega=ovfcoul(ig)
            omega1=1.d0-omega
            ioffst=ioffs(ig)
            ioffs1=ioffst+1	  
            ibpot1=ibpot+ioffst	  	  

            do i=1,4
               dmu2t(i)=dmu2(i,ig)
               dmu1t(i)=dmu1(i,ig)
            enddo

c           prepare left-hand side of the poisson equation
c           include the diagonal part of the differentiation operator in lhs

            do i=1,ngsize(ig)
               lhs(ioffst+i)=f3(ioffst+i)+diag(ig)
            enddo	    

            if (i1ng(iorb).eq.1) then 
c              icase=1
               ifill=1
               ngrd1 =ingr1(1,ig)
               ngrd6a=ingr1(2,ig)
               ngrd6b=ingr1(3,ig)
               ngrd7 =ingr1(4,ig)	  	  
c              
               call fill (nni,nmu(ig),isym,pot(iborb),wk2)
                  do itr2=1,maxsor2/lsor	  		  		
		  call mcsor
     &                 (wk2,lhs(ioffs1),rhs(ioffs1),bpot(ioffs1),
     &                 d(ioffs1),
     &                 cw_sor(iadext(ig)),cw_sor(iadnor(ig)),
     &                 cw_sor(iadex1(ig)),cw_sor(iadex2(ig)),
     &                 cw_sor(iadex3(ig)))
               enddo     
               call refill (nni,nmu(ig),pot(iborb),wk2)     
            else
               if (ig.eq.1) then 
c                 icase=2
                  ifill=2
                  ngrd1 =ingr2(1,ig)
                  ngrd6a=ingr2(2,ig)
                  ngrd6b=ingr2(3,ig)
                  ngrd7 =ingr2(4,ig)	  	  	    

                  call fill2 (nni,nmu(ig),pot(iborb),wk2)
                  do itr2=1,maxsor2/lsor	  			  		
                     call mcsor 
     &                    (wk2,lhs(ioffs1),rhs(ioffs1),bpot(ioffs1),
     &                    d(ioffs1),
     &                    cw_sor(iadext(ig+ngrids)),
     &                    cw_sor(iadnor(ig+ngrids)),
     &                    cw_sor(iadex1(ig+ngrids)),
     &                    cw_sor(iadex2(ig+ngrids)),
     &                    cw_sor(iadex3(ig+ngrids)))
                  enddo     
                  call refill (nni,nmu(ig),pot(iborb),wk2)     
               elseif (ig.ne.1.and.ig.ne.i1ng(iorb)) then 
c                 icase=2
                  ifill=3
                  ngrd1 =ingr2(1,ig)
                  ngrd6a=ingr2(2,ig)
                  ngrd6b=ingr2(3,ig)
                  ngrd7 =ingr2(4,ig)	  	  	    

                  muoffs=iemu(ig-1)-1
                  call fill3 (nni,nmu(ig),pot(iborb),wk2)
                  do itr2=1,maxsor2/lsor	  
                     call mcsor 
     &                    (wk2,lhs(ioffs1),rhs(ioffs1),bpot(ioffs1),
     &                    d(ioffs1),
     &                    cw_sor(iadext(ig+ngrids)),
     &                    cw_sor(iadnor(ig+ngrids)),
     &                    cw_sor(iadex1(ig+ngrids)),
     &                    cw_sor(iadex2(ig+ngrids)),
     &                    cw_sor(iadex3(ig+ngrids)))
                  enddo     
                  call refill34 (nni,nmu(ig),pot(iborb),wk2)     
                  muoffs=0
               elseif (ig.eq.i1ng(iorb)) then 
                  ifill=4
                  ngrd1 =ingr1(1,ig)
                  ngrd6a=ingr1(2,ig)
                  ngrd6b=ingr1(3,ig)
                  ngrd7 =ingr1(4,ig)	  	  	    

                  muoffs=iemu(ig-1)-1
                  call fill4 (nni,nmu(ig),pot(iborb),wk2)
                  do itr2=1,maxsor2/lsor	  		
                     call mcsor 
     &                    (wk2,lhs(ioffs1),rhs(ioffs1),bpot(ioffs1),
     &                    d(ioffs1),
     &                    cw_sor(iadext(ig)),cw_sor(iadnor(ig)),
     &                    cw_sor(iadex1(ig)),cw_sor(iadex2(ig)),
     &                    cw_sor(iadex3(ig)))
                  enddo
                  call refill34 (nni,nmu(ig),pot(iborb),wk2)     
                  muoffs=0	    
               endif
            endif
         enddo
      enddo
01021 format(/,i5,10d12.3,/(5x,10d12.3))
      return
      end
      

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inpf ###
c
c     Extracts a floating point number from an input card.
c
      subroutine inpf(buf)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 ia,ichar(15),itemp
      common/iochan/ iinp5,iinp11,iinp12,iinp13,iinp14,
     &               iout6,iout21,iout22,iout23,iout24
      common/work/jrec,jump,istrt(40),inumb(40),ia(80)
      data ichar/'0','1','2','3','4','5','6','7','8','9','+','&','^',
     &'-','.'/

      jrec = jrec + 1
      if(jrec .gt. jump) go to 40
      buf = 0.d0
      fact2 = 0.d0
      limit=15
      n = inumb(jrec)
      fact = 1.d0
      ist=istrt(jrec)
      nstrt = ist + n - 1
      do i=1,n
         itemp = ia(nstrt)
         do j = 1,limit
            if(ichar(j).eq.itemp)goto 5
         enddo
 4       write(iout6,*) 'Error detected in inpf'
         stop 'inpf' 
 5       if(j.lt.11)goto 7
         if(j.le.14)goto 6
         fact2 = dble(i-1)
         limit=14
         go to 9
 6       if(nstrt .ne. ist) go to 4
         if(j.eq.14)buf=-buf
         go to 20
 7       buf = buf + dble(j-1) * fact
         fact=fact*10.d0
 9       continue
         nstrt = nstrt - 1
      enddo

 20   buf=(0.1d0**fact2)*buf
 40   return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### mulex1 ###
c     Last modification: 16/10/00
c
c     This routine generates values of the associate Legendre functions P(k,q)
c     multiplied by [(k-|q|)!/(k+|q|)!]^{1/2} for k=1,..,8 and q=mt. 
c     See also routine which employs the same definition of the functions multi.
c
c     Note that the original routine (mulex) generates values scaled by (-1)**mt

      subroutine mulex1(i,j,mt,dome)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension dome(10)

      do k=1,8
         dome(k)=0.d0
      enddo

      if (mt.gt.4) return

      rr=sqrt(vxisq(j)+vetasq(i)-1.d0)		
      costh=0.d0
      if (abs(rr).gt.precis) then
         costh=veta(i)*vxi(j)/rr	 
      endif

      
      if (mt.eq.0) then
c        m=0
         dome( 1)=costh
         dome( 2)=( 3.d0*costh*dome(1) - 1.d0)	      / 2.d0
         dome( 3)=( 5.d0*costh*dome(2) - 2.d0*dome(1))/ 3.d0
         dome( 4)=( 7.d0*costh*dome(3) - 3.d0*dome(2))/ 4.d0
         dome( 5)=( 9.d0*costh*dome(4) - 4.d0*dome(3))/ 5.d0
         dome( 6)=(11.d0*costh*dome(5) - 5.d0*dome(4))/ 6.d0
         dome( 7)=(13.d0*costh*dome(6) - 6.d0*dome(5))/ 7.d0
         dome( 8)=(15.d0*costh*dome(7) - 7.d0*dome(6))/ 8.d0
         return
      elseif (mt.eq.1) then
c        m=1
         costh2=costh*costh
         costh4=costh2*costh2
         costh6=costh4*costh2

         sini2=abs(1.d0-costh2)
         sini =sqrt(sini2)

         dome(1)=-sini/sqrt(2.d0)
         dome(2)=-3.d0*sini*costh/sqrt(6.d0)
         dome(3)=(3.d0/2.d0)*sini*(1.d0-5.d0*costh2)/sqrt(12.d0)
         dome(4)=(5.d0/2.d0)*sini*costh
     &        *(3.d0-7.d0*costh2)/sqrt(20.d0)
         dome(5)=(15.d0/8.d0)*sini
     &        *(-1.d0+14.d0*costh2-21.d0*costh4)/sqrt(30.d0)
         dome(6)=(21.d0/8.d0)*sini*costh
     &        *(-5.d0+30.d0*costh2-33.d0*costh4)/sqrt(42.d0)
         dome(7)=(7.d0/16.d0)*sini
     &        *(5.d0-135.d0*costh2+495.d0*costh4
     &        -429.d0*costh6)/sqrt(56.d0)
         dome(8)=(9.d0/16.d0)*sini*costh*(35.d0-385.d0*costh2
     &        +1001.d0*costh4-715.d0*costh6)/sqrt(72.d0)

         return
      elseif (mt.eq.2) then
c        m=2
         costh2=costh*costh
         costh4=costh2*costh2
         costh6=costh4*costh2
         costh8=costh6*costh2
         
         sini2=abs(1.d0-costh2)

         dome(1)=0.d0
         dome(2)=3.d0*sini2/sqrt(24.d0)
         dome(3)=15.d0*costh*sini2/sqrt(120.d0)
         dome(4)=(15.d0/2.d0)*(-1.d0+8.d0*costh2
     &        -7.d0*costh4)/sqrt(360.d0)
         dome(5)=(105.d0/2.d0)*costh*(-1.d0+4.d0*costh2
     &        -3.d0*costh4)/sqrt(840.d0)
         dome(6)=(105.d0/8.d0)
     &        *(1.d0-19.d0*costh2+51.d0*costh4
     &        -33.d0*costh6)/sqrt(1680.d0)
         dome(7)=(63.d0/8.d0)*costh
     &        *(15.d0-125.d0*costh2+253.d0*costh4
     &        -143.d0*costh6)/sqrt(3024.d0)
         dome(8)=(315.d0/8.d0)*(-1.d0+34.d0*costh2-176.d0*costh4
     &        +286.d0*costh6-143.d0*costh8)/sqrt(5040.d0)
         return
      elseif (mt.eq.3) then 
c        m=3
         costh2=costh*costh
         costh4=costh2*costh2

         sini2=abs(1.d0-costh2)
         sini =sqrt(sini2)
         sini3=sini2*sini

         dome(1)=0.d0
         dome(2)=0.d0
         dome(3)=-15.d0*sini3/sqrt(720.d0)
         dome(4)=-105.d0*sini3*costh/sqrt(5040.d0)
         dome(5)=-(105.d0/2.d0)*sini3
     &        *(-1.d0+9.d0*costh2)/sqrt(20160.d0)
         dome(6)=-(315.d0/2.d0)*sini3*costh
     &        *(-3.d0+11.d0*costh2)/sqrt(60480.d0)
         dome(7)=-(315.d0/8.d0)*sini3
     &        *(3.d0-66.d0*costh2+143.d0*costh4)/sqrt(151200.d0)
         dome(8)=-(3465.d0/8.d0)*sini3*costh
     &        *(3.d0-26.d0*costh2+39.d0*costh4)/sqrt(332640.d0)
         return
      elseif (mt.eq.4) then
c        m=4
         costh2=costh*costh
         costh4=costh2*costh2
         costh6=costh4*costh2
         costh8=costh6*costh2

         dome(1)=0.d0
         dome(2)=0.d0
         dome(3)=0.d0
         dome(4)=105.d0*(1.d0-2.d0*costh2+costh4)/sqrt(40320.d0)
         dome(5)=945.d0*costh*(1.d0-2.d0*costh2+costh4)/sqrt(362880.d0)
         dome(6)=(945.d0/2.d0)
     &        *(-1.d0+13*costh2-23.d0*costh4
     &        +11.d0*costh6)/sqrt(1814400.d0)
         dome(7)=(3465.d0/2.d0)*costh
     &        *(-3.d0+19*costh2-29.d0*costh4
     &        +13.d0*costh6)/sqrt(6652800.d0)
         dome(8)=(10395.d0/8.d0)*(1.d0-28.d0*costh2+118.d0*costh4
     &        -156.d0*costh6+65.d0*costh8)/sqrt(19958400.d0)
      endif
      return	
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zeroarray ###
c
c     Zeroise main arrays.
c
      subroutine zeroarray (cw_orb,cw_coul,cw_exch,
     &                     cw_suppl,cw_sctch,cw_sor)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      integer*4 cw_sor
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),
     &     cw_suppl(*),cw_sctch(*),cw_sor(*)
      
      do i=1,length1 
         cw_orb(i)=0.d0
      enddo
      
      do i=1,length2
         cw_coul(i)=0.d0
      enddo
      
      do i=1,length3
         cw_exch(i)=0.d0
      enddo
      
      do i=1,length4
         cw_suppl(i)=0.d0
      enddo
      
      do i=1,length5
         cw_sctch(i)=0.d0
      enddo
      
      do i=1,length6
         cw_sor(i)=0
      enddo
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### tail ####
c
      subroutine tail (psi)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
c
      include 'commons8.inc'
      dimension psi(*)

c     examine the tails of all orbitals and determine location of the last
c     maximum (in mi variable), i.e.

c     f(max)=max{vmax(1),vmax(2),...,vmax(nni)}

c     and the maximum value of psi at the last mi=nmi grid line

      do iorb=1,norb
         ibeg=i1b(iorb)-1
         vpmax=-1.d30
         imaxg =0
         
         vpmax=-1.d30
         do ini=1,nni
            ijk=(mxnmu-1)*nni+ini
	    vp=abs(psi(ibeg+ijk))
	    if (vp.gt.vpmax) then
               vpmax=vp
               inimax=ini
            endif
         enddo 
         write(*,5110) 'tail: ',iorb,inimax,vpmax
      enddo

 5000 continue
      
 5100 format('   orbital     ni    max{psi(ni,mxnmui)}    ')
 5110 format(1x,a10,2i5,2x,d12.2)
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prepscf ####
c
c
      subroutine prepscf (cw_sor,cw_orb,cw_coul,cw_exch,cw_suppl,
     &					        cw_sctch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      integer*4 cw_sor	
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),
     &          cw_suppl(*),cw_sor(*),cw_sctch(*)

c     orbital energies and Lagrange multiplies are initialized
c     or have been retrieved from the disk file

c     asymptotic values of coulomb and exchange potentials are 
c     calculated or have been retrieved fro the disk file

c     see routine inifun for the explanation of the following command

      if (imethod.eq.3) islat=1
c     if (islat.eq.0.and.alphaf.ne.0.d0) islat=1

      if (imethod.eq.2.or.ini.eq.4) nel=1

      if (idbg(495).ne.0) then 
         idump=1
      endif
      
      if (idump.ne.0) then

c        check orhogonalization and return

         if (idbg(401).ne.0) then
            iprt=2
            do iorb=1,norb
               jorb=norb+1-iorb
               call ortho (jorb,cw_orb,
     &              cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &              cw_sctch(i5b(1)),iprt)
            enddo
         endif

         iprt=0
         if (idbg(400).ne.0) iprt=1

         do iorb=1,norb
	    jorb=norb+1-iorb
       	    call norm (jorb,cw_orb,
     &           cw_suppl(i4b(9)),cw_suppl(i4b(14)),cw_sctch(i5b(1)))
	    call ortho (jorb,cw_orb,cw_suppl(i4b(9)),
     &           cw_suppl(i4b(14)),cw_sctch(i5b(1)),iprt)
         enddo

         do i=1,norb
	    itouch(i)=1
         enddo	  

         if (imethod.ne.2) then 
            call momen(cw_orb,cw_suppl,cw_sctch)

c           determine asymptotic values of coulomb and exchange potentials
c           from multipole expansion

            if (iform.eq.1.or.iform.eq.3) then
               if (iinterp.eq.0) then
                  call asympot (cw_coul,cw_exch)  
c                 write(*,*) '... asympt has been called ...'
               else
                  call asympti (cw_coul,cw_exch)
c                 write(*,*) '... asympti has been called ...'
               endif
            endif
         endif

c  calculate off- and diagonal Lagrange multipliers

         do iorb=norb,1,-1
            if (iform.eq.0.or.iform.eq.2) call rfdexch(iorb,cw_exch)
            call rayl (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
            call lagra (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b(14)),cw_sctch(i5b(1)),cw_sctch(i5b(2)))
            engi(iorb)=eng(iorb)
         enddo
         write(*,*) '... initializing Lagrange multipliers ...'
      endif  
c  ----- if (idump.ne.0) -----
      write(iout6,*)
      call toten (cw_orb,cw_coul,cw_exch,
     &     cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &     cw_sctch(i5b( 4)))
      write(iout6,6110)  etot
      write(iout6,6100)  evt
      if (islat.eq.0) write(iout6,6120)  virrat

06100 format(1x,'total electronic energy: ',d25.13)
06110 format(1x,'total energy:            ',d25.13)
06120 format(1x,'virial ratio:            ',d25.13)

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### card ### 
c
c     This routine reads a data card and scans it for nonspace fields.
c     The number of fields is stored in jump, the starting point of a
c     field in istrt(i) and the number of characters in that field
c     in inumb(i).
c     If the routine finds an exclamation mark anything following it
c     is considered as a comment.
c
      subroutine card
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 ia,iexm,iblnk
      character*1 iatmp(80)
      common/iochan/ iinp5,iinp11,iinp12,iinp13,iinp14,
     &               iout6,iout21,iout22,iout23,iout24
      common/work/jrec,jump,istrt(40),inumb(40),ia(80)
      data iblnk/' '/,iexm/'!'/

      do i=1,80
         ia(i)=' '
      enddo

c     read a line 

      jump = 0
      jrec = 0
      isw = 0
 1    read(iinp5,100,end=40) ia
 100  format(80a1)
 101  format(2x,80a1)

      do i=1,80
         iatmp(i)=ia(i)
      enddo

c     set into lower case 

      call lowcas(iatmp,80)

c     check for tabs, and replace it by a blank

      call tabchk(iatmp,80)

c     check for blanks at left and remove them, fill with blanks at the end  

      call lftpos(iatmp,80) 

      do i=1,80
         ia(i)=iatmp(i)
      enddo

c     echo the slightly modified input data

      write(iout6,101) ia 

c     check for the exclamation mark
      
      do ike=1,80
         ile=ike
         if (ia(ile).eq.iexm) go to 910
      enddo 

 910  if(ile.eq.1) go to 1
      if(ia(ile).eq.iexm) ile=ile-1

      do i = 1,ile
         if (ia(i).eq.iblnk) goto 25
         if (isw) 15,15,20
 15      jump = jump +1
         istrt(jump) = i
         inumb(jump) = 0
         isw=1
 20      inumb(jump) = inumb(jump) + 1
         go to 30
 25      isw = 0
 30      continue
      enddo
      if (jump.eq.0) goto 1
      return

 40   write(iout6,45)
 45   format(//1x,'******* end of input file *******'//)
      stop 'card'
      end

c ### lftpos ###
c
c Eliminates blanks to the left and left position chararcter string card.
c 
      subroutine lftpos(line,length)
      character*1 line(length)

      ieff = 0
      do ipos = 1, length
         if(ieff.gt.0) then
            ieff=ieff+1
            line(ieff) = line(ipos)
         end if
         if(line(ipos).ne.' '.and.ieff.eq.0) then
            ieff=1
            line(ieff) = line(ipos)
         end if 
      end do  

c     fill end with trailing blanks

      do ipos = ieff+1,length 
         line(ipos) = ' '
      end do 

      ntest = 0
      if(ntest.ne.0) then
         write(6,*) ' Left adjusted character string '
         write(6,'(1H ,A)') line
      end if

      return
      end

c ### lowcas ### 
c
c Converts letters in a character string line to the lower case.
c
      subroutine lowcas(line,length)
      character*1 line(length)
      character*1 lower(26)
      character*1 upper(26)

      data lower/'a','b','c','d','e',
     &           'f','g','h','i','j',
     &           'k','l','m','n','o',
     &           'p','q','r','s','t',
     &           'u','v','w','x','y',
     &           'z'/
      data upper/'A','B','C','D','E',
     &           'F','G','H','I','J',
     &           'K','L','M','N','O',
     &           'P','Q','R','S','T',
     &           'U','V','W','X','Y',
     &           'Z'/

      do icha = 1, length
         do i = 1,26
            if(line(icha).eq.upper(i))
     &           line(icha) = lower(i)
         end do  
      end do  
      return 
      end 

c ### tabchk ###
c
c     Searches for a tab in the string line and replace it by a space.
c
      subroutine tabchk(line,length)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 itab
      character*1 line(length)

      itab=char(9)
      do i=1,length
         if(line(i).eq.itab) then
            line(i)=' '
         end if
      end do
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rfunorb ###	
c
c     Reads orbitals only from a disk file in an unformatted form
      subroutine rfunorb (norbt,cw_orb)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)	
      include 'commons8.inc'

      dimension cw_orb(*)
      dimension i1bt(60),i2bt(60),i3bt(1830),
     &     i1et(60),i2et(60),i3et(1830),
     &     i1sit(60),i2sit(60),i3sit(1830),
     &     i1ngt(60),i2ngt(60),i3ngt(1830),
     &     i1mut(60),i2mut(60),i3mut(1830)	
     
      read (iinp11,err=1000) i1bt,i2bt,i3bt,i1et,i2et,i3et,
     &     i1sit,i2sit,i3sit,i1ngt,i2ngt,i3ngt,
     &     i1mut,i2mut,i3mut	

      ioffset=norb-norbt
      do i=1,norbt
         call reada(iinp11,i1si(i+ioffset),cw_orb(i1b(i+ioffset)),ierr)
         if (ierr.ne.0) then
            write(iout6,*) 'error detected when reading orbital',i
            stop 'inifun'
         endif				   	
      enddo	   
      rewind iinp11	
 1000 continue
      write(iout6,*) 'error detected when reading file',iinp11
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### excont ###
c
c     Calculates the number of exchange integrals between two given 
c     (open) shells.

      subroutine excont (iorb1,iorb2,ox1,ox2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*8 alpha,beta

      include 'commons8.inc'
      data alpha,beta /'+','-'/

      ipe1 =mgx(6,iorb1)
      ipe2 =mgx(6,iorb2)

      io1=iorb1
      io2=iorb2

      ox1=0.d0
      ox2=0.d0

      ip1=4*(io1-1)
      ip2=4*(io2-1)

      if (ipe1.eq.0) then
         icase=1
         i1end=2
         if(ipe2.eq.0) then
            i2end=2
         else
            i2end=4
         endif
      else
         i1end=4
         if(ipe2.eq.0) then
            icase=1
            i2end=2
         else
            icase=2
         endif
      endif

      if (icase.eq.1) then

c        interaction between sigma-sigma or sigma-nonsigma shells

         do i1=1,i1end
            if(spin(ip1+i1).ne.alpha.and.spin(ip1+i1).ne.beta) goto 10
            do i2=1,i2end
               if(spin(ip2+i2).ne.alpha.and.spin(ip2+i2).ne.beta) 
     &              goto 12
               if(spin(ip1+i1).eq.spin(ip2+i2)) ox1=ox1+1.d0
00012          continue
            enddo
00010       continue
         enddo
      elseif(icase.eq.2) then

c        interaction between nonsigma-nonsigma shells
c        lambda positive for the both orbitals

	   do i1=1,2
              if(spin(ip1+i1).ne.alpha.and.spin(ip1+i1).ne.beta) goto 20
              do i2=1,2
                 if(spin(ip2+i2).ne.alpha.and.spin(ip2+i2).ne.beta) 
     &                goto 22
                 if(spin(ip1+i1).eq.spin(ip2+i2)) ox1=ox1+1.d0
00022            continue
              enddo
00020         continue
           enddo

c          lambda negative for the both orbitals

	   do i1=3,4
              if(spin(ip1+i1).ne.alpha.and.spin(ip1+i1).ne.beta) goto 30
              do i2=3,4
                 if(spin(ip2+i2).ne.alpha.and.spin(ip2+i2).ne.beta) 
     &                goto 32
                 if(spin(ip1+i1).eq.spin(ip2+i2)) ox1=ox1+1.d0
00032            continue
              enddo
00030         continue
           enddo

c          lambda positive and negative

	   do i1=1,2
              if(spin(ip1+i1).ne.alpha.and.spin(ip1+i1).ne.beta) goto 40
              do i2=3,4
                 if(spin(ip2+i2).ne.alpha.and.spin(ip2+i2).ne.beta) 
     &                goto 42
                 if(spin(ip1+i1).eq.spin(ip2+i2)) ox2=ox2+1.d0
00042            continue
              enddo
00040         continue
           enddo

c          lambda negative positive

	   do i1=3,4
              if(spin(ip1+i1).ne.alpha.and.spin(ip1+i1).ne.beta) goto 50
              do i2=1,2
                 if(spin(ip2+i2).ne.alpha.and.spin(ip2+i2).ne.beta) 
     &                goto 52
                 if(spin(ip1+i1).eq.spin(ip2+i2)) ox2=ox2+1.d0
00052            continue
              enddo
00050         continue
           enddo
      endif

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prepdiff ###
c
c     Initializes arrays used for differentiation.
c
      subroutine prepdiff (borb,d)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension borb(nni,mxnmu),d(nni,mxnmu)
      dimension aa1(9),aa2(9),a1(9),a2(9)
      dimension dc1(9,7,9),dc2(9,7,9)

c     derivative coeff. from 8th-order Stirling interpolation formula

      data aa1/ 3.d0, -32.d0, 168.d0, -672.d0, 0.d0, 672.d0,
     &	     -168.d0,  32.d0,	-3.d0 /
      data aa2/  -9.d0,  128.d0, -1008.d0, 8064.d0, -14350.d0,
     &	       8064.d0,-1008.d0,   128.d0,   -9.d0 /

c     initialization of the array performing differentiation
c     based on the 9-point interpolating formula

      w1=1.d0/(840.d0)
      w2=1.d0/(5040.d0)

c     initialize dni1, dni2, dmu1 and dmu2
      
      do ig=1,ngrids
         do  i=1,4
            dmu2(i,ig)=w2*aa2(i)/(hmu(ig)*hmu(ig))
            dmu1(i,ig)=w1*aa1(i)/hmu(ig)
         enddo
      enddo

      do i=1,4
         dni2(i)=w2*aa2(i)/(hni*hni)
         dni1(i)=w1*aa1(i)/hni
      enddo

c  initialize arrays used in matrix differentiation

c  initialize dmu

      ib=1
      do ig=1,ngrids
         do k=1,9
            a2(k)=w2*aa2(k)/(hmu(ig)*hmu(ig))
            a1(k)=w1*aa1(k)/hmu(ig)
         enddo 

         ie=iemu(ig)
         do i=ib,ie
            do k=1,9
               dmu(k,i)=a2(k)+borb(1,i)*a1(k)
            enddo
         enddo
         ib=ie+1
      enddo

c     initialize dni 
      
      do k=1,9
         a2(k)=w2*aa2(k)/(hni*hni)
         a1(k)=w1*aa1(k)/hni
      enddo

      do i=1,nni
         do k=1,9
            dni(k,i)=a2(k)+d(i,1)*a1(k)
         enddo
      enddo

      if (ngrids.ne.1) then
         
c        initialize arrays dc1 and dc2

c        in order to check lagrpol use two ajasent grids with equal step size 
c        and compare coefficients with those of the Stirling formulae

         call lagrpolq (dc1,dc2)

c        modify dmu array at the grid boundary region
c        derivative coeff. from 8th-order Lagrange interpolation formula
c        are stored in dc2(ngbound,imu,k) and dc1(ngbound,imu,k),
c        where ngbound is the number of 
c        the grid boundaries (1 for 1-2, 2 for 2-3 etc), imu is one of the 7 
c        intergrid mu values and k points to a derivative coefficient.

         do ig=1,ngrids-1
            ib=iemu(ig)-3
            ie=iemu(ig)+3
            imu=0
            do i=ib,ie
               imu=imu+1
               do k=1,9
c                 a2(k)=dc2(ig,imu,k)/(hmu(ig)*hmu(ig))
c                 a1(k)=dc1(ig,imu,k)/hmu(ig)
                  a2(k)=dc2(ig,imu,k)
                  a1(k)=dc1(ig,imu,k)
               enddo 
               
               do k=1,9
                  dmu(k,i)=a2(k)+borb(1,i)*a1(k)
               enddo
            enddo
         enddo
      endif

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zasyx1 ###
c
c     Evaluates asymptotic values of a given exchange potential from the
c     multipole expansion.
c
c     For odd values of q in P(k,q) (here q=idel) there should be no
c     (-1)**q factor in eq. (19). That is why this factor is missing in
c     this routine.
c
      subroutine zasyx1 (idel,ipc,excp)
      implicit integer*4 (i-n)
      implicit real*8(a-h,o-z)
      include 'commons8.inc'
      dimension excp(*),pe(10)
      do j=mxnmu-3,mxnmu
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            if (idbg(300).eq.0) then
               call multi1(i,j,idel,ipc,pe)
               excp(kk)= r2*vxi(j)*pe(impole)
            else
               call multi(i,j,idel,ipc,pev)
               excp(kk)= r2*vxi(j)*pev
            endif

         enddo
      enddo
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inisuppl ###
c
c     Initializes various variables and arrays
c
      subroutine inisuppl (cw_suppl,cw_sor)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      integer*4 cw_sor
      include 'commons8.inc'
      dimension cw_suppl(*),cw_sor(*)

c     initialize arrays within common blocks (except for differentiating 
c     arrays which are defined in prepdiff) and check input data

      call prepfix

c     employ input data to determine size and division of cw arrays
c     initialize address arrays

      call iniaddr

c     initialize arrays of variable length
c
c     i4b(1)=borb
c     i4b(2)=bpot
c     i4b(3)=d
c     i4b(4)=e
c     i4b(5)=f0
c     i4b(6)=f1
c     i4b(7)=f2
c     i4b(8)=f3
c     i4b(9)=f4
c     i4b(10)=g
c     i4b(11)=wjac1
c     i4b(12)=wjac2
c     i4b(13)=wgt1
c     i4b(14)=wgt2

      call prepvar (cw_suppl(i4b( 1)),cw_suppl(i4b( 2)), 
     &              cw_suppl(i4b( 3)),cw_suppl(i4b( 4)), 
     &              cw_suppl(i4b( 5)),cw_suppl(i4b( 6)), 
     &              cw_suppl(i4b( 7)),cw_suppl(i4b( 8)), 
     &              cw_suppl(i4b( 9)),cw_suppl(i4b(10)), 
     &              cw_suppl(i4b(11)),cw_suppl(i4b(12)), 
     &              cw_suppl(i4b(13)),cw_suppl(i4b(14)) )

      call prepdiff (cw_suppl(i4b( 1)),cw_suppl(i4b( 3)))

c     prepare meshes for all subgrids

      call prepmesh (cw_sor)
      
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### iniaddr ### 
c
c     Determines dimensions of arrays and addresses of particular
c     orbitals and coulomb potentials in cw_orb and cw_coul arrays 
c     addresses of exchange potentials v(i,j) in the cw_exch array.
c
c     With each cwork array are associated its address arrays:
c
c     cw_orb  - iaddr1(iorb,ip)
c     cw_coul - iaddr2(icoul,ip)
c     cw_exch - iaddr3(iexch,ip)
c     cw_suppl - iaddr4(isuppl)
c     cw_sctch - iaddr5(iscratch)
c     
c     In the case od iaddr1 the first index refers to orbital number
c     and the second one to the division point, i.e.
c     iaddr1(iorb,1)=i1b(iorb)
c     iaddr1(iorb,2)=i1e(iorb)
c     iaddr1(iorb,3)=i1si(iorb)
c     iaddr1(iorb,4)=i1ng(iorb)
c
c     i1addr1(iorb,1) - address of the first value of orbital
c                       iorb within cw_orb array 
c                       (address of the first value of orbital
c                       iorb defined on grid #1) 
c                       (starting address of orbital iorb)
c     iaddr1(iorb,2)  - address of the last value of orbital
c                       iorb within cw_orb array 
c     iaddr1(iorb,3)  - number of values defining orbital iorb 
c     iaddr1(iorb,4)  - number of grids used by the orbital iorb
c			(up to 9 grids can be used)
c     iaddr1(iorb,ip) - ip=5-10 reserved for further use
c
c     Similar definitions hold for iaddr2-3.
c     We assume no more than 60 orbitals and Coulomb potentials and
c     consequently no more than 1830 (iorb*(iorb+1)/2) exchange potentials.
c
      subroutine iniaddr 
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

c    warning!!!! istrt(1)=0 and i1b(1)=1, i2b(1)=1

      i1b(1)=1
      ngrid=nni*iemu(i1ng(1))
      i1e(1)=ngrid
      i1si(1)=ngrid
      i1mu(1)=iemu(i1ng(1))	

c     current value of cw_orb length is stored in l1cur
      
      l1cur=ngrid
      do iorb=2,norb
         i1b(iorb)=i1e(iorb-1)+1
         ngrid=nni*iemu(i1ng(iorb))
         i1e(iorb)=i1b(iorb)+ngrid-1
         i1si(iorb)=ngrid
         i1mu(iorb)=iemu(i1ng(iorb))
         l1cur=l1cur+ngrid	  
      enddo	  
      
c     it is assumed for a time being that potential functions are defined
c     on the same number of grids as the orbitals
      
      i2b(1)=1
      ngrid=nni*iemu(i2ng(1))	
      i2e(1)=ngrid
      i2si(1)=ngrid
      i2mu(1)=iemu(i1ng(1))	

c     current value of cw_coul length is stored in l2cur	
      
      l2cur=ngrid
      do iorb=2,norb
         i2b(iorb)=i2e(iorb-1)+1
         ngrid=nni*iemu(i2ng(iorb))		  
         i2e(iorb)=i2b(iorb)+ngrid-1
         i2si(iorb)=ngrid
         i2mu(iorb)=iemu(i2ng(iorb))	  
         l2cur=l2cur+ngrid	  
      enddo	  

c     warning! the value of k=i+i*(i-1)/2 for sigma type orbitals is undefined

c     dimension of i3??? is norb*(norb+1)/2  to allow for two
c     exchange potentials between non-sigma orbitals
      
c     exchange potential corresponding to orbitals iorb1 and iorb2
c     defined on 1ing(iorb1) and i1ng(iorb2) grids respectively, is
c     defined on smaller of these grids, i.e i3ng=min(i1ng(iorb1),i1ng(iorb2))

      iend=0
      l=0
      l3cur=0	
      i3boffset=0
      do  iorb1=1,norb
         do  iorb2=iorb1,norb
            k=iorb1+iorb2*(iorb2-1)/2
            ilc(k)=0
            i3xk(iorb1,iorb2)=0
            i3xk(iorb2,iorb1)=0
            if (iorb1.eq.iorb2.and.ll(iorb1).eq.0) goto 50
            ilc(k)=1
            l=l+1
            ngds=min(i1ng(iorb1),i1ng(iorb2))
            i3ng(k)=ngds
            ngrid=nni*iemu(ngds)
            iend=iend+ngrid
            i3e(k)=iend
            i3b(k)=i3e(k)-ngrid+1	    
            i3si(k)=ngrid	    	  
            i3mu(k)=iemu(i3ng(k))		
            i3bfin=i3e(k)

            i3xk(iorb1,iorb2)=k
            i3xk(iorb2,iorb1)=k
            i3orb1(k)=iorb1
            i3orb2(k)=iorb2

            l3cur=l3cur+ngrid
            if (iorb1.eq.iorb2) goto 50
            if (ll(iorb1).eq.0.or.ll(iorb2).eq.0) goto 50
            ilc(k)=2
            l=l+1
            iend=iend+ngrid
            l3cur=l3cur+ngrid		
            if (k.gt.1830) then
               write(*,*) 'iniaddr:'
               write(*,*) 'address array for exchange potentials ',
     &              'is too short'
               stop 'iniaddr'	
            endif
00050       continue
         enddo
         i3boffset=i3bfin
      enddo
      
      nexch=l

c     When exchange potential functions are stored as separate files each
c     containing a single potential then their labels are are generated
c     in the fashon defined below.
c     
c     prepare a two-dim array containing numerical labels of
c     exchange potential functions being needed for every orbital
c     
c     all exchange potentials have to be defined on the same grid
c     
c     let k=i3xk(iorb1,iorb2) be an index associated uniquely with a given
c     pair of orbitals
c     if k=0  - no ex.pot (no record)      
c     if k.ne.0 and ilc(k)=1  - ex.pot record label is stored in i3xrec1
c     if k.ne.0 and ilc(k)=2  - ex.pot record label is stored in i3xrec2
      
      ngrid=nni*mxnmu
      l=0
      do iorb1=1,norb
         ibeg=1
         do iorb2=iorb1,norb
            k=i3xk(iorb1,iorb2)
            if (k.ne.0) then
               if (ilc(k).ne.0) then
                  l=l+1
                  i3xrec1(k)=l
                  if (ilc(k).eq.2) then
                     l=l+1
                     i3xrec2(k)=l
                  endif
               endif
            endif
         enddo
      enddo
      
c     determine exchange potentials associated with a particular orbital
c     and store the record lables in i3btv array; the number of ex. pot. for
c     each orbital is kept in i3nexp array
      
      do iorb1=1,norb
         l=0
         ibeg=1
         do iorb2=1,maxorb
            i3breck(iorb1,iorb2)=0
         enddo
         do iorb2=1,norb
            k=i3xk(iorb1,iorb2)
            if (k.ne.0) then
               if (ilc(k).ne.0) then
                  l=l+1        
                  
                  if (l.gt.maxorb) then
                     print *,'iniaddr: the second dimension of arrays ',
     &                    'i3xpair,i3brec can not exceed',maxorb
                     stop
                  endif
                  
                  i3xpair(iorb1,l)=i3xrec1(k)
                  i3brec (iorb1,l)=ibeg
                  i3breck(iorb1,l)=k
                  
                  i3btv(iorb1,iorb2)=ibeg
                  i3btv(iorb2,iorb1)=ibeg
                  
c                 before a new portion of exc. pot.is being read in exc.pot 
c                 address array i3b has to be modified accordingly, i.e.
c                 i3b(k) (where k is determined by i3breck and must be non zero)
                  
                  i3nexcp(iorb1)=l
                  ibeg=ibeg+ngrid
                  if (ilc(k).eq.2) then
                     l=l+1      
                     i3xpair(iorb1,l)=i3xrec2(k)
                     i3brec(iorb1,l)=ibeg
                     i3breck(iorb1,l)=k
                     i3nexcp(iorb1)=l
                     ibeg=ibeg+ngrid
                  endif
               endif
            endif
         enddo
      enddo

c     checking i3btv entries

      iprint=0
      if (iprint.ne.0) then
         print *,'iniaddr: ngrid ',nni*mxnmu
         print *,'iniaddr: nexch ',nexch

         print *, 'iniaddr: iorb1,iorb2,k,i3xk,ilc(k),i3b'      
         do  iorb1=1,norb
            do  iorb2=iorb1,norb
               k=iorb1+iorb2*(iorb2-1)/2
               if (iorb1.eq.iorb2) print *,'==='
               write(*,1200) iorb1,iorb2,k,i3xk(iorb1,iorb2),ilc(k),
     &              i3b(k)
            enddo
            print *, '   '
         enddo

         print *,'iaddr: iorb,i3nexcp'
         do iorb1=1,norb
            print *,iorb1,i3nexcp(iorb1)
         enddo
         print *,' '
         
         print *,'iaddr: iorb // l,i3xpair,i3brec,i3breck'
         do iorb1=1,norb
            print *,'iorb1: ',iorb1
            do l=1,i3nexcp(iorb1)
               k=i3breck(iorb1,l)
               write(*,1210) l, i3xpair(iorb1,l),
     &              i3brec(iorb1,l),k
            enddo
         enddo
         
01200    format(2i4,i6,3i12)
01210    format(i4,5i12)
         
         print *,'iaddr: iorb1,iorb2,k,i3xrec1,i3xrec2'
         do  iorb1=1,norb
            do  iorb2=iorb1,norb
               k=i3xk(iorb1,iorb2)
               if (ilc(k).ne.0) then
                  print *,iorb1,iorb2,k,i3xrec1(k),i3xrec2(k)
               endif
            enddo
         enddo

         print *, '   '
         print *,'iorb1 // iorb2,k,irec,i3beg'
         do iorb1=1,norb
            print *,'    '
            print *, 'iorb1: ',iorb1
            do iorb2=1,i3nexcp(iorb1)
               k=i3breck(iorb1,iorb2)
               i3beg=i3brec(iorb1,iorb2)
               irec=i3xpair(iorb1,iorb2)
               ngrid=i3si(k)
               print *,iorb2,k,irec,i3beg
            enddo
         enddo
      endif

c     is working array cw_suppl large enough?
      
      if (14.gt.length4) then
         write(iout6,*) 'cw_suppl is too short!'
         write(iout6,*) 'declared length is:',length4
         write(iout6,*) 'needed length is 14'
         stop 'prepvar'
      endif		

      do i=1,14
         i4b(i)=(i-1)*mxsize+1
         i4e(i)=iorb*mxsize
         i4si(i)=mxsize
         i4ng(i)=ngrids
      enddo
      
c     current value of cw_sctch length is stored in l5cur
      
      mxsize8=(nni+8)*(mxnmu+8)
      do i=1,10
         i5b(i)=(i-1)*mxsize8+1
         i5e(i)=i*mxsize8
         i5si(i)=mxsize8
         i5ng(i)=ngrids
      enddo	  
      l5cur=i5e(20)

c     are working arrays large enough?

      if (l1cur.gt.length1) then
         write(iout6,*) 'cw_orb is too short!'
         write(iout6,*) 'declared length is:',length1      
         write(iout6,*) 'needed length is:',l1cur
         if (idbg(550).eq.0) stop 'iniaddr'
      endif		

      if (l2cur.gt.length2) then
         write(iout6,*) 'cw_coul is too short!'
         write(iout6,*) 'declared length is:',length2
         write(iout6,*) 'needed length is:',l2cur
         if (idbg(550).eq.0) stop 'iniaddr'
      endif		

c     l3cur is calculated as if all exchange potential functions were
c     to be kept in core. This is the case if iform=1 or iform=3.
      
      if (imethod.eq.1) then
         if (iform.eq.1.or.iform.eq.3) then
            if (l3cur.gt.length3) then
               write(iout6,*) 'cw_exch is too short!'
               write(iout6,*) 'declared length is:',length3
               write(iout6,*) 'needed length is:',l3cur
               if (idbg(550).eq.0) stop 'iniaddr'
            endif		
         else
            nons=0
            do iorb=1,norb
               if (ll(iorb).ne.0) nons=nons+1
            enddo
c           l3cur=nni*maxmu*(norb+nons)
            l3cur=mxsize*(norb+nons)
            if (l3cur.gt.length3) then
               write(iout6,*) 'cw_exch is too short!'
               write(iout6,*) 'declared length is:',length3
               write(iout6,*) 'needed length is:',l3cur
               stop 'iniaddr'		
            endif		
         endif
      endif

      if (l5cur.gt.length5) then	
         write(iout6,*) 'cw_sctch is too short!'
         write(iout6,*) 'declared length is:',length5
         write(iout6,*) 'needed length is',10*mxsize8
c        stop 'iniaddr'		
      endif		
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### dbgp ###
c
c     Prints out debug messages
c     idbgp - idbg point number
c     csub  - routine name
c     cmess - message
c     array - array to be printed; every incrni row and every incrmu column 
c             is printed
c     n1,n2 - dimension(s) of the array; set n2=0 to indicate 1-dimensional array

      subroutine dbgp (idbgp,csub,cmess,array,n1,n2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension array(n1,*)

      if(idbg(idbgp).ne.0) then
         write(iout6,1000) csub,idbgp
         write(iout6,1010) cmess

         if (n2.eq.0) then
c           print out 1-dim array
            write(iout6,1020) (array(i,1),i=1,n1,incrni)
         else 
c           print out 2-dim array
            do i=1,n1,incrni
               write(6,1000) i, (array(i,j),j=1,n2,incrmu)
            enddo
	 endif
      endif

01000 format(1x,'$$$ debug printout from routine:',15a1,
     &     '; idbg:',i3,1x,'$$$')
01010 format(1x,75a1)
01020 format(/,(5x,5d18.8))
01030 format(/,1x,i4,5d18.8,/(5x,5d18.8))
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### propet ####
c
c     Calculates dipole, quadrupole, octopole and hexadecapole moments 
c     relative to the geometrical centre and the centre of mass.
c
c     Last modification: 27/02/01
c
      subroutine propet (iscf,cw_orb,cw_coul,cw_exch,
     &                   f4,wgt2,wk0,wk1,wk2,wk3,wk4,wk5)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),f4(*),
     &     wgt2(*),wk0(*),wk1(*),wk2(*),wk3(*),wk4(*),wk5(*)
      dimension elect(10),electDA(10),total(10),totalDA(10)

c     1 bohr electron = 2.541765 Debye -- Gaussian94 User's Reference
c     data au2Debye /2.541765d0/
c     data bohr2ang /0.529177249d0/

      mpole=4

      cm1=0.d0
      cm2=0.d0
      cm3=0.d0
      cm4=0.d0

      zcm=0.d0
      qtot=0.d0
      do iorb=1,norb
         qq=-occ(iorb)
         qtot=qtot+qq
         cm1=cm1+qq*cmulti(iorb)
         cm2=cm2+qq*cmulti(iorb+norb)
         cm3=cm3+qq*cmulti(iorb+2*norb)
         cm4=cm4+qq*cmulti(iorb+3*norb)
      enddo
      elect(1)=cm1
      elect(2)=cm2
      elect(3)=cm3
      elect(4)=cm4

      do k=1,mpole
         qkz1=z1*abs(r/2.d0)**k*plegendg(k,0,-1.d0)
         qkz2=z2*abs(r/2.d0)**k*plegendg(k,0, 1.d0)
         qktot1=cm1+qkz1+qkz2
         total(k)=qktot1
         totalDA(k)=total(k)*au2Debye*bohr2ang**(k-1)
         electDA(k)=elect(k)*au2Debye*bohr2ang**(k-1)
      enddo

      write(*,'(/," multipole moments relative to geometrical centre:")')
      write(*,'(35x,"dipole",14x,"quadrupole",11x,"octopole",12x,
     &     "hexadecapole")')

      write(*,'(35x,"(Mu_z)",14x,"(Theta_zz)",10x,"(Omega_zzz)",11x,
     &     "(Phi_zzzz)")')
      write(*,'(2x,"electronic (au)          ",4e21.12)') (elect(k),k=1,mpole)
      write(*,'(2x,"electronic (Debye-Ang^k) ",4e21.12)') (electDA(k),k=1,mpole)
      
      write(*,'(2x,"total (au)               ",4e21.12)') (total(k),k=1,mpole)
      write(*,'(2x,"total (Debye-Ang^k)      ",4e21.12)') (totalDA(k),k=1,mpole)

      write(*,'(//," multipole moments relative to centre of mass:")')

      izz1=nint(z1)
      izz2=nint(z2)
      atw1=atweight(izz1)
      atw2=atweight(izz2)
      zcm=(-atw1+atw2)/(atw1+atw2)*r/2.d0
      write(iout6,1000) element(izz1),atweight(izz1),-r/2.d0, 
     &     element(izz2), atweight(izz2),r/2.d0,zcm

01000 format(/,6x,'centre     atomic weight       z',/
     &     8x,  a2,4x,f14.8,3x,f10.4,/,
     &     8x,  a2,4x,f14.8,3x,f10.4,/,
     &     2x,'centre-of-mass',15x,f10.4/)

c multipole moments relative to the centre of mass

      do k=1,mpole

c  loop over grid points
         
         do imu=1,mxnmu
            inioff=(imu-1)*nni
            do in=1,nni
               igp=inioff+in

c              rr=(r/2.d0)*sqrt(vxisq(imu)+vetasq(in)-1.d0)		
c              x=(r/2.d0)*vxi1(imu)*veta1(in)
               
               z=(r/2.d0)*vxi(imu)*veta(in)-zcm
               xxplusyy=((r/2.d0)*vxi1(imu)*veta1(in))**2
               rr=sqrt(xxplusyy+z*z)

               if (abs(rr).lt.precis) then
                  costh=0.d0
               else
                  costh=z/rr
               endif

               wk0(igp)=rr**k*plegendg(k,0,costh)
            enddo
         enddo
         qtot=0.d0
         cm2zz=0.d0
         do iorb=1,norb
            i1beg=i1b(iorb)
            ngorb=i1si(iorb)
            qq=-occ(iorb)
            qtot=qtot+qq
            call prod2 (ngorb,cw_orb(i1beg),cw_orb(i1beg),wk3)
            call prod  (ngorb,wk0,wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            cm2zz=cm2zz+qq*w
         enddo
         elect(k)=cm2zz
         electDA(k)=elect(k)*au2Debye*bohr2ang**(k-1)

         qkz1=z1*abs(r/2.d0+zcm)**k*plegendg(k,0,-1.d0)
         qkz2=z2*abs(r/2.d0-zcm)**k*plegendg(k,0, 1.d0)
         qktot=cm2zz+qkz1+qkz2
         total(k)=qktot
         totalDA(k)=total(k)*au2Debye*bohr2ang**(k-1)
      enddo

      write(*,'(35x,"dipole",14x,"quadrupole",11x,"octopole",12x,"hexadecapole")')
      write(*,'(35x,"(Mu_z)",14x,"(Theta_zz)",10x,"(Omega_zzz)",11x,"(Phi_zzzz)")')

      write(*,'(2x,"electronic (au)          ",4e21.12)') (elect(k),k=1,mpole)
      write(*,'(2x,"electronic (Debye-Ang^k) ",4e21.12)') (electDA(k),k=1,mpole)
      
      write(*,'(2x,"total (au)               ",4e21.12)') (total(k),k=1,mpole)
      write(*,'(2x,"total (Debye-Ang^k)      ",4e21.12)') (totalDA(k),k=1,mpole)

      if (idbg(221).ne.0) then
         write(*,*)
         write(*,*)
         write(*,*) 'Expectation values of r_1^k'
         
         do iorb=1,norb
            i1beg=i1b(iorb)
            ngorb=i1si(iorb)
            write(*,*)
            write(*,*) 'orbital #',iorb
            do mu=1,mxnmu
               imu=(mu-1)*nni
               do ni=1,nni
                  r1=(r/2.d0)*(vxi(mu)+veta(ni))
                  if (r1.lt.precis) then
                     wk0(imu+ni)=0.d0
                  else
                     wk0(imu+ni)=1.d0/r1
                  endif
                  wk1(imu+ni)=r1
                  wk2(imu+ni)=r1*r1
               enddo
            enddo
            call prod2 (ngorb,cw_orb(i1beg),wk0,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              <1/r> =',w

            call prod2 (ngorb,cw_orb(i1beg),wk1,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              < r > =',w

            call prod2 (ngorb,cw_orb(i1beg),wk2,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              <r^2> =',w
         enddo

         write(*,*)
         write(*,*)
         write(*,*) 'Expectation values of r^k'

         do iorb=1,norb
            i1beg=i1b(iorb)
            ngorb=i1si(iorb)
            write(*,*)
            write(*,*) 'orbital #',iorb
            do mu=1,mxnmu
               imu=(mu-1)*nni
               do ni=1,nni
                  rr=sqrt(vxisq(mu)+vetasq(ni)-1.d0)*r/2.d0
                  if (rr.lt.precis) then
                     wk0(imu+ni)=0.d0
                  else
                     wk0(imu+ni)=1.d0/rr
                  endif
                  wk1(imu+ni)=rr
                  wk2(imu+ni)=rr*rr
               enddo
            enddo
            call prod2 (ngorb,cw_orb(i1beg),wk0,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              <1/r> =',w

            call prod2 (ngorb,cw_orb(i1beg),wk1,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              < r > =',w

            call prod2 (ngorb,cw_orb(i1beg),wk2,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              <r^2> =',w

            call prod2 (ngorb,cw_orb(i1beg),cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              <   > =',w
         enddo

         write(*,*)
         write(*,*)
         write(*,*) 'Expectation values of r_2^k'
         
         do iorb=1,norb
            i1beg=i1b(iorb)
            ngorb=i1si(iorb)
            write(*,*)
            write(*,*) 'orbital #',iorb
            do mu=1,mxnmu
               imu=(mu-1)*nni
               do ni=1,nni
                  r1=(r/2.d0)*(vxi(mu)-veta(ni))
                  if (r1.lt.precis) then
                     wk0(imu+ni)=0.d0
                  else
                     wk0(imu+ni)=1.d0/r1
                  endif
                  wk1(imu+ni)=r1
                  wk2(imu+ni)=r1*r1
               enddo
            enddo
            call prod2 (ngorb,cw_orb(i1beg),wk0,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              <1/r> =',w

            call prod2 (ngorb,cw_orb(i1beg),wk1,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              < r > =',w

            call prod2 (ngorb,cw_orb(i1beg),wk2,wk3)
            call prod  (ngorb,cw_orb(i1beg),wk3)
            call prod  (ngorb,f4,wk3)
            w=ddot(ngorb,wgt2,1,wk3,1)
            write(*,*) '              <r^2> =',w
         enddo
      endif

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### gauss_ovlap ###
c
c     Evaluates the overlap matrix of gaussian basis functions.
c
      subroutine gauss_ovlap (psi,pot,excp,f2,f4,wgt2,wk0)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
c set the maximum value of an argument of the exp function 
      parameter (exp_max=700.d0)
      dimension psi(*),pot(*),excp(*),f2(*),f4(*),wgt2(*),wk0(*)

      do ipb1=1,npbasis
         do ipb2=ipb1,npbasis
            ovl(ipb1,ipb2)=0.d0
            ovl(ipb2,ipb1)=0.d0
         enddo
      enddo

      igauss=0
      if (igauss.eq.0) then
         ishift=0  
         ishift2=nni*mxnmu
         
c        outer loop over gaussian basis set functions

         do i=1,ishift2
            psi(i)=0.d0
         enddo
         do ipb1=1,npbasis
            l1  =lprim(ipb1)
            mp1  =mprim(ipb1)
            if (mp1.lt.0) goto 999
            m1  =abs(mprim(ipb1))
            d1  =primexp(ipb1)
            if (d1.gt.99999999.d0) goto 999
            ic1 =icgau(ipb1)
            fn1 =fngau2(ipb1)
            shn1=shngau(ipb1)
            fnorm1=fn1*shn1
            
01111       format(5i4,f20.9,3d15.5)
01112       format(4i4,f20.9)
01113       format(5i4,2f20.9)
01114       format(4i4,2f20.9)

c           loop over grid points

            do imu=1,mxnmu
               inioff=(imu-1)*nni
               do in=1,nni
                  igp=ishift+inioff+in

c                 for each grid point, i.e. for (vmu(imu),vni(ini)) determine 
c                 its distance |_r1| from the nuclei Z_1 and Z_2 and cosine 
c                 of the polar angles costh1 and costh2 between z axis and 
c                 the vectors _r1 and _r2

c                 rr=(r/2.d0)*sqrt(vxisq(imu)+vetasq(in)-1.d0)		

                  z=(r/2.d0)*vxi(imu)*veta(in)
                  if (ic1.eq.1) then
c                    gaussians centred on Z1
                     r1=(r/2.d0)*(vxi(imu)+veta(in))
                     if (r1.lt.precis) then
                        costh1=0.d0
                        psi1=0.d0
                        goto 99
                     else   
                        costh1=(z+r/2.d0)/r1
                     endif
                  elseif (ic1.eq.3) then
c                    gaussians centred on Z2
                     r1=(r/2.d0)*(vxi(imu)-veta(in))
                     if (r1.lt.precis) then
                        costh1=0.d0
                        psi1=0.d0
                        goto 99
                     else   
                        costh1=(z-r/2.d0)/r1	
                     endif
                  elseif (ic1.eq.2) then
c                    gaussians centred on the bond centre
                     r1=sqrt(vxisq(imu)+vetasq(in)-1.d0)*r/2.d0
                     if (r1.lt.precis) then
                        costh1=0.d0
                        psi1=0.d0
                        goto 99
                     else   
                        costh1= (z)/r1	
                     endif
                  endif

c                 calculate the gaussian function centered on one of the nuclei
                  
                  d1r=d1*r1*r1
                  if (d1r.gt.exp_max) then
                     expt=0.d0
                  else
                     expt=1.d0/exp(d1r)
                  endif
                  psi1=fnorm1*r1**l1*expt*plegendg(l1,m1,costh1)
00099             continue
                  psi(igp)=psi1
               enddo
            enddo

c           c1.ne.0 inner loop over gaussian functions
            do i=1,ishift2
               psi(ishift2+i)=0.d0
            enddo
            do ipb2=ipb1,npbasis
               l2  =lprim(ipb2)
               mp2  =mprim(ipb2)
               if (mp2.ne.mp1) goto 1999
               m2  =abs(mprim(ipb2))
               d2  =primexp(ipb2)
               if (d2.gt.99999999.d0) goto 1999
               ic2 =icgau(ipb2)
               fn2 =fngau2(ipb2)
               shn2=shngau(ipb2)
               fnorm2=fn2*shn2
               do imu=1,mxnmu
                  inioff=(imu-1)*nni
                  do in=1,nni
                     igp=ishift2+inioff+in
                     z=(r/2.d0)*vxi(imu)*veta(in)
                     if (ic2.eq.1) then
c                       gaussians centred on Z1
                        r1=(r/2.d0)*(vxi(imu)+veta(in))
                        if (r1.lt.precis) then
                           costh1=0.d0
                           psi1=0.d0
                           goto199
                        else   
                           costh1=(z+r/2.d0)/r1
                        endif
                     elseif (ic2.eq.3) then
c                       gaussians centred on Z2
                        r1=(r/2.d0)*(vxi(imu)-veta(in))
                        if (r1.lt.precis) then
                           costh1=0.d0
                           psi1=0.d0
                           goto199
                        else   
                           costh1=(z-r/2.d0)/r1	
                        endif
                     elseif (ic2.eq.2) then
c                       gaussians centred on the bond centre
                        r1=sqrt(vxisq(imu)+vetasq(in)-1.d0)*r/2.d0
                        if (r1.lt.precis) then
                           costh1=0.d0
                           psi1=0.d0
                           goto199
                        else   
                           costh1= (z)/r1	
                        endif
                     endif

c                    calculate the gaussian function centered on one of
c                    the nuclei

                     d2r=d2*r1*r1
                     if (d2r.gt.exp_max) then
                        expt=0.d0
                     else
                        expt=1.d0/exp(d2r)
                     endif
                     psi1=fnorm2*r1**l2*expt*plegendg(l2,m2,costh1)
00199                continue
                     psi(igp)=psi1
                  enddo
               enddo

c              evaluate overlap between ipb1 and ipb2 functions
               
               call prod2 (ishift2,psi(1),psi(ishift2+1),wk0)
               call prod  (ishift2,f4,wk0)

               xovlap=ddot (ishift2,wgt2,1,wk0,1)

               if (ipb1.eq.ipb2) then
                  write(*,1114) ipb1,ic2,l2,mprim(ipb2),d2,xovlap
                  call flush(iout6)
               endif

               ovl(ipb1,ipb2)=xovlap
               ovl(ipb2,ipb1)=xovlap

c              end inner loop over basis functions 
               
01999          continue
            enddo
00999       continue
c           end outer loop over basis functions
         enddo

c        save the matrix on disk

         open(30,file='overlap.data',status='unknown',
     &        form='unformatted')
         write(30) ovl
         close(30)
      endif

c     check normalization of finite basis molecular orbitals
      
      open(30,file='overlap.data',status='unknown',form='unformatted')
      read(30) ovl
      close(30)
      
      do iorb=1,norb
         xmon=0.d0
         do ipb1=1,npbasis
            do ipb2=1,npbasis
               xmon=xmon+primcoef(iorb,ipb1)*primcoef(iorb,ipb2)*
     &              ovl(ipb1,ipb2)
            enddo
         enddo
02123    format(2i5,2i3,4d15.4)
         write(*,*) 'norm of mol.orb ',iorb,xmon
      enddo

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### lagra ###
c
c     Calculates the off-diagonal lagrange multipliers.
c     Damping factors are set to 1, i.e. dmp=1
c 
      subroutine lagra (iorb,psi,pot,excp,wgt2,wk0,wk1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),wgt2(1),wk0(*),wk1(*)
      dimension engl(3600)

c     there are two possibilities to calculate Lagrange multipliers.
c     if abs((cw1*occ(i)-cw2*occ(iorb))/(c12*occ(i)*occ(iorb))  is
c              > 5.e-02  take <j/h/i> - <i/h/j>  
c              < 5.e-02  take <j/h/i> + <i/h/j>

      if    (idbg(370).eq.0) then
         dmp=1.d0
      elseif(idbg(371).eq.0) then
         dmp=0.8d0
      elseif(idbg(372).eq.0) then
         dmp=0.6d0
      elseif(idbg(373).eq.0) then
         dmp=0.4d0
      elseif(idbg(374).eq.0) then
         dmp=0.2d0
      elseif(idbg(375).eq.0) then
         dmp=0.1d0
      endif

      if (norb.le.1) return
      if (nel.eq.1)  return
      if (iorb.eq.norb) return

      iorbbeg=iorb+1
      do iorb1=1,norb
         if (ifix(iorb1).ne.0) iorbbeg=1
      enddo

      do iorb1=iorbbeg,norb

c        if break is on and the two orbitals have different symmetry
c        off-diagonal lm is not calculated

c        if (ihomon.eq.2.and.ihomo(iorb1)*ihomo(iorb).lt.0) goto 10
         if (ihomo(iorb1)*ihomo(iorb).lt.0) goto 10

         if (icou(iorb1,iorb).eq.0) goto 10

         ipc1=iorb1+(iorb-1)*norb
         ipc2=iorb+(iorb1-1)*norb

         cw1=1.0d0
         cw2=1.0d0
         c12=cw1*cw2
         
         engl(ipc1)=engo(ipc1)
         engl(ipc2)=engo(ipc2)

         call rayln (iorb1,iorb,psi,pot,excp,wgt2,wk0,wk1)
         call rayln (iorb,iorb1,psi,pot,excp,wgt2,wk0,wk1)

         ent=0.d0
         divt=(cw1*occ(iorb1)-cw2*occ(iorb))/(c12*occ(iorb1)*occ(iorb))

         if (abs(divt).lt.5.d-02) then
            divt=(cw1*occ(iorb1)+cw2*occ(iorb))/
     &           (c12*occ(iorb1)*occ(iorb))
            ent=(engo(ipc1)+engo(ipc2))/divt
         else
            ent=(engo(ipc1)-engo(ipc2))/divt
         endif	   	   

         if (idbg(333).ne.0) then
            write(*,*) 'E(ab) ',iorn(iorb),iorn(iorb1),
     &           engo(ipc1),engo(ipc1)/occ(iorb1)
            write(*,*) 'E(ba) ',iorn(iorb1),iorn(iorb),
     &           engo(ipc2),engo(ipc2)/occ(iorb)
         endif
         engo(ipc1)=sflagra*ent/(cw2*occ(iorb))
         engo(ipc2)=sflagra*ent/(cw1*occ(iorb1))

         engo(ipc1)=dmp*ent/(cw2*occ(iorb ))+(1.d0-dmp)*engl(ipc1)
         engo(ipc2)=dmp*ent/(cw1*occ(iorb1))+(1.d0-dmp)*engl(ipc2)

 10      continue
      enddo

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### scf ####
c
c     Controls SCF process.
c
      subroutine scf (cw_sor,cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)

      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      logical stop_x2dhf
      integer*4 cw_sor		
      character*1 str(80)
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),
     &		cw_suppl(*),cw_sctch(*)
      dimension inde(60),demaxt(60)
      equivalence(datetime,str(1))

c     prepare scf process
c     normalize/orthogonalize orbitals, calculate Lagrange multipliers
c     prepare data for boundary value evaluation
c
c      write(*,'("scf:",2d25.14)'),cw_exch(122),cw_exch(10465-1)
      call prepscf (cw_sor,cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)
c      write(*,'("scf:",2d25.14)'),cw_exch(122),cw_exch(10465-1)

      stop_x2dhf=.false.
      ic=0
      thren=10.d0**(-ienterm)
      thrno=10.d0**(-inoterm)

c     the scf procedure starts here (set some parameters and go ...)

      ddmax=0.d0
      do i=1,norb
         inde(i)=i 
         itouch(i)=0
         demax(i)=100.d0
         engi(i)=engo(i)
      enddo
      dnomax=100.d0

      tscf=0.d0
      trelax=0.d0
      tortho=0.d0
      trayl =0.d0
      tlagra=0.d0	
      tmomen=0.d0
      
c     if extension has not beeen read in recalculated asymptotic values
c     for potentials

      if (idump.ne.0.and.(iform.eq.0.or.iform.eq.3)) iasympt=norb
      
      call ttime (time1)      
      tscf=time1
      
      iscf=0
      
      time1=0.d0
      time2=0.d0
      
      if (ihomon.eq.2) then
	 call homo(0,cw_orb)
      endif     
      
c     initialize totenp 

      if (iform.eq.0.or.iform.eq.2) then
         iorb=0
         call totenp (iorb,cw_orb,cw_coul,cw_exch,
     &	    cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &      cw_suppl(i4b(14)),
     &      cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &      cw_sctch(i5b( 4)))
      endif
      
c     ----- begin of scf loop -----
      
      if (maxscf.le.0) write(iout6,*) '... skipping scf iterations ...'
      do iscf=1,maxscf
         if (iscf.eq.1) write(iout6,15000)
c        loop over orbitals (in reverse order) 
c        relaxation begins from the innermost orbital, i.e. the last
c        one on the input data list
         
         ibeg=1
         iend=norb
         
c        prepare retrieval of exchange potentials 
         
         call prepwexch
         
c        ----- begin of orbital loop -----	
         
         do i=ibeg,iend
            iorb=norb-i+1
            itouch(iorb)=1
            if (ifix(iorb).ne.0) goto 100

            call ttime (time1)
            if (iform.eq.0.or.iform.eq.2) then
c              retrieve from disk exchange potentials involving iorb	
               call rfdexch(iorb,cw_exch)
               if (iasympt.ne.0) then
                  call asymptp(iorb,cw_coul,cw_exch)  
                  iasympt=iasympt-1
               endif
            endif

c           calculate off-diagonal Lagrange multipliers

            call lagra (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b(14)),cw_sctch(i5b(1)),cw_sctch(i5b(2)))	
            call ttime(time2)
            trayl =trayl + (time2-time1)	  	  
            
c           print *,"scf: iorb,eng(iorb)",iorb,eng(iorb)

c            write(*,'("before: ",i4,(7d15.6))') iorb,
c     &              (cw_exch(i1),i1=100,length3,nni*mxnmu)
               
            call relax (iorb,cw_sor,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 1)),cw_suppl(i4b( 2)),cw_suppl(i4b( 3)),
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b( 6)),  
     &           cw_suppl(i4b( 7)),cw_suppl(i4b( 8)),cw_suppl(i4b( 9)),     
     &           cw_suppl(i4b(10)),cw_suppl(i4b(11)),cw_suppl(i4b(12)),     
     &           cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),          
     &           cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)))
            
c            write(*,'("after:  ",i4,(7d15.6))') iorb,
c     &           (cw_exch(i1),i1=100,length3,nni*mxnmu)
            

            call ttime (time2)
            trelax=trelax+(time2-time1)
            
            time1=time2
            call norm (iorb,cw_orb,
     &           cw_suppl(i4b(9)),cw_suppl(i4b(14)),cw_sctch(i5b(1)))	
            
c           enforce C_i symmetry of the orbital
            
            if (ihomon.eq.2) call homo(iorb,cw_orb)
            
            iprt=0
            if (norb.gt.1) then
               call ortho (iorb,cw_orb, 
     &              cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &              cw_sctch(i5b(1)),iprt)	  
            endif   
            
            call ttime(time2)
            tortho=tortho+(time2-time1)
            
c           calculate diagonal energy value
            
            call ttime(time1)
            call rayl (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &           cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
            demaxt(iorb)=eng(iorb)-engi(iorb)
            engi(iorb)=eng(iorb)	  
            
            if (iform.eq.0.or.iform.eq.1) then
               call wtdexch(iorb,cw_exch)
            endif
            
            if (iprtlev.eq.1) then
               write(iout6,15100) iscf,iorn(iorb),bond(iorb),gut(iorb),
     &              demaxt(iorb),eng(iorb),area(iorb)
            endif     

            if (nobckup.gt.0) then
               modv=mod(iscf,abs(nobckup))
               if (modv.eq.0) then
                  if (iform.eq.0.or.iform.eq.2) then

c                    calculate 'intermidiate' total energy
                     
                     call totenp (iorb,cw_orb,cw_coul,cw_exch,
     &                    cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &                    cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &                    cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &                    cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
                  endif
               endif
        endif

c       Sometimes a lengthy calculation needs to be stoped earlier. 
c       kill <pid> will do the job but you risk that the data being written 
c       will be lost. To avoid this and force the program to end gracefully 
c       make 
c       touch stop_x2dhf
        
c       If this file is detected the program ends.
        
        inquire (file ='stop_x2dhf',exist=stop_x2dhf)
        if (stop_x2dhf) goto 110
        
00100   continue
      enddo

c     ----- end of orbital loop -----	

00110 continue
      demax(1)=0.d0
      inde(1)=1
      dnomax=0.d0

      if (norb.gt.0) then
         do nei=1,norb
            if(abs(demaxt(nei)).ge.abs(demax(1))) then
               demax(1)=demaxt(nei)
               inde(1)=nei
            endif
         enddo
         do nei=1,norb
            if (abs(1.d0-area(nei)).ge.dnomax) then
               dnomax=abs(1.d0-area(nei))
            endif
         enddo
      endif	
      
c     inde containes indexes of orbitals in the order of their state
c     of convergence; inde(1) points to the worst converged orbital
      
      if (ddmax.eq.0.d0) ddmax=demax(1)
      
      if (iprtlev.eq.2) then 
         write(iout6,15110) iscf,iorn(inde(1)),bond(inde(1)),  
     &        gut(inde(1)),demaxt(iorb),eng(iorb),area(iorb)
      endif
      
c     check if the scf process is to be continued 
      
      if (abs(demax(1)).gt.diver) then
         write(*,*) '           '
         write(*,*) '... maximal orbital energy error is too ',
     &        'large ...'
         goto 9999
         
      elseif (iscf+1.gt.maxscf) then
         write(*,*) '          '
         write(*,*) '... scf iteration limit reached ... '
         goto 9999
         
      elseif (abs(demax(1)).lt.thren) then
         write(*,*) '          '
         write(*,*) '... orbital energy threshold reached ...'
         goto 9999
         
	elseif (exlorb.eq.0.and.dnomax.lt.thrno) then
           write(*,*) '          '
           write(*,*) '... orbital normalization threshold',
     &          ' reached ...'
           goto 9999
           
        elseif (stop_x2dhf) then
           write(*,*) '          '
           write(*,*) '... stop_x2dhf detected ... '
           write(*,*) '... aborting gracefully ...'
           write(*,*)
           goto 9999
	endif
        
c       write functions to disk file if nobckup > 0
        
	if (nobckup.gt.0) then
           modv=mod(iscf,nobckup)
           if (modv.eq.0) then
              call wtdisk(cw_orb,cw_coul,cw_exch)
              if (iprtlev.eq.3) write(iout6,15110) 
     &             iscf,iorn(inde(1)),bond(inde(1)),gut(inde(1)),
     &             demaxt(iorb),eng(iorb),area(iorb)
              if (iform.eq.1.or.iform.eq.3) then
                 
c                calculate 'intermidiate' total energy

                 call toten (cw_orb,cw_coul,cw_exch,
     &                cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),
     &                cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &                cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &                cw_sctch(i5b( 3)),cw_sctch(i5b( 4)))
              endif
              write(iout6,6100)  etot
           endif
	endif	  

c       recalculate multipole moments expansion coefficients
        
	if (abs(ddmax/demax(1)).gt.facmul.or.
     &       abs(demax(1)/ddmax).gt.facmul) then
	   call momen(cw_orb,cw_suppl,cw_sctch)
           ddmax=demax(1)
           
c          recalculate asymptotic values of potentials
           
           if (iform.eq.1.or.iform.eq.3) then
              call asympot (cw_coul,cw_exch)	  
	   else
	      iasympt=norb
	   endif
           
           do iorb=1,norb
              itouch(iorb)=0
	   enddo	    
        endif
        
	call flush(iout6)
        
c       to run a job in a bach mode (or in the background) with
c       the output redirected into a file and to monitor every single
c       iteration 
        
      enddo

c     ----- end of scf loop	-----
      
09999 iscf=iscf-1
      call summary (iscf,cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)
      
      call ttime (time1)      
      tscf=time1-tscf
      write(*,5010) tscf
      call  getdatetime(datetime)
      call clrstring(imax,datetime)
      write(*,'(//,1x,80a1)') (str(i),i=1,imax)
      
 1300 format(/,80a1)	
 5010 format(4x,'total time in scf routine          ', f12.2)
 6100 format(1x,'total energy: ',d20.13)
15000 format(/'  iter.   orbital',7x,'energy diff.',6x,'orbital energy',
     &          12x,'orbital norm')
15100 format(i5,i4,1x,a8,a1,3x,d13.5,2d25.14)
15110 format(i5,i4,1x,a8,a1,3x,d13.5,2d25.14)
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### exchmom ###	
c
c     Calculates multipole moments to k_max=7 and Delta_m=4
c
      subroutine exchmom (iorb1,iorb2,psi,f4,wgt2,d0,d1,d2,d3,
     &     d4,d5,d6,d7,wk1,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

      dimension psi(*),f4(*),wgt2(*),wk1(*),wk2(*),
     &     d0(nni,mxnmu),d1(nni,mxnmu),d2(nni,mxnmu),
     &     d3(nni,mxnmu),d4(nni,mxnmu),
     &     d5(nni,mxnmu),d6(nni,mxnmu),d7(nni,mxnmu)

      dimension dome(10)

      if (itouch(iorb1).eq.0.and.itouch(iorb2).eq.0) return
      if (iorb1.eq.iorb2.and.mgx(6,iorb2).eq.0) return

      ido=0
1234  ido=ido+1

c     calculate m

      idel=abs(mgx(6,iorb2)-mgx(6,iorb1))
      if (iorb1.eq.iorb2) idel=2*mgx(6,iorb2)
      ipc=iorb1+iorb2*(iorb2-1)/2

      if ((iorb1.eq.iorb2).and.(ilc(ipc).lt.1)) return

c     second values of expansion coefficients for the same pair of
c     orbitals are stored in the second half of the arrays.

      if (ido.eq.2) then
         idel=mgx(6,iorb2)+mgx(6,iorb1)
         ipc=ipc+norb*(norb+1)/2
      endif

c     homonuclear case is treated as a heteronuclear one

      ibeg1=i1b (iorb1)
      ibeg2=i1b (iorb2)

      xr2=r/2.d0
      do mu=2,mxnmu
         do ni=2,nni
            rr=sqrt (vxisq(mu)+vetasq(ni)-1.d0)
            xrr=xr2*rr
            do i=1,8
               dome(i)=0.d0
            enddo

            call mulex(ni,mu,idel,dome)

            xw=xrr
            d0(ni,mu)=dome(1)*xw
            xw=xw*xrr
            d1(ni,mu)=dome(2)*xw
            xw=xw*xrr
            d2(ni,mu)=dome(3)*xw
            xw=xw*xrr
            d3(ni,mu)=dome(4)*xw
            xw=xw*xrr
            d4(ni,mu)=dome(5)*xw
            xw=xw*xrr
            d5(ni,mu)=dome(6)*xw
            xw=xw*xrr
            d6(ni,mu)=dome(7)*xw
            xw=xw*xrr
            d7(ni,mu)=dome(8)*xw
c            if ((iorb1.eq.1).and.(iorb2.eq.1).and.(ni.eq.nni/2)
c     &           .and.(mu.eq.mxnmu/2)) then
c               write(*,'(10d16.7)') xrr,xw
c               write(*,'(10d16.7)') (dome(i),i=1,8)
c            endif
c           xw=xw*xrr
c           d8(ni,mu)=dome(9)*xw
c           xw=xw*xrr
c           d9(ni,mu)=dome(10)*xw
         enddo
      enddo

c     Now d0, d1, d2,... are equal to P0, P1*r, P2*r**2, ...,
c     respectively. P0, P1,..  are Legendre polynomials of a specified
c     order.

c     Prepare integrands and calculate moments. Multiplication by f4 is 
c     necessary because of the factor 2/(r*cosh(mu)) incorporated in wgt2.

      ngrid = min (i1si(iorb1),i1si(iorb2))
      call prod2 (ngrid,psi(ibeg1),psi(ibeg2),wk1)
      call prod  (ngrid,f4,wk1)

      call prod2 (ngrid,d0,wk1,wk2)
      excdi(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d1,wk1,wk2)
      excqu(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d2,wk1,wk2)
      excoc(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d3,wk1,wk2)
      exche(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d4,wk1,wk2)
      exc5(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d5,wk1,wk2)
      exc6(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d6,wk1,wk2)
      exc7(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d7,wk1,wk2)
      exc8(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      if (idbg(102).ne.0) then
         write(*,1000) iorn(iorb1),bond(iorb1),gut(iorb1),
     &        iorn(iorb2),bond(iorb2),gut(iorb2),idel
 1000    format(/,i4,1x,a8,a1,3x,i4,1x,a8,a1,3x,i5)
         
         write(*,1010) excdi(ipc),excqu(ipc),excoc(ipc),exche(ipc),
     &        exc5(ipc),exc6(ipc),exc7(ipc),exc8(ipc)
 1010    format(4d16.8)
      endif

      if (ilc(iorb1+iorb2*(iorb2-1)/2).eq.2.and.ido.eq.1) go to 1234

      return
      end

c ### exchmom1 ###	
c
c     Calculates multipole moments to l=8 and m=4 (iorb1<=iorb2)
c
      subroutine exchmom1 (iorb1,iorb2,psi,f4,wgt2,d0,d1,d2,d3,
     &     d4,d5,d6,d7,wk1,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

      dimension psi(*),f4(*),wgt2(*),wk1(*),wk2(*),
     &     d0(nni,mxnmu),d1(nni,mxnmu),d2(nni,mxnmu),
     &     d3(nni,mxnmu),d4(nni,mxnmu),
     &     d5(nni,mxnmu),d6(nni,mxnmu),d7(nni,mxnmu)

      dimension dome(10)

      if (itouch(iorb1).eq.0.and.itouch(iorb2).eq.0) return
      if (iorb1.eq.iorb2.and.mgx(6,iorb2).eq.0) return

      ido=0
1234  ido=ido+1

c     calculate m

      idel=abs(mgx(6,iorb2)-mgx(6,iorb1))
      if (iorb1.eq.iorb2) idel=2*mgx(6,iorb2)
      ipc=iorb1+iorb2*(iorb2-1)/2

      if ((iorb1.eq.iorb2).and.(ilc(ipc).lt.1)) return

c     second values of expansion coefficients for the same pair of
c     orbitals are stored in the second half of the arrays.

      if (ido.eq.2) then
         idel=mgx(6,iorb2)+mgx(6,iorb1)
         ipc=ipc+norb*(norb+1)/2
      endif

c   homonuclear case is treated as a heteronuclear one

      ibeg1=i1b (iorb1)
      ibeg2=i1b (iorb2)

      do mu=2,mxnmu
         do ni=2,nni
            xrr=r2*sqrt (vxisq(mu)+vetasq(ni)-1.d0)
            call mulex1(ni,mu,idel,dome)
            xw=xrr
            d0(ni,mu)=dome(1)*xw
            xw=xw*xrr
            d1(ni,mu)=dome(2)*xw
            xw=xw*xrr
            d2(ni,mu)=dome(3)*xw
            xw=xw*xrr
            d3(ni,mu)=dome(4)*xw
            xw=xw*xrr
            d4(ni,mu)=dome(5)*xw
            xw=xw*xrr
            d5(ni,mu)=dome(6)*xw
            xw=xw*xrr
            d6(ni,mu)=dome(7)*xw
            xw=xw*xrr
            d7(ni,mu)=dome(8)*xw

c            if ((iorb1.eq.1).and.(iorb2.eq.1).and.(ni.eq.nni/2)
c     &           .and.(mu.eq.mxnmu/2)) then
c               write(*,'(10d16.7)') xrr,xw
c               write(*,'(10d16.7)') (dome(i),i=1,8)
c            endif
c            print *,'iorb1,iorb2,ni,mu,nnu,mxnmu',
c     &           iorb1,iorb2,ni,mu,nni,mxnmu
c            stop "exchmom1"
         enddo
      enddo

c     Now d0, d1,... are equal to N*P(1,q)*r, N*P(2,q)*r**2, ...,
c     respectively. P(1,q), P(2,q),...  are associate Legendre polynomials
c     of a specified order (k) and degree q (q==idel). N is equal to
c     [(k-|q|)!/(k+|q|)!]^{1/2}.
c     Note that N*N is present in eq. (19). One N is taken care of when 
c     evaluating Q_kq (Q_{k\Delta m}^{ab}) and the other when generating 
c     Pkm (P_{k|\Delta m|).   

c     Prepare integrands and calculate moments. Multiplication by f4 is 
c     necessary because of the factor 2/(r*cosh(mu)) incorporated in wgt2.

      ngrid = min (i1si(iorb1),i1si(iorb2))
      call prod2 (ngrid,psi(ibeg1),psi(ibeg2),wk1)
      call prod  (ngrid,f4,wk1)

      call prod2 (ngrid,d0,wk1,wk2)
      excdi(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d1,wk1,wk2)
      excqu(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d2,wk1,wk2)
      excoc(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d3,wk1,wk2)
      exche(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d4,wk1,wk2)
      exc5(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d5,wk1,wk2)
      exc6(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d6,wk1,wk2)
      exc7(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      call prod2 (ngrid,d7,wk1,wk2)
      exc8(ipc) = ddot (ngrid,wgt2,1,wk2,1)

      if (idbg(102).ne.0) then
        write(*,1000) iorn(iorb1),bond(iorb1),gut(iorb1),
     &           iorn(iorb2),bond(iorb2),gut(iorb2),idel
 1000   format(/,i4,1x,a8,a1,3x,i4,1x,a8,a1,3x,i5)

        write(*,1010) excdi(ipc),excqu(ipc),excoc(ipc),exche(ipc),
     &		   exc5(ipc),exc6(ipc),exc7(ipc),exc8(ipc)
 1010   format(4d16.8)
      endif

      if (ilc(iorb1+iorb2*(iorb2-1)/2).eq.2.and.ido.eq.1) go to 1234

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### totenp ### 
c
c     Calculate the total energy in the case of exchange
c     potentials being kept on a disk

      subroutine totenp (iorb,psi,pot,excp,e,f0,wgt1,wgt2,
     &                    wk0,wk1,wk2,wk3)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),e(*),f0(*),wgt1(*),wgt2(*),
     &     wk0(*),wk1(*),wk2(*),wk3(*)
      data eps /1.d-7/

      if (iorb.eq.0) then
         ictot=0
         vkt  =0.d0
         vnt  =0.d0
         evt  =0.d0
         epott=0.d0
         return
      endif

      if (islat.ne.0) then
c        the Slater exchange approximation is used
	 call totensl (psi,pot,excp,e,f0,wgt1,wgt2,wk0,wk1,wk2,wk3)
	 return
      endif

      engt(1)=eng(1)

      if (nel.lt.2) return

      ictot=ictot+1
      
      woneel=0.d0
      wdcoul=0.d0
      
      engt(1)=0.d0
      
c     calculate first contributions from one particle operators and
c     coulomb potential contributions within the same shell

      if (idbg(70).ne.0) then
	 write(*,*) 'orb        t        v(n)      t+v(n)     ',
     &        ' v(c-within shell)'
      endif

      norb2=norb*norb
	        
      iborb=i1b(iorb)
      isiorb=i1si(iorb)
      nmut=i1mu(iorb)
      ibpot=i2b(iorb)	  
      isipot=i2si(iorb)
      oc=occ(iorb)
      
      ipe=mgx(6,iorb)
      ipex=ipe-2*(ipe/2)

c     calculate derivatives over mu and ni variables by means of matrix
c     multiplication

      if (ipex.eq.0) then
         isym= 1
      else
         isym=-1
      endif
      
      call fill (nni,nmut,isym,psi(iborb),wk3)
      call difni (nmut,wk3,wk0,wk1,wk2)
      call refill(nni,nmut,wk1,wk0)
      call difmu (nmut,wk3,wk2)
      call refill(nni,nmut,wk0,wk2)

c     add derivatives over mu and ni

      call add (isiorb,wk0,wk1)

c     add contribution from phi part of laplasian
c     e enters the expression with minus sign which is already
c     incorporated in e

      if (ipe.ne.0) then
         w=dble(ipe*ipe)
         call dcopy (isiorb,e,1,wk0,1)
         if (ipe.ne.1) then
            call dscal (isiorb,w,wk0,1)
         endif
         call prod  (isiorb,psi(iborb),wk0)
         call add   (isiorb,wk0,wk1)
      endif
      
      call dcopy (isiorb,wk1,1,wk2,1)
      call prod  (isiorb,psi(iborb),wk2)
      w=ddot(isiorb,wgt1,1,wk2,1)
      vk(iorb)=w

      call dcopy (isiorb,f0,1,wk0,1)
      call prod  (isiorb,psi(iborb),wk0)
      
      call prod2 (isiorb,psi(iborb),wk0,wk2)
      w=ddot(isiorb,wgt1,1,wk2,1)
      vn(iorb)=w

      call add	 (isiorb,wk0,wk1)
      call prod (isiorb,psi(iborb),wk1)
      
      w = ddot(isiorb,wgt1,1,wk1,1)
      woneel=oc*w

c     contribution from coulomb interaction within the same shell
      
      if (oc.gt.1.d0) then
         if (isipot.ne.isiorb) then
            write(iout6,*) 'coulomb potentials and orbitals have to ',
     &           'defined on the same number of subgrids'
            stop 'toten'
         endif				
         call dcopy (isipot,pot(ibpot),1,wk2,1)
         call prod  (isiorb,psi(iborb),wk2)
         call prod  (isiorb,psi(iborb),wk2)
         
         w=ddot(isiorb,wgt2,1,wk2,1)
c        wdcoul=wdcoul+oc*(oc-1.d0)/2.d0*w
         wdcoul= oc*(oc-1.d0)/2.d0*w
      endif	    

      vkt=vkt+oc*vk(iorb)
      vnt=vnt+oc*vn(iorb)

      if (idbg(70).ne.0) then
	 write(*,6000) iorb, vk(iorb),vn(iorb),vk(iorb)+vn(iorb),w
      endif
 10   continue

 6000 format(' ',i4,2x,4d20.9)
 6010 format(' ',i4,2x,4d20.9)
 6012 format(' ',2i4,2x,4d20.9)

c     contribution from coulomb and exchange interaction between shells
      
      wndc =0.d0
      wex1 =0.d0
      wex2 =0.d0
      
      iorb1=iorb
      iborb1=i1b(iorb1)
      isiorb1=i1si(iorb1)
      nmut1=i1mu(iorb1)
      ibpot1=i2b(iorb1)
      isipot1=i2si(iorb1)	  	  
      oc1=occ(iorb1)	

      ipe1=mgx(6,iorb1)
      iex1 =iorb1+iorb1*(iorb1-1)/2

      call dcopy (isiorb1,psi(iborb1),1,wk0,1)
      call prod  (isiorb1,psi(iborb1),wk0)

c     calculate exchange interaction within pi, delta, etc. open shell

      if (ipe1.gt.0.and.abs(oc1-1.d0).gt.eps) then
         call exint (iorb1,ocx1)
         ibex=i3b(iex1)
         isiex1=i3si(iex1)
         
         ngrid=min(isiorb1,isiex1)
         call prod2  (ngrid,wk0,excp(ibex),wk1)
         w=ddot (ngrid,wgt2,1,wk1,1)
         wex1=wex1+ocx1*w

         if (idbg(70).ne.0) then
	    write(*,6020) iorb1,w
 6020       format(' ','orb v(x-within shell) ',i4,2x,4d15.5)
         endif
      endif

      do iorb2=iorb1+1,norb
         iborb2=i1b(iorb2)
         isiorb2=i1si(iorb2)
         nmut2=i1mu(iorb2)
         ibpot2=i2b(iorb2)
         isipot2=i2si(iorb2)	  
         oc2=occ(iorb2)	
         
c        coulomb interaction between shells

         ngrid=min(isipot2,isiorb1)
         call prod2 (ngrid,pot(ibpot2),wk0,wk1)

         w=ddot(ngrid,wgt2,1,wk1,1)
         wndc=wndc+oc1*oc2*w
         
         if (idbg(70).ne.0) then
            write(*,6022) iorb1,iorb2,w
 6022       format(' ','orb1 orb2 v(c-inter shell) ',2i4,2x,4d15.5)
         endif

         ipe2=mgx(6,iorb2)
         iex=iorb1+iorb2*(iorb2-1)/2
         ibex=i3b(iex)	  
         isiex=i3si(iex)
         
c        exchange interaction between shells (same lambda)	  

         call excont (iorb1,iorb2,ocx1,ocx2)	  

         ngrid=min(isiorb1,isiorb2,isiex)
         call prod2 (ngrid,excp(ibex),psi(iborb1),wk1)
         call prod  (ngrid,psi(iborb2),wk1)
         
         w=ddot(ngrid,wgt2,1,wk1,1)
         wex1=wex1+ocx1*w
         
         if (idbg(70).ne.0) then
	    write(*,6024) iorb1,iorb2,w
 6024	    format(' ','orb1 orb2 v(x-inter shell)a',2i4,2x,4d15.5)
         endif
         
         if (ilc(iex).gt.1) then
            call prod2 (ngrid,excp(ibex+ngrid),psi(iborb1),wk1)
            call prod  (ngrid,psi(iborb2),wk1)
            w=ddot (ngrid,wgt2,1,wk1,1)
            wex2=wex2+ocx2*w

            if (idbg(70).ne.0) then
               write(*,6026) iorb1,iorb2,w
 6026          format(' ','orb1 orb2 v(x-inter shell)b',2i4,2x,4d15.5)
            endif
         endif
      enddo

      evt=evt+woneel+wdcoul+wndc-wex1-wex2
      epott=epott+oc*vn(iorb)+wdcoul+wndc-wex1-wex2

      virrat=(epott+z1*z2/r)/vkt
      
      if (ictot.eq.norb) then
         iready=ictot
         etot=evt+z1*z2/r
         engt(1)=evt
         
         ictot=0
         vkt  =0.d0
         vnt  =0.d0
         evt  =0.d0
         epott=0.d0
      endif
      
      if (idbg(70).ne.0) then
         write(*,*) 'total energy: ', evt
         write(*,*) 'contributions: one-electron     coulomb',
     &        '     exchange  '
         write(*,*)  woneel,wdcoul+wndc,wex1+wex2
      endif

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### setomega ###
c
c     Determines optimal omega overrelaxation parameter for relaxing
c     potentials according to a semiempirical formula due to B.Sobczak's
c     MSc thesis, Torun 2002
c
      function setomega()
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (a=0.603,b=0.79)
      include 'commons8.inc'

      rho=0.5*(cos(pii/dble(mxnmu))+cos(pii/dble(nni)))
      setomega=2.d0*a/(1.d0+sqrt(1.d0-rho*rho))+b
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### gmtran ###
c
c     Transposes an array A and stores it in ATR. 
       subroutine gmtran(a,atr,n,m)
      implicit integer*4 (i-n)
       implicit real*8 (a-h,o-z)
       dimension a(*),atr(*)

       ir=0
       do i=1,n
          ij=i-n
          do j=1,m
             ij=ij+n
             ir=ir+1
             atr(ir)=a(ij)
          enddo
       enddo

       return
       end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prepmesh ####
c
c     Establishes meshes for each subgrid and determines coefficients
c     of the interpolation polynomials needed in fill arrays.
c
c     Warning! At present at most 3 grids are allowed. 
c     See mesh for further detailes.
c
      subroutine prepmesh (cw_sor)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      integer*4 cw_sor	
      include 'commons8.inc'
      dimension cw_sor(*)

c     Array cw_sor is used to store index arrays needed to perform
c     sor relaxation on normal and extended grids. Two cases have to be
c     considered since all ngrids-1 subgrids can either be interior or 
c     last ones depending on the particular orbital or potential
c     function relaxed (outer diffused orbitals would need, say, a grid
c     consisting of the 3 subgrids while for the proper description of the 
c     the core, very much confined orbitals only one subgrid would sufice).

c     Division of the cw_sor array is as folows: 

c     ind1   - relaxation ordering on the extended grid
c     ind2   - relaxation ordering on the normal grid 
c     ind1ex - extrapolation ordering on the extended grid 
c     ind2ex - extrapolation ordering on the normal grid 
c     ind3   - number of points for relaxation and extrapolation
c     mxsize8==(nni+8)*(mxnmu+8)
c     mxnmu8=mxnmu+8

c     case 1 - all ngrids subgrids are considered as the last ones; 
c              in effect the last 4 columns of orbitals and potentials 
c	       are not relaxed two arrays of the indx1 type

c     case 2 - all (ngrids-1) subgrids are considered as the interior ones

c     cw_sor consists of
c     - ngrids     arrays of indx1 type (case 1);
c     - (ngrids-1) arrays of indx1 type (case 2);
c                  the length of each array is determined by ngsize 
c
c     - ngrids     arrays of indx2 type (case 1);
c     - (ngrids-1) arrays of indx2 type (case 2);
c		   the length of each array is determined by ngsize 
c
c     - ngrids	   arrays of indx6a (case 1)
c     - (ngrids-1) arrays of indx6a (case 2)
c     - ngrids	   arrays of indx6b (case 1)
c     - (ngrids-1) arrays of indx6b (case 2)
c     - ngrids	   arrays of indx7 (case 1)
c     - (ngrids-1) arrays of indx7 (case 2)
c  		   the length of each array is determined by nmu

c     ingr1(k,ig) and ingr2(k,ig),ig=1,ngrids, k=1,..,4, contain number of 
c     grids points to be relaxed in each subgrid (k=1) and number of points 
c     for which extrapolation is to be carried out (k=2 - ngrd6a, k=3 - ngrd6b, 
c     k=4 - ngrd7); ingr1 and ingr2 correspond to the extended and normal 
c     case, respectively.

c     i6b(1) - begining of ind1
c     i6b(2) - begining of ind2
c     i6b(3) - begining of index1 (indx6a)
c     i6b(4) - begining of index2 (indx6b)
c     i6b(5) - begining of index3 (indx7)

c     more space is reserved for the ordering arrays to avoid problems when
c     more than 3 subgrid would be used in the future

c     determine the largest subgrid length in mu variable

      mxsmu=0
      do ig=1,ngrids
         if (mxsmu.lt.nmu(ig)) mxsmu=nmu(ig)
      enddo
	
      is34=ngrids*mxsmu	  
      is5 =ngrids*nni
      mxnmu16=mxnmu+16
      ngrid16=nni*mxnmu16
      
      i6b(1)=1
      i6b(2)=i6b(1)+2*ngrid16
      i6b(3)=i6b(2)+2*ngrid16
      i6b(4)=i6b(3)+2*is34
      i6b(5)=i6b(4)+2*is5

c     i6b(4)=i6b(3)+is34
c     i6b(5)=i6b(4)+is5

c     determine ordering of grid points assuming the subgrids are the last
c     ones (grid points in the last 4 columns are excluded from relaxation
c     process

      imcase=1
      ibeg1=i6b(1)
      ibeg2=i6b(2)	
      ibeg3=i6b(3)		
      ibeg4=i6b(4)
      ibeg5=i6b(5)	
      imut=0		
      init=0	
      igs=0
      do ig=1,ngrids
         ib1=ibeg1+igs
         ib2=ibeg2+igs
         ib3=ibeg3+imut
         ib4=ibeg4+imut	  
         ib5=ibeg5+init	  	  
         iadext(ig)=ib1	  
         iadnor(ig)=ib2	  	  
         iadex1(ig)=ib3	  	  	  
         iadex2(ig)=ib4	  	  	  
         iadex3(ig)=ib5	  	  	  	  	  
         call mesh(imcase,ig,cw_sor(ib1),cw_sor(ib2),
     &        cw_sor(ib3),cw_sor(ib4),cw_sor(ib5)) 	
         imut=imut+nmu(ig)
         init=init+nni     
         igs=igs+ngsize(ig)
      enddo	  

c     determine ordering of grid points assuming the subgrids are 
c     the interior ones (only boundary points coressponding to 
c     mu=1, ni=1 and ni=nni are excluded from the relaxation process)

      imcase=2
      ibeg1=i6b(1)+ngrid16
      ibeg2=i6b(2)+ngrid16	
      ibeg3=i6b(3)+is34
      ibeg4=i6b(4)+is34			
      ibeg5=i6b(5)+is5				
      imut=0	
      init=0			
      igs=0
      do ig=1,ngrids-1
         ib1=ibeg1+igs
         ib2=ibeg2+igs
         ib3=ibeg3+imut
         ib4=ibeg4+imut	  
         ib5=ibeg5+init	  	  	  
         iadext(ig+ngrids)=ib1	  
         iadnor(ig+ngrids)=ib2	  	  	  
         iadex1(ig+ngrids)=ib3	  	  	  
         iadex2(ig+ngrids)=ib4	  	  	  
         iadex3(ig+ngrids)=ib5	  	  	  	  	  	  
         call mesh(imcase,ig,cw_sor(ib1),cw_sor(ib2),
     &        cw_sor(ib3),cw_sor(ib4),cw_sor(ib5)) 	     
         imut=imut+nmu(ig)
         init=init+nni          
         igs=igs+ngsize(ig)
      enddo	  

c     determine coefficients of interpolation polynomials

      if (ngrids.gt.1) call interpolq

      return 
      end 

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### exint ###
c
c     Calculates the number of exchange integrals within one open nonsigma 
c     shell.
c
      subroutine exint (iorb1,ox1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*8 alpha,beta

      include 'commons8.inc'
      data alpha,beta /'+','-'/

      ox1=0.d0
      ip1=4*(iorb1-1)

c     interaction within nonsigma shell

      do i1=1,2
         if(spin(ip1+i1).ne.alpha.and.spin(ip1+i1).ne.beta) goto 10
         do i2=3,4
            if(spin(ip1+i2).ne.alpha.and.spin(ip1+i2).ne.beta) goto 12
            if(spin(ip1+i1).eq.spin(ip1+i2)) ox1=ox1+1.d0
00012       continue
         enddo
00010    continue
      enddo

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### inigauss ###
c
c     Molecular orbitals are initialized as a linear combination of
c     gaussian orbitals. Parameters of the orbitals and the coeeficients
c     are provided by the GAUSSIAN program.
c     
c     Coulomb (HF) potentials are initialized as a linear combination of 
c     -ez1/r1 and -ez2/r2. For the initialization of exchange potentials 
c     see routine tfpot.

      subroutine inigauss (psi,pot,excp,f2,f4,wgt2,wk0)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
c     set the maximum value of an argument of the exp function 
      parameter (exp_max=700.d0)
      parameter (thnorm2=1.d-2, thnorm3=1.d-2)
      dimension psi(*),pot(*),excp(*),f2(*),f4(*),wgt2(*),wk0(*)

c     evaluate overlap matrix over gaussian basis functions
      
      igauss=0
      if (idbg(552).ne.0) igauss=1
      if (igauss.ne.0) then
         call gauss_ovlap (psi,pot,excp,f2,f4,wgt2,wk0)
         stop
      endif

c     Initialization of molecular orbitals 
      
      if (ini.eq.4.) then
         norbt=1
      else
         norbt=norb
      endif

      write(*,1114)
      icen1=1
      icen2=2
      icen3=3
      iorb=0
      iorbnorm=1
 900  continue

c     Gaussian normal output
c     In the case of homonuclear molecules Gaussian program reverses 
c     the order of the centres (with respect to the order defined  
c     by the input data (sigma g/u and nonsigma orbitals are effected). 
c     That is why the other ordering is tried when the norm of a numerical 
c     orbital is off from unity by thnorm2.

      if     ((ini.eq.2.or.ini.eq.3).and.idbg(551).eq.0) then
         icen1=1
         icen2=2
         icen3=3
         xnorm_prv=0.d0
      elseif ((ini.eq.2.or.ini.eq.3).and.idbg(551).eq.1) then
         icen1=3
         icen2=2
         icen3=1
      endif
      iorb=iorb+1
      
      if (iorb.gt.norbt) goto 910  
      
      if (iorbnorm.eq.1) then
         if(ini.eq.3.and.mm(iorb).ne.0) then 
            iprint=0
         else
            iprint=1
         endif
         if (ini.eq.2) then
            iprint=0
         endif
      endif


      psi00=0.d0
      psi01=0.d0

      if (idbg(550).ne.0) then
         i1b(iorb)=1
         ngrid= i1si(iorb)
         do i=1,ngrid
            psi(i)=0.d0
         enddo
      endif

      ishift=i1b(iorb)-1
      ngrid= i1si(iorb)
      igp=ishift
      do i=1,ngrid
         psi(ishift+i)=0.d0
      enddo

c     loop over basis set functions
      
      ipnzero=0
      nc2=0
      c1sum=0.d0
      do ipb=1,npbasis
         l1  =lprim(ipb)
         m1  =abs(mprim(ipb))
         if (m1.ne.mm(iorb)) goto 999

c        Gaussian long (customized) output.
c        In most cases PX components are used to construct numerical
c        molecular orbital. Sometimes PY components are used instead to
c        get the norm of the orbital correct. If the norm is off by more
c        than thnorm3 than idbg(551) is set to 1 and the orbital is 
c        initialized afresh. 

         if (ini.eq.3.and.idbg(551).eq.0) then
            if (mprim(ipb).lt.0) goto 999 
         elseif (ini.eq.3.and.idbg(551).eq.1) then
            if (mprim(ipb).gt.0) goto 999 
         endif
         ic1 =icgau(ipb)
         d1  =primexp(ipb)

c        sometimes the gaussian long output contains unprintable exponents
c        which must be singled out
         if (ini.eq.3) then
            if (d1.gt.99999999.d0) goto 999
         endif

         fn1 =fngau2(ipb)
         shn1=shngau(ipb)
         fnorm=fn1*shn1
         c1 =primcoef(iorb,ipb)
         if (abs(c1).gt.0.d0) then
            ipnzero=ipnzero+1
c           write(*,1111) iorb,ipb,ic1,l1,m1,d1,c1,fn1,shn1
c           write(*,1112) iorb,ipb,ic1,l1,mprim(ipb),c1,d1
 1111       format(5i4,f20.9,3d15.5)
 1112       format(5i4,2f20.9)

c           ic1=1 basis function at centre Z1
c           ic1=2 basis function at bond centre
c           ic1=3 basis function at centre Z2

c           loop over grid points

            do imu=1,mxnmu
               inioff=(imu-1)*nni
               do in=1,nni
                  igp=ishift+inioff+in

c                 for each grid point, i.e. for (vmu(imu),vni(ini)) determine 
c                 its distance |_r1| from the nuclei Z_1 and Z_2 and cosine 
c                 of the polar angles costh1 and costh2 betp ween z axis 
c                 and the vectors _r1 and _r2

c                 rr=(r/2.d0)*sqrt(vxisq(imu)+vetasq(in)-1.d0)		

                  z=(r/2.d0)*vxi(imu)*veta(in)
                  if (ic1.eq.icen1) then
c                    gaussians centred on Z1
                     r1=(r/2.d0)*(vxi(imu)+veta(in))
                     if (r1.lt.precis) then
                        costh1=0.d0
                     else   
                        costh1=(z+r/2.d0)/r1
                     endif
                  elseif (ic1.eq.icen3) then
c                    gaussians centred on Z2
                     r1=(r/2.d0)*(vxi(imu)-veta(in))
                     if (r1.lt.precis) then
                        costh1=0.d0
                     else   
                        costh1=(z-r/2.d0)/r1	
                     endif
                  elseif (ic1.eq.icen2) then
c                    gaussians centred on the bond centre
                     r1=sqrt(vxisq(imu)+vetasq(in)-1.d0)*r/2.d0
                     if (r1.lt.precis) then
                        costh1=0.d0
                     else   
                        costh1= (z)/r1	
                     endif
                  endif

c                 calculate the gaussian function centered on one of the nuclei

                  d1r=d1*r1*r1
                  if (d1r.gt.exp_max) then
                     expt=0.d0
                  else
                     expt=1.d0/exp(d1r)
                  endif

                  if (r1.lt.precis.and.l1.eq.0) then
                     psi1=fnorm*expt*plegendg(l1,m1,costh1)
                  elseif (r1.lt.precis.and.l1.gt.0) then
                     psi1=0.d0
                  else
                     psi1=fnorm*r1**l1*expt*plegendg(l1,m1,costh1)
                  endif
 99               continue
                  psi(igp)=psi(igp)+c1*psi1
               enddo
            enddo
c           c1.ne.0
         endif
c        
 999     continue
      enddo
      call norm94 (iorb,psi,f4,wgt2,wk0,xnorm)
      write (*,1115) iorn(iorb),bond(iorb),gut(iorb),xnorm
      if (iprint.eq.1) write (*,1115) iorn(iorb),bond(iorb),
     &     gut(iorb),xnorm

      if (iorbnorm.eq.1) then
c         if(ini.eq.2) then
         if(ini.eq.2.and.
     &        abs(xnorm-1.d0).gt.thnorm2) then

c   Try reversed ordering of atomic centres. This might lead to a better orbital
            idbg(551)=1
            iorb=iorb-1
            iorbnorm=2
            xnorm_prev=xnorm
         endif
c         if(ini.eq.3.and.mm(iorb).ne.0) then
         if(ini.eq.3.and.mm(iorb).ne.0.and.
     &        abs(xnorm-1.d0).gt.thnorm3) then

            idbg(551)=1
            iorb=iorb-1
            iorbnorm=2
            xnorm_prev=xnorm
         endif
      elseif (iorbnorm.eq.2) then
         if (abs(xnorm-1.d0).le.abs(xnorm_prev-1.d0)) then
            iorbnorm=3
            idbg(551)=0
            iprint=1
         else
            iorbnorm=3
            xnorm=xnorm_prev
            iorb=iorb-1
            idbg(551)=0
            iprint=1
         endif
      endif
      goto 900
 910  continue
      write(*,*)

      if (idbg(550).ne.0) stop 'inigauss'

c     initialize Coulomb and exchange potentials

      call tfpot(psi,pot,excp,f2,f4,wk0)	

 1114 format(/1x,'    orbital        norm      ')
 1115 format(1x,i3,1x,a8,a1,d20.12)

      return
      end
      

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### wtdisk ### 
c     
c     Writes orbitals, potenials, Lagrange multipliers (diagonal 
c     and off-diagonal) and multipole expansion coefficients to a disk 
c     in an unformatted form

c     dump contains:  psi, pot, excp, eng, engo, 
c                     cmulti, excdi, excqm, excoc, exche
c
      subroutine wtdisk (cw_orb,cw_coul,cw_exch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*15 csub
      character*75 cmess
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*)

      write(iout6,1050)

c     write a header into the orbital output file

      write(iout21,err=1000) header
      write(iout21,err=1000) datetime

      write(iout21,err=1000) ngrids,nni,nmu
      write(iout21,err=1000) r,rgrid
      write(iout21,err=1000) z1,z2	
      write(iout21,err=1000) norb,nel,nexch
      
      write (iout21,err=1000) i1b,i2b,i3b,i1e,i2e,i3e,
     &     i1si,i2si,i3si,i1ng,i2ng,i3ng,
     &     i1mu,i2mu,i3mu	
      
c     add orbitals

      do i=1,norb
         call writea(iout21,i1si(i),cw_orb(i1b(i)),ierr)
         if (ierr.ne.0) then
            write(iout6,*) 'error detected when writing orbital',i
            stop 'wtdisk'
         endif				   	
      enddo	   

c     append the following arrays to the output orbital file 

      write(iout21,err=1020) area
      write(iout21,err=1020) eng
      write(iout21,err=1020) engo
      write(iout21,err=1020) cmulti
      write(iout21,err=1020) excdi
      write(iout21,err=1020) excqu
      write(iout21,err=1020) excoc
      write(iout21,err=1020) exche
      write(iout21,err=1020) exc5
      write(iout21,err=1020) exc6
      write(iout21,err=1020) exc7
      write(iout21,err=1020) exc8

c     write out Coulomb potentials

      do i=1,norb
         call writea(iout22,i2si(i),cw_coul(i2b(i)),ierr)
         if (ierr.ne.0) then
            write(iout6,*) 'error detected when writing coulomb',
     &           ' potential',i
            stop 'wtdisk'
         endif				   	
      enddo	   

c     write out exchange potentials

      if (imethod.eq.1) then  
         if (iform.eq.2.or.iform.eq.3) then
            
            do iorb1=1,norb
               do iorb2=iorb1,norb
                  k=iorb1+iorb2*(iorb2-1)/2
                  if (iorb1.eq.iorb2.and.ll(iorb1).eq.0) goto 50
                  call writea(iout23,i3si(k),cw_exch(i3b(k)),ierr)
                  if (ierr.ne.0) then
                     write(iout6,*) 'error detected when writing ', 
     &                    'exchange potential',iorb1,iorb2,k
                     stop 'wtdisk'
                  endif				   	
                  if (iorb1.eq.iorb2) goto 50
                  if (ll(iorb1).eq.0.or.ll(iorb2).eq.0) goto 50
                  call writea(iout23,i3si(k),cw_exch(i3b(k)+i3si(k)),
     &                 ierr)
                  if (ierr.ne.0) then
                     write(iout6,*) 'error detected when writing ',
     &                    ' exchange potential',iorb1,iorb2,k
                     stop 'wtdisk'
                  endif				   	
 50               continue
               enddo
            enddo
            rewind(iout23)
            
c           if iform=0 exchange potentials do not have to be saved since 
c           they are continually updated during the scf process
            
         elseif (iform.eq.0.or.iform.eq.1) then
            if (iform.eq.1) then
               call wtdexch1(cw_exch)
            endif
         endif
         
      elseif (imethod.eq.3) then
         call writea(iout23,i3si(1),cw_exch(i3b(1)),ierr)
      endif

      rewind(iout21)
      rewind(iout22)
      rewind(iout23)

      csub='wtdisk'
      if(idbg(59).ne.0) then
c        print orbitals and coulomb potentials
	 do i=1,norb
            cmess='orbital '
            call dbgp (59,csub,cmess,cw_orb(i1b(i)),nni,i1mu(i))
	 enddo	   

	 do i=1,norb
            cmess='coulomb potential '
	    call dbgp (59,csub,cmess,cw_coul(i2b(i)),nni,i2mu(i))
	 enddo	   
         
c        print exchange potentials
	 do i=1,nexch
            cmess='exchange potential '       	 
	    call dbgp (59,csub,cmess,cw_exch(i3b(i)),nni,i3mu(i))
	 enddo	   
      endif
      return

 1000 continue
      write(iout6,1070)
      stop 'wtdisk'	
      
 1020 continue
      write(*,*) 'wtdisk: error has been encountered when writing ',
     &     'extension to disk file'
      write(*,*) '      '
      stop 'wtdisk'
 1050 format(1x,'... writing functions to disk ...')
 1070 format(//1x,'error! can not write data to disk'//)     
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prepvar ###
c
c  Initialize arrays of variable length
c
      subroutine prepvar (borb,bpot,d,e,f0,f1,f2,f3,f4,g,
     &		          wjac1,wjac2,wgt1,wgt2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension borb(nni,mxnmu),bpot(nni,mxnmu),
     &          d(nni,mxnmu),e(nni,mxnmu),
     &		f0(nni,mxnmu),f1(nni,mxnmu),f2(nni,mxnmu),
     &          f3(nni,mxnmu),f4(nni,mxnmu),g(nni,mxnmu),
     &          wjac1(nni,mxnmu),wjac2(nni,mxnmu),
     &          wgt1(mxsize),wgt2(mxsize)

c     iaddr4(1)=borb
c     iaddr4(2)=bpot
c     iaddr4(3)=d
c     iaddr4(4)=e
c     iaddr4(5)=f0
c     iaddr4(6)=f1
c     iaddr4(7)=f2
c     iaddr4(8)=f3
c     iaddr4(9)=f4
c     iaddr4(10)=g
c     iaddr4(11)=wjac1
c     iaddr4(12)=wjac2
c     iaddr4(13)=wgt1
c     iaddr4(14)=wgt2

c     wjac1 - jacobian for rayleigh quotient
c     wjac2 - jacobian for two-electron integrals

c     initialize arrays needed for the poisson equations

c     f4 - array of factors multiplying off-diagonal lagrange multipliers
c	   in the hf equation
c     off-diagonal l.m. must be multiplied by the same factor as
c     diagonal one i.e. f1 instead of f4

      if (ifefield.ne.0) then
         izz1=nint(z1)
         izz2=nint(z2)
         atw1=atweight(izz1)
         atw2=atweight(izz2)
         zcm=(-atw1+atw2)/(atw1+atw2)*r/2.d0
c         write(iout6,1000) element(izz1), atweight(izz1), 
c     &        element(izz2), atweight(izz2),zcm
c1000    format(5x,'atomic weight: ',a2,' --',f14.8,/,
c     &        5x,'               ',a2,' --',f14.8,/,
c     &        5x,'    z_cm (bohr)','     ',f14.8)
      endif
      
      wj1 =-r*pii/2.d0
      wj2 = r*r*pii/2.d0 
      xrr=r/2.d0
      ib=ibmu(1)
      do ig=1,ngrids
         ie=iemu(ig)
         diag(ig)=-14350.d0/(5040.d0)*
     &        ( 1.d0/(hmu(ig)*hmu(ig))+1.d0/(hni*hni) )
         do i=ib,ie
            w1=vxi1(i)
            w2=vxi(i)*vxi(i)
            w9=xrr*vxi(i)

c           ssf is included in differentiation array dmu1
c           w4=vxi2(i)/ssf

            w4=vxi2(i)
            if(i.eq.1) then
               w5=0.d0
               w6=0.d0
            else
               w5= vxi(i)/vxi1(i)-2.0*vxi1(i)/vxi(i)
               w6= 1.d0/(vxi1(i)*vxi1(i))
            endif
            
            w8=-r*r*r*pii*vxi(i)/2.d0
            
            do j=1,nni
               w10=veta1(j)
               borb(j,i)=w4
               bpot(j,i)=w5
               d   (j,i)=veta2(j)
               if (w10.lt.precis) then
                  e(j,i)= 0.d0
               else
                  e(j,i)=-w6 - 1.d0/(w10*w10)
               endif

               if (ifermi.eq.0) then
                  f0(j,i)=r*(vxi(i)*(z1+z2)+veta(j)*(z2-z1))
               elseif (ifermi.eq.1) then
                  z1t=zz1(i,j)
                  z2t=zz2(i,j)
                  f0(j,i)=r*(vxi(i)*(z1t+z2t)+veta(j)*(z2t-z1t))
c                 write(*,*) i,j,z1t,z2t,f0(j,i)
               elseif (ifermi.eq.2) then
                  z1t=zz1g(i,j)
                  z2t=zz2g(i,j)
                  f0(j,i)=r*(vxi(i)*(z1t+z2t)+veta(j)*(z2t-z1t))
c                 write(*,*) i,j,z1t,z2t,f0(j,i)
               endif

               w7=w2-veta(j)*veta(j)
               f1(j,i)= r*r*w7/2.d0
               
               if (ifefield.eq.1) then

c                 when external electric field is present (z-zcm)*E 
c                 has to be added (times -f1)

                  z=(r/2.d0)*vxi(i)*veta(j)
                  if (abs(z).lt.zcutoff) then
                     f0(j,i)=f0(j,i)-ffield*(z-zcm)*f1(j,i)
                  else
                     f0(j,i)=f0(j,i)-ffield*(z-zcm)*
     &                    exp(zcutoff-abs(z))*f1(j,i)
                  endif 
                  
c                 stop 'prepvar: ifefield'
               elseif (ifefield.eq.2) then

c                 if electric field gradient is nonzero the interaction 
c                 energy is -(Q_z/4)*(dE/dz) 

c                 if electric field gradient is nonzero the interaction 
c                 energy is  -R^2/3 P(2,0)*(dE/dz) (Greiner, Electrodynamics, p.91)

                  imu=i
                  in=j
                  z=(r/2.d0)*vxi(imu)*veta(in)-zcm
                  xxplusyy=((r/2.d0)*vxi1(imu)*veta1(in))**2
                  rr=sqrt(xxplusyy+z*z)
                  if (abs(rr).lt.precis) then
                     costh=0.d0
                  else
                     costh=z/rr
                  endif
                  
                  wktmp=rr**2*plegendg(2,0,costh)
                  z=(r/2.d0)*vxi(i)*veta(j)
                  if (abs(z).lt.zcutoff) then
                     f0(j,i)=f0(j,i)-fgrad*wktmp*f1(j,i)/3.d0
                  else
                     f0(j,i)=f0(j,i)-fgrad*wktmp*f1(j,i)/3.d0
     &                    *exp(zcutoff-abs(z))
                  endif
               endif
               
               if(i.eq.1) then
                  f2(j,i)=0.d0
               else
                  f2(j,i)=-r*w7/vxi(i)
               endif
               f3(j,i)=-2.d0/w2
               g (j,i)= w8*w7
               f4(j,i)= w9
               
c              Integration needs hmu*hni but the integration routine works
c              for hni*hni. That is why ssf must be inserted here.

c              wjac1(j,i)=wj1*w1*w5/ssf(ig)
c              wjac2(j,i)=wj2*w1*w5*(w3+w6)/(ssf(ig)*w0)

               wjac1(j,i)=wj1*w1*w10
               wjac2(j,i)=wj2*w1*w10*(w1*w1+w10*w10)/vxi(i)
            enddo
         enddo
         ib=ie+1
c        enddo over ig
      enddo

c     initialize vector of integration weights
c     (7-point formula	abramovic 25.4.16.)

      wmup=0.d0
      do ig=1,ngrids
         ib=ibmu(ig)
         ie=iemu(ig)
         w1 =hmu(ig)/140.d0
         wmu(ib)=wmup+w1*41.d0
         do i=ib+1,ie,6
            wmu(i  )=w1*216.d0
            wmu(i+1)=w1* 27.d0
            wmu(i+2)=w1*272.d0
            wmu(i+3)=w1* 27.d0
            wmu(i+4)=w1*216.d0
            if (i+5.eq.ie) then
               wmu(i+5)=w1*41.d0
            else
               wmu(i+5)=2.d0*w1*41.d0
            endif
         enddo
         wmup=wmu(ie)
      enddo

      w1    =hni/140.d0
      wni(1)=w1*41.d0
      do i=2,nni,6
         wni(i  )=w1*216.d0
         wni(i+1)=w1* 27.d0
         wni(i+2)=w1*272.d0
         wni(i+3)=w1* 27.d0
         wni(i+4)=w1*216.d0
         if (i+5.eq.nni) then
            wni(i+5)=w1*41.d0
         else
            wni(i+5)=2.d0*w1*41.d0
         endif
c        enddo over i
      enddo

c     multiply jacobians for one and two-electron integrals by elements
c     of wmu array

      do i=1,mxnmu
         w1=wmu(i)
         do j=1,nni
            wjac1(j,i)=w1*wjac1(j,i)
            wjac2(j,i)=w1*wjac2(j,i)
         enddo
      enddo

c     prepare superarrays with the integration weights over ni variable
c     and with jacobians included

      do i=1,mxnmu
         ii=(i-1)*nni
         do j=1,nni
            wgt1(ii+j)=wni(j)*wjac1(j,i)
            wgt2(ii+j)=wni(j)*wjac2(j,i)
         enddo
      enddo

c     initialize extrapolation coefficients for even functions
c     bondary values for odd functions must be all zero

      exeven(1)= 210.d0/126.d0
      exeven(2)=-120.d0/126.d0
      exeven(3)=  45.d0/126.d0
      exeven(4)= -10.d0/126.d0
      exeven(5)=   1.d0/126.d0

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rfun_int ###	
c
c     Reads functions from disk in unformatted form and interpolates 
c     to a new grid.
c
      subroutine rfun_int (norb_p,cw_orb,cw_coul,cw_exch,cw_sctch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)	
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),cw_sctch(*)
      dimension i1b_p(60),i2b_p(60),i3b_p(1830),
     &     i1e_p(60),i2e_p(60),i3e_p(1830),
     &     i1si_p(60),i2si_p(60),i3si_p(1830),
     &     i1ng_p(60),i2ng_p(60),i3ng_p(1830),
     &     i1mu_p(60),i2mu_p(60),i3mu_p(1830)	

      read (iinp11,err=1000) i1b_p,i2b_p,i3b_p,i1e_p,i2e_p,i3e_p,
     &     i1si_p,i2si_p,i3si_p,i1ng_p,i2ng_p,i3ng_p,
     &     i1mu_p,i2mu_p,i3mu_p	
      
      ioffset=norb-norb_p
      ica=1
      write(iout6,1100) 
01100 format('... interpolating orbitals:',/6x,$)
01110 format(i4,$)
      
      do i=1,norb_p
         write(iout6,1110) i
         
         ipex=mgx(6,i)
         ipex=ipex-2*(ipex/2)
         if (ipex.eq.0) then
            isym= 1 
         else 
            isym=-1
         endif
         call reada(iinp11,i1si_p(i+ioffset),cw_sctch(i5b(1)),ierr)
         call dointerp     (ica,i1mu_p(i),i1mu(i),cw_sctch(i5b(1)),
     &        cw_orb(i1b(i+ioffset)))
         
         if (ierr.ne.0) then
            write(iout6,*) 'error detected when reading orbital',i
            stop 'inifun'
         endif				   	
      enddo	   

c     retrieve the extra data from the orbital input file

      read(iinp11,end=1010,err=1010) area
      read(iinp11,end=1010,err=1010) eng
      read(iinp11,end=1010,err=1010) engo
      read(iinp11,end=1010,err=1010) cmulti
      read(iinp11,end=1010,err=1010) excdi
      read(iinp11,end=1010,err=1010) excqu
      read(iinp11,end=1010,err=1010) excoc
      read(iinp11,end=1010,err=1010) exche
      read(iinp11,end=1010,err=1010) exc5
      read(iinp11,end=1010,err=1010) exc6
      read(iinp11,end=1010,err=1010) exc7
      read(iinp11,end=1010,err=1010) exc8

      write(iout6,*)
      rewind iinp11	
      
      ica=2
      isym=1
      write(iout6,1102) 
01102 format('... interpolating Coulomb potentials:',
     &       /6x,$)
      do i=1,norb_p
         write(iout6,1110) i
         call reada(iinp12,i2si_p(i+ioffset),cw_sctch(i5b(1)),ierr)
         call dointerp     (ica,i2mu_p(i),i2mu(i),cw_sctch(i5b(1)),
     &        cw_coul(i2b(i+ioffset)),cw_sctch(i5b(2)) )
         
         if (ierr.ne.0) then
            write(iout6,*) 'error detected when reading coulomb',
     &           ' potential',i
            stop 'inifun'
         endif				   	
      enddo	   
      write(iout6,*)
      rewind iinp12	
      
      if (imethod.eq.2) then
         write(*,*) 'inifun: disk file without extension has been ',
     &        'retrieved '
         write(*,*) '      '
         rewind iinp13
         return
      endif
      
      if (imethod.eq.1) then
         ica=3

c        to interpolate exchange potentials they have to be read in as a
c        single file
         if (iform.eq.0.or.iform.eq.2) then
            write(*,'("rfun_int: cannot interpolate exchange "
     &        "potentials when they are retrieved as separate files")')
            stop "rfun_int"
         endif

         write(iout6,1104) 
01104    format('... interpolating exchange ',
     &        'potentials for orbitals:',/6x,$)
         do iorb1=1,norb_p
            write(iout6,1110) iorb1 
            
            do iorb2=iorb1,norb_p
               k=iorb1+iorb2*(iorb2-1)/2
               
               idel=abs(mgx(6,iorb1)-mgx(6,iorb2))
               if (iorb1.eq.iorb2) idel=2*mgx(6,iorb1)
               ipex=idel-2*(idel/2)
               if (ipex.eq.0) then
                  isym= 1  
               else
                  isym=-1
               endif
               
               if (iorb1.eq.iorb2.and.ll(iorb1).eq.0) goto 50
               call reada(iinp13,i3si_p(k),cw_sctch(i5b(1)),ierr)
               call dointerp     (ica,i3mu_p(k),i3mu(k),cw_sctch(i5b(1)),
     &              cw_exch(i3b(k)),cw_sctch(i5b(2)) )
               
               if (ierr.ne.0) then
                  write(iout6,*) 'error detected when reading exchange',
     &                 ' potential',iorb1,iorb2,k
                  stop 'rfun_int'
               endif				   	
               if (iorb1.eq.iorb2) goto 50
               if (ll(iorb1).eq.0.or.ll(iorb2).eq.0) goto 50
               call reada(iinp13,i3si_p(k),cw_sctch(i5b(1)),ierr)
               call dointerp     (ica,i3mu_p(k),i3mu(k),cw_sctch(i5b(1)),
     &              cw_exch(i3b(k)+i3si(k)),cw_sctch(i5b(2)) )
               if (ierr.ne.0) then
                  write(iout6,*) 'error detected when reading exchange',
     &                 ' potential',iorb1,iorb2,k
                  stop 'rfun_int'
               endif				   	
00050          continue
            enddo
         enddo
         write(iout6,*)
         write(iout6,*)
         rewind iinp13
      endif
      
      return
01000 continue
      write(*,*) '... error detected when retrieving the disk', 
     &     ' file ... '
      stop 'rfun_int'
01010 write(*,*) '... error has been detected when retrieving ',
     &     'extension of the orbital input file ...'
      write(*,*) '... disk file without extension retrieved ... '
      idump=1
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### pmtx ###
c
c     Prints two-dimensional array in the tabula form row-wise.
c
      subroutine pmtx (n1,n2,a,n1st,n2st,incrn1,incrn2)
      real*8 a
      dimension a(n1,n2)

      do i=n1st,n1,incrn1
         write(6,1000) i, (a(i,j),j=n2st,n2,incrn2)
      enddo

01000 format(/,1x,i4,4d18.8,/(5x,4d18.8))

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### momen ###
c
c     Recalculates multipole moment expansion coefficients every time demax(1),
c     i.e. maximum error in orbital energy, is reduced by facmul

c     Warning!
c     Coefficients and then asymptotic values are recalculated only for
c     orbitals which underwent relaxation, i.e. those being touched (itouch=1)

      subroutine momen (cw_orb,cw_suppl,cw_sctch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension cw_orb(*),cw_suppl(*),cw_sctch(*)

      if (nel.eq.1) return

      call ttime(time1)
      call coulmom (cw_orb,cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),     
     &     cw_sctch(i5b( 7)),
     &     cw_sctch(i5b( 8)),cw_sctch(i5b( 9)),cw_sctch(i5b(10)))

      if (nel.gt.1.and.imethod.eq.1) then
         do  iorb1=1,norb
            do  iorb2=iorb1,norb
               if (idbg(300).eq.0) then
                  call exchmom1 (iorb1,iorb2,cw_orb,
     &                 cw_suppl(i4b(9)),cw_suppl(i4b(14)),	     
     &                 cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &                 cw_sctch(i5b( 3)),cw_sctch(i5b( 4)),
     &                 cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),     
     &                 cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),
     &                 cw_sctch(i5b( 9)),cw_sctch(i5b(10)))
               else
                  call exchmom (iorb1,iorb2,cw_orb,
     &                 cw_suppl(i4b(9)),cw_suppl(i4b(14)),	     
     &                 cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),
     &                 cw_sctch(i5b( 3)),cw_sctch(i5b( 4)),
     &                 cw_sctch(i5b( 5)),cw_sctch(i5b( 6)),     
     &                 cw_sctch(i5b( 7)),cw_sctch(i5b( 8)),
     &                 cw_sctch(i5b( 9)),cw_sctch(i5b(10)))

               endif
            enddo
         enddo
      endif
      call ttime (time2)
      tmomen =tmomen + (time2-time1)
      if (iprtlev.ne.3) then 
         write(iout6,*) 
     &        '... multipole moment expansion coefficients',
     &        ' (re)calculated ...'
      endif
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### plegend ###		  	    
c
c
      function plegend(l,m,costh)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)		

      plegend=0.d0
      p00=1.d0
      if (l.eq.0) then
         plegend=p00
         return
      endif
c     P10	
      p10=costh
      if (l.eq.0.and.m.eq.0) then
         plegend=p10
         return
      endif
c     P11
      costh2=sqrt(costh*costh-1.d0)
      p11=1.d0/costh2*(costh*p10-p00)
      if (l.eq.1.and.m.eq.1) then
         plegend=p11
         return  
      endif

      write(*,*) 'No spherical harmonics for l>1'
      
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 9-2002                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### prepfix ###
c
c     Initializes arrays within common blocks and prepares grids.
c
      subroutine prepfix
      implicit real*8 (a-h,o-z)
      character*8 sigma,pi,delta,phi
      character*8 spac,ger,uger
      include 'commons8.inc'

      data sigma/'sigma'/,pi/'pi'/,delta/'delta'/,phi/'phi'/  
      data spac/' '/,ger/'g'/,uger/'u'/
c
c     homonuclear case is treated as a heteronuclear one; if ihomon=2, i.e
c     if HOMO label is used, the g/u symmetry is imposed explicitely

c     ihomon=0 --  heteronuclear case
c     ihomon=1 --  homonuclear case |z1-z2|<1.d-6
c     ihomon=2 --  homonuclear case with forced symmetry

c     ihomon=2 is equivalent to idbg(90).ne.0

c     since in this version 7 point integration formula is used the number 
c     of mesh points in the variable ni and the total number of points
c     in mu must be equal to 6*n+1

c     Another restriction has to be imposed on the number of points in the
c     mu variable if the mcsor scheme is to be used: nmu must be
c     of the form kN+k+1, where k=iorder/2+1 for each grid (in this program
c     iorder, i.e. the order of descritization is 8) 

c     checking and possibly adjusting the grid size so that nmu is
c     of the form kN+k+1, where k=iorder/2+1 

c     check first if ngrids does not exceed maxgrids

      if (ngrids.gt.3) then
         write(iout6,*) '===== prepfix ====='
	 write(iout6,*) 'number of grids can not exceed',maxgrids
	 stop 'prepfix'
      endif

      k1=5
      k2=6
      do ig=1,ngrids
 20      continue
         ichk1=0
         ichk2=0

 11      nord=(nmu(ig)-1)/k2
         if (k2*nord.ne.nmu(ig)-1) then
            nmu(ig)=nmu(ig)-1
            ichk2=ichk2+1
            goto 11
         endif
         if (ichk1.ne.0.or.ichk2.ne.0) goto 20
      enddo

 12   nord=(nni-1)/k2
      if (k2*nord.ne.nni-1) then
         nni=nni-1
         goto 12
      endif

c     mxnmu --  maximum no. of grid points in mu variable
c               mxmnu should be of the form 6N+1

c     When counting the maximum number of points in mu variable do not forget
c     that the first point of the next grid is the last on of the previous grid.

c     Arrays ibmu and iemu contain the first and last addresses of
c     particular grid within the combined grid

      ibmu(1)=1
      iemu(1)=nmu(1)
      mxnmu=nmu(1)
      ioffs(1)=0
      do ig=2,ngrids
         mxnmu=mxnmu+nmu(ig)-1
         ibmu(ig)=iemu(ig-1)	 	 
         iemu(ig)=mxnmu
         ioffs(ig)=nni*(iemu(ig-1)-1)
      enddo

c     determine the size of each grid
      
      do ig=1,ngrids
         ngsize(ig)=nni*nmu(ig)
      enddo

c     total no of grid points 

      mxsize=nni*mxnmu
      if ( norb.gt.60 ) then
         write(iout6,*) '===== prepfix ====='
	 write(*,*) 'number of orbitals can not exceed 60'
	 stop
      endif

      nel=0
      do i=1,norb
         nn(i)=mgx(1,i)
         ll(i)=mgx(3,i)
         mm(i)=mgx(3,i)
         iocc(i)=occ(i)+.000001d0
         nel=nel+iocc(i)
      enddo

c     hni - step in ni variable
c     hmu - step in mu variable

c     determine step size in ni variable 

      hni=pii/dble(nni-1)
      
c     determine step size in mu variable for each grid

c     when ngrids=1 hmu can be calculated from the practical infinity
c     variable if its value is provided in the input;

      if (ngrids.eq.1) then
         xmi0=2.d0*rgrid(1)/r
         xmi0=log(xmi0+sqrt(xmi0*xmi0-1.d0))
         hmu(1)=xmi0/dble(mxnmu-1)
         rgrid(1)=hmu(1)
      else
         do ig=1,ngrids
            if(ig.eq.1) then 
               hmu(ig)=rgrid(ig)
            else
               hmu(ig)=hmu(1)*rgrid(ig)
            endif
         enddo
      endif

c    initialize mu and xi arryas

      vmu(1) =0.d0
      vxi(1) =cosh(vmu(1))
      vxisq(1)=vxi(1)*vxi(1)	    	    
      vxi1(1)=sqrt(vxi(1)*vxi(1)-1.d0)
      vxi2(1)=0.0d0

      ib=2

      do ig=1,ngrids
         ie=iemu(ig)
         do i=ib,ie
            vmu(i)=vmu(i-1)+hmu(ig)
            vxi(i)=cosh(vmu(i))
            vxisq(i)=vxi(i)*vxi(i)	    	    

            vxi1(i)=sqrt(vxi(i)*vxi(i)-1.d0)
            vxi2(i)=vxi(i)/vxi1(i)
c           enddo over i
         enddo 
         ib=ie+1
c        enddo over ig
      enddo

c    initialize ni and eta arrays

      do i=1,nni
         vni(i)=dble((i-1))*hni
         veta(i)=cos(vni(i))
         vetasq(i)=veta(i)*veta(i)		

c     sqrt(1-veta*veta) and  veta/sqrt(1-veta*veta)
c
         veta1(i)=sqrt(1.d0-veta(i)*veta(i))
         if (veta1(i).lt.precis) then
            veta2(i)=0.0
         else
            veta2(i)=veta(i)/veta1(i)
         endif
      enddo

c     determine rinf

      if (idbg(155).ne.0) then
         write(iout6,*) 
         write(iout6,*) 'subgrid   nni  nmu     hni     hmu      rb ',
     &        '    heta     hxib     hxie'
      endif

      rinf=r*vxi(iemu(ngrids))/2.d0
      heta=abs(veta(nni)-veta(nni-1))
      ib=1
      do ig=1,ngrids
         rinfig=r*vxi(iemu(ig))/2.d0
         ie=iemu(ig)
         hxibeg=vxi(ib+1)-vxi(ib)
         hxiend=vxi(ie)-vxi(ie-1)
         if (idbg(155).ne.0) write(iout6,1000) ig,nni,nmu(ig),
     &        hni,hmu(ig),rinfig,heta,hxibeg,hxiend
         ib=ie
      enddo
01000 format(4x,i2,3x,i4,2x,i4,2f9.5,f8.3,3f9.5)

c     ige(i)=1 ungerade
c     ige(i)=2 gerade or heteronuclear case
c     if break is on 	

      if (ibreak.eq.1) then 
         do i=1,norb
            gut(i)=spac
         enddo
      endif

c     give a number within a symmetry

      isu=0
      isi=0
      ipu=0
      ipi=0
      idu=0
      idi=0
      ipsu=0
      ips=0

      do ibo=1,norb
         iba=norb+1-ibo
         if (bond(iba).eq.sigma) then
            if (gut(iba).eq.ger) then 
               isi=isi+1
               iorn(iba)=isi
            endif
            
            if (gut(iba).eq.spac) then 
               isi=isi+1
               iorn(iba)=isi
            endif
            
            if (gut(iba).eq.uger) then
               isu=isu+1
               iorn(iba)=isu
            endif
            goto 100
         endif	    
         
         if (bond(iba).eq.pi) then
            if (gut(iba).eq.ger) then
               ipi=ipi+1
               iorn(iba)=ipi
            endif
            
            if (gut(iba).eq.spac) then
               ipi=ipi+1
               iorn(iba)=ipi
            endif

            if (gut(iba).eq.uger) then
               ipu=ipu+1
               iorn(iba)=ipu
            endif
            goto 100
         endif

         if (bond(iba).eq.delta) then
            if (gut(iba).eq.ger) then
               idi=idi+1
               iorn(iba)=idi
            endif

            if (gut(iba).eq.spac) then
               idi=idi+1
               iorn(iba)=idi
            endif

            if (gut(iba).eq.uger) then
               idu=idu+1
               iorn(iba)=idu
            endif
            goto 100
         endif	  

         if (bond(iba).eq.phi) then
            if (gut(iba).eq.ger) then
               ips=ips+1
               iorn(iba)=ips
            endif

            if (gut(iba).eq.spac) then
               ips=ips+1
               iorn(iba)=ips
            endif

            if (gut(iba).eq.uger) then
               ipsu=ipsu+1
               iorn(iba)=ipsu
            endif	  
         endif
 100     continue
      enddo
      
c     ihsym = 1 - symmetry g
c     ihsym =-1 - symmetry u
      do i=1,norb
         ihomo(i)=1
c        if (gut(i).eq.'u') ihomo(i)=-1
         if (gut(i).eq.'u'.and.orbsym(i).eq.sigma) ihomo(i)=-1
         if (gut(i).eq.'u'.and.orbsym(i).eq.delta) ihomo(i)=-1
         if (gut(i).eq.'g'.and.orbsym(i).eq.pi) ihomo(i)=-1
         if (gut(i).eq.'g'.and.orbsym(i).eq.phi) ihomo(i)=-1
      enddo

      do ial=1,norb
         ige(ial)=2
         if (gut(ial).eq.'u') ige(ial)=1
      enddo

c     calculate the weights of the two-electron contributions to the total energy
c     expression for an open shell scf case

      call oshell

c     set optimal value of omega for potentials if ovfcoul(1)< 0
      if (ovfcoul(1).lt.0.0) then
         ovfcoul(1)=setomega()
         ovfexch(1)=ovfcoul(1)
      endif

c     initialize array calp of coefficients of associated Legendre
c     functions needed by mulex and multi routines

c      data c/1.25d-01,       5.d-01,         5.59016994d-01,
c             4.33012702d-01, 1.2247448710d0, 3.95284708d-01,
c             1.369306394d0,  6.12372436d-01, 1.479019946d0, 
c             5.59016994d-01, 5.22912517d-01, 7.07106781d-01/

      calp( 1)=0.125d0
      calp( 2)=0.5d0
      calp( 3)=sqrt( 5.d0/ 16.d0)
      calp( 4)=sqrt( 3.d0/ 16.d0)
      calp( 5)=sqrt( 3.d0/  2.d0)
      calp( 6)=sqrt( 5.d0/ 32.d0)
      calp( 7)=sqrt(15.d0/  8.d0)
      calp( 8)=sqrt( 3.d0/  8.d0)
      calp( 9)=sqrt(35.d0/ 16.d0)
      calp(10)=sqrt( 5.d0/ 16.d0)
      calp(11)=sqrt(35.d0/128.d0)
      calp(12)=sqrt( 1.d0/  2.d0)

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### rinputd ###
c
c     Handles the input to 2DHF.
c
      subroutine rinputd(iform_t,ni_t,mu_t,no_t,nons_t)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*8 clabel,char8
      character*8 labellc(30),cmethod(6),pab(3)
      character*8 sigma,sigmag,sigmau,pi,delta,phi,space,angstrom,
     &     endl,endc
      character*20 psiinp,coulinp,exchinp,psiout,coulout,exchout
      include 'commons8.inc'
      dimension id(600)
      data nlabels/28/
      data labellc /'title','method','nuclei','config','initial',
     &     'break','multipol','grid','cutoff','homo',
     &     'scf','sor','debug','help','stop','interp',
     &     'subgrid','fix','xalpha','omega','order',
     &     'plot','fermi','lagra','gauss','damp','canon',
     &     'fefield',2*'        '/
c
      data angstrom/'angstrom'/
      data cmethod/'hf','HF','oed','OED','hfs','HFS'/,
     &     endl/'end'/,endc/'END'/
      data pab/'u','g',' '/
      data sigma/'sigma'/,pi/'pi'/,delta/'delta'/,phi/'phi'/
      data sigmag/'sigma g'/,sigmau/'sigma u'/
      data space/'    '/
      data inpiexit/-99999/

c  no=isum=norb
c  iexd=maxorb
c  bond=orbsym

c  initialization of some variables

      ihomon=0
      ibreak=0
      iinterp=0
     
      cutorb =1.d-6
      cutcoul=1.d-6
      cutexch=1.d-6
      itail  =13    

c     diver  -  if demax(1) in proce is greater than diver
c               divergence in the scf process is detected and
c               the program stops

      diver = 1.d8

c     initial default value
      
      inclorb = 0

c     default canonicalization coefficients

      icanon=1
      
c     multipol default value
      
      impole=8
c     default number of grids and the default ordering of mesh points
      ngrids=1
      iorder(ngrids)=2

c     scf default values
      
      maxscf  = 1000
      nobckup =  100
      ienterm =   10
      inoterm =   10
      iprtlev =    2
      facmul  =    1.15d0

c     fix default values

      iexlorb  = 0
      iexlcoul = 0
      iexlexp  = 2
   
      exlorb  = 0.d0
      exlcoul = 0.d0
      exlexp  = 2.d0

c     xalpha defaul value

      alphaf = 0.0d0
      sltthr = 0.0d0
      
c     sor default value
      
      maxsor2 =10
      maxsor1 = 1
      lsor    = 1
      ipoiss  = 1

c     fermi default value (point nuclei)

      ifermi=0
      
c     plot default value (no data exported for making plots)

      iplot=0
      
c     additional relaxation of the least relaxed orbital is switched off
c     facrel is no longer used	

      facrel=-10.d0

c     search for optimal value of the overrelaxation parameter is
c     switched off
      
      search=1.d-15
      omincr=0.0d0
      
      sflagra=1.d0

      ifefield=0
      ffield =0.d0
      fgrad  =0.d0
      zcutoff=1.d5
      
      cmass =0.d0
      cmass1=0.d0

c     default order of interpolation polynomials when changing grids 
c     for orbitals and potentials

      iord_nu_orb=5
      iord_nu_coul=5
      iord_nu_exch=5
      
      iord_mu_orb=5
      iord_mu_coul=5
      iord_mu_exch=5

      incrni=10
      incrmu=10

c     set maximum allowed unit number
      call setmaxunit()

      write(*,*) '  ...  start of input data  ...'
      write(*,*)'        '

 5    continue
      
      call card
      call inpa(clabel)
      
      do i=1,nlabels
         if (clabel.eq.labellc(i)) go to 12
      enddo
      
      write(iout6,1100) clabel
 1100 format(/10x,'******  ',a8,' not yet in the menu ******'//)
      write(iout6,1102) (labellc(i),i=1,nlabels)
 1102 format(/10x,'try one of the following :'//
     &	     10(10x,a8/))
      stop
      
 12   go to ( 20, 40, 60, 80,100,
     &     120,140,160,180,200,
     &     220,240,260,280,300,
     &     320,162,222,224,244,
     &     242,340,360,370,362,
     &     380,390,392), i
      stop

c     label: title

 20   continue
      read(iinp5,1104,err=1500) header
      write(iout6,1104) header
 1104 format(80a1)
      go to 5

c     label: method
      
 40   continue
c     call card
      call inpa(char8)
      if (char8.eq.cmethod(1).or.char8.eq.cmethod(2)) imethod=1
      if (char8.eq.cmethod(3).or.char8.eq.cmethod(4)) imethod=2
      if (char8.eq.cmethod(5).or.char8.eq.cmethod(6)) imethod=3
     
c     prepare for HFS calculations
      
      if (imethod.eq.3) then
         alphaf=0.70d0
         sltthr=precis
	 exlexp=1.d0
	 islat =1
      endif
      
      if (char8.eq.cmethod(1).or.char8.eq.cmethod(2).or.
     &    char8.eq.cmethod(3).or.char8.eq.cmethod(4).or.
     &    char8.eq.cmethod(5).or.char8.eq.cmethod(6)) go to 5
      write(iout6,*) 'method must be HF, HFS or OED for a time being'
      stop 'rinputd'

c     label: nuclei

 60   continue

      call inpf(z1)
      call inpf(z2)
      call inpf(r)
      call inpa(char8)

c     conversion factor due to Cohen and Taylor (1986)
c     The 1986 Adjustment of the Fundamental Physical Constants

      if (char8.eq.angstrom) r=r/bohr2ang
      r2=r/2.0d0

      if ((abs(z1)+abs(z2)).eq.0.d0.or.r.eq.0.d0) then
         write(iout6,*) 'Error: incomplete input'
         stop 'rinputd'
      endif

      go to 5

c     label: config

 80   continue
      
c     read total charge for the system

      call inpi(itotq)
      totq=z1+z2-dble(itotq)

c     to allow for noninteger nucleus charge needed to force convergence
c     in some open-shell cases read in the nuclei charges again

      z1t=0.d0
      z2t=0.d0
      call inpf(z1t)
      call inpf(z2t)
      if (z1t.gt.precis) z1=z1t
      if (z2t.gt.precis) z2=z2t

c     read in symmetry and occupation and test if
c     the orbital is locked = 1 (open shell case)
c                           = 0 (closed shell case)
      isum=0
 82   call card
      call inpi(nbsym)
      call inpa(char8)

      if(char8.ne.sigma.and.char8.ne.pi.and.
     &     char8.ne.delta.and.char8.ne.phi) then
	 write(iout6,*) 'Error: wrong symmetry or symmetry higher',
     &        ' than phi'
         stop 'rinputd'
      endif

      isum0=isum
      do i=1,nbsym
         isum=isum+1
         orbsym(isum)=char8
	 bond(isum)=orbsym(isum)
         gut(isum)=space
      enddo
      
      if (isum.gt.maxorb) then
         write(iout6,*) 'too many orbitals (max. see maxorb)'
         stop 'rinputd'
      endif
      
c     in homonuclear case read in the parity of each orbital 
c     if BREAK is on (ibreak=1) u/g labels are ignored
c     if |z1-z2|<homolevl then the case is treated as a homonuclear one
c     homolevl is set to 1.0e-6 (see blk_data.inc) 

      if (abs(z1-z2).lt.homolevl.and.ibreak.eq.0) then
         call inpa(gut(isum))
         isum1=isum0
         do i=1,nbsym
            isum1=isum1+1
            gut(isum1)=gut(isum)
         enddo
      endif
      
      cloe=4.d0
      if (orbsym(isum).eq.sigma) cloe=2.d0
      iput=4*(isum-1)
      call inpa(char8)
      if (char8.ne.endl) then
         spin(1+iput)=char8
         call inpa(char8)
         if (char8.ne.endl) then 
            spin(2+iput)=char8
            call inpa(char8)
            if (char8.ne.endl) then
               spin(3+iput)=char8
               call inpa(char8)
               if (char8.ne.endl) then
                  spin(4+iput)=char8
               endif
            endif
         endif
      endif

      if (spin(1+iput).ne.'+'.and.spin(1+iput).ne.'-') then
         do i=1,nbsym
            occ(isum0+i)= cloe
         enddo
      else
         do i=1,4
            if (spin(i+iput).eq.'+'.or.spin(i+iput).eq.'-') then
               do j=1,nbsym 
                  occ(isum0+j)=occ(isum0+j)+1.d0
               enddo
            endif
         enddo
      endif
      norb=isum
      no=norb
      
c     initialize scaling factors for off-diagonal Lagrange multipliers

      do i=1,norb
         do j=i+1,norb
            sflagrat(i,j)=sflagra
         enddo
      enddo

c     initialize damping factors and SOR parameters

      do i=1,norb
         dampf(i)=0.d0
         maxsor(i)=maxsor2
      enddo

      if (char8.eq.endl.or.char8.eq.endc) then
         totchar=0.d0
         do iorb=1,norb
            totchar=totchar+occ(iorb)
         enddo

c        Warning!
c        on Cray Y-MP (F90) the calculated charge was 29. and the one 
c        read in -- 29.00000000000011. 
c        The statement if (totchar.eq.totq) had to be replaced by the following
c        one

         if (abs(totchar-totq).gt.precis*1000.0) then
            write(iout6,*) 'Error: mismatch in given and',
     &           ' calculated total charge'
            stop 'rinputd'
         endif
         goto 5
      endif
      
      goto 82

c     label: initial

 100  continue

c     iform =0  read multiple exchange files &  write multiple exchange files
c     iform =1  read a single exchange file  &  write multiple exchange files
c     iform =2  read multiple exchange files &  write a single exchange file 
c     iform =3  read a single file           &  write a single exchange file 

      call inpi(ini)
      call inpi(iform)
      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         inclorb=itmp
      else
         inclorb=0
      endif
      
      if (imethod.eq.2) then
         if (ini.ne.1) ini=4 
         facmul=10.0**(15)
      endif

      if (imethod.eq.3.and.iform.ne.3) then
         write(iout6,*) 'Error: if method is chosen as HFS ',
     &        'the second parameter has to be set to 3'
         stop 'rinputd'
      endif
      
      if (inclorb.eq.2) then

c        'hydrogen' initialization with screening

         do iorb=1,norb
            call card
            call inpf(co1(iorb))
            call inpi(mgx(1,iorb))
            call inpi(mgx(2,iorb))
            call inpf(eza1(iorb))
            eza1(iorb)=z1-eza1(iorb)
            call inpf(co2(iorb))
            call inpi(mgx(4,iorb))
            call inpi(mgx(5,iorb))
            call inpf(eza2(iorb))
            eza2(iorb)=z2-eza2(iorb)
            call inpi(ifix(iorb))
            call inpi(maxsor(iorb))
            if (maxsor(iorb).eq.0) maxsor(iorb)=maxsor2
            i1ng(iorb)=0
         enddo
      elseif (inclorb.eq.1) then

c        'hydrogen' initialization without screening

         do iorb=1,norb
            call card
            call inpf(co1(iorb))
            call inpi(mgx(1,iorb))
            call inpi(mgx(2,iorb))
            call inpf(eza1(iorb))
            eza1(iorb)=eza1(iorb)
            call inpf(co2(iorb))
            call inpi(mgx(4,iorb))
            call inpi(mgx(5,iorb))
            call inpf(eza2(iorb))
            eza2(iorb)=eza2(iorb)
            call inpi(ifix(iorb))
            call inpi(maxsor(iorb))
            if (maxsor(iorb).eq.0) maxsor(iorb)=maxsor2
            i1ng(iorb)=0
         enddo
      elseif (inclorb.eq.0) then
         
c        orbitals already initialized or taken from Gaussian output

         do iorb=1,norb
            maxsor(iorb)=maxsor2
            co1(iorb)=1.d0
            co2(iorb)=1.d0
         enddo
      else
         write(*,*) 'rinputd: Wrong value of the third parameter'
         stop 'rinputd'
      endif

      do iorb=1,norb
	if (i1ng(iorb).eq.0) then
	  i1ng(iorb)=ngrids
	  i2ng(iorb)=ngrids
	endif
      enddo

      do iorb=1,norb
         if (orbsym(iorb).eq.sigma) mt=0
         if (orbsym(iorb).eq.pi)    mt=1
         if (orbsym(iorb).eq.delta) mt=2
         if (orbsym(iorb).eq.phi)   mt=3

c        asymuthal quantum number of a hydrogen orbital is taken 
c        in accordance with the symmetry of a molecular orbital

         mgx(3,iorb)=mt
         mgx(6,iorb)=mt
         lock(iorb)=0

         clo=4.d0
         if (orbsym(iorb).eq.sigma) clo=2.d0
         clo=occ(iorb)/clo
	 if (abs(clo-1.d0).gt.1.d-06) then
	    lock(iorb)=1
	 endif

         mgi=(-1)**mgx(3,iorb)
      enddo

c     the program works on a set of standard input and output dump files
c     containing orbitals, Coulomb potentials (with extentions .orb and .pot, 
c     respectively), exchange potentials (fort.201, fort.202, ...) and
c     some additional data ( *.ext)

      psiinp ='2dhf_input.orb'
      coulinp='2dhf_input.coul'
      exchinp='2dhf_input.exch'
     
      psiout ='2dhf_output.orb'
      coulout='2dhf_output.coul'
      exchout='2dhf_output.exch'

c     open separate files for reading and writing orbitals and potentials 

      if (iform.eq.0) then
         open(11,file=psiinp, status='unknown',form='unformatted')
         open(12,file=coulinp,status='unknown',form='unformatted')
         iinp13=iout23

         open(21,file=psiout, status='unknown',form='unformatted')
         open(22,file=coulout,status='unknown',form='unformatted')
         
      elseif (iform.eq.1) then
         open(11,file=psiinp, status='unknown',form='unformatted')
         open(12,file=coulinp,status='unknown',form='unformatted')
         open(13,file=exchinp,status='unknown',form='unformatted')
         rewind(13)        

         open(21,file=psiout, status='unknown',form='unformatted')
         open(22,file=coulout,status='unknown',form='unformatted')

      elseif (iform.eq.2) then
         open(11,file=psiinp, status='unknown',form='unformatted')
         open(12,file=coulinp,status='unknown',form='unformatted')

         open(21,file=psiout, status='unknown',form='unformatted')
         open(22,file=coulout,status='unknown',form='unformatted')
         open(23,file=exchout,status='unknown',form='unformatted')
         rewind(23)

      elseif (iform.eq.3) then
         open(11,file=psiinp, status='unknown',form='unformatted')
         open(12,file=coulinp,status='unknown',form='unformatted')
         open(13,file=exchinp,status='unknown',form='unformatted')
         rewind(13)

         open(21,file=psiout, status='unknown',form='unformatted')
         open(22,file=coulout,status='unknown',form='unformatted')
         open(23,file=exchout,status='unknown',form='unformatted')
         rewind(23)
      endif

      rewind(11)
      rewind(12)
      rewind(21)
      rewind(22)

c     ini=5 enables to retrieve from complete/uncomplete dump file
c           if only one (the highest= the first) orbital is missing
c           the rest is retreived and the first is initialized as 
c           a hydrogenic one (ini is changed from 5 to 4)

      go to 5

c     label: break put switch on for breaking the symmetry

 120  continue
      ibreak=1
      go to 5

c     label: multipol -- define number of multipole moments to be calculated

 140  continue

c     facmul  -  if facmul>0  multipole moment expansion
c		 coefficients are recalculated	every time demax(1),
c		 i.e. maximum error in orbital energy, is reduced by
c		 facmul
c		 if facmul<0 these coefficients are not calculated
c
      call inpf(facmul)
      if (facmul.lt.0.d0) facmul=10.0**(15)
      go to 5

c     label: grid

 160  continue

c     call inpi(nni)
c     call inpi(nmu(ngrids))
c     call inpf(rgrid(ngrids))
      
      tmp1=0.d0
      tmp2=0.d0
      call inpi(nni)
      call inpf(tmp1)
      call inpf(tmp2)
      if (tmp2.ne.0.d0) then
c        nnu nmu R_infty
         nmu(ngrids)=tmp1
         rgrid(ngrids)=tmp2
      else
c        nni R_infty
         if (ngrids.ne.1) then
            write(*,*)'rinputd: missing item in GRID card'
            stop 'rinputd'
         endif
         rgrid(ngrids)=tmp1
         nmu(1)=nmucalc()
      endif
     
      rinf=rgrid(ngrids)
      nmutot=nmu(ngrids)

      if (nni.gt.maxni) then
         write(*,*) 'Error: too many grid points in nu variable'
         stop 'rinputd'
      endif
      if (nmutot.gt.maxmu) then
         write(*,*) 'Error: too many grid points in mu variable'
         stop 'rinputd'
      endif

      goto 5

c     label: subgrid

c     up to 10 grids can be formally defined (rgrid(10) though
c     rgrid(9) would sufice nmu(10))
c     the last value of rgrid must be equal to rinf, i.e. the practical infinity

 162  continue

      call inpi(ngrids)
      call card
      call inpi(nni)
      nmutot=0
      do ig=1,ngrids
        call inpi(nmu(ig))
        nmutot=nmutot+nmu(ig)
      enddo
 
      if (nni.gt.maxni) then
         write(*,*) 'Error: too many grid points in nu variable'
         stop 'rinputd'
      endif
      if (nmutot.gt.maxmu) then
         write(*,*) 'Error: too many grid points in mu variable'
         stop 'rinputd'
      endif

      call card
      do ig=1,ngrids
        call inpf(rgrid(ig))
      enddo
      rinf=rgrid(ngrids)

      if (ngrids.gt.maxgrids) then
         write(*,*) 'Error: too many subgrids'
         stop 'rinputd'
      endif

c     set default ordering for subgrids

      do ig=1,ngrids
         iorder(ig)=2
      enddo      
      goto 5

c     label: cutoff -- cutoff values for orbitals and potentials

 180  continue
      call inpi(itmp)
      if (itmp.ge.0) itail=itmp
      goto 5

c     label: homo --  when this label is encountered the g/u symmetry of
c                     orbitals is strictly imposed; in all other respects
c                     a homonuclear case is treated as a heteronuclear one
c     ihomon=0 --  heteronuclear case
c     ihomon=1 --  homonuclear case |z1-z2|<homolevl (set in common block data)
c     ihomon=2 --  homonuclear case with forced symmetry

 200  continue
      ihomon=2
      goto 5

c     label: scf
c
c     maxscf  - max. no. of scf iterations
c     nobckup - no. of iterations between backups 
c     ienterm - if max. error in orbital energy is less than 
c               1/10**ienterm than scf iterations are terminated
c     inoterm - if max. error in orbital norm is less than 
c               1/10**inoterm than scf iterations are terminated
c     iprtlev - level of output during scf process
c               conv. rate, orbital energy, normalization of the worst
c               converged orbital is printed every nobckup iterations
c               if iprtlev=3 or every scf iteration if iprtlev=2 (default).
c               if iprtlev=1 then conv. rate, orbital energy and normalization 
c               of every orbital is printed in every scf iteration;
c               in any case total energy is printed every nobckup iterations;

 220  continue
      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         maxscf = itmp
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            nobckup = itmp
            call inpi(itmp)
            if (itmp.ne.inpiexit) then
               ienterm = itmp
               call inpi(itmp)
               if (itmp.ne.inpiexit) then
                  inoterm = itmp
                  call inpi(itmp)
                  if (itmp.ne.inpiexit) then
                     iprtlev=itmp
                  endif
               endif
            endif
         endif
      endif
      goto 5

c     label: fix

c     exlwf exlpot- if nonzero wave functions, coulomb potentials or
c     exlexp        exchange potentials are not relaxed; exlpot and 
c                   exlexp cannot be non zero if hydrogen orbitals 
c                   are used to start the scf process
 222  continue

      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         iexlorb=itmp
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            iexlcoul=itmp
            call inpi(itmp)
            if (itmp.ne.inpiexit) then
               iexlexp=itmp
            endif
         endif
      endif

      exlorb=dble(iexlorb)
      exlcoul=dble(iexlcoul)
      exlexp=dble(iexlexp)
      goto 5

c     label: xalpha
c
c      alphaf  -  if alphaf is not zero the slater exchange approximation
c		 is used as long as demax(1) exceeds the value of sltthr
c      sltthr -  if demax(1) is less then sltthr the local slater
c		 approximation is replaced by the full exchange

 224  continue
      call inpf(ftmp)
      if (ftmp.ne.0.d0) then
         alphaf = ftmp
         call inpf(ftmp)
         if (ftmp.ne.0.d0) then
            sltthr = ftmp
         endif
      endif
      if (alphaf.ne.0.d0) then
         exlexp=1.d0
         islat =1
      endif
      goto 5

c     label: sor

c     maxsor2 - maximal number of (mc)sor iterations (over each subgrid)
c               during relaxation of every orbital and potential in an SCF cycle

c     lsor    - a scaling factor used to change maxsor2 value when relaxing
c               potentials (see relcoul1/2 and relexch1/2); the number of (mc)sor
c               iterations for the potentials is calculalated as maxsor2/lsor

c     ipoiss  -  choice of poisson's equation solving method
c        = 1     sor (modified LPS's code)
c        = 2     mcsor - variables are relaxed in 5 sweeps each relaxing
c                every 5th variable (145 mflops on Cray Y-MP)

 240  continue
      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         maxsor2 = itmp
         call inpi(itmp)
         if (itmp.ne.inpiexit) then
            lsor = itmp
            call inpi(itmp)
            if (itmp.ne.inpiexit) then
               ipoiss = itmp                       
c     maxsor1  -  maximal number of (mc)sor iterations over the whole grid
c                 between which boundary value at infinity are recalculated

c               call inpi(itmp)
c               if (itmp.ne.inpiexit) then
c                  maxsor1 = itmp
c               endif
            endif
         endif
      endif

      goto 5
      
c     label: order

c     iorder  -  type of (mc)sor sweeps (ordering) for each grid
c	= 1   -  natural column-wise ordering for the mesh points
c	= 2   -  'middle' type of sweep - default of 2d-hf program
c	= 3   -  natural row-wise
c	= 4   -  reversed natural (column-wise) ordering (see meshwk for details)
c

 242  continue
      do ig=1,ngrids
         call inpi(iorder(ig))
      enddo
      goto 5

c     label: omega

c     ovforb   -  overelaxation parameter for orbitals and grids
c     ovfcoul  -  overelaxation parameter for coulomb pot. and grids
c     ovfexch  -  overelaxation parameter for exchange pot. and grids

 244  continue
      call card
      call inpf(tmp)
      if (tmp.gt.0.d0) then
         ovforb(1)=tmp
      else
         write(*,*) 'Error: missing or incorrect entry'
         stop 'rinputd'
      endif
      do ig=2,ngrids
        ovforb(ig) = ovforb(1)
      enddo      
      call inpf(tmp)
      if (tmp.gt.0.d0) then
         ovforb(2)=tmp
         call inpf(tmp)
         if (tmp.gt.0.d0) then
            ovforb(3)=tmp
         endif
      endif
      
      call card

      call inpf(tmp)
      if (tmp.ne.0.d0) then
         ovfcoul(1)=tmp
      else
         write(*,*) 'Error: missing or incorrect entry'
         stop 'rinputd'
      endif
      do ig=2,ngrids
        ovfcoul(ig) = ovfcoul(1)
      enddo
      call inpf(tmp)
      if (tmp.gt.0.d0) then
         ovfcoul(2)=tmp
         call inpf(tmp)
         if (tmp.gt.0.d0) then
            ovfcoul(3)=tmp
         endif
      endif
      
      do ig=1,ngrids
        ovfexch(ig) = ovfcoul(ig)
      enddo
      goto 5

c     label: plot
      
 340  continue
      stop 'rinputd: plot disabled'
c      call inpi(itmp)
c      if (itmp.ne.inpiexit) iplot=itmp
c      goto 5
      
c     label: fermi

 360  continue
      call inpf(z1atmass)
      call inpf(z2atmass)
      if (z1atmass.le.0.d0.and.z2atmass.le.0.d0) then
         write(*,*) 'Error: missing or incorrect entry'
         stop 'rinputd'
      endif
      ifermi=1
      goto 5

c     label: gauss

 362  continue
      call inpf(z1atmass)
      call inpf(z2atmass)
      if (z1atmass.le.0.d0.and.z2atmass.le.0.d0) then
         write(*,*) 'Error: missing or incorrect entry'
         stop 'rinputd'
      endif
      ifermi=2
      goto 5

c     label: lagra (not used)
c     scaling factor for off-diagonal Lagrange multipliers

 370  continue
c      call inpf(sflagra)
      stop 'rinputd: lagra disabled'
      goto 5

c     label: damp (not used)
c     damping factor for smoothing out oscillations in orbital values
c     caused by orthogonalization

 380  continue

      stop 'rinputd: damp disabled'

c      do i=1,norb
c         call card
c         call inpf(damp)
c         dampf(i)=damp
c      enddo

      goto 5

c     label: canon
c     choice of canonication coefficients due to
c     Davidson (default)       - 1
c     Guest and Saunders       - 2
c     Roothaan (single matrix) - 3
c     McWeeny and Diercksen    - 4

 390  continue

      call inpi(icanon)
      goto 5
      
c     label: fefield
c     finite field calculations
c     1 field strength
c     2 gradient strength
      
 392  continue
      ifefield=1
c      call inpi(ifefield)
c      if     (ifefield.eq.1) then 
      call inpf(ffield)
      call inpf(zcutoff)
c         write(*,*) 'ifefield,ffield ',ifefield,ffield
c      elseif (ifefield.eq.2) then 
c         call inpf(fgrad)
c         call inpf(zcutoff)
c      else
c         write(*,*) 'Error: incorrect type of finite ',
c     &        'field calculations'
c         stop 'rinputd'
c      endif
      goto 5

c     label: debug

c     idbg    -  additional printout
c     incrni  -  parameters of pmtx routine used to print matrice
c     incrmi	 row-wise. every incrni row and every incrmi column
c		 are printed

c     idbg  -  additional printout for testing purposes

c     set debug flags. if an integer i is encountered debuf flag i
c     is set, i.e. idbg(i)=1. at most 15 integers (1<i<100) can
c     be specified. if fewer integers are in the record terminate
c     it by a slash.

 260  continue

      do i=1,600
         id(i)=0
      enddo

      inzero=0
      do i=1,20
         call inpi(id(i))
         if (id(i).gt.0) then
           inzero=inzero+1
           idbg(id(i))=1
        endif
      enddo
      write(iout6,1110) (id(i),i=1,inzero)
      if (idbg(300).ne.0.or.idbg(301).ne.0) then
         write(*,*) "rinputd: Warning! ",
     &        "Do you realy want to use this flag?!"
      endif
 1110 format(10i7)
      
      if (idbg(600).eq.1) then
         call card
         call inpi(incrni)
         call inpi(incrmu)
      endif
      goto 5
      
      if (idbg(599).eq.1) then
         call card
         call inpi(iorb)
         read(*,*) (sflagrat(iorb,i),i=iorb+1,norb)
         
         do i=iorb+1,norb
            sflagrat(i,iorb)=sflagrat(iorb,i)/2.d0
         enddo
         write(*,'(10d12.2)') (sflagrat(iorb,i),i=iorb+1,norb)
      endif

c  label: help 

 280  continue
      write(*,*) '... no online help is available ...'
      write(*,*) '... see ./doc/users_guide.html or ',
     &     './doc/users_guide.pdf ...'
      stop 'rinputd'
      goto 5

c     label: stop

 300  continue

      write(*,*) '  ... end of input data  ...'
      write(*,*)'        '

      iform_t = iform
      ni_t    = nni
      mu_t    = nmutot
      no_t=norb
      nons_t=0
      do iorb=1,norb
         if (mgx(3,iorb).ne.0) nons_t=nons_t+1
      enddo
      return

c     label: interp

 320  continue

      iflag=0
      call inpi(itmp)
      if (itmp.ne.inpiexit) then
         iord_nu_orb=itmp+1
         call inpi(iord_mu_orb)
         iord_mu_orb=iord_mu_orb+1
         
         call inpi(iord_nu_coul)
         iord_nu_coul=iord_nu_coul+1
         call inpi(iord_mu_coul)
         iord_mu_coul=iord_mu_coul+1

         call inpi(iord_nu_exch)
         iord_nu_exch=iord_nu_exch+1
         call inpi(iord_mu_exch)
         iord_mu_exch=iord_mu_exch+1
      endif
      if ((iord_nu_orb.ne.3).and.(iord_nu_orb.ne.5).and.
     &     (iord_nu_orb.ne.7).and.(iord_nu_orb.ne.9)) goto 1600
      
      if ((iord_mu_orb.ne.3).and.(iord_mu_orb.ne.5).and.
     &     (iord_mu_orb.ne.7).and.(iord_mu_orb.ne.9)) goto 1600
      
      if ((iord_nu_coul.ne.3).and.(iord_nu_coul.ne.5).and.
     &     (iord_nu_coul.ne.7).and.(iord_nu_coul.ne.9)) goto 1600
      
      if ((iord_mu_coul.ne.3).and.(iord_mu_coul.ne.5).and.
     &     (iord_mu_coul.ne.7).and.(iord_mu_coul.ne.9)) goto 1600
      
      if ((iord_nu_exch.ne.3).and.(iord_nu_exch.ne.5).and.
     &     (iord_nu_exch.ne.7).and.(iord_nu_exch.ne.9)) goto 1600
      
      if ((iord_mu_exch.ne.3).and.(iord_mu_exch.ne.5).and.
     &     (iord_mu_exch.ne.7).and.(iord_mu_exch.ne.9)) goto 1600
      
      iinterp=1
      goto 5

01500 write(iout6,*) 'I/O error when reading header'
      stop 'rinputd'
01600 continue
      write(*,1120)
01120 format(1x,'Error: order of interpolation polynomial must be',
     &     ' 2, 4, 6 or 8')
      stop 'rinputd'
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### setmaxunit ###
c
c     Determines and sets maximum unit number allowed
c
      subroutine setmaxunit
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      do i=99,1000 
         iunit=i
         open(iunit,status='scratch',form='unformatted',err=100)
         close(iunit)
      enddo
      maxunit=1000
      return
 100  maxunit=i-1
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### plegendg ###		  	    
c
c
      function plegendg(l,m,costh)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)		
      include 'commons8.inc'

      ct=abs(1.d0-costh*costh)
      
      if (m.eq.0) then
         plegendg=hypgf3(-l,l+1,1,(1.d0-costh)/2.d0)
      elseif (m.ne.0.and.ct.lt.precis) then           
         plegendg=0.d0
      else
         fn0=(-1.d0**m)*factor(l+m)/factor(l-m)
     &        /factor(m)/(2.d0**m)
         ct1=fn0*ct**(dble(m)/2.d0)	   
         plegendg=hypgf3(m-l,m+l+1,m+1,(1.d0-costh)/2.d0)*ct1
      endif
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### interpolq ### 
c
c     This routine works for ngrids<=3
c
      subroutine interpolq
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      real*8 vmuq,coeffq,xmu,vpoly1q
      include 'commons8.inc'
      include 'commons16.inc'
c
      dimension coeffq(9)

c  |--------------------------------------|
c  |            ifill=1                   |    ngrids=1 
c  |				          | 
c  |--------------------------------------|
c
c  |--------------|-----------------------|
c  |     ifill=2  | ifill=4               |    ngrids=2
c  |              |                       |
c  |--------------|-----------------------|
c
c  |--------------|-----------|-----------|
c  |	ifill=2	  | ifill=3   | ifill=4	  |    ngrids=3 
c  |              |           |           |
c  |--------------|-----------|-----------|

c     To relax a function defined on nni*nmu grid using the 8th-order central
c     difference formulae the function is immersed into (nni+8)*(nmu+8) grid
c     but the valued outside the boundary necessary to perform relaxation
c     within the boundary region have to be previded. The symmetry properties
c     are used to this end along ni=1, ni=nni and mu=1 lines. However the
c     boundaries between subgrids have to be treated differently.

c     At each subgrid boundary a set of the 8th-order Lagrange interpolation 
c     formulae are formed in order to be able to calculate missing outer
c     region data.

c     For each value of mup (p) a Lagrange polynomial of the 8th-order
c     employing 4 grid points to the left and right of imu (imu is included)
c     is build (x_{0} corresponds to the grid boundary mu value) 

c     f^{(p)}(x) = \sum_{k=p-4}^{p+4} f(x_{k})
c                  \prod_{i=p-4,i\ne k}^{p+4} {(x-x_{i}) \over (x_{k}-x_{i})}

c     Polynomials for each k have to be calculated and stored.

c     cint?(k,i) store the interpolation coefficients; i=1,...,4 corresponds
c     to appropriate (left or right) inter(sub)grid mu values in increasing 
c     order, k numbers the coefficients. 
c     The interpolation formula is constructed using 9 grid points somehow 
c     distributed around the point at which interpolated value is sought 
c     (see below).

c     Determine the grid points which will be used for the construction of the
c     polynomial

c !!!!!!!! iord is changed

      iord=9
      iord2=iord/2
      kbeg=1
      kend=9

      if (idbg(80).ne.0) then
         iord=3
         iord2=iord/2
         kbeg=4
         kend=6
      endif 

      if (ngrids.eq.2) then

c        ifill=2 
c        boundary between 1-2

         do i=1,4
              do k=1,9
                 cint2(k,i)=0.d0
                 cint4(k,i)=0.d0
              enddo
           enddo

           hmu1=hmu(1)
           hmu2=hmu(2)	

           if (hmu2.lt.hmu1) then	  
              write(iout6,*) '2nd subgrid should be sparser than the 1st'
              stop 'interpolq: ifill=2'
           endif	  	

c          for each i=1,...,4 determine the smallest imup for which 
c          |vmu(imup)-vmu(iemu(1))| > i*hmu(1)
c          and construct polynomial around imup+1-4 using 4 grid points to the	
c          left and right

           do i=1,4
              do imu=iemu(1)+1,iemu(2)
                 if ((vmu(imu)-vmu(iemu(1))).ge.dble(i)*hmu1) then	  
                    mup=imu+1-iord2
                    goto 90
                 endif				  	     
              enddo
00090         continue	
              iadint2(i)=mup-4
              do k=kbeg,kend
                 call lpcoeffq(mup,k,coeffq)
                 xmu=dble(vmu(iemu(1))+dble(i)*hmu1)
                 cint2(k,i)=vpoly1q(xmu,coeffq)
              enddo
           enddo				  

c          ifill=4 

c          to the left of the boundary (only 3 values are actually needed but
c          4 values would be generated)
c          for each i=1,...,4 determine the largest imup for which 
c          |vmu(imup)-vmu(iemu(1))| > i*hmu(2)
c          and construct polynomial around such imup using 4 grid points to the
c          left and right

c          boundary between 1-2	

           do i=1,4
              do imu=iemu(1)-1,1,-1
                 if ((vmu(iemu(1))-vmu(imu)).ge.dble(i)*hmu2) then	  
                    mup=imu
                    goto 100
                 endif				  		  
              enddo
00100         continue
              iadint4(5-i)=mup-4
              do k=kbeg,kend
                 call lpcoeffq(mup,k,coeffq)
                 xmu=dble(vmu(iemu(1))-dble(i)*hmu2)
c                reverse order of addressing columns, cf. fill4		
                 cint4(k,5-i)=vpoly1q(xmu,coeffq)
              enddo
           enddo				  

           if (idbg(81).ne.0) then
              write(iout6,*) 'iadint2',iadint2
              write(iout6,*) 'cint2'
              do i=1,4
                 write(iout6,*) i,(cint2(k,i),k=1,9)
              enddo

              write(iout6,*) 'iadint4',iadint4
              write(iout6,*) 'cint4'
              do i=1,4
                 write(iout6,*) i,(cint4(k,i),k=1,9)
              enddo
           endif
           return
	endif	  

c       33333333333333333333333333333333333333333333333
c       ifill=3 (ngrids=3)	

	if (ngrids.eq.3) then

c          boundary between 1-2

           hmu1=hmu(1)
           hmu2=hmu(2)	

           if (hmu2.lt.hmu1) then	  
              write(iout6,*) '2nd subgrid should be sparser than the 1st'
              stop 'interpolq: ifill=2'
           endif

           do i=1,4
                do k=1,9
                   cint2 (k,i)=0.d0
                   cint3l(k,i)=0.d0
                   cint3r(k,i)=0.d0
                   cint4 (k,i)=0.d0
                enddo
             enddo	  	

c            for each i=1,...,4 determine the smallest imup for which 
c            |vmu(imup)-vmu(iemu(1))| > i*hmu(1)
c            and construct polynomial around imup+1-4 using 4 grid points 
c            to the left and right

             do i=1,4
                do imu=iemu(1)+1,iemu(2)
                   if ((vmu(imu)-vmu(iemu(1))).ge.dble(i)*hmu1) then	  
                      mup=imu+1-iord2
                      goto 91
                   endif				  	     
                enddo
00091           continue	
                iadint2(i)=mup-4
                do k=kbeg,kend
                   call lpcoeffq(mup,k,coeffq)
                   xmu=dble(vmu(iemu(1))+dble(i)*hmu1)
                   cint2(k,i)=vpoly1q(xmu,coeffq)
                enddo
             enddo				  

c            ifill=4 

c            to the left of the boundary (only 3 values are actually needed but
c            4 values would be generated)
c            for each i=1,...,4 determine the largest imup for which 
c            |vmu(imup)-vmu(iemu(1))| > i*hmu(2)
c            and construct polynomial around such imup using 4 grid points to the
c            left and right

c            boundary between 2-3	

             hmu3=hmu(3)
             if (hmu3.lt.hmu2) then	  
                write(iout6,*) '3rd subgrid should be sparser than the 2nd'
                stop 'interpolq: ifill=3'
             endif	  	
             
             do i=1,4
                do imu=iemu(2)-1,1,-1
                   if ((vmu(iemu(2))-vmu(imu)).ge.dble(i)*hmu3) then	  
                      mup=imu
                      goto 101
                   endif				  		  
                enddo
00101           continue
                iadint4(5-i)=mup-4
                do k=kbeg,kend
                   call lpcoeffq(mup,k,coeffq)
                   xmu=dble(vmu(iemu(2))-dble(i)*hmu3)
c                  reverse order of addressing columns, cf. fill4		
                   cint4(k,5-i)=vpoly1q(xmu,coeffq)
                enddo
             enddo				  

c            to the left of the boundary (only 3 values are needed but 4 ...)

c            for each i=1,...,4 determine the largest imup for which 
c            |vmu(imup)-vmu(iemu(1))| > i*hmu(2)
c            and construct polynomial around such imup using 4 grid points to the
c            left and right

c            boundary between 1-2	

             do i=1,4
                do imu=iemu(1)-1,1,-1
                   if ((vmu(iemu(1))-vmu(imu)).ge.dble(i)*hmu2) then	  
                      mup=imu
                      goto 110
                   endif				  		  
                enddo
00110           continue
                iadint3l(5-i)=mup-4
                do k=kbeg,kend
                   call lpcoeffq(mup,k,coeffq)
                   xmu=dble(vmu(iemu(1))-dble(i)*hmu2)
c                  reverse order of addressing columns, cf. fill3
                   cint3l(k,5-i)=vpoly1q(xmu,coeffq)
                enddo
             enddo				  

c            boundary between 2-3

c            for each i=1,...,4 determine the smallest imup for which 
c            |vmu(imup)-vmu(iemu(2))| > i*hmu(2)
c            and construct polynomial around imup+1-4 using 4 grid points to the  	
c            left and right

             do i=1,4
                do imu=iemu(2)+1,iemu(3)
                   if ((vmu(imu)-vmu(iemu(2))).ge.dble(i)*hmu2) then	  
                      mup=imu+1-iord2
                      goto 120
                   endif
                enddo
00120           continue	
                iadint3r(i)=mup-4
                do k=kbeg,kend
                   call lpcoeffq(mup,k,coeffq)
                   xmu=dble(vmu(iemu(2))+dble(i)*hmu2)
	      cint3r(k,i)=vpoly1q(xmu,coeffq)
           enddo
        enddo	

        if (idbg(81).ne.0) then
           write(iout6,*) 'iadint2',iadint2
           write(iout6,*) 'cint2'
           do i=1,4
              write(iout6,*) i,(cint2(k,i),k=1,9)
           enddo

           write(iout6,*) 'iadint3l',iadint3l
           write(iout6,*) 'cint3l'
           do i=1,4
              write(iout6,*) i,(cint3l(k,i),k=1,9)
           enddo

           write(iout6,*) 'iadint3r',iadint3r
           write(iout6,*) 'cint3r'
           do i=1,4
              write(iout6,*) i,(cint3r(k,i),k=1,9)
           enddo

           write(iout6,*) 'iadint4',iadint4
           write(iout6,*) 'cint4'
           do i=1,4
              write(iout6,*) i,(cint4(k,i),k=1,9)
           enddo
	endif
        return
      endif	  

      if (ngrids.gt.3) then
         write(iout6,*) 'No more than 3 subgrids are allowd'
         stop 'interpolq'
      endif
      return
      end

c ### vpoly1q ###
c  
c     This function uses the Horner scheme to calculate value of the polynomial 
c     stored in array a at a particular point
c
      function vpoly1q (x,a)
      implicit real*8 (a-h,o-z)
      real*8 vmuq
      include 'commons16.inc'
      dimension a(9)

      vpoly1q=0.d0
      do i=iord,2,-1
         vpoly1q=(vpoly1q+a(i))*x
      enddo
      vpoly1q=vpoly1q+a(1)
      return
      end

c ### lagrpolq ###
c
      subroutine lagrpolq (dc1,dc2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      real*8 vmuq,coeffq,coeff1,coeff2,vpolyq
      include 'commons8.inc'
      include 'commons16.inc'

      dimension dc1(9,7,9),dc2(9,7,9),coeffq(9),coeff1(9),coeff2(9)

c     derivative coeff. from 8th-order Lagrange interpolation formula
c     are stored in dc[1-2](ngbound,imu,k), where ngbound is the number of 
c     the grid boundaries (1 for 1-2, 2 for 2-3 etc), imu is one of the 7 
c     intergrid mu values and k points to a derivative coefficient.

c     the grid boundaries (1 for 1-2, 2 for 2-3 etc), imu is one of the 7 
c     intergrid mu values and k points to a derivative coefficient.

c     For each value of mup (p) a Lagrange polynomial of the 8th-order
c     employing 4 grid points to the left and right of imu (imu is included)
c     is build (x_{0} corresponds to the grid boundary mu value) 

c     f^{(p)}(x) = \sum_{k=p-4}^{p+4} f(x_{k})
c                  \prod_{i=p-4,i\ne k}^{p+4} {(x-x_{i}) \over (x_{k}-x_{i})}

c     Polynomials for each k have to be calculated and their first and second
c     derivatives obtained. The values of the derivative polynomials at grid 
c     point x_{p} (mup) are the differentiation coefficients sought.

c     in order to quarantee the real*8 in the Lagrange coefficients
c     the quadruple precision have to be used during their generation

      iord=9
      kbeg=1
      kend=9

      do i=1,mxnmu
         vmuq(i)=dble(vmu(i))
      enddo

c     loop over grid boundaries first (ngrids>1)

      do ig=1,ngrids-1
         ib=iemu(ig)-3	
         ie=iemu(ig)+3
c        loop over mup values (mup=ib...ie)
c        loop over k	     
         imup=0
         do mup=ib,ie
            imup=imup+1
	    do k=kbeg,kend
               call lpcoeffq(mup,k,coeffq)
               call lpderq(coeffq,coeff1,coeff2)
               dc1(ig,imup,k)=vpolyq(mup,coeff1)
               dc2(ig,imup,k)=vpolyq(mup,coeff2)
            enddo 
         enddo
      enddo
      return
      end

c ### lpcoeffq ###
c
c     This routine calculates coefficients of the (sub)Lagrange 
c     polynomial for a grid point k
c     \prod_{i=1,i\ne k}^{9} {(x-x_{i}) \over (x_{k}-x_{i})}
c
c     x_{k}= vmu(mup-5+k), k=1,...,9 
c
c     Last modification: 2.01.01
c     
      subroutine lpcoeffq (mup,k,coeffq)
      implicit real*8 (a-h,o-z)
      include 'commons16.inc'
      dimension a(12),b(12),coeffq(9)

c  calculate denominator product

      denom=1.d0
      ib=mup-(iord/2+1)
      do i=kbeg,kend
         if (i.ne.k) denom=denom*(vmuq(ib+k)-vmuq(ib+i))
      enddo

      do i=1,12
         a(i)=0.d0
         b(i)=0.d0	 
      enddo

c     calculate nominator product: 
c     a(1)+a(2)*x+a(3)*x^2+...+a(9)*x^8
c     storing coefficients in a and b

c     if (k.ne.kbeg) then
c     a(1)=-vmuq(ib+kbeg)
c     else
c     a(1)=-vmuq(ib+kbeg+1)	  
c     endif
c     a(2)=1.d0	

      a(1)=1.d0

c  multiply polynomial a by (x+c1), c1=-vmuq(ib+i)

      ic2=1	
      do i=kbeg,kend	  
         if (i.ne.k) then
  	    ic2=ic2+1
            c1=-vmuq(ib+i)	  
	    b(1)=a(1)*c1
	    do ic1=2,ic2
               b(ic1)=a(ic1)*c1+a(ic1-1)
	    enddo
            b(ic2+1)=a(ic2)	
            do j=1,ic2+1
               a(j)=b(j)
            enddo
         endif	    
      enddo   
c     
      do i=1,iord
         coeffq(i)=a(i)/denom
      enddo
      return
      end

c ### lpderq ###
c     
c     This routine calculates coefficients of the first and second
c     derivative of the polynomial stored in a
c
      subroutine lpderq (a,a1,a2)
      implicit real*8 (a-h,o-z)
      include 'commons16.inc'
      dimension a(9),a1(9),a2(9)

      do i=1,iord-1
         a1(i)=a(i+1)*dble(i)
      enddo
      a1(iord)=0.d0

      do i=1,iord-2
         a2(i)=a1(i+1)*dble(i)
      enddo
      a2(iord-1)=0.d0
      a2(iord)  =0.d0
      return
      end

c ### vpolyq ###
c
c     This function uses the Horner scheme to calculate value of the polynomial 
c     stored in array a at a particular point
c
      function vpolyq (mup,a)
      implicit real*8 (a-h,o-z)
      include 'commons16.inc'
      dimension a(9)

      x=vmuq(mup)  
      vpolyq=0.d0
      do i=iord,2,-1
         vpolyq=(vpolyq+a(i))*x
      enddo
      vpolyq=vpolyq+a(1)
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### asymptp ### 
c
      subroutine asymptp (iorb1,pot,excp)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*),excp(*)

c     determine values of Coulomb potentials in the asymptotic region
c     from the multipole expansion

      if (itouch(iorb1).eq.1) then	
         ibeg=i2b(iorb1)
         call zmulti(iorb1,pot(ibeg))
      endif	    

      if (islat.eq.1) return

c     initialize amul array needed to evaluate exch. potential in
c     the asymptotic region by calling zasyx

      do iorb2=1,norb
         if (itouch(iorb1).eq.0.and.itouch(iorb2).eq.0) goto 10
         k=i3xk(iorb1,iorb2)
c        check if k=0
         if (k.eq.0) goto 10
         ngrid=i3si(k)
         if (ilc(k).ne.0) then

c           the exchange potential address array should already be modified by
c           call to rfdexch routine

            i3beg=i3b(k)
            idel=abs(mgx(6,iorb1)-mgx(6,iorb2))
            if (iorb1.eq.iorb2) idel=2*mgx(6,iorb1)

            if (idbg(300).eq.0) then
               call zasyx1 (idel,k,excp(i3beg))
            else
               call zasyx (idel,k,excp(i3beg))
            endif

            if (ilc(k).eq.2) then
               idel=mgx(6,iorb2)+mgx(6,iorb1)
               k=k+norb*(norb+1)/2
               i3beg=i3beg+ngrid
               if (idbg(300).eq.0) then
                  call zasyx1 (idel,k,excp(i3beg))
               else
                  call zasyx (idel,k,excp(i3beg))
               endif
            endif
         endif
 10      continue
      enddo
      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### fill1 ###
c
c     Immerses FUN array into WORK and adds boundary values.
c 
      subroutine fill1 (nnit,nmit,fun,work)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension fun(nnit,nmit),work(nnit+8,nmit+8)

c     fill the interior of work array

      do i=1,nmit
         do j=1,nnit
            work(j+4,i+4)=fun(j,i)
         enddo
      enddo

c     isym = 1 - even symmetry, isym =-1 - odd symmetry
c     values over i=nmit bondary are determined from the asymptotic expansion

      if (isym.eq.1) then

c        mu=1...4	
	  do i=2,5
             do j=1,nnit
                work(j+4,6-i)= fun(j,i)
             enddo
          enddo

c         mu=nmu+5....nmu+8
c         the following code is unnecessary since the filled in values
c         are not used during relaxation

c	  do 102 i=1,4
c	  do 102 j=1,nnit
c00102	    work(j+4,nmit+4+i)= fun(j,nmit)

c         ni=1...4
	  do i=1,nmit
             do j=2,5
                work(6-j,i+4)= fun(j,i)
             enddo
          enddo

c         ni=ni+4...ni+8
	  do i=1,nmit
             jj=0
             do j=nnit-4,nnit-1
                jj=jj+1
                work(nnit+9-jj,i+4)= fun(j,i)
             enddo
          enddo
       else
          do i=2,5
             do j=1,nnit
                work(j+4,6-i)=-fun(j,i)
             enddo
          enddo

c	  do 122 i=1,4
c	  do 122 j=1,nnit
c00122	    work(j+4,nmit+4+i)=-fun(j,nmit)
c
	  do i=1,nmit
             do j=2,5
                work(6-j,i+4)=-fun(j,i)
             enddo
          enddo

	  do i=1,nmit
             jj=0
             do j=nnit-4,nnit-1
                jj=jj+1
                work(nnit+9-jj,i+4)=-fun(j,i)
             enddo
          enddo
      endif

      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### relorb1 ###  
c
      subroutine relorb1 (iorb,cw_sor,psi,pot,excp,
     &     b,d,e,f0,f1,f2,f4,wgt2,lhs,rhs,wk0,wk1,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      integer*4 cw_sor
      real*8 lhs
      include 'commons8.inc'

      dimension psi(*),pot(*),excp(*),cw_sor(*),
     &     rhs(*),b(*),d(*),e(*),
     &     f0(*),f1(*),f2(*),f4(*),wgt2(*),
     &     lhs(*),wk0(*),wk1(*),wk2(*)
     
      ddmax=abs(demax(1))
      if (alphaf.ne.0.d0) then
         if (sltthr.gt.ddmax.and.ddmax.ne.0.d0) then
	    if(islat.eq.1) then
               write(*,*) '*** the full exchange has been turned on ***'
               islat=0
               exlexp=0.d0
	    endif
         endif
      endif

c     prepare right and left-hand side of the Poisson equation
c     include the diagonal part of the differentiation operator in lhs

      if (islat.ne.0) then
c        the slater exchange approximation is used
         call focksl(iorb,psi,pot,excp,e,f0,f1,f2,f4,wk0,wk1,wk2)
      else
         call fock (iorb,psi,pot,excp,e,f0,f1,f2,f4,wk0,wk1,wk2)
      endif

      call dcopy (mxsize,foc1,1,lhs,1)
      call dcopy (mxsize,foc2,1,rhs,1)

      ipex=mgx(6,iorb)
      ipex=ipex-2*(ipex/2)
      if (ipex.eq.0) then
         isym= 1 
      else
         isym=-1
      endif

c     start the sor iterations
c     fill wk2 array

      iborb=i1b(iorb)

      do itr1=1,maxsor1	  
         do ig=1,i1ng(iorb)
            muoffs=0
            omega=ovforb(ig)
            omega1=1.d0-omega
            ioffst=ioffs(ig)	  	  
            ioffs1=ioffst+1	  
            iborb1=iborb+ioffst
           
            do i=1,4
               dmu2t(i)=dmu2(i,ig)
               dmu1t(i)=dmu1(i,ig)
            enddo

            do i=1,ngsize(ig)
               lhs(ioffst+i)=foc1(ioffst+i)+diag(ig)
            enddo	    

            if (i1ng(iorb).eq.1) then 
c              icase=1
               ifill=1
               ngrd1 =ingr1(1,ig)
               ngrd6a=ingr1(2,ig)
               ngrd6b=ingr1(3,ig)
               ngrd7 =ingr1(4,ig)	  	  

c              initialize aorb array needed to evaluate orbital values in
c              the asymptotic region

               nmut=i1mu(iorb)
               do i=nmut-4,nmut
                  ii=(i-1)*nni
                  do j=1,nni
                     ij=ii+j
                     if (f1(ij).eq.0.d0) then
                        wk1(ij)=0.d0
                     else
                        wk1(ij)=lhs(ij)/f1(ij)
                     endif
                  enddo
               enddo
               call iniaorb (nmut,wk0,wk1)
               
               call fill (nni,nmu(ig),isym,psi(iborb),wk2)
               do itr2=1,maxsor2	  		
		  call sor
     &                 (wk2,lhs(ioffs1),rhs(ioffs1),b(ioffs1),d(ioffs1),
     &                 cw_sor(iadext(ig)),cw_sor(iadnor(ig)),
     &                 cw_sor(iadex1(ig)),cw_sor(iadex2(ig)),
     &                 cw_sor(iadex3(ig)))
               enddo     
               call refill (nni,nmu(ig),psi(iborb),wk2)     
               call asymorb (nmut,psi(iborb),wk0)				
            else
               if (ig.eq.1) then 
c                 icase=2
                  ifill=2
                  ngrd1 =ingr2(1,ig)
                  ngrd6a=ingr2(2,ig)
                  ngrd6b=ingr2(3,ig)
                  ngrd7 =ingr2(4,ig)	  	  	    
                  call fill2 (nni,nmu(ig),psi(iborb),wk2)
                  do itr2=1,maxsor2	  		
                     call sor 
     &                    (wk2,lhs(ioffs1),rhs(ioffs1),b(ioffs1),
     &                    d(ioffs1),
     &                    cw_sor(iadext(ig+ngrids)),
     &                    cw_sor(iadnor(ig+ngrids)),
     &                    cw_sor(iadex1(ig+ngrids)),
     &                    cw_sor(iadex2(ig+ngrids)),
     &                    cw_sor(iadex3(ig+ngrids)))
                  enddo     
                  call refill (nni,nmu(ig),psi(iborb),wk2)     
               elseif (ig.ne.1.and.ig.ne.i1ng(iorb)) then 
c                 icase=2
                  ifill=3
                  ngrd1 =ingr2(1,ig)
                  ngrd6a=ingr2(2,ig)
                  ngrd6b=ingr2(3,ig)
                  ngrd7 =ingr2(4,ig)	  	  	    
                  
                  muoffs=iemu(ig-1)-1
                  call fill3 (nni,nmu(ig),psi(iborb),wk2)
                  do itr2=1,maxsor2	  		
                     call sor 
     &                    (wk2,lhs(ioffs1),rhs(ioffs1),b(ioffs1),
     &                    d(ioffs1),
     &                    cw_sor(iadext(ig+ngrids)),
     &                    cw_sor(iadnor(ig+ngrids)),
     &                    cw_sor(iadex1(ig+ngrids)),
     &                    cw_sor(iadex2(ig+ngrids)),
     &                    cw_sor(iadex3(ig+ngrids)))
                  enddo     
                  call refill34 (nni,nmu(ig),psi(iborb),wk2)     
                  muoffs=0
               elseif (ig.eq.i1ng(iorb)) then 
                  
c                 initialize aorb array needed to evaluate orbital values in
c                 the asymptotic region
                  
                  nmut=i1mu(iorb)
                  do i=nmut-4,nmut
                     ii=(i-1)*nni
                     do j=1,nni
                        ij=ii+j
                        if (f1(ij).eq.0.d0) then
                           wk1(ij)=0.d0
                        else
                           wk1(ij)=lhs(ij)/f1(ij)
                        endif
                     enddo
                  enddo
                  call iniaorb (nmut,wk0,wk1)
                  
                  ifill=4
                  ngrd1 =ingr1(1,ig)
                  ngrd6a=ingr1(2,ig)
                  ngrd6b=ingr1(3,ig)
                  ngrd7 =ingr1(4,ig)	  	  	    
                  
                  muoffs=iemu(ig-1)-1
                  
                  call fill4 (nni,nmu(ig),psi(iborb),wk2)
                  do itr2=1,maxsor2	  		
                     call sor 
     &                    (wk2,lhs(ioffs1),rhs(ioffs1),b(ioffs1),
     &                    d(ioffs1),
     &                    cw_sor(iadext(ig)),
     &                    cw_sor(iadnor(ig)),
     &                    cw_sor(iadex1(ig)),
     &                    cw_sor(iadex2(ig)),
     &                    cw_sor(iadex3(ig)))
                  enddo
                  call refill34 (nni,nmu(ig),psi(iborb),wk2)     
                  call asymorb (nmut,psi(iborb),wk0)
                  muoffs=0	    
               endif
            endif
         enddo
         
c        if iortho is nonzero the strong orthogonality conditions are imposed
c        i.e. the orthogonalization is performed every maxsor2 iterations
         
         if (iortho.eq.1) then
            iprt=0
            if (iorb.gt.1) call ortho (iorb,psi,f4,wgt2,wk2,iprt)
         endif
      enddo
      
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### wrec ###
c
      subroutine wrec(irec,ngrid,axyz)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'        
      dimension axyz(ngrid)
      iunit=irec+30
      if (iunit.gt.maxunit) then
         write(*,910)
         stop "wrec"
 910     format('wrec: maximum unit number exceeded ',
     &        '(see User''s Guide)')
      endif

      open(iunit,status='unknown',form='unformatted')
      rewind(iunit)
      write (iunit,err=900) axyz
      close(iunit)
      return
 900  write(iout6,*) 'error detected when writing exchange',  
     &     ' potential',irec
      stop 'wrec'
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### relax ###
c
c     Controls relaxation of Coulomb potentials, exchange potentials
c     and orbitals
c
      subroutine  relax (iorb,cw_sor,psi,pot,excp,
     &     borb,bpot,d,e,f0,f1,f2,f3,f4,g,wjac1,wjac2,
     &     wgt2,lhs,rhs,wk00,wk0,wk1,wk2)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      real*8 lhs
      integer*4 cw_sor		

      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*)
      dimension wjac1(*),wjac2(*),borb(*),bpot(*),d(*),e(*),
     &     f0(*),f1(*),f2(*),f3(*),f4(*),g(*),wgt2(*),
     &     lhs(*),rhs(*),wk00(*),wk0(*),wk1(*),wk2(*)

c     when ipoiss=3 then mcsor method is used to solve poisson's eqs for
c     potentials

      if (exlcoul.eq.0.d0) then
         if (ipoiss.eq.1) then
            call relcoul1 (iorb,cw_sor,psi,pot,excp,bpot,d,f3,g,
     &           lhs,rhs,wk2)
         elseif (ipoiss.eq.2.or.ipoiss.eq.3) then
            call relcoul2 (iorb,cw_sor,psi,pot,excp,bpot,d,f3,g,
     &           lhs,rhs,wk2)
         endif	  
      endif

c     process the exchange potentials
      
      if (islat.eq.0) then
         if (exlexp.eq.0.d0.or.exlexp.eq.2.d0) then
            if (ipoiss.eq.1) then
               call relexch1 (iorb,cw_sor,psi,pot,excp,bpot,d,e,
     &              f3,g,lhs,rhs,wk2)
            elseif (ipoiss.eq.2.or.ipoiss.eq.3) then
               call relexch2 (iorb,cw_sor,psi,pot,excp,bpot,d,e,
     &              f3,g,lhs,rhs,wk2)
            endif
	 endif
      endif


      if (exlorb.eq.0.d0) then
         if (idbg(90).ne.0) call tail(psi)
         if (ipoiss.eq.1.or.ipoiss.eq.3) then
            call relorb1(iorb,cw_sor,psi,pot,excp,borb,d,e,
     &		        f0,f1,f2,f4,wgt2,lhs,rhs,wk00,wk0,wk2)
         elseif (ipoiss.eq.2) then
            call relorb2(iorb,cw_sor,psi,pot,excp,borb,d,e,
     &           f0,f1,f2,f4,wgt2,lhs,rhs,wk00,wk0,wk2)
         endif
      endif

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### multi ###
c
c     Calculates the value for the multipole expansion for the exchange 
c     potential in practical infinity.

      subroutine multi(i,j,mt,ipc,pe)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension dome(10)

      rr=sqrt(vxisq(j)+vetasq(i)-1.d0)		
      costh=0.d0
      if (abs(rr).gt.precis) then
         costh=veta(i)*vxi(j)/rr	 
      endif

      costh2=costh*costh
      costh3=costh2*costh
      costh4=costh2*costh2
      rr=rr*r2
      pe=0.d0

      if (mt.eq.0) then
c        m=0
         dome( 1)=costh
         dome( 2)=( 3.d0*costh*dome(1) - 1.d0)	  / 2.d0
         dome( 3)=( 5.d0*costh*dome(2) - 2.d0*dome(1))/ 3.d0
         dome( 4)=( 7.d0*costh*dome(3) - 3.d0*dome(2))/ 4.d0
         dome( 5)=( 9.d0*costh*dome(4) - 4.d0*dome(3))/ 5.d0
         dome( 6)=(11.d0*costh*dome(5) - 5.d0*dome(4))/ 6.d0
         dome( 7)=(13.d0*costh*dome(6) - 6.d0*dome(5))/ 7.d0
         dome( 8)=(15.d0*costh*dome(7) - 7.d0*dome(6))/ 8.d0

c        dome( 9)=(17.d0*costh*dome(8) - 8.d0*dome(7))/ 9.d0
c        dome(10)=(19.d0*costh*dome(9) - 9.d0*dome(8))/10.d0

         pe=      dome(8)*exc8 (ipc) /rr
         pe=(pe + dome(7)*exc7 (ipc))/rr
         pe=(pe + dome(6)*exc6 (ipc))/rr

         pe=(pe + dome(5)*exc5 (ipc))/rr
         pe=(pe + dome(4)*exche(ipc))/rr
         pe=(pe + dome(3)*excoc(ipc))/rr
         pe=(pe + dome(2)*excqu(ipc))/rr
         pe=(pe + dome(1)*excdi(ipc))/rr/rr
         return	

c     pe=(3.5d01*costh4-3.d01*costh2+3.d0)*exche(ipc)*calp(1)/rr
c     pe=(pe+(5.d0*costh3-3.d0*costh)*excoc(ipc)*calp(2))/rr
c     pe=(pe+(3.d0*costh2-1.d0)*excqu(ipc)*calp(2))/rr
c     rx2=rr*rr
c     pe=(pe+costh*excdi(ipc))/rx2

      elseif (mt.eq.1) then
c        m=1
         sini2=abs(1.d0-costh2)
         sini=sqrt(sini2)
         pe=sini*(7.d0*costh3-3.d0*costh)*exche(ipc)*calp(3)/rr
         pe=(pe+sini*(5.d0*costh2-1.d0)*excoc(ipc)*calp(4))/rr
         pe=(pe+sini*costh*excqu(ipc)*calp(5))/rr
         rx2=rr*rr
         pe=(pe+sini*excdi(ipc)*calp(12))/rx2
         
         return
         
      elseif (mt.eq.2) then
c        m=2
         sini2=1.d0-costh2
         pe=sini2*(7.d0*costh2-1.d0)*exche(ipc)*calp(6)/rr
         pe=(pe+sini2*costh*excoc(ipc)*calp(7))/rr
         rx3=rr*rr*rr
         pe=(pe+sini2*excqu(ipc)*calp(8))/rx3
         return
      elseif (mt.eq.3) then
c        m=3
         sini2=abs(1.d0-costh2)
         sini=sqrt(sini2)
         sini3=sini2*sini
         pe=sini3*costh*exche(ipc)*calp(9)/rr
         rx4=rr*rr*rr*rr
         pe=(pe+sini3*excoc(ipc)*calp(10))/rx4
         return
      elseif (mt.eq.4) then
c        m=4
         sini2=1.d0-costh2
         sini4=sini2*sini2
         rx5=rr*rr*rr*rr*rr
         pe=sini4*exche(ipc)*calp(11)/rx5
      endif
      return
      end

********************************************************************************
*                                                                              *
*          2-dimensional finite difference Hartree-Fock program                *
*                        for diatomic molecules                                *
*                                                                              *
*                 (http://www.csc.fi/~laaksone/num2d.html)                     *
*                                                                              *
*                                                                              *
*  Copyright (C) 1996 Jacek Kobus, Jacek.Kobus@phys.uni.torun.pl               *
*  Instytut Fizyki, Uniwersytet Mikolaja Kopernika                             *
*  Grudziadzka 5/7, PL-87-100 Torun, Poland                                    *
*                                                                              *
*  Copyright (C) 1996 Leif Laaksonen, Leif.Laaksonen@csc.fi                    *
*  Centre for Scientific Computing                                             *
*  Tietotie 6, P.O.Box 405, FIN-02101 Espoo, Finland                           *
*                                                                              *
*  Copyright (C) 1996 Dage Sundholm, sundholm@chem.helsinki.fi                 *
*  Department of Chemistry, University of Helsinki                             *
*  P.O. Box 55, FIN-00014 Helsinki, Finland                                    *
*                                                                              *
*  This program is free software; you can redistribute it and/or               *
*  modify it under the terms of the GNU General Public License                 *
*  as published by the Free Software Foundation; either version 2              *
*  of the License, or (at your option) any later version.                      *
*                                                                              *
*  This program is distributed in the hope that it will be useful,             *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                *
*  GNU General Public License for more details.                                *
*                                                                              *
*  You should have received a copy of the GNU General Public License           *
*  along with this program (see COPYING).                                      *
*                                                                              *
********************************************************************************
c ### 2DHF ###
c
c     This is the main routine of the 2DHF program.
c     Dimensions of working arrays have to be defined either statically 
c     or dynamically, i.e. based on input data (see prep_src).
c                                                                      
      PROGRAM  fdhf
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'main-dynamic-f77.inc'
      stop
      end
      
      include 'blk_data.inc'

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### dointerp_mu ###	
c
c     Performs interpolations of functions in mu variable.
c
      subroutine dointerp_mu (nnit,nmumin_p,nmumax_p,nmumin,nmumax,
     &     fbefore,fafter) 

      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)	
      real*8 vmuq,coeffq(9),coeffq2(9,9),xmu,vpoly1q  
      include 'commons8.inc'
      include 'commons16.inc'
      dimension fbefore(nnit,*),fafter(nnit,*)

      rerror=2
      idebug1=0
      idebug2=0
      idebug3=0

c     interpolation for the first iord2 points in mu variable

      do imu=nmumin,nmumax
         if(vmu(imu).ge.vmu_p((nmumin_p-1)+iord2)) goto 115
      enddo
00115 continue
      nmu_first=imu
 
c     print *,"dointerp_mu: nmumin,nmu_first",nmumin,nmu_first
      
      do k=1,kend
         call lpcoeffq((nmumin_p-1)+iord2+1,k,coeffq)
         do i=1,kend
            coeffq2(i,k)=coeffq(i)
         enddo
      enddo
      do imu=nmumin,nmu_first
         xmu=vmu(imu)            
         do ini=1,nnit
            fafter(ini,imu)=0.d0
            do k=1,kend
               fafter(ini,imu)=fafter(ini,imu)+
     &              fbefore(ini,nmumin_p-1+k)
     &              *vpoly1q(xmu,coeffq2(1,k))
            enddo
            if (idebug1.eq.1) then 
               if (abs(fafter(ini,imu)-fbefore(ini,nmumin_p+2)).gt.
     &              abs(fbefore(ini,nmumin_p+2))*rerror) then
                  
                  write(*,'(2i5,d15.3,4x,3d15.3)') 
     &                 ini,imu,fafter(ini,imu),
     &                 (fbefore(ini,nmumin_p-1+k),k=1,kend)
               endif
            endif
            
         enddo
      enddo

c     Interpolation for the last iord2 points in mu variable.
c     Determine the location of the tail region in the new grid

      do imu=nmumin,nmumax
         if(vmu(imu).ge.vmu_p(nmumax_p)) goto 120
      enddo
00120 continue
      nmu_last=imu
      
      do k=1,kend
         call lpcoeffq(nmumax_p-iord2,k,coeffq)
         do i=1,kend
            coeffq2(i,k)=coeffq(i)
         enddo
      enddo
      do imu=nmu_last-iord2+1,nmumax
         xmu=vmu(imu)            
         do ini=1,nnit
            fafter(ini,imu)=0.d0
            do k=1,kend
               fafter(ini,imu)=fafter(ini,imu)+
     &              fbefore(ini,nmumax_p-iord+k)
     &              *vpoly1q(xmu,coeffq2(1,k))
            enddo
            if (idebug2.eq.1) then 
               if (abs(fafter(ini,imu)-fbefore(ini,nmumax_p-iord+2)).gt.
     &              abs(fbefore(ini,nmumax_p-iord+2))*rerror) then
                  
                  write(*,'(2i5,d15.3,4x,3d15.3)') 
     &                 ini,imu,fafter(ini,imu),
     &                 (fbefore(ini,nmumax_p-iord+k),k=1,kend)
               endif
            endif
         enddo
      enddo

c     interpolation for the inner points in this region
      
      do imu=nmu_first+1,nmu_last-iord2
         xmu=vmu(imu)            
         do i=1,nmumax_p
            if(vmu_p(i).ge.xmu) goto 130
         enddo
00130    continue
         imu_p=i
         do k=1,kend
            call lpcoeffq(imu_p,k,coeffq)
            do i=1,kend
               coeffq2(i,k)=coeffq(i)
            enddo
         enddo
         
         do ini=1,nnit
            fafter(ini,imu)=0.d0
            do k=1,kend
               fafter(ini,imu)=fafter(ini,imu)+
     &              fbefore(ini,imu_p-iord2-1+k)
     &              *vpoly1q(xmu,coeffq2(1,k))
            enddo
            if (idebug3.eq.1) then
               if (abs(fafter(ini,imu)-fbefore(ini,imu_p-iord2+1)).gt.
     &              abs(fbefore(ini,imu_p-iord2+1))*rerror) then
                  write(*,'(2i5,d15.3,4x,3d15.3,2i5)') 
     &                 ini,imu,fafter(ini,imu),
     &                 (fbefore(ini,imu_p-iord2-1+k),k=1,kend),
     &                 nmu_first,nmu_last
               endif
            endif
         enddo
      enddo
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zasyxtail1 ###
c     
      subroutine zasyxtail1 (idel,ipc,excp)
      implicit integer*4 (i-n)
      implicit real*8(a-h,o-z)
      include 'commons8.inc'
      dimension excp(*),excptmp(10),pe(10)

c     In order to compare asymptotic values of exchange potentials
c     obtained when running the program with and without idbg(300) being
c     set one has to take into account a different sign convention
c     adopted when idbg(300) is set (the associated Legendre polynomials
c     P(k,q) are multiplied by (-1)**q). This results in some multipole
c     moments Q^{ab} having their sign reversed.

      sgn=1.d0
      idelt=idel/2
      if (2*idelt.ne.idel) sgn=-1.d0
      j=mxnmu
      i=(nni-1)/2
      call multi1(i,j,idel,ipc,pe)
      do m=1,impole
         excptmp(m)= r2*sgn*vxi(j)*pe(m)
      enddo
      write(*,1000) excptmp(1),(excptmp(m)-excptmp(m-1),m=2,impole),
     &     excptmp(impole)
 1000 format(4d16.8/5d16.8)
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### zasyxtail ###
c
      subroutine zasyxtail (idel,ipc,excp)
      implicit integer*4 (i-n)
      implicit real*8(a-h,o-z)
      include 'commons8.inc'
      dimension excp(*)
     
      j=mxnmu
      i=(nni-1)/2
      pe=0.d0
      call multi(i,j,idel,ipc,pe)
      excptmp=r2*vxi(j)*pe
      write(*,1000) excptmp

 1000 format(4d16.8/5d16.8)
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### raylsl ###
c 
c     Solves the eigenvalue  to the Schroedinger equation assuming 
c     the local form of the exchange potential
c
      subroutine raylsl(iorb,psi,pot,excp,e,f0,wgt1,wgt2,
     &		      wk0,wk1,wk2,wk3)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

      dimension psi(*),pot(*),excp(*),e(*),f0(*),wgt1(*),wgt2(*),
     &          wk0(*),wk1(*),wk2(*),wk3(*)

      do i=1,mxsize
         wk0(i)=0.d0	  
         wk1(i)=0.d0
      enddo

      wtwoel=0.d0

      i1beg=i1b(iorb)
      i2beg=i2b(iorb)	
      nmut=i1mu(iorb)
      ngorb=i1si(iorb)
      ngpot=i2si(iorb)	
	
      if (ngorb.ne.ngpot) then
         write(*,*) 'Orbitals and corresponding Coulomb potentials ',
     &        'have to be defined on the same number of grid points'
         stop 'raylsl'
      endif
		 
      isd=iorb+(iorb-1)*norb
      engo(isd)=0.0d0
      ipe=mgx(6,iorb)
      ipex=ipe-2*(ipe/2)

c     calculate derivatives over mu and ni 

      if (ipex.eq.0) then
         isym= 1
      else
         isym=-1
      endif
      
      call fill (nni,nmut,isym,psi(i1beg),wk3)
      call difni (nmut,wk3,wk0,wk1,wk2)
      call refill(nni,nmut,wk1,wk0)

      call difmu (nmut,wk3,wk2)
      call refill(nni,nmut,wk0,wk2)

c     add contribution from derivatives over mu and ni
      
      call add (ngorb,wk0,wk1)

      if (ipe.eq.0) then
         call dcopy (ngorb,f0,1,wk0,1)
      else
         
c        e enters the expression with minus sign which is already 
c        incorporated in e
         
         w=dble(ipe*ipe)
         call dcopy (ngorb,f0,1,wk0,1)
         call daxpy (ngorb,w,e,1,wk0,1)
      endif

      call proda (ngorb,psi(i1beg),wk0,wk1)
      call prod  (ngorb,psi(i1beg),wk1)
      
      woneel=ddot(ngorb,wgt1,1,wk1,1)
      
      if(idbg(96).ne.0) then
         write(*,*) 'woneel', woneel
      endif

      if (nel.gt.1) then
         do i=1,mxsize
            wk2(i)=0.d0
         enddo
        
         if (norb.eq.1) then

c           calculate the Coulomb potential contribution 
c           from one sigma orbital

            oc=occ(norb)
            call daxpy (ngpot,oc,pot(i2beg),1,wk2,1)
            call prod  (ngorb,psi(i1beg),wk2)
         else 

c           Add contributions from coulomb and local exchange potential.
c           In the local exchange approximation the coulomb potential 
c           includes also the contribution from the orbital

            do iorb1=1,norb
               i1beg1=i1b(iorb1)
               i2beg1=i2b(iorb1)
               ngorb1=i1si(iorb1)		
               ngpot1=i2si(iorb1)
               oc=occ(iorb1)
               call daxpy (ngpot1,oc,pot(i2beg1),1,wk2,1)
            enddo
            call prod  (ngorb,psi(i1beg),wk2)
            
c           multiply the local exchange potential by psi(i1beg) and 
c           add the result to the coulomb potential (multiplied by
c           psi(i1beg))

	    call prod2 (ngorb,psi(i1beg),excp(1),wk1)
	    call add (ngorb,wk1,wk2)
         endif
        
c        to complete the integrand wk2 has to be multiplied by psi(i1beg)    

         call prod (ngorb,psi(i1beg),wk2)
         wtwoel=ddot(ngorb,wgt2,1,wk2,1)
      endif

      engo(isd) = woneel+wtwoel
      eng(iorb) = engo(isd)

      if(idbg(95).ne.0) then
         write(*,*) 'iorb,woneel,wtwoel', iorb,woneel,wtwoel
      endif

      if(idbg(96).ne.0) then
         write(*,*) 'raylsl: wk1'
         call pmtx (nni,nmu(1),wk1,1,1,incrni,incrmu)
         write(*,*) 'raylsl: wk2'
         call pmtx (nni,nmu(1),wk2,1,1,incrni,incrmu)
      endif

      if (idbg(70).ne.0) then
         write(*,*) 'raylsl: woneel, wtwoel, eng ',woneel,wtwoel,
     &        eng(iorb)
      endif
      
      return
      end

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### raynsl ###
c
c     Evaluates the off-diagonal Lagrange multiplier e(iorb2,iorb1) 
c     assuming the local exchange approximation

      subroutine raynsl(iorb1,iorb2,psi,pot,excp,wgt2,wk0,wk1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      include 'commons8.inc'
      dimension psi(*),pot(*),excp(*),wgt2(*),wk0(*),wk1(*)

      if (mgx(6,iorb1).ne.mgx(6,iorb2)) return
      if (ige(iorb1).ne.ige(iorb2)) return

      isd=iorb1+(iorb2-1)*norb
      ipe=mgx(6,iorb2)
      engo(isd)=0.d0
      iborb1=i1b(iorb1)
      isiorb1=i1si(iorb1)	
      iborb2=i1b(iorb2)
      isiorb2=i1si(iorb2)	
      norb2=norb*norb

c     Add contributions from coulomb and local exchange potential.
c     In the local exchange approximtion the coulomb potential includes
c     also the contribution from the orbital

c     calculate the coulomb potential contribution from all the orbitals

      do i=1,mxsize
         wk0(i)=0.d0
      enddo
	
      do iorb=1,norb
         iborb=i1b(iorb)
         ibpot=i2b(iorb)	
         nmut=i1mu(iorb)
         isipot=i2si(iorb)
         oc=occ(iorb)
         call daxpy (isipot,oc,pot(ibpot),1,wk0,1)
      enddo

      call prod  (isiorb2,psi(iborb2),wk0)

c     multiply the local exchange potENTIAL by psi(iborb2) 
c     and add the result to the coulomb potential

      call prod2 (isiorb2,psi(iborb2),excp(1),wk1)
      call add (isiorb2,wk0,wk1)

c     to complete the integrand wk1 has to be multiplied by psi(iborb1)

      ngrid=min(isiorb1,isiorb2)
      call prod (ngrid,psi(iborb1),wk1)
      wtwoel=ddot(ngrid,wgt2,1,wk1,1)

      engo(isd)= wtwoel

      return
      end

********************************************************************************
*                                                                              *
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### blas ###
c
c     Replacement for BLAS routines: dcopy, daxpy, dscal, ddot, mxv
c
      subroutine  dcopy(n,dx,ix,dy,iy)
      real*8  dx(*),dy(*)
      integer*4 i,ix,iy,n
      
      do i=1,n
         dy(i)=dx(i)
      enddo
      return
      end

      subroutine  daxpy(n,da,dx,ix,dy,iy)
      real*8 da,dx(*),dy(*)
      integer*4  i,ix,iy,n

      do i=1,n
         dy(i)=da*dx(i)+dy(i)
      enddo
      return
      end

      subroutine  dscal(n,da,dx,ix)
      real*8 da,dx(*)
      integer*4 i,ix,n

      do i=1,n
         dx(i)=da*dx(i)
      enddo
      return
      end

      function  ddot(n,dx,ix,dy,iy)
      real*8  dx(*),dy(*),ddot
      integer*4  i,ix,iy,n

      ddot=0.d0
      do i=1,n
         ddot=ddot+dx(i)*dy(i)
      enddo
      return
      end

      subroutine  mxv (dx,nr,dv,nc,dvr)

c     Routine multiplying the matrix DX(NR,NC) times the vector DV(NC) and
c     storing the result in the vector DVR(NR)

      real*8  dx(nr,nc),dv(nc),dvr(nr),s
      integer*4  nr,nc,nh,inr,inc

      do inr=1,nr
         s=0.d0
         do inc=1,nc
            s=s+dx(inr,inc)*dv(inc)
         enddo
         dvr(inr)=s
      enddo
      return
      end
                      

********************************************************************************
*                                                                              * 
*  2DHF version 1-2003                                                         *
*  Copyright (C) 1996  Jacek Kobus, Leif Laaksonen, Dage Sundholm              *
*                                                                              *
*  This software may be used and distributed according to the terms            *
*  of the GNU General Public License, see README and COPYING.                  *
*                                                                              *
********************************************************************************
c ### summary ####
c
      subroutine summary (iscf,cw_orb,cw_coul,cw_exch,
     &     cw_suppl,cw_sctch)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension cw_orb(*),cw_coul(*),cw_exch(*),
     &     cw_suppl(*),cw_sctch(*)

c     write functions to disk file if nobckup < 10000

      if (nobckup.ge.0) then
         call wtdisk(cw_orb,cw_coul,cw_exch)
      endif

c     calculate final total energy
      
      write (*,*)
      call toten (cw_orb,cw_coul,cw_exch,                         
     &     cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &     cw_sctch(i5b( 4)))

      write(iout6,6110)  etot
      write(iout6,6100)  evt
      if (islat.eq.0) write(iout6,6120)  virrat
      etot_final=etot


c     write final orbital energies and normalization factors
      
      write(*,*)
      write(iout6,1000)
      do i=1,norb
         write(iout6,1002) iorn(i),bond(i),gut(i),eng(i),area(i)
      enddo  
      write(*,*)

c     check how an error in the orbital normalization factors influence
c     the accuracy of the total energy

      do iorb=1,norb
         ibeg = i1b (iorb)
         ngrid= i1si(iorb)
         xnorm=area(iorb)
         zarea = sqrt(xnorm)
         call dscal (ngrid,zarea,cw_orb(ibeg),1)
      enddo  

c     calculate final total energy
      
      write (*,*)
      call toten (cw_orb,cw_coul,cw_exch,                         
     &     cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b(13)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &     cw_sctch(i5b( 4)))

      write(iout6,6111)  abs(etot_final-etot),
     &     abs(etot_final/etot-1.d0)*100

      do iorb=1,norb
         ibeg = i1b (iorb)
         ngrid= i1si(iorb)
         xnorm=area(iorb)
         zarea = 1.d0/sqrt(xnorm)
         call dscal (ngrid,zarea,cw_orb(ibeg),1)
      enddo  
 
      
c     check orthohonality

      if (idbg(210).ne.0) then
         write(*,*) 'checking orthogonality:'
         iprt=2
         do iorb=1,norb
            i=norb+1-iorb
            call ortho (i,cw_orb,
     &           cw_suppl(i4b(9)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b(1)),iprt)
         enddo
      endif

c     check symmetry of orbitals in the homonuclear case
      
      if (abs(z1-z2).lt.homolevl) call homo_check(cw_orb)

c      call orbtails (cw_orb,cw_coul,cw_exch,cw_suppl,cw_sctch)
      
      if (idbg(495).ne.0) then
         write(*,*)
         write(*,*) 'Euclidean norms of (T+V(n)+V-E)|i>:'
         do iorb=1,norb
            call locenergy (iorb,cw_orb,cw_coul,cw_exch,
     &           cw_suppl(i4b( 4)),cw_suppl(i4b( 5)),cw_suppl(i4b( 9)),
     &           cw_suppl(i4b(13)),cw_suppl(i4b(14)),
     &           cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),
     &           cw_sctch(i5b( 4)))
         enddo
      endif

c     check multipole expansion
      if (idbg(302).ne.0) then
         call chasympot (cw_coul,cw_exch)
      endif

c     calculate multipole moments and expectation values

      call propet (iscf,cw_orb,cw_coul,cw_exch,cw_suppl(i4b( 9)),
     &     cw_suppl(i4b(14)),
     &     cw_sctch(i5b( 1)),cw_sctch(i5b( 2)),cw_sctch(i5b( 3)),          
     &     cw_sctch(i5b( 4)),cw_sctch(i5b( 5)),cw_sctch(i5b( 6)))
c     
      write(*,'(//,"////////////////////////////////////////////",
     &     "////////////////////////////////////////////////////",
     &     "////////////////")')

c     cpu time statistics
      
      tcpu=trelax+tortho+trayl+tmomen

      write(*,'(/," cpu summary (sec):")')
      write(*,5001) trelax
      write(*,5002) tortho
      write(*,5003) trayl
      write(*,5004) tmomen
      write(*,5005) tcpu
      if (iscf.ne.0) write(*,5006) tcpu/dble(iscf)
      
 1000 format(19x,'  orbital energies       normalization factors')  
 1002 format(1x,i3,1x,a8,1x,a1,2d25.13)
 5001 format(4x,'relaxation of orb. and pot.        ', f12.2)
 5002 format(4x,'normalization+orthogonalization    ', f12.2)
 5003 format(4x,'lagrange multipliers               ', f12.2)
 5004 format(4x,'multipole moments                  ', f12.2)
 5005 format(4x,'sum total                          ', f12.2)
 5006 format(4x,'duration of single scf iteration   ', f12.2)
 6100 format(1x,'total electronic energy: ',d25.13)
 6110 format(1x,'total energy:            ',d25.13)
 6111 format(1x,'total energy uncertaininty due to orbital norms',
     &     ' not being equal 1:'/,
     &     '  absolute   +/-',d8.2,/,
     &     '  relative   +/-',d8.2,'%')
 6120 format(1x,'virial ratio:            ',d25.13)

      return
      end
